const proxmoxOnlineHelpInfo = {
  "pbs_documentation_index": {
    "link": "/docs/index.html",
    "title": "Proxmox Backup Server Documentation Index"
  },
  "client-repository": {
    "link": "/docs/backup-client.html#client-repository",
    "title": "Backup Repository Locations"
  },
  "client-creating-backups": {
    "link": "/docs/backup-client.html#client-creating-backups",
    "title": "Creating Backups"
  },
  "client-change-detection-mode": {
    "link": "/docs/backup-client.html#client-change-detection-mode",
    "title": "Change Detection Mode"
  },
  "client-encryption": {
    "link": "/docs/backup-client.html#client-encryption",
    "title": "Encryption"
  },
  "client-restoring-data": {
    "link": "/docs/backup-client.html#client-restoring-data",
    "title": "Restoring Data"
  },
  "changing-backup-owner": {
    "link": "/docs/backup-client.html#changing-backup-owner",
    "title": "Changing the Owner of a Backup Group"
  },
  "backup-pruning": {
    "link": "/docs/backup-client.html#backup-pruning",
    "title": "Pruning and Removing Backups"
  },
  "client-garbage-collection": {
    "link": "/docs/backup-client.html#client-garbage-collection",
    "title": "Garbage Collection"
  },
  "calendar-event-scheduling": {
    "link": "/docs/calendarevents.html#calendar-event-scheduling",
    "title": "Calendar Events"
  },
  "domains-cfg": {
    "link": "/docs/configuration-files.html#domains-cfg",
    "title": "``domains.cfg``"
  },
  "notifications-cfg": {
    "link": "/docs/configuration-files.html#notifications-cfg",
    "title": "``notifications.cfg``"
  },
  "notifications-priv-cfg": {
    "link": "/docs/configuration-files.html#notifications-priv-cfg",
    "title": "``notifications-priv.cfg``"
  },
  "faq-support-table": {
    "link": "/docs/faq.html#faq-support-table",
    "title": "How long will my Proxmox Backup Server version be supported?"
  },
  "faq-upgrade-major": {
    "link": "/docs/faq.html#faq-upgrade-major",
    "title": "How can I upgrade Proxmox Backup Server to the next major release?"
  },
  "pxar-format": {
    "link": "/docs/file-formats.html#pxar-format",
    "title": "Proxmox File Archive Format (``.pxar``)"
  },
  "pxar-meta-format": {
    "link": "/docs/file-formats.html#pxar-meta-format",
    "title": "Proxmox File Archive Format - Meta (``.mpxar``)"
  },
  "ppxar-format": {
    "link": "/docs/file-formats.html#ppxar-format",
    "title": "Proxmox File Archive Format - Payload (``.ppxar``)"
  },
  "data-blob-format": {
    "link": "/docs/file-formats.html#data-blob-format",
    "title": "Data Blob Format (``.blob``)"
  },
  "fixed-index-format": {
    "link": "/docs/file-formats.html#fixed-index-format",
    "title": "Fixed Index Format  (``.fidx``)"
  },
  "dynamic-index-format": {
    "link": "/docs/file-formats.html#dynamic-index-format",
    "title": "Dynamic Index Format (``.didx``)"
  },
  "consent-banner": {
    "link": "/docs/gui.html#consent-banner",
    "title": "Consent Banner"
  },
  "minimum-system-requirements": {
    "link": "/docs/system-requirements.html#minimum-system-requirements",
    "title": "Minimum Server Requirements, for Evaluation"
  },
  "installation-medium": {
    "link": "/docs/installation-media.html#installation-medium",
    "title": "Installation Medium"
  },
  "install-pbs": {
    "link": "/docs/installation.html#install-pbs",
    "title": "Server Installation"
  },
  "using-the-installer": {
    "link": "/docs/using-the-installer.html#using-the-installer",
    "title": "Install `Proxmox Backup`_ Server using the Installer"
  },
  "advanced-lvm-options": {
    "link": "/docs/using-the-installer.html#advanced-lvm-options",
    "title": "Advanced LVM Configuration Options"
  },
  "advanced-zfs-options": {
    "link": "/docs/using-the-installer.html#advanced-zfs-options",
    "title": "Advanced ZFS Configuration Options"
  },
  "nomodeset-kernel-param": {
    "link": "/docs/using-the-installer.html#nomodeset-kernel-param",
    "title": "Adding the ``nomodeset`` Kernel Parameter"
  },
  "install-pbs-unattended": {
    "link": "/docs/installation.html#install-pbs-unattended",
    "title": "Install `Proxmox Backup`_ Server Unattended"
  },
  "install-pbs-on-debian": {
    "link": "/docs/installation.html#install-pbs-on-debian",
    "title": "Install `Proxmox Backup`_ Server on Debian"
  },
  "install-pbs-on-pve": {
    "link": "/docs/installation.html#install-pbs-on-pve",
    "title": "Install Proxmox Backup Server on `Proxmox VE`_"
  },
  "install-pbc": {
    "link": "/docs/installation.html#install-pbc",
    "title": "Client Installation"
  },
  "sysadmin-package-repositories": {
    "link": "/docs/installation.html#sysadmin-package-repositories",
    "title": "Debian Package Repositories"
  },
  "package-repos-secure-apt": {
    "link": "/docs/installation.html#package-repos-secure-apt",
    "title": "SecureApt"
  },
  "sysadmin-package-repos-enterprise": {
    "link": "/docs/installation.html#sysadmin-package-repos-enterprise",
    "title": "`Proxmox Backup`_ Enterprise Repository"
  },
  "package-repositories-client-only": {
    "link": "/docs/installation.html#package-repositories-client-only",
    "title": "Proxmox Backup Client-only Repository"
  },
  "package-repositories-client-only-apt": {
    "link": "/docs/installation.html#package-repositories-client-only-apt",
    "title": "APT-based Proxmox Backup Client Repository"
  },
  "node-options-http-proxy": {
    "link": "/docs/installation.html#node-options-http-proxy",
    "title": "Repository Access Behind HTTP Proxy"
  },
  "get-help": {
    "link": "/docs/introduction.html#get-help",
    "title": "Getting Help"
  },
  "get-help-enterprise-support": {
    "link": "/docs/introduction.html#get-help-enterprise-support",
    "title": "Enterprise Support"
  },
  "maintenance-pruning": {
    "link": "/docs/maintenance.html#maintenance-pruning",
    "title": "Pruning"
  },
  "maintenance-prune-jobs": {
    "link": "/docs/maintenance.html#maintenance-prune-jobs",
    "title": "Prune Jobs"
  },
  "maintenance-gc": {
    "link": "/docs/maintenance.html#maintenance-gc",
    "title": "Garbage Collection"
  },
  "gc-background": {
    "link": "/docs/maintenance.html#gc-background",
    "title": "GC Background"
  },
  "maintenance-verification": {
    "link": "/docs/maintenance.html#maintenance-verification",
    "title": "Verification"
  },
  "maintenance-notification": {
    "link": "/docs/maintenance.html#maintenance-notification",
    "title": "Notifications"
  },
  "maintenance-mode": {
    "link": "/docs/maintenance.html#maintenance-mode",
    "title": "Maintenance Mode"
  },
  "backup-remote": {
    "link": "/docs/managing-remotes.html#backup-remote",
    "title": "Remote"
  },
  "syncjobs": {
    "link": "/docs/managing-remotes.html#syncjobs",
    "title": "Sync Jobs"
  },
  "markdown-primer": {
    "link": "/docs/markdown-primer.html#markdown-primer",
    "title": "Markdown Primer"
  },
  "markdown-basics": {
    "link": "/docs/markdown-primer.html#markdown-basics",
    "title": "Markdown Basics"
  },
  "sysadmin-network-configuration": {
    "link": "/docs/network-management.html#sysadmin-network-configuration",
    "title": "Network Management"
  },
  "sysadmin-traffic-control": {
    "link": "/docs/network-management.html#sysadmin-traffic-control",
    "title": "Traffic Control"
  },
  "notifications": {
    "link": "/docs/notifications.html#notifications",
    "title": "Notifications"
  },
  "notification-targets": {
    "link": "/docs/notifications.html#notification-targets",
    "title": "Notification Targets"
  },
  "notification-targets-sendmail": {
    "link": "/docs/notifications.html#notification-targets-sendmail",
    "title": "Sendmail"
  },
  "notification-targets-smtp": {
    "link": "/docs/notifications.html#notification-targets-smtp",
    "title": "SMTP"
  },
  "notification-targets-gotify": {
    "link": "/docs/notifications.html#notification-targets-gotify",
    "title": "Gotify"
  },
  "notification-targets-webhook": {
    "link": "/docs/notifications.html#notification-targets-webhook",
    "title": "Webhook"
  },
  "notification-matchers": {
    "link": "/docs/notifications.html#notification-matchers",
    "title": "Notification Matchers"
  },
  "notification-events": {
    "link": "/docs/notifications.html#notification-events",
    "title": "Notification Events"
  },
  "notification-mode": {
    "link": "/docs/notifications.html#notification-mode",
    "title": "Notification Mode"
  },
  "pve-integration": {
    "link": "/docs/pve-integration.html#pve-integration",
    "title": "`Proxmox VE`_ Integration"
  },
  "storage-disk-management": {
    "link": "/docs/storage.html#storage-disk-management",
    "title": "Disk Management"
  },
  "datastore-intro": {
    "link": "/docs/storage.html#datastore-intro",
    "title": "Datastore"
  },
  "storage-datastore-create": {
    "link": "/docs/storage.html#storage-datastore-create",
    "title": "Creating a Datastore"
  },
  "storage-namespaces": {
    "link": "/docs/storage.html#storage-namespaces",
    "title": "Backup Namespaces"
  },
  "datastore-tuning-options": {
    "link": "/docs/storage.html#datastore-tuning-options",
    "title": "Tuning"
  },
  "ransomware-protection": {
    "link": "/docs/storage.html#ransomware-protection",
    "title": "Ransomware Protection & Recovery"
  },
  "sysadmin-host-administration": {
    "link": "/docs/sysadmin.html#sysadmin-host-administration",
    "title": "Host System Administration"
  },
  "chapter-zfs": {
    "link": "/docs/sysadmin.html#chapter-zfs",
    "title": "ZFS on Linux"
  },
  "zfs-swap": {
    "link": "/docs/sysadmin.html#zfs-swap",
    "title": "Swap on ZFS"
  },
  "local-zfs-special-device": {
    "link": "/docs/sysadmin.html#local-zfs-special-device",
    "title": "ZFS special device"
  },
  "chapter-systembooting": {
    "link": "/docs/sysadmin.html#chapter-systembooting",
    "title": "Host Bootloader"
  },
  "systembooting-installer-part-scheme": {
    "link": "/docs/sysadmin.html#systembooting-installer-part-scheme",
    "title": "Partitioning Scheme Used by the Installer"
  },
  "systembooting-proxmox-boot-tool": {
    "link": "/docs/sysadmin.html#systembooting-proxmox-boot-tool",
    "title": "Synchronizing the Content of the ESP with ``proxmox-boot-tool``"
  },
  "systembooting-proxmox-boot-setup": {
    "link": "/docs/sysadmin.html#systembooting-proxmox-boot-setup",
    "title": "Setting up a New Partition for use as Synced ESP"
  },
  "systembooting-proxmox-boot-refresh": {
    "link": "/docs/sysadmin.html#systembooting-proxmox-boot-refresh",
    "title": "Updating the Configuration on all ESPs"
  },
  "systembooting-determine-bootloader": {
    "link": "/docs/sysadmin.html#systembooting-determine-bootloader",
    "title": "Determine which Bootloader is Used"
  },
  "systembooting-grub": {
    "link": "/docs/sysadmin.html#systembooting-grub",
    "title": "Grub"
  },
  "systembooting-grub-config": {
    "link": "/docs/sysadmin.html#systembooting-grub-config",
    "title": "Configuration"
  },
  "systembooting-systemdboot": {
    "link": "/docs/sysadmin.html#systembooting-systemdboot",
    "title": "Systemd-boot"
  },
  "systembooting-systemd-boot-config": {
    "link": "/docs/sysadmin.html#systembooting-systemd-boot-config",
    "title": "Configuration"
  },
  "systembooting-edit-kernel-cmdline": {
    "link": "/docs/sysadmin.html#systembooting-edit-kernel-cmdline",
    "title": "Editing the Kernel Commandline"
  },
  "systembooting-kernel-cmdline-grub": {
    "link": "/docs/sysadmin.html#systembooting-kernel-cmdline-grub",
    "title": "Grub"
  },
  "systembooting-kernel-cmdline-systemd-boot": {
    "link": "/docs/sysadmin.html#systembooting-kernel-cmdline-systemd-boot",
    "title": "systemd-boot"
  },
  "systembooting-kernel-pin": {
    "link": "/docs/sysadmin.html#systembooting-kernel-pin",
    "title": "Override the Kernel-Version for next Boot"
  },
  "systembooting-secure-boot": {
    "link": "/docs/sysadmin.html#systembooting-secure-boot",
    "title": "Secure Boot"
  },
  "systembooting-secure-boot-existing-installation": {
    "link": "/docs/sysadmin.html#systembooting-secure-boot-existing-installation",
    "title": "Switching an Existing Installation to Secure Boot"
  },
  "systembooting-secure-boot-existing-systemd-boot": {
    "link": "/docs/sysadmin.html#systembooting-secure-boot-existing-systemd-boot",
    "title": "**systemd-boot**"
  },
  "systembooting-secure-boot-other-modules": {
    "link": "/docs/sysadmin.html#systembooting-secure-boot-other-modules",
    "title": "Using DKMS/Third Party Modules With Secure Boot"
  },
  "sysadmin-certificate-management": {
    "link": "/docs/sysadmin.html#sysadmin-certificate-management",
    "title": "Certificate Management"
  },
  "sysadmin-certs-api-gui": {
    "link": "/docs/sysadmin.html#sysadmin-certs-api-gui",
    "title": "Certificates for the API and SMTP"
  },
  "sysadmin-certs-upload-custom": {
    "link": "/docs/sysadmin.html#sysadmin-certs-upload-custom",
    "title": "Upload Custom Certificate"
  },
  "sysadmin-certs-get-trusted-acme-cert": {
    "link": "/docs/sysadmin.html#sysadmin-certs-get-trusted-acme-cert",
    "title": "Trusted certificates via Let\u2019s Encrypt (ACME)"
  },
  "sysadmin-certs-acme-account": {
    "link": "/docs/sysadmin.html#sysadmin-certs-acme-account",
    "title": "ACME Account"
  },
  "sysadmin-certs-acme-plugins": {
    "link": "/docs/sysadmin.html#sysadmin-certs-acme-plugins",
    "title": "ACME Plugins"
  },
  "domains": {
    "link": "/docs/sysadmin.html#domains",
    "title": "Domains"
  },
  "sysadmin-certs-acme-http-challenge": {
    "link": "/docs/sysadmin.html#sysadmin-certs-acme-http-challenge",
    "title": "ACME HTTP Challenge Plugin"
  },
  "sysadmin-certs-acme-dns-challenge": {
    "link": "/docs/sysadmin.html#sysadmin-certs-acme-dns-challenge",
    "title": "ACME DNS API Challenge Plugin"
  },
  "sysadmin-certs-acme-dns-api-config": {
    "link": "/docs/sysadmin.html#sysadmin-certs-acme-dns-api-config",
    "title": "Configuring ACME DNS APIs for validation"
  },
  "dns-validation-through-cname-alias": {
    "link": "/docs/sysadmin.html#dns-validation-through-cname-alias",
    "title": "DNS Validation through CNAME Alias"
  },
  "sysadmin-certs-acme-dns-wildcard": {
    "link": "/docs/sysadmin.html#sysadmin-certs-acme-dns-wildcard",
    "title": "Wildcard Certificates"
  },
  "combination-of-plugins": {
    "link": "/docs/sysadmin.html#combination-of-plugins",
    "title": "Combination of Plugins"
  },
  "sysadmin-certs-acme-automatic-renewal": {
    "link": "/docs/sysadmin.html#sysadmin-certs-acme-automatic-renewal",
    "title": "Automatic renewal of ACME certificates"
  },
  "manually-change-certificate-over-command-line": {
    "link": "/docs/sysadmin.html#manually-change-certificate-over-command-line",
    "title": "Manually Change Certificate over the Command Line"
  },
  "tape-backup": {
    "link": "/docs/tape-backup.html#tape-backup",
    "title": "Tape Backup"
  },
  "tape-supported-hardware": {
    "link": "/docs/tape-backup.html#tape-supported-hardware",
    "title": "Supported Hardware"
  },
  "tape-changer-config": {
    "link": "/docs/tape-backup.html#tape-changer-config",
    "title": "Tape changers"
  },
  "tape-drive-config": {
    "link": "/docs/tape-backup.html#tape-drive-config",
    "title": "Tape drives"
  },
  "tape-media-pool-config": {
    "link": "/docs/tape-backup.html#tape-media-pool-config",
    "title": "Media Pools"
  },
  "tape-backup-job-config": {
    "link": "/docs/tape-backup.html#tape-backup-job-config",
    "title": "Tape Backup Jobs"
  },
  "tape-key-management": {
    "link": "/docs/tape-backup.html#tape-key-management",
    "title": "Encryption Key Management"
  },
  "tape-restore-encryption-key": {
    "link": "/docs/tape-backup.html#tape-restore-encryption-key",
    "title": "Restoring Encryption Keys"
  },
  "tech-design-overview": {
    "link": "/docs/technical-overview.html#tech-design-overview",
    "title": "Technical Overview"
  },
  "change-detection-mode-legacy": {
    "link": "/docs/technical-overview.html#change-detection-mode-legacy",
    "title": "Legacy Mode"
  },
  "change-detection-mode-data": {
    "link": "/docs/technical-overview.html#change-detection-mode-data",
    "title": "Data Mode"
  },
  "change-detection-mode-metadata": {
    "link": "/docs/technical-overview.html#change-detection-mode-metadata",
    "title": "Metadata Mode"
  },
  "terms": {
    "link": "/docs/terminology.html#terms",
    "title": "Terminology"
  },
  "term-backup-snapshot": {
    "link": "/docs/terminology.html#term-backup-snapshot",
    "title": "Backup Snapshot"
  },
  "user-mgmt": {
    "link": "/docs/user-management.html#user-mgmt",
    "title": "User Management"
  },
  "user-tokens": {
    "link": "/docs/user-management.html#user-tokens",
    "title": "API Tokens"
  },
  "user-acl": {
    "link": "/docs/user-management.html#user-acl",
    "title": "Access Control"
  },
  "user-tfa": {
    "link": "/docs/user-management.html#user-tfa",
    "title": "Two-Factor Authentication"
  },
  "user-tfa-setup-totp": {
    "link": "/docs/user-management.html#user-tfa-setup-totp",
    "title": "TOTP"
  },
  "user-tfa-setup-webauthn": {
    "link": "/docs/user-management.html#user-tfa-setup-webauthn",
    "title": "WebAuthn"
  },
  "user-tfa-setup-recovery-keys": {
    "link": "/docs/user-management.html#user-tfa-setup-recovery-keys",
    "title": "Recovery Keys"
  },
  "user-tfa-lockout": {
    "link": "/docs/user-management.html#user-tfa-lockout",
    "title": "Limits and Lockout of Two-Factor Authentication"
  },
  "user-realms-ldap": {
    "link": "/docs/user-management.html#user-realms-ldap",
    "title": "LDAP"
  },
  "user-realms-ad": {
    "link": "/docs/user-management.html#user-realms-ad",
    "title": "Active Directory"
  }
};
Ext.ns('PBS');

console.log("Starting Backup Server GUI");

Ext.define('PBS.Utils', {
    singleton: true,

    missingText: gettext('missing'),

    updateLoginData: function(data) {
	Proxmox.Utils.setAuthData(data);
    },

    dataStorePrefix: 'DataStore-',

    cryptmap: [
	'none',
	'mixed',
	'sign-only',
	'encrypt',
    ],

    cryptText: [
	Proxmox.Utils.noText,
	gettext('Mixed'),
	gettext('Signed'),
	gettext('Encrypted'),
    ],

    cryptIconCls: [
	'',
	'',
	'lock faded',
	'lock good',
    ],

    calculateCryptMode: function(data) {
	let mixed = data.mixed;
	let encrypted = data.encrypt;
	let signed = data['sign-only'];
	let files = data.count;
	if (mixed > 0) {
	    return PBS.Utils.cryptmap.indexOf('mixed');
	} else if (files === encrypted && encrypted > 0) {
	    return PBS.Utils.cryptmap.indexOf('encrypt');
	} else if (files === signed && signed > 0) {
	    return PBS.Utils.cryptmap.indexOf('sign-only');
	} else if ((signed+encrypted) === 0) {
	    return PBS.Utils.cryptmap.indexOf('none');
	} else {
	    return PBS.Utils.cryptmap.indexOf('mixed');
	}
    },

    noSubKeyHtml: 'You do not have a valid subscription for this server. Please visit <a target="_blank" href="https://www.proxmox.com/proxmox-backup-server/pricing">www.proxmox.com</a> to get a list of available options.',

    getDataStoreFromPath: function(path) {
	return path.slice(PBS.Utils.dataStorePrefix.length);
    },

    isDataStorePath: function(path) {
	return path.indexOf(PBS.Utils.dataStorePrefix) === 0;
    },

    parsePropertyString: function(value, defaultKey) {
	var res = {},
	    error;

	if (typeof value !== 'string' || value === '') {
	    return res;
	}

	Ext.Array.each(value.split(','), function(p) {
	    var kv = p.split('=', 2);
	    if (Ext.isDefined(kv[1])) {
		res[kv[0]] = kv[1];
	    } else if (Ext.isDefined(defaultKey)) {
		if (Ext.isDefined(res[defaultKey])) {
		    error = 'defaultKey may be only defined once in propertyString';
		    return false; // break
		}
		res[defaultKey] = kv[0];
	    } else {
		error = 'invalid propertyString, not a key=value pair and no defaultKey defined';
		return false; // break
	    }
	    return true;
	});

	if (error !== undefined) {
	    console.error(error);
	    return null;
	}

	return res;
    },

    printPropertyString: function(data, defaultKey) {
	var stringparts = [],
	    gotDefaultKeyVal = false,
	    defaultKeyVal;

	Ext.Object.each(data, function(key, value) {
	    if (defaultKey !== undefined && key === defaultKey) {
		gotDefaultKeyVal = true;
		defaultKeyVal = value;
	    } else if (value !== '' && value !== undefined) {
		stringparts.push(key + '=' + value);
	    }
	});

	stringparts = stringparts.sort();
	if (gotDefaultKeyVal) {
	    stringparts.unshift(defaultKeyVal);
	}

	return stringparts.join(',');
    },

    // helper for deleting field which are set to there default values
    delete_if_default: function(values, fieldname, default_val, create) {
	if (values[fieldname] === '' || values[fieldname] === default_val) {
	    if (!create) {
		if (values.delete) {
		    if (Ext.isArray(values.delete)) {
			values.delete.push(fieldname);
		    } else {
			values.delete += ',' + fieldname;
		    }
		} else {
		    values.delete = [fieldname];
		}
	    }

	    delete values[fieldname];
	}
    },


    render_datetime_utc: function(datetime) {
	let pad = (number) => number < 10 ? '0' + number : number;
	return datetime.getUTCFullYear() +
	    '-' + pad(datetime.getUTCMonth() + 1) +
	    '-' + pad(datetime.getUTCDate()) +
	    'T' + pad(datetime.getUTCHours()) +
	    ':' + pad(datetime.getUTCMinutes()) +
	    ':' + pad(datetime.getUTCSeconds()) +
	    'Z';
    },

    render_datastore_worker_id: function(id, what) {
	const res = id.match(/^(\S+?):(\S+?)\/(\S+?)(\/(.+))?$/);
	if (res) {
	    let datastore = res[1], backupGroup = `${res[2]}/${res[3]}`;
	    if (res[4] !== undefined) {
		let datetime = Ext.Date.parse(parseInt(res[5], 16), 'U');
		let utctime = PBS.Utils.render_datetime_utc(datetime);
		return `Datastore ${datastore} ${what} ${backupGroup}/${utctime}`;
	    } else {
		return `Datastore ${datastore} ${what} ${backupGroup}`;
	    }
	}
	return `Datastore ${what} ${id}`;
    },

    render_prune_job_worker_id: function(id, what) {
	const res = id.match(/^(\S+?):(\S+)$/);
	if (!res) {
	    return `${what} on Datastore ${id}`;
	}
	let datastore = res[1], namespace = res[2];
	return `${what} on Datastore ${datastore} Namespace  ${namespace}`;
    },

    render_tape_backup_id: function(id, what) {
	const res = id.match(/^(\S+?):(\S+?):(\S+?)(:(.+))?$/);
	if (res) {
	    let datastore = res[1];
	    let pool = res[2];
	    let drive = res[3];
	    return `${what} ${datastore} (pool ${pool}, drive ${drive})`;
	}
	return `${what} ${id}`;
    },

    render_drive_load_media_id: function(id, what) {
	const res = id.match(/^(\S+?):(\S+?)$/);
	if (res) {
	    let drive = res[1];
	    let label = res[2];
	    return gettext('Drive') + ` ${drive} - ${what} '${label}'`;
	}

	return `${what} ${id}`;
    },

    // mimics Display trait in backend
    renderKeyID: function(fingerprint) {
	return fingerprint.substring(0, 23);
    },

    render_task_status: function(value, metadata, record, rowIndex, colIndex, store) {
	// GC tasks use 'upid' for backwards-compat, rest use 'last-run-upid'
	if (
	    !record.data['last-run-upid'] &&
	    !store.getById('last-run-upid')?.data.value &&
	    !record.data.upid &&
	    !store.getById('upid')?.data.value
	) {
	    return '-';
	}

	if (!record.data['last-run-endtime'] && !store.getById('last-run-endtime')?.data.value) {
	    metadata.tdCls = 'x-grid-row-loading';
	    return '';
	}

	let parsed = Proxmox.Utils.parse_task_status(value);
	let text = value;
	let icon = '';
	switch (parsed) {
	case 'unknown':
	    icon = 'question faded';
	    text = Proxmox.Utils.unknownText;
	    break;
	case 'error':
	    icon = 'times critical';
	    text = Proxmox.Utils.errorText + ': ' + value;
	    break;
	case 'warning':
	    icon = 'exclamation warning';
	    break;
	case 'ok':
	    icon = 'check good';
	    text = gettext("OK");
	}

	return `<i class="fa fa-${icon}"></i> ${text}`;
    },

    render_next_task_run: function(value, metadat, record) {
	if (!value) return '-';

	let now = new Date();
	let next = new Date(value*1000);

	if (next < now) {
	    return gettext('pending');
	}
	return Proxmox.Utils.render_timestamp(value);
    },

    render_optional_timestamp: function(value, metadata, record) {
	if (!value) return '-';
	return Proxmox.Utils.render_timestamp(value);
    },

    parse_datastore_worker_id: function(type, id) {
	let result;
	let res;
	if (type.startsWith('verif')) {
	    res = PBS.Utils.VERIFICATION_JOB_ID_RE.exec(id);
	    if (res) {
		result = res[1];
	    }
	} else if (type.startsWith('sync')) {
	    res = PBS.Utils.SYNC_JOB_ID_RE.exec(id);
	    if (res) {
		result = res[3];
	    }
	} else if (type === 'backup') {
	    res = PBS.Utils.BACKUP_JOB_ID_RE.exec(id);
	    if (res) {
		result = res[1];
	    }
	} else if (type === 'garbage_collection') {
	    return id;
	} else if (type === 'prune') {
	    return id;
	}


	return result;
    },

    extractTokenUser: function(tokenid) {
	return tokenid.match(/^(.+)!([^!]+)$/)[1];
    },

    extractTokenName: function(tokenid) {
	return tokenid.match(/^(.+)!([^!]+)$/)[2];
    },

    render_estimate: function(value, metaData, record) {
	if (record.data.avail === 0) {
	    return gettext("Full");
	}

	if (value === undefined) {
	    return gettext('Not enough data');
	}

	let now = new Date();
	let estimate = new Date(value*1000);

	let timespan = (estimate - now)/1000;

	if (Number(estimate) <= Number(now) || isNaN(timespan)) {
	    return gettext('Never');
	}

	let duration = Proxmox.Utils.format_duration_human(timespan);
	return Ext.String.format(gettext("in {0}"), duration);
    },

    // FIXME: deprecated by Proxmox.Utils.render_size_usage ?!
    render_size_usage: function(val, max) {
	if (max === 0) {
	    return gettext('N/A');
	}
	return (val*100/max).toFixed(2) + '% (' +
	    Ext.String.format(gettext('{0} of {1}'),
	    Proxmox.Utils.format_size(val), Proxmox.Utils.format_size(max)) + ')';
    },

    get_help_tool: function(blockid) {
	let info = Proxmox.Utils.get_help_info(blockid);
	if (info === undefined) {
	    info = Proxmox.Utils.get_help_info('pbs_documentation_index');
	}
	if (info === undefined) {
	    throw "get_help_info failed"; // should not happen
	}

	let docsURI = window.location.origin + info.link;
	let title = info.title;
	if (info.subtitle) {
	    title += ' - ' + info.subtitle;
	}
	return {
	    type: 'help',
	    tooltip: title,
	    handler: function() {
		window.open(docsURI);
	    },
	};
    },

    calculate_dedup_factor: function(gcstatus) {
	let dedup = 1.0;
	if (gcstatus['disk-bytes'] > 0) {
	    dedup = (gcstatus['index-data-bytes'] || 0)/gcstatus['disk-bytes'];
	}
	return dedup;
    },

    parse_snapshot_id: function(snapshot) {
	if (!snapshot) {
	    return [undefined, undefined, undefined];
	}
	let nsRegex = /(?:^|\/)(ns\/([^/]+))/g;
	let namespaces = [];
	let nsPaths = [];
	snapshot = snapshot.replace(nsRegex, (_, nsPath, ns) => { nsPaths.push(nsPath); namespaces.push(ns); return ""; });
	let [_match, type, group, id] = /^\/?([^/]+)\/([^/]+)\/(.+)$/.exec(snapshot);

	return [type, group, id, namespaces.join('/'), nsPaths.join('/')];
    },

    get_type_icon_cls: function(btype) {
	var cls = '';
	if (btype.startsWith('vm')) {
	    cls = 'fa-desktop';
	} else if (btype.startsWith('ct')) {
	    cls = 'fa-cube';
	} else if (btype.startsWith('host')) {
	    cls = 'fa-building';
	}
	return cls;
    },

    constructor: function() {
	var me = this;

	let PROXMOX_SAFE_ID_REGEX = "([A-Za-z0-9_][A-Za-z0-9._-]*)";
	me.SAFE_ID_RE = new RegExp(`^${PROXMOX_SAFE_ID_REGEX}$`);
	// only anchored at beginning, only parses datastore for now
	me.VERIFICATION_JOB_ID_RE = new RegExp("^" + PROXMOX_SAFE_ID_REGEX + ':?');
	me.SYNC_JOB_ID_RE = new RegExp("^" + PROXMOX_SAFE_ID_REGEX + ':' +
	    PROXMOX_SAFE_ID_REGEX + ':' + PROXMOX_SAFE_ID_REGEX + ':');
	me.BACKUP_JOB_ID_RE = new RegExp("^" + PROXMOX_SAFE_ID_REGEX + ':');

	// do whatever you want here
	Proxmox.Utils.override_task_descriptions({
	    'acme-deactivate': (type, id) =>
		Ext.String.format(gettext("Deactivate {0} Account"), 'ACME') + ` '${id || 'default'}'`,
	    'acme-register': (type, id) =>
		Ext.String.format(gettext("Register {0} Account"), 'ACME') + ` '${id || 'default'}'`,
	    'acme-update': (type, id) =>
		Ext.String.format(gettext("Update {0} Account"), 'ACME') + ` '${id || 'default'}'`,
	    'acme-new-cert': ['', gettext('Order Certificate')],
	    'acme-renew-cert': ['', gettext('Renew Certificate')],
	    'acme-revoke-cert': ['', gettext('Revoke Certificate')],
	    backup: (type, id) => PBS.Utils.render_datastore_worker_id(id, gettext('Backup')),
	    'barcode-label-media': [gettext('Drive'), gettext('Barcode-Label Media')],
	    'catalog-media': [gettext('Drive'), gettext('Catalog Media')],
	    'delete-datastore': [gettext('Datastore'), gettext('Remove Datastore')],
	    'delete-namespace': [gettext('Namespace'), gettext('Remove Namespace')],
	    dircreate: [gettext('Directory Storage'), gettext('Create')],
	    dirremove: [gettext('Directory'), gettext('Remove')],
	    'eject-media': [gettext('Drive'), gettext('Eject Media')],
	    "format-media": [gettext('Drive'), gettext('Format media')],
	    "forget-group": [gettext('Group'), gettext('Remove Group')],
	    garbage_collection: ['Datastore', gettext('Garbage Collect')],
	    'realm-sync': ['Realm', gettext('User Sync')],
	    'inventory-update': [gettext('Drive'), gettext('Inventory Update')],
	    'label-media': [gettext('Drive'), gettext('Label Media')],
	    'load-media': (type, id) => PBS.Utils.render_drive_load_media_id(id, gettext('Load Media')),
	    logrotate: [null, gettext('Log Rotation')],
	    'mount-device': [gettext('Datastore'), gettext('Mount Device')],
	    prune: (type, id) => PBS.Utils.render_datastore_worker_id(id, gettext('Prune')),
	    prunejob: (type, id) => PBS.Utils.render_prune_job_worker_id(id, gettext('Prune Job')),
	    reader: (type, id) => PBS.Utils.render_datastore_worker_id(id, gettext('Read Objects')),
	    'rewind-media': [gettext('Drive'), gettext('Rewind Media')],
	    sync: ['Datastore', gettext('Remote Sync')],
	    syncjob: [gettext('Sync Job'), gettext('Remote Sync')],
	    'tape-backup': (type, id) => PBS.Utils.render_tape_backup_id(id, gettext('Tape Backup')),
	    'tape-backup-job': (type, id) => PBS.Utils.render_tape_backup_id(id, gettext('Tape Backup Job')),
	    'tape-restore': ['Datastore', gettext('Tape Restore')],
	    'unload-media': [gettext('Drive'), gettext('Unload Media')],
	    'unmount-device': [gettext('Datastore'), gettext('Unmount Device')],
	    verificationjob: [gettext('Verify Job'), gettext('Scheduled Verification')],
	    verify: ['Datastore', gettext('Verification')],
	    verify_group: ['Group', gettext('Verification')],
	    verify_snapshot: ['Snapshot', gettext('Verification')],
	    wipedisk: ['Device', gettext('Wipe Disk')],
	    zfscreate: [gettext('ZFS Storage'), gettext('Create')],
	});

	Proxmox.Utils.overrideNotificationFieldName({
	    'datastore': gettext('Datastore'),
	    'job-id': gettext('Job ID'),
	    'media-pool': gettext('Media Pool'),
	});

	Proxmox.Utils.overrideNotificationFieldValue({
	    'acme': gettext('ACME certificate renewal'),
	    'gc': gettext('Garbage collection'),
	    'package-updates': gettext('Package updates are available'),
	    'prune': gettext('Prune job'),
	    'sync': gettext('Sync job'),
	    'tape-backup': gettext('Tape backup notifications'),
	    'tape-load': gettext('Tape loading request'),
	    'verify': gettext('Verification job'),
	});

	Proxmox.Schema.overrideAuthDomains({
	    pbs: {
		name: 'Proxmox Backup authentication server',
		add: false,
		edit: false,
		pwchange: true,
		sync: false,
	    },
	});

	// TODO: use `overrideEndpointTypes` later - not done right now to avoid
	// breakage if widget-toolkit is not updated yet.
	Proxmox.Schema.notificationEndpointTypes = {
	    sendmail: {
		name: 'Sendmail',
		    ipanel: 'pmxSendmailEditPanel',
		    iconCls: 'fa-envelope-o',
		    defaultMailAuthor: 'Proxmox Backup Server - $hostname',
	    },
	    smtp: {
		name: 'SMTP',
		    ipanel: 'pmxSmtpEditPanel',
		    iconCls: 'fa-envelope-o',
		    defaultMailAuthor: 'Proxmox Backup Server - $hostname',
	    },
	    gotify: {
		name: 'Gotify',
		    ipanel: 'pmxGotifyEditPanel',
		    iconCls: 'fa-bell-o',
	    },
	    webhook: {
		name: 'Webhook',
		    ipanel: 'pmxWebhookEditPanel',
		    iconCls: 'fa-bell-o',
	    },
	};
    },

    // Convert an ArrayBuffer to a base64url encoded string.
    // A `null` value will be preserved for convenience.
    bytes_to_base64url: function(bytes) {
	if (bytes === null) {
	    return null;
	}

	return btoa(Array
	    .from(new Uint8Array(bytes))
	    .map(val => String.fromCharCode(val))
	    .join(''),
	)
	.replace(/\+/g, '-')
	.replace(/\//g, '_')
	.replace(/[=]/g, '');
    },

    // Convert an a base64url string to an ArrayBuffer.
    // A `null` value will be preserved for convenience.
    base64url_to_bytes: function(b64u) {
	if (b64u === null) {
	    return null;
	}

	return new Uint8Array(
	    atob(b64u
		.replace(/-/g, '+')
		.replace(/_/g, '/'),
	    )
	    .split('')
	    .map(val => val.charCodeAt(0)),
	);
    },

    driveCommand: function(driveid, command, reqOpts) {
	let params = Ext.apply(reqOpts, {
	    url: `/api2/extjs/tape/drive/${driveid}/${command}`,
	    timeout: 5*60*1000,
	    failure: function(response) {
		Ext.Msg.alert(gettext('Error'), response.htmlStatus);
	    },
	});

	Proxmox.Utils.API2Request(params);
    },

    showMediaLabelWindow: function(response) {
	let list = [];
	for (let [key, val] of Object.entries(response.result.data)) {
	    if (key === 'ctime' || key === 'media-set-ctime') {
		val = Proxmox.Utils.render_timestamp(val);
	    }
	    list.push({ key: key, value: val });
	}

	Ext.create('Ext.window.Window', {
	    title: gettext('Label Information'),
	    modal: true,
	    width: 600,
	    height: 450,
	    layout: 'fit',
	    scrollable: true,
	    items: [
		{
		    xtype: 'grid',
		    store: {
			data: list,
		    },
		    columns: [
			{
			    text: gettext('Property'),
			    dataIndex: 'key',
			    width: 120,
			},
			{
			    text: gettext('Value'),
			    dataIndex: 'value',
			    flex: 1,
			},
		    ],
		},
	    ],
	}).show();
    },

    showCartridgeMemoryWindow: function(response) {
	Ext.create('Ext.window.Window', {
	    title: gettext('Cartridge Memory'),
	    modal: true,
	    width: 600,
	    height: 450,
	    layout: 'fit',
	    scrollable: true,
	    items: [
		{
		    xtype: 'grid',
		    store: {
			data: response.result.data,
		    },
		    columns: [
			{
			    text: gettext('ID'),
			    hidden: true,
			    dataIndex: 'id',
			    width: 60,
			},
			{
			    text: gettext('Name'),
			    dataIndex: 'name',
			    flex: 2,
			},
			{
			    text: gettext('Value'),
			    dataIndex: 'value',
			    flex: 1,
			},
		    ],
		},
	    ],
	}).show();
    },

    showVolumeStatisticsWindow: function(response) {
	let list = [];
	for (let [key, val] of Object.entries(response.result.data)) {
	    if (key === 'total-native-capacity' ||
		key === 'total-used-native-capacity' ||
		key === 'lifetime-bytes-read' ||
		key === 'lifetime-bytes-written' ||
		key === 'last-mount-bytes-read' ||
		key === 'last-mount-bytes-written') {
		val = Proxmox.Utils.format_size(val);
	    }
	    list.push({ key: key, value: val });
	}
	Ext.create('Ext.window.Window', {
	    title: gettext('Volume Statistics'),
	    modal: true,
	    width: 600,
	    height: 450,
	    layout: 'fit',
	    scrollable: true,
	    items: [
		{
		    xtype: 'grid',
		    store: {
			data: list,
		    },
		    columns: [
			{
			    text: gettext('Property'),
			    dataIndex: 'key',
			    flex: 1,
			},
			{
			    text: gettext('Value'),
			    dataIndex: 'value',
			    flex: 1,
			},
		    ],
		},
	    ],
	}).show();
    },

    showDriveStatusWindow: function(response) {
	let list = [];
	for (let [key, val] of Object.entries(response.result.data)) {
	    if (key === 'manufactured') {
		val = Proxmox.Utils.render_timestamp(val);
	    }
	    if (key === 'bytes-read' || key === 'bytes-written') {
		val = Proxmox.Utils.format_size(val);
	    }
	    if (key === 'drive-activity') {
		val = PBS.Utils.renderDriveActivity(val);
	    }
	    list.push({ key: key, value: val });
	}

	Ext.create('Ext.window.Window', {
	    title: gettext('Status'),
	    modal: true,
	    width: 600,
	    height: 450,
	    layout: 'fit',
	    scrollable: true,
	    items: [
		{
		    xtype: 'grid',
		    store: {
			data: list,
		    },
		    columns: [
			{
			    text: gettext('Property'),
			    dataIndex: 'key',
			    width: 120,
			},
			{
			    text: gettext('Value'),
			    dataIndex: 'value',
			    flex: 1,
			},
		    ],
		},
	    ],
	}).show();
    },

    tapeDriveActivities: {
	'no-activity': gettext('No Activity'),
	'cleaning': gettext('Cleaning'),
	'loading': gettext('Loading'),
	'unloading': gettext('Unloading'),
	'other': gettext('Other Activity'),
	'reading': gettext('Reading data'),
	'writing': gettext('Writing data'),
	'locating': gettext('Locating'),
	'rewinding': gettext('Rewinding'),
	'erasing': gettext('Erasing'),
	'formatting': gettext('Formatting'),
	'calibrating': gettext('Calibrating'),
	'other-dt': gettext('Other DT Activity'),
	'microcode-update': gettext('Updating Microcode'),
	'reading-encrypted': gettext('Reading encrypted data'),
	'writing-encrypted': gettext('Writing encrypted data'),
    },

    renderDriveActivity: function(value) {
	if (!value) {
	    return Proxmox.Utils.unknownText;
	}
	return PBS.Utils.tapeDriveActivities[value] ?? value;
    },

    renderDriveState: function(value, md, rec) {
	if (!value) {
	    if (rec?.data?.activity && rec?.data?.activity !== 'no-activity') {
		return PBS.Utils.renderDriveActivity(rec.data.activity);
	    }
	    return gettext('Idle');
	}

	let icon = '<i class="fa fa-spinner fa-pulse fa-fw"></i>';

	if (value.startsWith("UPID")) {
	    let upid = Proxmox.Utils.parse_task_upid(value);
	    md.tdCls = "pointer";
	    return `${icon} ${upid.desc}`;
	}

	return `${icon} ${value}`;
    },

    /**
     * Parses maintenance mode property string.
     * Examples:
     *   "offline,message=foo" -> ["offline", "foo"]
     *   "offline" -> ["offline", null]
     *   "message=foo,offline" -> ["offline", "foo"]
     *   null/undefined -> [null, null]
     *
     * @param {string|null} mode - Maintenance mode string to parse.
     * @return {Array<string|null>} - Parsed maintenance mode values.
     */
    parseMaintenanceMode: function(mode) {
	if (!mode) {
	    return [null, null];
	}
	return mode.split(',').reduce(([m, msg], pair) => {
	    const [key, value] = pair.split('=');
	    if (key === 'message') {
		return [m, value.replace(/^"(.*)"$/, '$1').replace(/\\"/g, '"')];
	    } else {
		return [value ?? key, msg];
	    }
	}, [null, null]);
    },

    renderMaintenance: function(mode, activeTasks) {
	if (!mode) {
	    return gettext('None');
	}

	let [type, message] = PBS.Utils.parseMaintenanceMode(mode);

	let extra = '';

	if (activeTasks !== undefined) {
	    const conflictingTasks = activeTasks.write + (type === 'offline' || type === 'unmount' ? activeTasks.read : 0);

	    if (conflictingTasks > 0) {
		extra += '| <i class="fa fa-spinner fa-pulse fa-fw"></i> ';
		extra += Ext.String.format(gettext('{0} conflicting tasks still active.'), conflictingTasks);
	    } else {
		extra += '<i class="fa fa-check"></i>';
	    }
	}

	if (message) {
	    extra += ` ("${message}")`;
	}

	let modeText = Proxmox.Utils.unknownText;
	switch (type) {
	    case 'read-only': modeText = gettext("Read-only");
		break;
	    case 'offline': modeText = gettext("Offline");
		break;
	    case 'unmount': modeText = gettext("Unmounting");
		break;
	}
	return `${modeText} ${extra}`;
    },

    render_optional_namespace: function(value, metadata, record) {
	if (!value) return `- (${gettext('Root')})`;
	return Ext.String.htmlEncode(value);
    },

    render_optional_remote: function(value, metadata, record) {
	if (!value) {
	    return `- (${gettext('Local')})`;
	}
	return Ext.String.htmlEncode(value);
    },

    tuningOptions: {
	'chunk-order': {
	    '__default__': Proxmox.Utils.defaultText + ` (${gettext('Inode')})`,
	    none: gettext('None'),
	    inode: gettext('Inode'),
	},
	'sync-level': {
	    '__default__': Proxmox.Utils.defaultText + ` (${gettext('Filesystem')})`,
	    none: gettext('None'),
	    file: gettext('File'),
	    filesystem: gettext('Filesystem'),
	},
    },

    render_tuning_options: function(tuning) {
	let options = [];
	let order = tuning['chunk-order'];
	delete tuning['chunk-order'];
	order = PBS.Utils.tuningOptions['chunk-order'][order ?? '__default__'];
	options.push(`${gettext('Chunk Order')}: ${order}`);

	let sync = tuning['sync-level'];
	delete tuning['sync-level'];
	sync = PBS.Utils.tuningOptions['sync-level'][sync ?? '__default__'];
	options.push(`${gettext('Sync Level')}: ${sync}`);

	for (const [k, v] of Object.entries(tuning)) {
	    options.push(`${k}: ${v}`);
	}

	return options.join(', ');
    },
});
Ext.define('PBS.Schema', {

    singleton: true,

    metricServer: {
	'influxdb-http': {
	    type: 'InfluxDB (HTTP)',
	    xtype: 'InfluxDbHttp',
	},
	'influxdb-udp': {
	    type: 'InfluxDB (UDP)',
	    xtype: 'InfluxDbUdp',
	},
    },
});
Ext.define('PBS.form.TokenSelector', {
    extend: 'Proxmox.form.ComboGrid',
    alias: 'widget.pbsTokenSelector',

    allowBlank: false,
    autoSelect: false,
    valueField: 'tokenid',
    displayField: 'tokenid',

    editable: true,
    anyMatch: true,
    forceSelection: true,

    store: {
	model: 'pbs-tokens',
	params: {
	    enabled: 1,
	},
	sorters: 'tokenid',
    },

    initComponent: function() {
	let me = this;
	me.userStore = Ext.create('Ext.data.Store', {
	    model: 'pbs-users-with-tokens',
	});
	me.userStore.on('load', this.onLoad, this);
	me.userStore.load();

	me.callParent();
    },

    onLoad: function(store, data, success) {
	let me = this;
	if (!success) return;

	let tokenStore = this.store;

	let records = [];
	Ext.Array.each(data, function(user) {
	let tokens = user.data.tokens || [];
	Ext.Array.each(tokens, function(token) {
	    let r = {};
	    r.tokenid = token.tokenid;
	    r.comment = token.comment;
	    r.expire = token.expire;
	    r.enable = token.enable;
	    records.push(r);
	});
	});

	tokenStore.loadData(records);
	// we need to re-set the value, ExtJS doesn't knows that we injected data into the store
	me.setValue(me.value);
	me.validate();
    },

    listConfig: {
	width: 500,
	columns: [
	    {
		header: gettext('API Token'),
		sortable: true,
		dataIndex: 'tokenid',
		renderer: Ext.String.htmlEncode,
		flex: 2,
	    },
	    {
		header: gettext('Comment'),
		sortable: false,
		dataIndex: 'comment',
		renderer: Ext.String.htmlEncode,
		flex: 3,
	    },
	],
    },
});
Ext.define('pbs-authids', {
    extend: 'Ext.data.Model',
    fields: [
	'authid', 'comment', 'type',
    ],
    idProperty: 'authid',
});

Ext.define('PBS.form.AuthidSelector', {
    extend: 'Proxmox.form.ComboGrid',
    alias: 'widget.pbsAuthidSelector',

    allowBlank: false,
    autoSelect: false,
    valueField: 'authid',
    displayField: 'authid',

    editable: true,
    anyMatch: true,
    forceSelection: true,

    store: {
	model: 'pbs-authids',
	params: {
	    enabled: 1,
	},
	sorters: 'authid',
    },

    initComponent: function() {
	let me = this;
	me.userStore = Ext.create('Ext.data.Store', {
	    model: 'pbs-users-with-tokens',
	});
	me.userStore.on('load', this.onLoad, this);
	me.userStore.load();

	me.callParent();
    },

    onLoad: function(store, data, success) {
	let me = this;
	if (!success) return;

	let records = [];
	for (const rec of data) {
	    records.push({
		authid: rec.data.userid,
		comment: rec.data.comment,
		type: 'u',
	    });
	    let tokens = rec.data.tokens || [];
	    for (const token of tokens) {
		records.push({
		    authid: token.tokenid,
		    comment: token.comment,
		    type: 't',
		});
	    }
	}

	me.store.loadData(records);
	// we need to re-set the value, ExtJS doesn't knows that we injected data into the store
	me.setValue(me.value);
	me.validate();
    },

    listConfig: {
	width: 500,
	columns: [
	    {
		header: gettext('Type'),
		sortable: true,
		dataIndex: 'type',
		renderer: function(value) {
		    switch (value) {
			case 'u': return gettext('User');
			case 't': return gettext('API Token');
			default: return Proxmox.Utils.unknownText;
		    }
		},
		width: 80,
	    },
	    {
		header: gettext('Auth ID'),
		sortable: true,
		dataIndex: 'authid',
		renderer: Ext.String.htmlEncode,
		flex: 2,
	    },
	    {
		header: gettext('Comment'),
		sortable: false,
		dataIndex: 'comment',
		renderer: Ext.String.htmlEncode,
		flex: 3,
	    },
	],
    },
});

Ext.define('PBS.form.RemoteSelector', {
    extend: 'Proxmox.form.ComboGrid',
    alias: 'widget.pbsRemoteSelector',

    allowBlank: false,
    autoSelect: false,
    valueField: 'name',
    displayField: 'name',

    store: {
	model: 'pmx-remotes',
	autoLoad: true,
	sorters: 'name',
    },

    listConfig: {
	columns: [
	    {
		header: gettext('Remote ID'),
		sortable: true,
		dataIndex: 'name',
		renderer: Ext.String.htmlEncode,
		flex: 1,
	    },
	    {
		header: gettext('Host'),
		sortable: true,
		dataIndex: 'host',
		flex: 1,
	    },
	    {
		header: gettext('Auth ID'),
		sortable: true,
		dataIndex: 'auth-id',
		renderer: Ext.String.htmlEncode,
		flex: 1,
	    },
	],
    },
});
Ext.define('PBS.form.RemoteStoreSelector', {
    extend: 'Proxmox.form.ComboGrid',
    alias: 'widget.pbsRemoteStoreSelector',

    queryMode: 'local',

    valueField: 'store',
    displayField: 'store',
    notFoundIsValid: true,

    matchFieldWidth: false,
    listConfig: {
	loadingText: gettext('Scanning...'),
	width: 350,
	columns: [
	    {
		header: gettext('Datastore'),
		sortable: true,
		dataIndex: 'store',
		renderer: Ext.String.htmlEncode,
		flex: 1,
	    },
	    {
		header: gettext('Comment'),
		dataIndex: 'comment',
		renderer: Ext.String.htmlEncode,
		flex: 1,
	    },
	],
    },

    doRawQuery: function() {
	// do nothing.
    },

    setRemote: function(remote, forceReload = false) {
	let me = this;

	if (!forceReload && me.remote === remote) {
	    return;
	}

	me.remote = remote;

	me.store.removeAll();

	me.setDisabled(false);
	if (!me.firstLoad) {
	    me.clearValue();
	}
	if (me.remote) {
	    me.store.proxy.url = `/api2/json/config/remote/${encodeURIComponent(me.remote)}/scan`;
	    me.store.removeFilter('storeFilter');
	} else {
	    me.store.proxy.url = '/api2/json/admin/datastore';
	    me.store.addFilter({
		filterFn: function(item) {
		    return item.get('store') !== me.datastore;
		},
		id: 'storeFilter',
	    });
	}
	me.store.load();

	me.firstLoad = false;
    },

    initComponent: function() {
	let me = this;

	me.firstLoad = true;

	let store = Ext.create('Ext.data.Store', {
	    fields: ['store', 'comment'],
	    proxy: {
		type: 'proxmox',
		url: '/api2/json/config/remote/' + encodeURIComponent(me.remote) + '/scan',
	    },
	});

	store.sort('store', 'ASC');

	Ext.apply(me, {
	    store: store,
	});

	me.callParent();
    },
});

Ext.define('PBS.form.RemoteNamespaceSelector', {
    extend: 'Proxmox.form.ComboGrid',
    alias: 'widget.pbsRemoteNamespaceSelector',

    queryMode: 'local',

    valueField: 'ns',
    displayField: 'ns',
    emptyText: gettext('Root'),
    notFoundIsValid: true,

    triggers: {
	clear: {
	    cls: 'pmx-clear-trigger',
	    weight: -1,
	    hidden: true,
	    handler: function() {
		this.triggers.clear.setVisible(false);
		this.setValue('');
	    },
	},
    },
    listeners: {
	change: function(field, value) {
	    let canClear = value !== '';
	    field.triggers.clear.setVisible(canClear);
	},
    },


    matchFieldWidth: false,
    listConfig: {
	loadingText: gettext('Scanning...'),
	width: 350,
	columns: [
	    {
		header: gettext('Namespace'),
		sortable: true,
		dataIndex: 'ns',
		renderer: PBS.Utils.render_optional_namespace,
		flex: 1,
	    },
	    {
		header: gettext('Comment'),
		dataIndex: 'comment',
		renderer: Ext.String.htmlEncode,
		flex: 1,
	    },
	],
    },

    doRawQuery: function() {
	// do nothing.
    },

    setRemote: function(remote) {
	let me = this;
	let previousRemote = me.remote;
	if (previousRemote === remote) {
	    return;
	}
	me.remote = remote;

	me.store.removeAll();

	if (previousRemote) {
	    me.setDisabled(true);
	    me.clearValue();
	}
    },

    setRemoteStore: function(remoteStore) {
	let me = this;
	let previousStore = me.remoteStore;
	if (previousStore === remoteStore) {
	    return;
	}
	me.remoteStore = remoteStore;

	me.store.removeAll();

	if (me.remote && me.remoteStore) {
	    me.setDisabled(false);
	    if (!me.firstLoad) {
		me.clearValue();
	    }
	    let encodedRemote = encodeURIComponent(me.remote);
	    let encodedStore = encodeURIComponent(me.remoteStore);

	    me.store.proxy.url = `/api2/json/config/remote/${encodedRemote}/scan/${encodedStore}/namespaces`;
	    me.store.load();

	    me.firstLoad = false;
	} else if (me.remoteStore) {
	    me.setDisabled(false);
	    if (!me.firstLoad) {
		me.clearValue();
	    }
	    let encodedStore = encodeURIComponent(me.remoteStore);

	    me.store.proxy.url = `/api2/json/admin/datastore/${encodedStore}/namespace`;
	    me.store.load();

	    me.firstLoad = false;
	} else if (previousStore) {
	    me.setDisabled(true);
	    me.clearValue();
	}
    },

    initComponent: function() {
	let me = this;

	me.firstLoad = true;

	let store = Ext.create('Ext.data.Store', {
	    fields: ['ns', 'comment'],
	    proxy: {
		type: 'proxmox',
		url: `/api2/json/config/remote/${encodeURIComponent(me.remote)}/scan`,
	    },
	});
	store.sort('ns', 'ASC');

	Ext.apply(me, {
	    store: store,
	});

	me.callParent();
    },
});
Ext.define('PBS.form.DataStoreSelector', {
    extend: 'Proxmox.form.ComboGrid',
    alias: 'widget.pbsDataStoreSelector',

    allowBlank: false,
    autoSelect: false,
    valueField: 'store',
    displayField: 'store',

    store: {
	model: 'pbs-datastore-list',
	autoLoad: true,
	sorters: 'store',
    },

    listConfig: {
	columns: [
	    {
		header: gettext('Datastore'),
		sortable: true,
		dataIndex: 'store',
		renderer: (v, metaData, rec) => {
		    let icon = '';
		    if (rec.data?.maintenance) {
			let tip = Ext.String.htmlEncode(PBS.Utils.renderMaintenance(rec.data?.maintenance));
			icon = ` <i data-qtip="${tip}" class="fa fa-wrench"></i>`;
		    }
		    return Ext.String.htmlEncode(v) + icon;
		},
		flex: 1,
	    },
	    {
		header: gettext('Comment'),
		sortable: true,
		dataIndex: 'comment',
		renderer: Ext.String.htmlEncode,
		flex: 1,
	    },
	],
    },
});
Ext.define('pbs-namespaces', {
    extend: 'Ext.data.Model',
    fields: [
	{
	    name: 'ns',
	},
	{
	    name: 'id', // fake as else the model messes with our value and/or display...
	    type: 'string',
	    calculate: data => data.ns === '' ? '/' : data.ns,
	},
    ],
    idProperty: 'id',
});

Ext.define('PBS.form.NamespaceSelector', {
    extend: 'Ext.form.field.ComboBox',
    alias: 'widget.pbsNamespaceSelector',

    allowBlank: true,
    autoSelect: true,
    valueField: 'ns',

    displayField: 'ns',
    emptyText: gettext('Root'),

    editable: true,
    anyMatch: true,
    forceSelection: true,
    queryMode: 'local',

    matchFieldWidth: false,
    listConfig: {
	minWidth: 170,
	maxWidth: 500,
	// below doesn't work :/
	minHeight: 30,
	emptyText: `<div class="x-grid-empty">${gettext('No namespaces accessible.')}</div>`,
    },

    triggers: {
	clear: {
	    cls: 'pmx-clear-trigger',
	    weight: -1,
	    hidden: true,
	    handler: function() {
		this.triggers.clear.setVisible(false);
		this.setValue('');
	    },
	},
    },

    listeners: {
	change: function(field, value) {
	    let canClear = value !== '';
	    field.triggers.clear.setVisible(canClear);
	},
    },

    setDatastore: function(datastore) {
	let me = this;
	if (datastore ?? false) {
	    me.datastore = datastore;
	    me.store.getProxy().setUrl(`/api2/json/admin/datastore/${me.datastore}/namespace`);
	    if (me.isDisabled()) {
		me.setDisabled(false);
	    }
	    me.store.load();
	    me.validate();
	} else {
	    me.datastore = undefined;
	    me.setDisabled(true);
	}
    },

    initComponent: function() {
	let me = this;
	if (!me.datastore) {
	    me.disabled = true;
	}

	me.store = Ext.create('Ext.data.Store', {
	    model: 'pbs-namespaces',
	    autoLoad: !!me.datastore,
	    filters: (rec) => rec.data.ns !== '',
	    proxy: {
		type: 'proxmox',
		timeout: 30 * 1000,
		url: `/api2/json/admin/datastore/${me.datastore}/namespace`,
	    },
	});

	me.callParent();
    },
});
Ext.define('PBS.form.NamespaceMaxDepth', {
    extend: 'Proxmox.form.field.Integer',
    alias: 'widget.pbsNamespaceMaxDepth',

    allowBlank: true,

    emptyText: gettext('Full'),
    fieldLabel: gettext('Max. Depth'),
    deleteEmpty: true,

    minValue: 0,
    maxValue: 7,

    triggers: {
	clear: {
	    cls: 'pmx-clear-trigger',
	    weight: -1,
	    hidden: true,
	    handler: function() {
		this.triggers.clear.setVisible(false);
		this.setValue('');
	    },
	},
    },

    listeners: {
	change: function(field, value) {
	    let canClear = value !== '';
	    field.triggers.clear.setVisible(canClear);
	},
    },
});

Ext.define('PBS.form.NamespaceMaxDepthReduced', {
    extend: 'PBS.form.NamespaceMaxDepth',
    alias: 'widget.pbsNamespaceMaxDepthReduced',

    calcMaxPrefixLength: function(ns1, ns2) {
	let maxPrefixLength = 0;
	if (ns1 !== undefined && ns1 !== null && typeof ns1 === 'string') {
	    maxPrefixLength = (ns1.match(/[/]/g) || []).length + (ns1 === '' ? 0 : 1);
	}
	if (ns2 !== undefined && ns2 !== null && typeof ns2 === 'string') {
	    let ns2PrefixLength = (ns2.match(/[/]/g) || []).length + (ns2 === '' ? 0 : 1);
	    if (ns2PrefixLength > maxPrefixLength) {
		maxPrefixLength = ns2PrefixLength;
	    }
	}
	return maxPrefixLength;
    },

    setLimit: function(ns1, ns2) {
	let me = this;
	let maxPrefixLength = me.calcMaxPrefixLength(ns1, ns2);
	if (maxPrefixLength !== undefined) {
	    me.maxValue = 7 - maxPrefixLength;
	} else {
	    me.maxValue = 7;
	}
    },
});
Ext.define('PBS.data.CalendarEventExamples', {
    extend: 'Ext.data.Store',
    alias: 'store.calendarEventExamples',

    field: ['value', 'text'],
    data: [
	{ value: '*:0/30', text: Ext.String.format(gettext("Every {0} minutes"), 30) },
	{ value: 'hourly', text: gettext("Every hour") },
	{ value: '0/2:00', text: gettext("Every two hours") },
	{ value: '2,22:30', text: gettext("Every day") + " 02:30, 22:30" },
	{ value: '21:00', text: gettext("Every day") + " 21:00" },
	{ value: 'daily', text: gettext("Every day") + " 00:00" },
	{ value: 'mon..fri 00:00', text: gettext("Monday to Friday") + " 00:00" },
	{ value: 'mon..fri *:00', text: gettext("Monday to Friday") + ', ' + gettext("hourly") },
	{ value: 'sat 18:15', text: gettext("Every Saturday") + " 18:15" },
	{ value: 'monthly', text: gettext("Every first day of the Month") + " 00:00" },
	{ value: 'sat *-1..7 02:00', text: gettext("Every first Saturday of the month") + " 02:00" },
	{ value: 'yearly', text: gettext("First day of the year") + " 00:00" },
    ],
});

Ext.define('PBS.form.CalendarEvent', {
    extend: 'Ext.form.field.ComboBox',
    xtype: 'pbsCalendarEvent',

    editable: true,

    valueField: 'value',
    queryMode: 'local',

    matchFieldWidth: false,

    config: {
	deleteEmpty: true,
    },
    // override framework function to implement deleteEmpty behaviour
    getSubmitData: function() {
	let me = this, data = null;
	if (!me.disabled && me.submitValue) {
	    let val = me.getSubmitValue();
	    if (val !== null && val !== '' && val !== '__default__') {
		data = {};
		data[me.getName()] = val;
	    } else if (me.getDeleteEmpty()) {
		data = {};
		data.delete = me.getName();
	    }
	}
	return data;
    },

    triggers: {
	clear: {
	    cls: 'pmx-clear-trigger',
	    weight: -1,
	    hidden: true,
	    handler: function() {
		this.triggers.clear.setVisible(false);
		this.setValue('');
	    },
	},
    },

    listeners: {
	change: function(field, value) {
	    let canClear = (value ?? '') !== '';
	    field.triggers.clear.setVisible(canClear);
	},
    },

    store: {
	type: 'calendarEventExamples',
    },

    tpl: [
	'<ul class="x-list-plain"><tpl for=".">',
	    '<li role="option" class="x-boundlist-item">{text}</li>',
	'</tpl></ul>',
    ],

    displayTpl: [
	'<tpl for=".">',
	'{value}',
	'</tpl>',
    ],
});
Ext.define('PBS.data.PermissionPathsStore', {
    extend: 'Ext.data.Store',
    alias: 'store.pbsPermissionPaths',
    fields: ['value'],
    autoLoad: false,
    data: [
	{ 'value': '/' },
	{ 'value': '/access' },
	{ 'value': '/access/acl' },
	{ 'value': '/access/users' },
	{ 'value': '/access/domains' },
	{ 'value': '/access/openid' },
	{ 'value': '/datastore' },
	{ 'value': '/remote' },
	{ 'value': '/system' },
	{ 'value': '/system/certificates' },
	{ 'value': '/system/disks' },
	{ 'value': '/system/log' },
	{ 'value': '/system/network' },
	{ 'value': '/system/network/dns' },
	{ 'value': '/system/network/interfaces' },
	{ 'value': '/system/notifications' },
	{ 'value': '/system/services' },
	{ 'value': '/system/status' },
	{ 'value': '/system/tasks' },
	{ 'value': '/system/time' },
	{ 'value': '/tape' },
	{ 'value': '/tape/device' },
	{ 'value': '/tape/pool' },
	{ 'value': '/tape/job' },
    ],

    constructor: function(config) {
	let me = this;

	config = config || {};
	me.callParent([config]);

	// TODO: this is but a HACK until we have some sort of resource storage like PVE
	let datastores = Ext.data.StoreManager.lookup('pbs-datastore-list');

	if (datastores) {
	    let donePaths = {};
	    me.suspendEvents();
	    datastores.each(function(record) {
		let path = `/datastore/${record.data.store}`;
		if (path !== undefined && !donePaths[path]) {
		    me.add({ value: path });
		    donePaths[path] = 1;
		}
	    });
	    me.resumeEvents();

	    if (me.datastore) {
		me.setDatastore(me.datastore);
	    }

	    me.fireEvent('refresh', me);
	    me.fireEvent('datachanged', me);
	}

	me.sort({
	    property: 'value',
	    direction: 'ASC',
	});
	me.initialized = true;
    },

    setDatastore: async function(datastore) {
	let me = this;
	if (!datastore) {
	    me.clearFilter();
	    return;
	}
	let url = `/api2/extjs/admin/datastore/${datastore}/namespace?max-depth=7`;
	let { result: { data: ns } } = await Proxmox.Async.api2({ url });
	// TODO: remove "old" datastore's ns paths?
	if (ns.length > 0) {
	    if (me.initialized) {
		me.suspendEvents();
	    }
	    for (const item of ns) {
		if (item.ns !== '') {
		    me.add({ value: `/datastore/${datastore}/${item.ns}` });
		}
	    }
	    if (me.initialized) {
		me.resumeEvents();
		me.fireEvent('refresh', me);
		me.fireEvent('datachanged', me);
	    }
	}
	me.filter(item => item.get('value')?.startsWith(`/datastore/${datastore}`));
    },
});

Ext.define('PBS.form.PermissionPathSelector', {
    extend: 'Ext.form.field.ComboBox',
    xtype: 'pbsPermissionPathSelector',
    mixins: ['Proxmox.Mixin.CBind'],

    config: {
	datastore: null, // set to filter by a datastore, could be also made generic path
    },

    setDatastore: function(datastore) {
	let me = this;
	if (me.datastore === datastore) {
	    return;
	}
	me.datastore = datastore;
	let store = me.getStore();
	if (!me.rendered) {
	    if (store) {
		store.datastore = datastore;
	    }
	} else {
	    store.setDatastore(datastore);
	}
    },

    valueField: 'value',
    displayField: 'value',
    cbind: {
	typeAhead: '{editable}',
    },
    anyMatch: true,
    queryMode: 'local',

    store: {
	type: 'pbsPermissionPaths',
    },
    regexText: gettext('Invalid permission path.'),
    regex: /\/((access|datastore|remote|system)\/.*)?/,
});
Ext.define('pbs-partition-list', {
    extend: 'Ext.data.Model',
    fields: ['name', 'uuid', 'filesystem', 'devpath', 'size', 'model'],
    proxy: {
	type: 'proxmox',
	url: "/api2/json/nodes/localhost/disks/list?skipsmart=1&include-partitions=1",
	reader: {
	    transform: ({ data }) => data
		.flatMap(disk =>
		    (disk.partitions.map(part => ({ ...part, model: disk.model })) ?? [])
		        .filter(partition => partition.used === 'filesystem' && !!partition.uuid),
		),
	},
    },
    idProperty: 'devpath',

});

Ext.define('PBS.form.PartitionSelector', {
    extend: 'Proxmox.form.ComboGrid',
    alias: 'widget.pbsPartitionSelector',

    allowBlank: false,
    autoSelect: false,
    submitEmpty: false,
    valueField: 'uuid',
    displayField: 'devpath',

    store: {
	model: 'pbs-partition-list',
	autoLoad: true,
	sorters: 'devpath',
    },
    getSubmitData: function() {
	let me = this;
	let data = null;
	if (!me.disabled && me.submitValue && !me.isFileUpload()) {
	    let val = me.getSubmitValue();
	    if (val !== undefined && val !== null && val !== '') {
		data = {};
		data[me.getName()] = val;
	    } else if (me.getDeleteEmpty()) {
		data = {};
		data.delete = me.getName();
	    }
	}
	return data;
    },
    listConfig: {
	columns: [
	    {
		header: gettext('Path'),
		sortable: true,
		dataIndex: 'devpath',
		renderer: (v, metaData, rec) => Ext.String.htmlEncode(v),
		flex: 1,
	    },
	    {
		header: gettext('Filesystem'),
		sortable: true,
		dataIndex: 'filesystem',
		flex: 1,
	    },
	    {
		header: gettext('Size'),
		sortable: true,
		dataIndex: 'size',
		renderer: Proxmox.Utils.format_size,
		flex: 1,
	    },
	    {
		header: gettext('Model'),
		sortable: true,
		dataIndex: 'model',
		flex: 1,
	    },
	],
	viewConfig: {
	    emptyText: 'No usable partitions present',
	},
    },
});
Ext.define('pbs-groups', {
    extend: 'Ext.data.Model',
    fields: [
	'backup-type',
	'backup-id',
	{
	    name: 'group',
	    type: 'string',
	    convert: function(value, record) {
		if (record.data['backup-type'] && record.data['backup-id']) {
		    return `${record.data['backup-type']}/${record.data['backup-id']}`;
		}
		return value;
	    },
	},
    ],
    proxy: {
	type: 'proxmox',
    },
});

Ext.define('PBS.form.GroupSelector', {
    extend: 'Proxmox.form.ComboGrid',
    alias: 'widget.pbsGroupSelector',
    mixins: ['Proxmox.Mixin.CBind'],

    allowBlank: false,
    autoSelect: false,
    notFoundIsValid: true,
    editable: true,
    valueField: 'group',
    displayField: 'group',

    store: {
	sorters: 'group',
	model: 'pbs-groups',
    },

    listConfig: {
	minHeight: 80,
	emptyText: gettext('No Groups'),
	viewConfig: {
	    deferEmptyText: false,
	},
	columns: [
	    {
		header: gettext('Group'),
		sortable: true,
		dataIndex: 'group',
		renderer: Ext.String.htmlEncode,
		flex: 1,
	    },
	],
    },
});
Ext.define('PBS.form.GroupFilter', {
    extend: 'Ext.form.FieldContainer',
    alias: 'widget.pbsGroupFilter',
    mixins: ['Proxmox.Mixin.CBind'],

    cindData: {},

    controller: {
	xclass: 'Ext.app.ViewController',

	removeReferences: function(record) {
	    for (const widget of Object.keys(record.widgets || {})) {
		delete record.widgets[widget].record;
		delete record.widgets[widget];
	    }

	    delete record.widgets;
	},

	cleanupReferences: function(grid) {
	    let me = this;

	    // break cyclic reference
	    grid.getStore()?.each(me.removeReferences);
	},

	removeFilter: function(field) {
	    let me = this;
	    let record = field.getWidgetRecord();
	    if (record === undefined) {
		// this is sometimes called before a record/column is initialized
		return;
	    }

	    // break cyclic reference
	    me.removeReferences(record);

	    me.lookup('grid-include').getStore().remove(record);
	    me.lookup('grid-exclude').getStore().remove(record);
	    me.updateRealField();
	},

	addIncludeFilter: function() {
	    let me = this;
	    me.lookup('grid-include').getStore().add({ behavior: 'include' });
	    me.updateRealField();
	},

	addExcludeFilter: function() {
	    let me = this;
	    me.lookup('grid-exclude').getStore().add({ behavior: 'exclude' });
	    me.updateRealField();
	},


	onBehaviorChange: function(field, value) {
	    let me = this;
	    let record = field.getWidgetRecord();
	    if (record === undefined) {
		return;
	    }

	    record.set('behavior', value);
	    record.commit();
	    if (record.widgets) {
		me.setInputValue(record.widgets, record);
	    }
	    me.updateRealField();
	},

	onTypeChange: function(field, value) {
	    let me = this;
	    let record = field.getWidgetRecord();
	    if (record === undefined) {
		return;
	    }

	    record.set('type', value);
	    record.commit();
	    if (record.widgets) {
		me.setInputValue(record.widgets, record);
	    }
	    me.updateRealField();
	},

	onInputChange: function(field, value) {
	    let me = this;
	    if (value === null) {
		return;
	    }
	    let record = field.record;
	    if (record === undefined) {
		// this is sometimes called before a record/column is initialized
		return;
	    }
	    record.set('input', value);
	    record.commit();

	    me.updateRealField();
	},

	parseGroupFilter: function(filter) {
	    let [, behavior, type, input] = filter.match(/^(?:(exclude|include):)?(type|group|regex):(.*)$/);
	    if (behavior === undefined) {
		behavior = "include";
	    }
	    return {
		behavior,
		type,
		input,
	    };
	},

	onValueChange: function(field, values) {
	    let me = this;
	    let grid_include = me.lookup('grid-include');
	    let grid_exclude = me.lookup('grid-exclude');
	    if (!values || values.length === 0) {
		grid_include.getStore().removeAll();
		grid_exclude.getStore().removeAll();
		return;
	    }
	    let records = values.map((filter) => me.parseGroupFilter(filter));
	    grid_include.getStore().setData(records);
	    grid_exclude.getStore().setData(records);
	},

	setInputValue: function(widgets, rec) {
	    let { type, regex, group } = widgets;

	    type.setHidden(true);
	    type.setDisabled(true);
	    type.setValue(undefined);

	    regex.setHidden(true);
	    regex.setDisabled(true);
	    regex.setValue(undefined);

	    group.setHidden(true);
	    group.setDisabled(true);
	    group.setValue(undefined);

	    let field;
	    if (rec.data.type === 'type') {
		field = type;
	    } else if (rec.data.type === 'regex') {
		field = regex;
	    } else if (rec.data.type === 'group') {
		field = group;
	    } else {
		return;
	    }

	    field.setHidden(false);
	    field.setDisabled(false);
	    field.setValue(rec.data.input);
	},

	newInputColumn: function(col, widget, rec) {
	    let me = this;
	    let view = me.getView();

	    let type = widget.down('pbsGroupTypeSelector');
	    let regex = widget.down('textfield[type=regex]');
	    let group = widget.down('pbsGroupSelector');

	    // cannot reuse the same store for all group selectors due to combo grid limitations,
	    // and just setting the data directly makes trouble due to Ext.util.Collection and its
	    // observers behavior, so, lets do a manual full-clone
	    let recs = [];
	    view.dsStore.each(record => recs.push(record.data));
	    group.getStore().setData(recs);

	    // add a widget reference to the record so we can access them from the other column
	    rec.widgets = {
		type,
		regex,
		group,
	    };

	    // add a record reference so we can access the record from the change handler
	    type.record = rec;
	    regex.record = rec;
	    group.record = rec;

	    // CAUTION: we just created a cyclic reference, we have to delete that on filter removal!

	    me.setInputValue(rec.widgets, rec);
	},

	updateRealField: function() {
	    let me = this;

	    let filter = [];
	    me.lookup('grid-include').getStore().each((rec) => {
	    if (rec.data.type && rec.data.input) {
		filter.push(`${rec.data.type}:${rec.data.input}`);
		}
	    });
	    me.lookup('grid-exclude').getStore().each((rec) => {
		if (rec.data.type && rec.data.input && rec.data.behavior) {
		    let behavior_string = '';
		    if (rec.data.behavior === 'exclude') {
			behavior_string = 'exclude:';
		    }
		    filter.push(`${behavior_string}${rec.data.type}:${rec.data.input}`);
		}
	    });

	    let field = me.lookup('realfield');
	    field.suspendEvent('change');
	    field.setValue(filter);
	    field.resumeEvent('change');
	},

	control: {
	    'grid pbsGroupBehaviorSelector': {
		change: 'onBehaviorChange',
	    },
	    'grid pbsGroupFilterTypeSelector': {
		change: 'onTypeChange',
	    },
	    'grid fieldcontainer field': {
		change: 'onInputChange',
	    },
	    'grid button': {
		click: 'removeFilter',
	    },
	    'field[reference=realfield]': {
		change: 'onValueChange',
	    },
	    'grid': {
		beforedestroy: 'cleanupReferences',
	    },
	},
    },

    onDestroy: function() {
	let me = this;

	me.dsStore.destroy();
	delete me.dsStore;
    },

    setDsStoreUrl: function(url) {
	let me = this;
	me.dsStore.getProxy().setUrl(url);
    },

    updateGroupSelectors: function() {
	let me = this;
	let url;
	if (me.remote) {
	    url = `/api2/json/config/remote/${me.remote}/scan/${me.datastore}/groups`;
	    if (me.namespace) {
		url += `?namespace=${me.namespace}`;
	    }
	} else if (me.datastore) {
	    url = `/api2/json/admin/datastore/${me.datastore}/groups`;
	    if (me.namespace) {
		url += `?ns=${me.namespace}`;
	    }
	} else {
	    return;
	}
	me.setDsStoreUrl(url);
	me.dsStore.load({
	    callback: (records) => {
		if (me.isDestroyed) {
		    return;
		}
		let groups = records || [];
		me.query('pbsGroupSelector').forEach(el => el.getStore().setData(groups));
	    },
	});
    },

    setLocalDatastore: function(datastore) {
	let me = this;
	if (me.remote === undefined && me.datastore === datastore) {
	    return;
	}
	me.remote = undefined;
	me.datastore = datastore;
	me.namespace = undefined;
	me.updateGroupSelectors();
    },

    setLocalNamespace: function(datastore, namespace) {
	let me = this;
	if (me.datastore === datastore && me.namespace === namespace) {
	    return;
	}
	me.remote = undefined;
	me.datastore = datastore;
	me.namespace = namespace;
	me.updateGroupSelectors();
    },

    setRemoteDatastore: function(remote, datastore) {
	let me = this;
	if (me.remote === remote && me.datastore === datastore && me.namespace === undefined) {
	    return;
	}
	me.remote = remote;
	me.datastore = datastore;
	me.namespace = undefined;
	me.updateGroupSelectors();
    },

    setRemoteNamespace: function(remote, datastore, namespace) {
	let me = this;
	if (me.remote === remote && me.datastore === datastore && me.namespace === namespace) {
	    return;
	}
	me.remote = remote;
	me.datastore = datastore;
	me.namespace = namespace;
	me.updateGroupSelectors();
    },

    items: [
	{
	    xtype: 'pbsGroupFilterGrid',
	    title: 'Include filters',
	    margin: '0 0 5 0',
	    reference: 'grid-include',
	    store: {
		filters: [
		    function(item) {
                    return item.data.behavior === "include";
		    },
		],
            },
	    emptyText: gettext('Include all groups'),
	    viewConfig: {
		deferEmptyText: false,
	    },
	},
	{
	    xtype: 'container',
	    layout: {
		type: 'hbox',
	    },
	    items: [
		{
		    xtype: 'button',
		    text: gettext('Add include'),
		    iconCls: 'fa fa-plus-circle',
		    handler: 'addIncludeFilter',
		},
		{
		    xtype: 'box',
		    flex: 1,
		},
		{
		    xtype: 'box',
		    style: 'margin: 3px 0px;',
		    html: `<span class="pmx-hint">${gettext('Note')}</span>: `
			+ gettext('Filters are additive'),
		},
	    ],
	},
	{
	    xtype: 'pbsGroupFilterGrid',
	    title: 'Exclude filters',
	    margin: '10 0 5 0',
	    reference: 'grid-exclude',
	    store: {
		filters: [
		    function(item) {
                    return item.data.behavior === "exclude";
		    },
		],
            },
	},
	{
	    xtype: 'hiddenfield',
	    reference: 'realfield',
	    setValue: function(value) {
		let me = this;
		me.value = value;
		me.checkChange();
	    },
	    getValue: function() {
		return this.value;
	    },
	    getSubmitValue: function() {
		return this.value;
	    },
	    cbind: {
		name: '{name}',
	    },
	},
	{
	    xtype: 'container',
	    layout: {
		type: 'hbox',
	    },
	    items: [
		{
		    xtype: 'button',
		    text: gettext('Add exclude'),
		    iconCls: 'fa fa-plus-circle',
		    handler: 'addExcludeFilter',
		},
		{
		    xtype: 'box',
		    flex: 1,
		},
		{
		    xtype: 'box',
		    style: 'margin: 3px 0px;',
		    html: `<span class="pmx-hint">${gettext('Note')}</span>: `
			+ gettext('Exclude filters will be applied after include filters'),
		},
	    ],
	},
    ],

    initComponent: function() {
	let me = this;
	me.callParent();
	me.dsStore = Ext.create('Ext.data.Store', {
	    sorters: 'group',
	    model: 'pbs-groups',
	});
    },
});

Ext.define('PBS.form.pbsGroupBehaviorSelector', {
    extend: 'Proxmox.form.KVComboBox',
    alias: 'widget.pbsGroupBehaviorSelector',

    allowBlank: false,

    comboItems: [
	['include', gettext('Include')],
	['exclude', gettext('Exclude')],
    ],
});
Ext.define('PBS.form.GroupFilterGrid', {
    extend: 'Ext.grid.Panel',
    alias: 'widget.pbsGroupFilterGrid',

    scrollable: true,
    height: 200,
    store: {
	fields: ['type', 'input'],
            },
    columns: [
	{
	    text: gettext('Filter Type'),
	    xtype: 'widgetcolumn',
	    dataIndex: 'type',
	    flex: 1,
	    widget: {
		xtype: 'pbsGroupFilterTypeSelector',
		isFormField: false,
	    },
	},
	{
	    text: gettext('Filter Value'),
	    xtype: 'widgetcolumn',
	    flex: 1,
	    onWidgetAttach: 'newInputColumn',
	    widget: {
		padding: 0,
		bodyPadding: 0,
		xtype: 'fieldcontainer',
		layout: 'fit',
		defaults:
		{
		    margin: 0,
		},
		items: [
		    {
			hidden: true,
			xtype: 'pbsGroupTypeSelector',
			isFormField: false,
		    },
		    {
			hidden: true,
			xtype: 'textfield',
			type: 'regex',
			isFormField: false,
		    },
		    {
			hidden: true,
			xtype: 'pbsGroupSelector',
			isFormField: false,
		    },
		],
	    },
	},
	{
	    xtype: 'widgetcolumn',
	    width: 40,
	    widget: {
		xtype: 'button',
		iconCls: 'fa fa-trash-o',
	    },
	},
    ],
});

Ext.define('PBS.form.GroupFilterTypeSelector', {
    extend: 'Proxmox.form.KVComboBox',
    alias: 'widget.pbsGroupFilterTypeSelector',

    allowBlank: false,

    comboItems: [
	['type', gettext('Type')],
	['group', gettext('Group')],
	['regex', gettext('Regex')],
    ],
});

Ext.define('PBS.form.GroupTypeSelector', {
    extend: 'Proxmox.form.KVComboBox',
    alias: 'widget.pbsGroupTypeSelector',

    allowBlank: false,

    comboItems: [
	['vm', gettext('VM')],
	['ct', gettext('CT')],
	['host', gettext('Host')],
    ],
});
Ext.define('PBS.form.VerifyOutdatedAfter', {
    extend: 'Proxmox.form.field.Integer',
    alias: 'widget.pbsVerifyOutdatedAfter',

    name: 'outdated-after',

    minValue: 1,
    value: 30,
    allowBlank: false,

    triggers: {
	clear: {
	    cls: 'pmx-clear-trigger',
	    weight: -1,
	    hidden: false,
	    handler: function() {
		this.triggers.clear.setVisible(false);
		this.setValue('');
	    },
	},
    },

    listeners: {
	change: function(field, value) {
	    let canClear = value !== '';
	    field.triggers.clear.setVisible(canClear);
	},
    },
});

Ext.define('PBS.data.RunningTasksStore', {
    extend: 'Proxmox.data.UpdateStore',

    singleton: true,

    constructor: function(config) {
	let me = this;
	config = config || {};
	Ext.apply(config, {
	    interval: 3000,
	    storeid: 'pbs-running-tasks-dash',
	    model: 'proxmox-tasks',
	    proxy: {
		type: 'proxmox',
		// maybe separate api call?
		url: '/api2/json/nodes/localhost/tasks?running=1&limit=100',
	    },
	});
	me.callParent([config]);
    },
});
Ext.define('PBS.TaskButton', {
    extend: 'Ext.button.Button',
    alias: 'widget.pbsTaskButton',

    config: {
	badgeText: '0',
	badgeCls: '',
    },

    iconCls: 'fa fa-list-alt',
    userCls: 'pmx-has-badge',
    text: gettext('Tasks'),

    setText: function(value) {
	let me = this;
	me.realText = value;
	let badgeText = me.getBadgeText();
	let badgeCls = me.getBadgeCls();
	let text = `${value} <span class="pmx-button-badge ${badgeCls}">${badgeText}</span>`;
	return me.callParent([text]);
    },

    getText: function() {
	let me = this;
	return me.realText;
    },

    setBadgeText: function(value) {
	let me = this;
	me.badgeText = value.toString();
	return me.setText(me.getText());
    },

    setBadgeCls: function(value) {
	let me = this;
	let res = me.callParent([value]);
	let badgeText = me.getBadgeText();
	me.setBadgeText(badgeText);
	return res;
    },

    handler: function() {
	let me = this;
	if (me.grid.isVisible()) {
	    me.grid.setVisible(false);
	} else {
	    me.grid.showBy(me, 'tr-br');
	}
    },

    initComponent: function() {
	let me = this;

	me.grid = Ext.create({
	    xtype: 'pbsRunningTasks',
	    title: '',
	    hideHeaders: false,
	    floating: true,

	    width: 600,

	    bbar: [
		'->',
		{
		    xtype: 'button',
		    text: gettext('Show All Tasks'),
		    handler: function() {
			var mainview = me.up('mainview');
			mainview.getController().redirectTo('pbsServerAdministration:tasks');
			me.grid.hide();
		    },
		},
	    ],

	    listeners: {
		'taskopened': function() {
		    me.grid.hide();
		},
	    },
	});
	me.callParent();
	me.mon(me.grid.getStore().rstore, 'load', function(store, records, success) {
	    if (!success) return;

	    let count = records.length;
	    let text = count > 99 ? '99+' : count.toString();
	    let cls = count > 0 ? 'active': '';
	    me.setBadgeText(text);
	    me.setBadgeCls(cls);
	});
    },
});
Ext.define('PBS.panel.PruneInputPanel', {
    extend: 'Proxmox.panel.InputPanel',
    xtype: 'pbsPruneInputPanel',
    mixins: ['Proxmox.Mixin.CBind'],

    onlineHelp: 'maintenance_pruning',

    // show/hide dry-run field  FIXME: rename to canDryrun, this is confusing..
    dryrun: false,

    canRecurse: false, // show a recursive/max-depth field

    cbindData: function() {
	let me = this;
	me.isCreate = !!me.isCreate;
	return {
	    ns: me.ns ?? '',
	};
    },

    viewModel: {
	data: { canRecurse: false },
    },

    onGetValues: function(values) {
	let me = this;
	if (me.ns && me.ns !== '') {
	    values.ns = me.ns;
	}
	if (!values.recursive && me.canRecurse) {
	    values['max-depth'] = 0;
	}
	delete values.recursive;
	return values;
    },

    column1: [
	{
	    xtype: 'pbsPruneKeepInput',
	    name: 'keep-last',
	    fieldLabel: gettext('Keep Last'),
	    cbind: {
		deleteEmpty: '{!isCreate}',
	    },
	},
	{
	    xtype: 'pbsPruneKeepInput',
	    name: 'keep-daily',
	    fieldLabel: gettext('Keep Daily'),
	    cbind: {
		deleteEmpty: '{!isCreate}',
	    },
	},
	{
	    xtype: 'pbsPruneKeepInput',
	    name: 'keep-monthly',
	    fieldLabel: gettext('Keep Monthly'),
	    cbind: {
		deleteEmpty: '{!isCreate}',
	    },
	},
	{
	    xtype: 'proxmoxcheckbox',
	    name: 'dry-run',
	    fieldLabel: gettext('Dry Run'),
	    cbind: {
		hidden: '{!dryrun}',
		disabled: '{!dryrun}',
	    },
	},
    ],
    column2: [
	{
	    xtype: 'pbsPruneKeepInput',
	    fieldLabel: gettext('Keep Hourly'),
	    name: 'keep-hourly',
	    cbind: {
		deleteEmpty: '{!isCreate}',
	    },
	},
	{
	    xtype: 'pbsPruneKeepInput',
	    name: 'keep-weekly',
	    fieldLabel: gettext('Keep Weekly'),
	    cbind: {
		deleteEmpty: '{!isCreate}',
	    },
	},
	{
	    xtype: 'pbsPruneKeepInput',
	    name: 'keep-yearly',
	    fieldLabel: gettext('Keep Yearly'),
	    cbind: {
		deleteEmpty: '{!isCreate}',
	    },
	},
	{
	    xtype: 'fieldcontainer',
	    layout: 'hbox',
	    fieldLabel: gettext('Recursive'),
	    cbind: {
		hidden: '{!canRecurse}',
		disabled: '{!canRecurse}',
	    },
	    items: [
		{
		    xtype: 'proxmoxcheckbox',
		    name: 'recursive',
		    uncheckedValue: false,
		    value: true,
		    bind: {
			value: '{canRecurse}',
		    },
		},
		{
		    xtype: 'pbsNamespaceMaxDepth',
		    name: 'max-depth',
		    padding: '0 0 0 5',
		    labelWidth: 75,
		    deleteEmpty: false,
		    bind: {
			disabled: '{!canRecurse}',
		    },
		    flex: 1,
		},
	    ],
	},
    ],
});
Ext.define('pmx-users', {
    extend: 'Ext.data.Model',
    fields: [
	'userid', 'firstname', 'lastname', 'email', 'comment', 'totp-locked',
	{ type: 'boolean', name: 'enable', defaultValue: true },
	{ type: 'date', dateFormat: 'timestamp', name: 'expire' },
    ],
    idProperty: 'userid',
    proxy: {
	type: 'proxmox',
	url: '/api2/json/access/users',
    },
});

Ext.define('PBS.config.UserView', {
    extend: 'Ext.grid.GridPanel',
    alias: 'widget.pbsUserView',

    stateful: true,
    stateId: 'grid-users',

    title: gettext('Users'),

    controller: {
	xclass: 'Ext.app.ViewController',

	addUser: function() {
	    let me = this;
            Ext.create('PBS.window.UserEdit', {
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
            }).show();
	},

	editUser: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (selection.length < 1) return;

            Ext.create('PBS.window.UserEdit', {
                userid: selection[0].data.userid,
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
            }).show();
	},

	setPassword: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();

	    if (selection.length < 1) return;

	    Ext.create('Proxmox.window.PasswordEdit', {
		userid: selection[0].data.userid,
		confirmCurrentPassword: Proxmox.UserName !== 'root@pam',
		minLength: 8,
	    }).show();
	},

	showPermissions: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();

	    if (selection.length < 1) return;

	    Ext.create('Proxmox.PermissionView', {
		auth_id: selection[0].data.userid,
		auth_id_name: 'auth-id',
	    }).show();
	},

	renderName: function(val, cell, rec) {
	    let name = [];
	    if (rec.data.firstname) {
		name.push(rec.data.firstname);
	    }
	    if (rec.data.lastname) {
		name.push(rec.data.lastname);
	    }
	    return name.join(' ');
	},

	renderUsername: function(userid) {
	    return Ext.String.htmlEncode(userid.match(/^(.+)@([^@]+)$/)[1]);
	},

	renderRealm: function(userid) {
	    return Ext.String.htmlEncode(userid.match(/^(.+)@([^@]+)$/)[2]);
	},

	reload: function() { this.getView().getStore().rstore.load(); },

	init: function(view) {
	    Proxmox.Utils.monStoreErrors(view, view.getStore().rstore);
	},

	unlockTfa: function(btn, event, rec) {
	    let me = this;
	    let view = me.getView();
	    Ext.Msg.confirm(
		Ext.String.format(gettext('Unlock TFA authentication for {0}'), rec.data.userid),
		gettext("Locked 2nd factors can happen if the user's password was leaked. Are you sure you want to unlock the user?"),
		function(btn_response) {
		    if (btn_response === 'yes') {
			Proxmox.Utils.API2Request({
			    url: `/access/users/${rec.data.userid}/unlock-tfa`,
			    waitMsgTarget: view,
			    method: 'PUT',
			    failure: function(response, options) {
				Ext.Msg.alert(gettext('Error'), response.htmlStatus);
			    },
			    success: function(response, options) {
				me.reload();
			    },
			});
		    }
		},
	    );
	},
    },

    listeners: {
	activate: 'reload',
	itemdblclick: 'editUser',
    },

    store: {
	type: 'diff',
	autoDestroy: true,
	autoDestroyRstore: true,
	sorters: 'userid',
	rstore: {
	    type: 'update',
	    storeid: 'pmx-users',
	    model: 'pmx-users',
	    autoStart: true,
	    interval: 5000,
	},
    },

    tbar: [
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Add'),
	    handler: 'addUser',
	    selModel: false,
	},
	'-',
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Edit'),
	    handler: 'editUser',
	    disabled: true,
	},
	{
	    xtype: 'proxmoxStdRemoveButton',
	    baseurl: '/access/users/',
	    enableFn: (rec) => rec.data.userid !== 'root@pam',
	    getUrl: (rec) =>
		`/access/users/${encodeURIComponent(rec.getId())}`,
	    callback: 'reload',
	},
	'-',
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Change Password'),
	    handler: 'setPassword',
	    disabled: true,
	},
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Show Permissions'),
	    handler: 'showPermissions',
	    disabled: true,
	},
	'-',
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Unlock TFA'),
	    handler: 'unlockTfa',
	    disabled: true,
	    enableFn: ({ data }) =>
	        data['totp-locked'] || (data['tfa-locked-until'] > (new Date().getTime() / 1000)),
	},
    ],

    viewConfig: {
	trackOver: false,
    },

    columns: [
	{
	    header: gettext('User name'),
	    width: 200,
	    sortable: true,
	    renderer: 'renderUsername',
	    dataIndex: 'userid',
	},
	{
	    header: gettext('Realm'),
	    width: 100,
	    sortable: true,
	    renderer: 'renderRealm',
	    dataIndex: 'userid',
	},
	{
	    header: gettext('Enabled'),
	    width: 80,
	    sortable: true,
	    renderer: Proxmox.Utils.format_boolean,
	    dataIndex: 'enable',
	},
	{
	    header: gettext('Expire'),
	    width: 80,
	    sortable: true,
	    renderer: Proxmox.Utils.format_expire,
	    dataIndex: 'expire',
	},
	{
	    header: gettext('Name'),
	    width: 150,
	    sortable: true,
	    dataIndex: 'firstname',
	    renderer: 'renderName',
	},
	{
	    header: gettext('TFA Lock'),
	    width: 120,
	    sortable: true,
	    dataIndex: 'totp-locked',
	    renderer: function(v, metaData, record) {
		let locked_until = record.data['tfa-locked-until'];
		if (locked_until !== undefined) {
		    let now = new Date().getTime() / 1000;
		    if (locked_until > now) {
			return gettext('Locked');
		    }
		}

		if (record.data['totp-locked']) {
		    return gettext('TOTP Locked');
		}

		return Proxmox.Utils.noText;
	    },
	},
	{
	    header: gettext('Comment'),
	    sortable: false,
	    renderer: Ext.String.htmlEncode,
	    dataIndex: 'comment',
	    flex: 1,
	},
    ],
});
Ext.define('pbs-tokens', {
    extend: 'Ext.data.Model',
    fields: [
	'tokenid', 'tokenname', 'user', 'comment',
	{ type: 'boolean', name: 'enable', defaultValue: true },
	{ type: 'date', dateFormat: 'timestamp', name: 'expire' },
    ],
    idProperty: 'tokenid',
});

Ext.define('pbs-users-with-tokens', {
    extend: 'Ext.data.Model',
    fields: [
	'userid', 'firstname', 'lastname', 'email', 'comment',
	{ type: 'boolean', name: 'enable', defaultValue: true },
	{ type: 'date', dateFormat: 'timestamp', name: 'expire' },
	'tokens',
    ],
    idProperty: 'userid',
    proxy: {
	type: 'proxmox',
	url: '/api2/json/access/users/?include_tokens=1',
    },
});

Ext.define('PBS.config.TokenView', {
    extend: 'Ext.grid.GridPanel',
    alias: 'widget.pbsTokenView',

    stateful: true,
    stateId: 'grid-tokens',

    title: gettext('API Tokens'),

    controller: {
	xclass: 'Ext.app.ViewController',

	init: function(view) {
	    view.userStore = Ext.create('Proxmox.data.UpdateStore', {
		autoStart: true,
		interval: 5 * 1000,
		storeId: 'pbs-users-with-tokens',
		storeid: 'pbs-users-with-tokens',
		model: 'pbs-users-with-tokens',
	    });
	    view.userStore.on('load', this.onLoad, this);
	    view.on('destroy', view.userStore.stopUpdate);
	    Proxmox.Utils.monStoreErrors(view, view.userStore);
	},

	reload: function() { this.getView().userStore.load(); },

	onLoad: function(store, data, success) {
	    if (!success) return;

	    let tokenStore = this.getView().store.rstore;

	    let records = [];
	    Ext.Array.each(data, function(user) {
		let tokens = user.data.tokens || [];
		Ext.Array.each(tokens, function(token) {
		    let r = {};
		    r.tokenid = token.tokenid;
		    r.comment = token.comment;
		    r.expire = token.expire;
		    r.enable = token.enable;
		    records.push(r);
		});
	    });

	    tokenStore.loadData(records);
	    tokenStore.fireEvent('load', tokenStore, records, true);
	},

	addToken: function() {
	    let me = this;
	    Ext.create('PBS.window.TokenEdit', {
		isCreate: true,
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
	    }).show();
	},

	editToken: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (selection.length < 1) return;
	    Ext.create('PBS.window.TokenEdit', {
		user: PBS.Utils.extractTokenUser(selection[0].data.tokenid),
		tokenname: PBS.Utils.extractTokenName(selection[0].data.tokenid),
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
	    }).show();
	},

	showPermissions: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();

	    if (selection.length < 1) return;

	    Ext.create('Proxmox.PermissionView', {
		auth_id: selection[0].data.tokenid,
		auth_id_name: 'auth-id',
	    }).show();
	},

	renderUser: function(tokenid) {
	    return Ext.String.htmlEncode(PBS.Utils.extractTokenUser(tokenid));
	},

	renderTokenname: function(tokenid) {
	    return Ext.String.htmlEncode(PBS.Utils.extractTokenName(tokenid));
	},

    },

    listeners: {
	activate: 'reload',
	itemdblclick: 'editToken',
    },

    store: {
	type: 'diff',
	autoDestroy: true,
	autoDestroyRstore: true,
	sorters: 'tokenid',
	model: 'pbs-tokens',
	rstore: {
	    type: 'store',
	    proxy: 'memory',
	    storeid: 'pbs-tokens',
	    model: 'pbs-tokens',
	},
    },

    tbar: [
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Add'),
	    handler: 'addToken',
	    selModel: false,
	},
	'-',
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Edit'),
	    handler: 'editToken',
	    disabled: true,
	},
	{
	    xtype: 'proxmoxStdRemoveButton',
	    baseurl: '/access/users/',
	    callback: 'reload',
	    getUrl: function(rec) {
		let tokenid = rec.getId();
		let user = PBS.Utils.extractTokenUser(tokenid);
		let tokenname = PBS.Utils.extractTokenName(tokenid);
		return '/access/users/' + encodeURIComponent(user) + '/token/' + encodeURIComponent(tokenname);
	    },
	},
	'-',
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Show Permissions'),
	    handler: 'showPermissions',
	    disabled: true,
	},
    ],

    viewConfig: {
	trackOver: false,
    },

    columns: [
	{
	    header: gettext('User'),
	    width: 200,
	    sortable: true,
	    renderer: 'renderUser',
	    dataIndex: 'tokenid',
	},
	{
	    header: gettext('Token name'),
	    width: 100,
	    sortable: true,
	    renderer: 'renderTokenname',
	    dataIndex: 'tokenid',
	},
	{
	    header: gettext('Enabled'),
	    width: 80,
	    sortable: true,
	    renderer: Proxmox.Utils.format_boolean,
	    dataIndex: 'enable',
	},
	{
	    header: gettext('Expire'),
	    width: 80,
	    sortable: true,
	    renderer: Proxmox.Utils.format_expire,
	    dataIndex: 'expire',
	},
	{
	    header: gettext('Comment'),
	    sortable: false,
	    renderer: Ext.String.htmlEncode,
	    dataIndex: 'comment',
	    flex: 1,
	},
    ],
});
Ext.define('pmx-remotes', {
    extend: 'Ext.data.Model',
    fields: ['name', 'host', 'port', 'auth-id', 'fingerprint', 'comment',
	{
	    name: 'server',
	    calculate: function(data) {
		let txt = data.host || "localhost";
		let port = data.port || "8007";
		if (port.toString() !== "8007") {
		    if (Proxmox.Utils.IP6_match.test(txt)) {
			txt = `[${txt}]`;
		    }
		    txt += `:${port}`;
		}
		return txt;
	    },
	},
    ],
    idProperty: 'name',
    proxy: {
	type: 'proxmox',
	url: '/api2/json/config/remote',
    },
});

Ext.define('PBS.config.RemoteView', {
    extend: 'Ext.grid.GridPanel',
    alias: 'widget.pbsRemoteView',

    stateful: true,
    stateId: 'grid-remotes',

    title: gettext('Remotes'),

    tools: [PBS.Utils.get_help_tool("backup-remote")],

    controller: {
	xclass: 'Ext.app.ViewController',

	addRemote: function() {
	    let me = this;
            Ext.create('PBS.window.RemoteEdit', {
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
            }).show();
	},

	editRemote: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (selection.length < 1) return;

            Ext.create('PBS.window.RemoteEdit', {
                name: selection[0].data.name,
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
            }).show();
	},

	reload: function() { this.getView().getStore().rstore.load(); },

	init: function(view) {
	    Proxmox.Utils.monStoreErrors(view, view.getStore().rstore);
	},
    },

    listeners: {
	activate: 'reload',
	itemdblclick: 'editRemote',
    },

    store: {
	type: 'diff',
	autoDestroy: true,
	autoDestroyRstore: true,
	sorters: 'name',
	rstore: {
	    type: 'update',
	    storeid: 'pmx-remotes',
	    model: 'pmx-remotes',
	    autoStart: true,
	    interval: 5000,
	},
    },

    tbar: [
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Add'),
	    handler: 'addRemote',
	    selModel: false,
	},
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Edit'),
	    handler: 'editRemote',
	    disabled: true,
	},
	{
	    xtype: 'proxmoxStdRemoveButton',
	    baseurl: '/config/remote',
	    callback: 'reload',
	},
    ],

    viewConfig: {
	trackOver: false,
    },

    columns: [
	{
	    header: gettext('Remote ID'),
	    width: 200,
	    sortable: true,
	    renderer: Ext.String.htmlEncode,
	    dataIndex: 'name',
	},
	{
	    header: gettext('Host'),
	    width: 200,
	    sortable: true,
	    dataIndex: 'server',
	},
	{
	    header: gettext('Auth ID'),
	    width: 200,
	    sortable: true,
	    renderer: Ext.String.htmlEncode,
	    dataIndex: 'auth-id',
	},
	{
	    header: gettext('Fingerprint'),
	    sortable: false,
	    renderer: Ext.String.htmlEncode,
	    dataIndex: 'fingerprint',
	    width: 200,
	},
	{
	    header: gettext('Comment'),
	    sortable: false,
	    renderer: Ext.String.htmlEncode,
	    dataIndex: 'comment',
	    flex: 1,
	},
    ],
});
Ext.define('pmx-traffic-control', {
    extend: 'Ext.data.Model',
    fields: [
	'name', 'rate-in', 'rate-out', 'burst-in', 'burst-out', 'network',
	'timeframe', 'comment', 'cur-rate-in', 'cur-rate-out',
	{
	    name: 'rateInUsed',
	    calculate: d => Proxmox.Utils.size_unit_ratios(d['cur-rate-in'], d['rate-in']),
	},
	{
	    name: 'rateOutUsed',
	    calculate: d => Proxmox.Utils.size_unit_ratios(d['cur-rate-out'], d['rate-out']),
	},
    ],
    idProperty: 'name',
    proxy: {
	type: 'proxmox',
	url: '/api2/json/admin/traffic-control',
    },
});

Ext.define('PBS.config.TrafficControlView', {
    extend: 'Ext.grid.GridPanel',
    alias: 'widget.pbsTrafficControlView',

    stateful: true,
    stateId: 'grid-traffic-control',

    title: gettext('Traffic Control'),

//    tools: [PBS.Utils.get_help_tool("backup-remote")], // TODO!

    controller: {
	xclass: 'Ext.app.ViewController',

	addRemote: function() {
	    let me = this;
            Ext.create('PBS.window.TrafficControlEdit', {
		autoShow: true,
		listeners: {
		    destroy: () => me.reload(),
		},
            });
	},

	editTrafficControl: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (selection.length < 1) return;

	    Ext.create('PBS.window.TrafficControlEdit', {
		name: selection[0].data.name,
		autoShow: true,
		listeners: {
		    destroy: () => me.reload(),
		},
            });
	},

	render_bandwidth: v => v ? Proxmox.Utils.autoscale_size_unit(v) + '/s' : '',

	reload: function() { this.getView().getStore().rstore.load(); },

	init: function(view) {
	    Proxmox.Utils.monStoreErrors(view, view.getStore().rstore);
	},
    },

    listeners: {
	activate: 'reload',
	itemdblclick: 'editTrafficControl',
    },

    store: {
	type: 'diff',
	autoDestroy: true,
	autoDestroyRstore: true,
	sorters: 'name',
	rstore: {
	    type: 'update',
	    storeid: 'pmx-traffic-control',
	    model: 'pmx-traffic-control',
	    autoStart: true,
	    interval: 5000,
	},
    },

    tbar: [
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Add'),
	    handler: 'addRemote',
	    selModel: false,
	},
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Edit'),
	    handler: 'editTrafficControl',
	    disabled: true,
	},
	{
	    xtype: 'proxmoxStdRemoveButton',
	    baseurl: '/config/traffic-control',
	    callback: 'reload',
	},
    ],

    viewConfig: {
	trackOver: false,
    },

    columns: [
	{
	    header: gettext('Rule'),
	    width: 120,
	    sortable: true,
	    renderer: Ext.String.htmlEncode,
	    dataIndex: 'name',
	},
	{
	    header: gettext('Rate In'),
	    width: 120,
	    sortable: true,
	    renderer: 'render_bandwidth',
	    dataIndex: 'rate-in',
	},
	{
	    header: gettext('Rate In Used'),
	    xtype: 'widgetcolumn',
	    dataIndex: 'rateInUsed',
	    //width: 200,
	    flex: 2,
	    widget: {
		xtype: 'progressbarwidget',
		textTpl: '{percent:number("0")}%',
		animate: true,
	    },
	},
	{
	    header: gettext('Rate Out'),
	    width: 120,
	    sortable: true,
	    renderer: 'render_bandwidth',
	    dataIndex: 'rate-out',
	},
	{
	    header: gettext('Rate Out Used'),
	    xtype: 'widgetcolumn',
	    dataIndex: 'rateOutUsed',
	    flex: 2,
	    widget: {
		xtype: 'progressbarwidget',
		textTpl: '{percent:number("0")}%',
		animate: true,
	    },
	},
	{
	    header: gettext('Burst In'),
	    width: 120,
	    sortable: true,
	    renderer: 'render_bandwidth',
	    dataIndex: 'burst-in',
	},
	{
	    header: gettext('Burst Out'),
	    width: 120,
	    sortable: true,
	    renderer: 'render_bandwidth',
	    dataIndex: 'burst-out',
	},
	{
	    header: gettext('Networks'),
	    flex: 3,
	    sortable: true,
	    renderer: Ext.String.htmlEncode,
	    dataIndex: 'network',
	},
	{
	    header: gettext('Timeframes'),
	    sortable: false,
	    renderer: tf => tf ? Ext.String.htmlEncode(tf.join('; ')) : '',
	    dataIndex: 'timeframe',
	    flex: 3,
	},
	{
	    header: gettext('Comment'),
	    sortable: false,
	    renderer: Ext.String.htmlEncode,
	    dataIndex: 'comment',
	    flex: 2,
	},
    ],
});
Ext.define('pmx-acls', {
    extend: 'Ext.data.Model',
    fields: [
	'path', 'ugid', 'ugid_type', 'roleid', 'propagate',
	{
	    name: 'aclid',
	    calculate: function(data) {
		return `${data.path} for ${data.ugid} - ${data.roleid}`;
	    },
	},
    ],
    idProperty: 'aclid',
    proxy: {
	type: 'proxmox',
	url: '/api2/json/access/acl',
    },
});

Ext.define('PBS.config.ACLView', {
    extend: 'Ext.grid.GridPanel',
    alias: 'widget.pbsACLView',

    title: gettext('Permissions'),

    // Show only those permissions, which can affect this and children paths.
    // That means that also higher up, "shorter" paths are included, as those
    // can have a say in the rights on the asked path.
    aclPath: undefined,

    // tell API to only return ACLs matching exactly the aclPath config.
    aclExact: undefined,

    controller: {
	xclass: 'Ext.app.ViewController',

	addUserACL: function() {
	    let me = this;
	    let view = me.getView();
	    Ext.create('PBS.window.ACLEdit', {
		path: view.aclPath,
		aclType: 'user',
		datastore: view.datastore,
		listeners: {
		    destroy: () => me.reload(),
		},
	    }).show();
	},

	addTokenACL: function() {
	    let me = this;
	    let view = me.getView();
	    Ext.create('PBS.window.ACLEdit', {
		path: view.aclPath,
		aclType: 'token',
		datastore: view.datastore,
		listeners: {
		    destroy: () => me.reload(),
		},
	    }).show();
	},


	removeACL: function(btn, event, rec) {
	    let me = this;
	    Proxmox.Utils.API2Request({
		url: '/access/acl',
		method: 'PUT',
		params: {
		    'delete': 1,
		    path: rec.data.path,
		    role: rec.data.roleid,
		    'auth-id': rec.data.ugid,
		},
		callback: function() {
		    me.reload();
		},
		failure: function(response, opts) {
		    Ext.Msg.alert(gettext('Error'), response.htmlStatus);
		},
	    });
	},

	reload: function() { this.getView().getStore().rstore.load(); },

	init: function(view) {
	    let proxy = view.getStore().rstore.getProxy();

	    let params = {};
	    if (typeof view.aclPath === "string") {
		let pathFilter = Ext.create('Ext.util.Filter', {
		    filterPath: view.aclPath,
		    filterAtoms: view.aclPath.split('/'),
		    filterFn: function(item) {
			let me = this;
			let path = item.data.path;
			if (path === "/" || path === me.filterPath) {
			    return true;
			} else if (path.length > me.filterPath.length) {
			    return path.startsWith(me.filterPath + '/');
			}
			let pathAtoms = path.split('/');
			let commonLength = Math.min(pathAtoms.length, me.filterAtoms.length);
			for (let i = 1; i < commonLength; i++) {
			    if (me.filterAtoms[i] !== pathAtoms[i]) {
				return false;
			    }
			}
			return true;
		    },
		});
		view.getStore().addFilter(pathFilter);
	    }
	    if (view.aclExact !== undefined) {
		if (view.aclPath !== undefined) {
		    params.path = view.aclPath;
		}
		params.exact = view.aclExact;
	    }

	    proxy.setExtraParams(params);
	    Proxmox.Utils.monStoreErrors(view, view.getStore().rstore);
	},
	control: {
	    '#': { // view
		activate: function() {
		    this.getView().getStore().rstore.startUpdate();
		},
		deactivate: function() {
		    this.getView().getStore().rstore.stopUpdate();
		},
	    },
	},
    },

    store: {
	type: 'diff',
	autoDestroy: true,
	autoDestroyRstore: true,
	sorters: 'aclid',
	rstore: {
	    type: 'update',
	    storeid: 'pmx-acls',
	    model: 'pmx-acls',
	    interval: 5000,
	},
    },

    tbar: [
	{
	    text: gettext('Add'),
	    menu: {
		xtype: 'menu',
		items: [
		    {
			text: gettext('User Permission'),
			iconCls: 'fa fa-fw fa-user',
			handler: 'addUserACL',
		    },
		    {
			text: gettext('API Token Permission'),
			iconCls: 'fa fa-fw fa-user-o',
			handler: 'addTokenACL',
		    },
		],
	    },
	},
	{
	    xtype: 'proxmoxStdRemoveButton',
	    handler: 'removeACL',
	    callback: 'reload',
	},
    ],

    columns: [
	{
	    header: gettext('Path'),
	    minWidth: 250,
	    flex: 4,
	    sortable: true,
	    renderer: Ext.String.htmlEncode,
	    dataIndex: 'path',
	},
	{
	    header: gettext('User/Group/API Token'),
	    width: 200,
	    sortable: true,
	    renderer: Ext.String.htmlEncode,
	    dataIndex: 'ugid',
	},
	{
	    header: gettext('Role'),
	    width: 200,
	    sortable: true,
	    dataIndex: 'roleid',
	},
	{
	    header: gettext('Propagate'),
	    flex: 9, // last element flex looks better
	    sortable: true,
	    renderer: Proxmox.Utils.format_boolean,
	    dataIndex: 'propagate',
	},
    ],
});
Ext.define('pbs-sync-jobs-status', {
    extend: 'Ext.data.Model',
    fields: [
	'id', 'owner', 'remote', 'remote-store', 'remote-ns', 'store', 'ns',
	'schedule', 'group-filter', 'next-run', 'last-run-upid', 'last-run-state',
	'last-run-endtime', 'transfer-last', 'max-depth',
	{
	    name: 'duration',
	    calculate: function(data) {
		let endtime = data['last-run-endtime'];
		if (!endtime) return undefined;
		let task = Proxmox.Utils.parse_task_upid(data['last-run-upid']);
		return endtime - task.starttime;
	    },
	},
	'comment',
    ],
    idProperty: 'id',
});

Ext.define('PBS.config.SyncJobView', {
    extend: 'Ext.grid.GridPanel',
    alias: 'widget.pbsSyncJobView',
    mixins: ['Proxmox.Mixin.CBind'],

    stateful: true,
    stateId: 'grid-sync-jobs-v1',

    title: gettext('Sync Jobs'),

    controller: {
	xclass: 'Ext.app.ViewController',

	search: function(tf, value) {
	    let me = this;
	    let view = me.getView();
	    let store = view.getStore();
	    if (!value && value !== 0) {
		store.clearFilter();
		tf.triggers.clear.setVisible(false);
		return;
	    }
	    tf.triggers.clear.setVisible(true);
	    if (value.length < 2) return;

	    store.clearFilter();

	    let fieldsToSearch = ['sync-direction', 'id', 'remote', 'remote-store', 'owner'];
	    if (!view.datastore) {
		fieldsToSearch.push('store');
	    }
	    value = value.toLowerCase();


	    store.addFilter(function(rec) {
		let found = false;
		for (const field of fieldsToSearch) {
		    let recValue = rec.data[field] ?? '';
		    if (recValue.toString().toLowerCase().indexOf(value) !== -1) {
			found = true;
			break;
		    }
		}
		return found;
	    });
	},

	addPullSyncJob: function() {
	    this.addSyncJob('pull');
	},

	addPushSyncJob: function() {
	    this.addSyncJob('push');
	},

	addSyncJob: function(syncDirection) {
	    let me = this;
	    let view = me.getView();
            Ext.create('PBS.window.SyncJobEdit', {
		datastore: view.datastore,
		syncDirection,
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
            }).show();
	},

	editSyncJob: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (selection.length < 1) return;

            Ext.create('PBS.window.SyncJobEdit', {
		datastore: view.datastore,
                id: selection[0].data.id,
		syncDirection: selection[0].data['sync-direction'],
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
            }).show();
	},

	openTaskLog: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (selection.length < 1) return;

	    let upid = selection[0].data['last-run-upid'];
	    if (!upid) return;

	    Ext.create('Proxmox.window.TaskViewer', {
		upid,
	    }).show();
	},

	runSyncJob: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (selection.length < 1) return;

	    let id = selection[0].data.id;
	    Proxmox.Utils.API2Request({
		method: 'POST',
		url: `/admin/sync/${id}/run`,
		success: function(response, opt) {
		    Ext.create('Proxmox.window.TaskViewer', {
		        upid: response.result.data,
		        taskDone: function(success) {
			    me.reload();
		        },
		    }).show();
		},
		failure: function(response, opt) {
		    Ext.Msg.alert(gettext('Error'), response.htmlStatus);
		},
	    });
	},

	render_optional_owner: function(value, metadata, record) {
	    if (!value) return '-';
	    return Ext.String.htmlEncode(value);
	},

	startStore: function() { this.getView().getStore().rstore.startUpdate(); },
	stopStore: function() { this.getView().getStore().rstore.stopUpdate(); },

	reload: function() { this.getView().getStore().rstore.load(); },

	init: function(view) {
	    let params = {};
	    if (view.datastore !== undefined) {
		params.store = view.datastore;
	    }
	    params['sync-direction'] = 'all';
	    view.getStore().rstore.getProxy().setExtraParams(params);
	    Proxmox.Utils.monStoreErrors(view, view.getStore().rstore);
	},
    },

    listeners: {
	activate: 'startStore',
	deactivate: 'stopStore',
	itemdblclick: 'editSyncJob',
    },

    store: {
	type: 'diff',
	autoDestroy: true,
	autoDestroyRstore: true,
	sorters: ['store', 'sync-direction', 'id'],
	rstore: {
	    type: 'update',
	    storeid: 'pbs-sync-jobs-status',
	    model: 'pbs-sync-jobs-status',
	    interval: 5000,
	    proxy: {
		type: 'proxmox',
		url: '/api2/json/admin/sync',
	    },
	},
    },

    tbar: [
	{
	    text: gettext('Add'),
	    menu: [
		{
		    text: gettext('Add Pull Sync Job'),
		    iconCls: "fa fa-fw fa-download",
		    handler: 'addPullSyncJob',
		    selModel: false,
		},
		{
		    text: gettext('Add Push Sync Job'),
		    iconCls: "fa fa-fw fa-upload",
		    handler: 'addPushSyncJob',
		    selModel: false,
		},
	    ],
	},
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Edit'),
	    handler: 'editSyncJob',
	    disabled: true,
	},
	{
	    xtype: 'proxmoxStdRemoveButton',
	    baseurl: '/config/sync/',
	    confirmMsg: gettext('Remove entry?'),
	    callback: 'reload',
	},
	'-',
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Show Log'),
	    handler: 'openTaskLog',
	    enableFn: (rec) => !!rec.data['last-run-upid'],
	    disabled: true,
	},
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Run now'),
	    handler: 'runSyncJob',
	    disabled: true,
	},
	'->',
	{
	    xtype: 'tbtext',
	    html: gettext('Search'),
	},
	{
	    xtype: 'textfield',
	    reference: 'searchbox',
	    emptyText: gettext('(remote) store, remote, id, owner, direction'),
	    minWidth: 300,
	    triggers: {
		clear: {
		    cls: 'pmx-clear-trigger',
		    weight: -1,
		    hidden: true,
		    handler: function() {
			this.triggers.clear.setVisible(false);
			this.setValue('');
		    },
		},
	    },
	    listeners: {
		change: {
		    fn: 'search',
		    buffer: 500,
		},
	    },
	},
    ],

    viewConfig: {
	trackOver: false,
    },

    columns: [
	{
	    header: gettext('Job ID'),
	    dataIndex: 'id',
	    renderer: Ext.String.htmlEncode,
	    maxWidth: 220,
	    minWidth: 75,
	    flex: 1,
	    sortable: true,
	},
	{
	    header: gettext('Direction'),
	    dataIndex: 'sync-direction',
	    renderer: function(value) {
		let iconCls, text;
		if (value === 'push') {
		    iconCls = 'upload';
		    text = gettext('Push');
		} else {
		    iconCls = 'download';
		    text = gettext('Pull');
		}
		return `<i class="fa fa-fw fa-${iconCls}"></i> ${text}`;
	    },
	    width: 100,
	    sortable: true,
	},
	{
	    header: gettext('Local Store'),
	    dataIndex: 'store',
	    width: 120,
	    sortable: true,
	},
	{
		header: gettext('Namespace'),
		dataIndex: 'ns',
		width: 120,
		sortable: true,
		renderer: PBS.Utils.render_optional_namespace,
	},
	{
	    header: gettext('Remote ID'),
	    dataIndex: 'remote',
	    width: 120,
	    sortable: true,
	    renderer: PBS.Utils.render_optional_remote,
	},
	{
	    header: gettext('Remote Store'),
	    dataIndex: 'remote-store',
	    width: 120,
	    sortable: true,
	},
	{
	    header: gettext('Remote Namespace'),
	    dataIndex: 'remote-ns',
	    width: 120,
	    sortable: true,
	    renderer: PBS.Utils.render_optional_namespace,
	},
	{
	    header: gettext('Max. Depth'),
	    dataIndex: 'max-depth',
	    width: 100,
	    sortable: true,
	},
	{
	    header: `${gettext('Local Owner/User')} <i class="fa fa-question-circle" data-qtip="
	    ${gettext("Pull: The local owner.")}<br>
	    ${gettext("Push: The local user used for access control.")}
	    "></i>`,
	    dataIndex: 'owner',
	    renderer: 'render_optional_owner',
	    flex: 2,
	    sortable: true,
	},
	{
	    header: gettext('Backup Groups'),
	    dataIndex: 'group-filter',
	    renderer: v => v ? Ext.String.htmlEncode(v) : gettext('All'),
	    width: 80,
	},
	{
	    header: gettext('Transfer Last'),
	    dataIndex: 'transfer-last',
	    flex: 1,
	    sortable: true,
	    hidden: true,
	},
	{
	    header: gettext('Schedule'),
	    dataIndex: 'schedule',
	    maxWidth: 220,
	    minWidth: 80,
	    flex: 1,
	    sortable: true,
	},
	{
	    header: gettext('Last Sync'),
	    dataIndex: 'last-run-endtime',
	    renderer: PBS.Utils.render_optional_timestamp,
	    width: 150,
	    sortable: true,
	},
	{
	    text: gettext('Duration'),
	    dataIndex: 'duration',
	    renderer: Proxmox.Utils.render_duration,
	    width: 80,
	},
	{
	    header: gettext('Status'),
	    dataIndex: 'last-run-state',
	    renderer: PBS.Utils.render_task_status,
	    flex: 3,
	},
	{
	    header: gettext('Next Run'),
	    dataIndex: 'next-run',
	    renderer: PBS.Utils.render_next_task_run,
	    width: 150,
	    sortable: true,
	},
	{
	    header: gettext('Comment'),
	    dataIndex: 'comment',
	    renderer: Ext.String.htmlEncode,
	    flex: 2,
	    sortable: true,
	},
    ],

    initComponent: function() {
	let me = this;
	let hideLocalDatastore = !!me.datastore;

	for (let column of me.columns) {
	    if (column.dataIndex === 'store') {
		column.hidden = hideLocalDatastore;
		break;
	    }
	}

	me.callParent();
    },
});
Ext.define('pbs-verify-jobs-status', {
    extend: 'Ext.data.Model',
    fields: [
	'id', 'store', 'outdated-after', 'ignore-verified', 'schedule',
	'next-run', 'last-run-upid', 'last-run-state', 'last-run-endtime',
	{
	    name: 'duration',
	    calculate: function(data) {
		let endtime = data['last-run-endtime'];
		if (!endtime) return undefined;
		let task = Proxmox.Utils.parse_task_upid(data['last-run-upid']);
		return endtime - task.starttime;
	    },
	},
	'comment',
	'ns',
	'max-depth',
    ],
    idProperty: 'id',
    proxy: {
	type: 'proxmox',
	url: '/api2/json/admin/verify',
    },
});

Ext.define('PBS.config.VerifyJobView', {
    extend: 'Ext.grid.GridPanel',
    alias: 'widget.pbsVerifyJobView',

    stateful: true,
    stateId: 'grid-verify-jobs-v1',

    title: gettext('Verify Jobs'),

    controller: {
	xclass: 'Ext.app.ViewController',

	addVerifyJob: function() {
	    let me = this;
	    let view = me.getView();
	    Ext.create('PBS.window.VerifyJobEdit', {
		datastore: view.datastore,
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
	    }).show();
	},

	editVerifyJob: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (selection.length < 1) return;

	    Ext.create('PBS.window.VerifyJobEdit', {
		datastore: view.datastore,
		id: selection[0].data.id,
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
	    }).show();
	},

	openTaskLog: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (selection.length < 1) return;

	    let upid = selection[0].data['last-run-upid'];
	    if (!upid) return;

	    Ext.create('Proxmox.window.TaskViewer', {
		upid,
	    }).show();
	},

	runVerifyJob: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (selection.length < 1) return;

	    let id = selection[0].data.id;
	    Proxmox.Utils.API2Request({
		method: 'POST',
		url: `/admin/verify/${id}/run`,
		success: function(response, opt) {
		    Ext.create('Proxmox.window.TaskViewer', {
			upid: response.result.data,
			taskDone: function(success) {
			    me.reload();
			},
		    }).show();
		},
		failure: function(response, opt) {
		    Ext.Msg.alert(gettext('Error'), response.htmlStatus);
		},
	    });
	},

	startStore: function() { this.getView().getStore().rstore.startUpdate(); },
	stopStore: function() { this.getView().getStore().rstore.stopUpdate(); },

	reload: function() { this.getView().getStore().rstore.load(); },

	init: function(view) {
	    let params = {};
	    if (view.datastore !== undefined) {
		params.store = view.datastore;
	    }
	    view.getStore().rstore.getProxy().setExtraParams(params);
	    Proxmox.Utils.monStoreErrors(view, view.getStore().rstore);
	},
    },

    listeners: {
	activate: 'startStore',
	deactivate: 'stopStore',
	itemdblclick: 'editVerifyJob',
    },

    store: {
	type: 'diff',
	autoDestroy: true,
	autoDestroyRstore: true,
	sorters: 'id',
	rstore: {
	    type: 'update',
	    storeid: 'pbs-verify-jobs-status',
	    model: 'pbs-verify-jobs-status',
	    interval: 5000,
	},
    },

    tbar: [
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Add'),
	    handler: 'addVerifyJob',
	    selModel: false,
	},
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Edit'),
	    handler: 'editVerifyJob',
	    disabled: true,
	},
	{
	    xtype: 'proxmoxStdRemoveButton',
	    baseurl: '/config/verify/',
	    confirmMsg: gettext('Remove entry?'),
	    callback: 'reload',
	},
	'-',
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Show Log'),
	    handler: 'openTaskLog',
	    enableFn: (rec) => !!rec.data['last-run-upid'],
	    disabled: true,
	},
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Run now'),
	    handler: 'runVerifyJob',
	    disabled: true,
	},
    ],

    viewConfig: {
	trackOver: false,
    },

    columns: [
	{
	    header: gettext('Job ID'),
	    dataIndex: 'id',
	    renderer: Ext.String.htmlEncode,
	    maxWidth: 220,
	    minWidth: 75,
	    flex: 1,
	    sortable: true,
	},
	{
	    header: gettext('Datastore'),
	    dataIndex: 'store',
	    minWidth: 80,
	    flex: 1,
	},
	{
	    header: gettext('Namespace'),
	    dataIndex: 'ns',
	    minWidth: 80,
	    flex: 2,
	    sortable: true,
	    renderer: PBS.Utils.render_optional_namespace,
	},
	{
	    header: gettext('Max. Depth'),
	    dataIndex: 'max-depth',
	    width: 90,
	    sortable: true,
	},
	{
	    header: gettext('Skip Verified'),
	    dataIndex: 'ignore-verified',
	    renderer: Proxmox.Utils.format_boolean,
	    width: 100,
	    sortable: true,
	},
	{
	    header: gettext('Re-Verify After'),
	    dataIndex: 'outdated-after',
	    renderer: v => v ? v +' '+ gettext('Days') : gettext('Never'),
	    width: 125,
	    sortable: true,
	},
	{
	    header: gettext('Schedule'),
	    dataIndex: 'schedule',
	    sortable: true,
	    maxWidth: 220,
	    minWidth: 80,
	    flex: 1,
	},
	{
	    header: gettext('Last Verification'),
	    dataIndex: 'last-run-endtime',
	    renderer: PBS.Utils.render_optional_timestamp,
	    width: 150,
	    sortable: true,
	},
	{
	    text: gettext('Duration'),
	    dataIndex: 'duration',
	    renderer: Proxmox.Utils.render_duration,
	    width: 80,
	},
	{
	    header: gettext('Status'),
	    dataIndex: 'last-run-state',
	    renderer: PBS.Utils.render_task_status,
	    flex: 3,
	},
	{
	    header: gettext('Next Run'),
	    dataIndex: 'next-run',
	    renderer: PBS.Utils.render_next_task_run,
	    width: 150,
	    sortable: true,
	},
	{
	    header: gettext('Comment'),
	    dataIndex: 'comment',
	    renderer: Ext.String.htmlEncode,
	    flex: 2,
	    sortable: true,
	},
    ],

    initComponent: function() {
	let me = this;
	let hideDatastore = !!me.datastore;

	for (let column of me.columns) {
	    if (column.dataIndex === 'store') {
		column.hidden = hideDatastore;
		break;
	    }
	}

	me.callParent();
    },
});
Ext.define('pbs-prune-jobs-status', {
    extend: 'Ext.data.Model',
    fields: [
	'id', 'disable', 'store', 'ns', 'max-depth', 'schedule',
	'keep-last', 'keep-hourly', 'keep-daily', 'keep-weekly', 'keep-monthly', 'keep-yearly',
	'next-run', 'last-run-upid', 'last-run-state', 'last-run-endtime',
	{
	    name: 'duration',
	    calculate: function(data) {
		let endtime = data['last-run-endtime'];
		if (!endtime) return undefined;
		let task = Proxmox.Utils.parse_task_upid(data['last-run-upid']);
		return endtime - task.starttime;
	    },
	},
	'comment',
    ],
    idProperty: 'id',
    proxy: {
	type: 'proxmox',
	url: '/api2/json/admin/prune',
    },
});

Ext.define('PBS.config.PruneJobView', {
    extend: 'Ext.grid.GridPanel',
    alias: 'widget.pbsPruneJobView',

    stateful: true,
    stateId: 'grid-prune-jobs-v1',

    title: gettext('Prune Jobs'),

    controller: {
	xclass: 'Ext.app.ViewController',

	init: function(view) {
	    let params = {};
	    if (view.datastore !== undefined) {
		params.store = view.datastore;
	    }
	    view.getStore().rstore.getProxy().setExtraParams(params);
	    Proxmox.Utils.monStoreErrors(view, view.getStore().rstore);
	},

	addPruneJob: function() {
	    let me = this;
	    let view = me.getView();
            Ext.create('PBS.window.PruneJobEdit', {
		datastore: view.datastore,
		listeners: {
		    destroy: () => me.reload(),
		},
            }).show();
	},

	editPruneJob: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (selection.length < 1) return;

            Ext.create('PBS.window.PruneJobEdit', {
		datastore: view.datastore,
                id: selection[0].data.id,
		listeners: {
		    destroy: () => me.reload(),
		},
            }).show();
	},

	openTaskLog: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (selection.length < 1) return;

	    let upid = selection[0].data['last-run-upid'];
	    if (!upid) return;

	    Ext.create('Proxmox.window.TaskViewer', {
		autoShow: true,
		upid,
	    });
	},

	runPruneJob: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (selection.length < 1) return;

	    let id = selection[0].data.id;
	    Proxmox.Utils.API2Request({
		method: 'POST',
		url: `/admin/prune/${id}/run`,
		success: function(response, opt) {
		    Ext.create('Proxmox.window.TaskViewer', {
			autoShow: true,
		        upid: response.result.data,
		        taskDone: success => me.reload(),
		    });
		},
		failure: response => Ext.Msg.alert(gettext('Error'), response.htmlStatus),
	    });
	},

	startStore: function() { this.getView().getStore().rstore.startUpdate(); },
	stopStore: function() { this.getView().getStore().rstore.stopUpdate(); },
	reload: function() {
	    this.getView().getStore().rstore.load();
	},
    },

    listeners: {
	activate: 'startStore',
	deactivate: 'stopStore',
	itemdblclick: 'editPruneJob',
    },

    store: {
	type: 'diff',
	autoDestroy: true,
	autoDestroyRstore: true,
	sorters: 'id',
	rstore: {
	    type: 'update',
	    storeid: 'pbs-prune-jobs-status',
	    model: 'pbs-prune-jobs-status',
	    interval: 5000,
	},
    },

    tbar: [
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Add'),
	    handler: 'addPruneJob',
	    selModel: false,
	},
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Edit'),
	    handler: 'editPruneJob',
	    disabled: true,
	},
	{
	    xtype: 'proxmoxStdRemoveButton',
	    baseurl: '/config/prune/',
	    confirmMsg: gettext('Remove entry?'),
	    callback: 'reload',
	},
	'-',
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Show Log'),
	    handler: 'openTaskLog',
	    enableFn: (rec) => !!rec.data['last-run-upid'],
	    disabled: true,
	},
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Run now'),
	    handler: 'runPruneJob',
	    disabled: true,
	},
    ],

    viewConfig: {
	trackOver: false,
    },

    columns: [
	{
	    header: gettext('Job ID'),
	    dataIndex: 'id',
	    renderer: Ext.String.htmlEncode,
	    maxWidth: 220,
	    minWidth: 50,
	    flex: 1,
	    sortable: true,
	},
	{
	    header: gettext('Datastore'),
	    dataIndex: 'store',
	    width: 120,
	    sortable: true,
	},
	{
	    header: gettext('Namespace'),
	    dataIndex: 'ns',
	    minWidth: 75,
	    flex: 2,
	    sortable: true,
	    renderer: PBS.Utils.render_optional_namespace,
	},
	{
	    header: gettext('Max. Depth'),
	    dataIndex: 'max-depth',
	    width: 90,
	    sortable: true,
	},
	{
	    header: gettext('Schedule'),
	    dataIndex: 'schedule',
	    maxWidth: 220,
	    minWidth: 80,
	    flex: 1,
	    sortable: true,
	},
	{
	    text: gettext('Keep'),
	    defaults: {
		minWidth: 60,
		flex: 1,
	    },
	    columns: [
		['last', gettext('Last')],
		['hourly', gettext('Hourly')],
		['daily', gettext('Daily')],
		['weekly', gettext('Weekly')],
		['monthly', gettext('Monthly')],
		['yearly', gettext('Yearly')],
	    ].map(([data, header]) => ({
		header: header,
		dataIndex: `keep-${data}`,
	    })),
	},
	{
	    header: gettext('Last Prune'),
	    dataIndex: 'last-run-endtime',
	    renderer: PBS.Utils.render_optional_timestamp,
	    width: 150,
	    sortable: true,
	},
	{
	    text: gettext('Duration'),
	    dataIndex: 'duration',
	    renderer: Proxmox.Utils.render_duration,
	    width: 80,
	},
	{
	    header: gettext('Status'),
	    dataIndex: 'last-run-state',
	    renderer: PBS.Utils.render_task_status,
	    flex: 3,
	},
	{
	    header: gettext('Next Run'),
	    dataIndex: 'next-run',
	    renderer: PBS.Utils.render_next_task_run,
	    width: 150,
	    sortable: true,
	},
	{
	    header: gettext('Comment'),
	    dataIndex: 'comment',
	    renderer: Ext.String.htmlEncode,
	    flex: 2,
	    sortable: true,
	},
    ],

    initComponent: function() {
	let me = this;
	let hideLocalDatastore = !!me.datastore;

	for (let column of me.columns) {
	    if (column.dataIndex === 'store') {
		column.hidden = hideLocalDatastore;
		break;
	    }
	}

	me.callParent();
    },
});
Ext.define('pbs-gc-jobs-status', {
    extend: 'Ext.data.Model',
    fields: [
	'store', 'upid', 'removed-bytes', 'pending-bytes', 'schedule',
	'next-run', 'last-run-endtime', 'last-run-state', 'duration',
    ],
    idProperty: 'store',
    proxy: {
	type: 'proxmox',
	url: '/api2/json/admin/gc',
    },
});

Ext.define('PBS.config.GCJobView', {
    extend: 'Ext.grid.GridPanel',
    alias: 'widget.pbsGCJobView',

    stateful: true,
    allowDeselect: false,

    title: gettext('Garbage Collect Jobs'),

    controller: {
	xclass: 'Ext.app.ViewController',

	init: function(view) {
	    let params = {};
	    let store = view.getStore();
	    let proxy = store.rstore.getProxy();
	    if (view.datastore) {
		params.store = view.datastore;

		// after the store is loaded, select the row to enable the Edit,.. buttons
		store.rstore.proxy.on({
		    'afterload': {
			fn: () => {
			    if (view.store) {
				view.getSelectionModel().select(0);
			    }
			},
			single: true,
		    },
		});

		// do not highlight the selected row
		view.items.items[0].selectedItemCls = '';
		view.items.items[0].overItemCls = '';
	    }
	    proxy.setExtraParams(params);
	    Proxmox.Utils.monStoreErrors(view, store.rstore);
	},

	getDatastoreName: function() {
	    return this.getView().getSelection()[0]?.data.store;
	},

	getData: function() {
	    let view = this.getView();
	    let datastore = this.getDatastoreName();
	    return view.getStore().getById(datastore).data;
	},

	editGCJob: function() {
	    let data = this.getData();
	    Ext.create('PBS.window.GCJobEdit', {
		datastore: data.store,
		id: data.store,
		schedule: data.schedule,
		listeners: {
		    destroy: () => this.reload(),
		},
	    }).show();
	},

	garbageCollect: function() {
	    let datastore = this.getDatastoreName();
	    Proxmox.Utils.API2Request({
		url: `/admin/datastore/${datastore}/gc`,
		method: 'POST',
		failure: function(response) {
		    Ext.Msg.alert(gettext('Error'), response.htmlStatus);
		},
		success: function(response, options) {
		    Ext.create('Proxmox.window.TaskViewer', {
			upid: response.result.data,
		    }).show();
		},
	    });
	},

	showTaskLog: function() {
	    let me = this;

	    let upid = this.getData().upid;
	    if (!upid) return;

	    Ext.create('Proxmox.window.TaskViewer', { upid }).show();
	},

	startStore: function() { this.getView().getStore().rstore.startUpdate(); },
	stopStore: function() { this.getView().getStore().rstore.stopUpdate(); },
	reload: function() { this.getView().getStore().rstore.load(); },


	filterState: function(view, state) {
	    delete state.height;
	},
    },

    listeners: {
	activate: 'startStore',
	beforedestroy: 'stopStore',
	deactivate: 'stopStore',
	itemdblclick: 'editGCJob',
	beforestatesave: 'filterState',
    },

    store: {
	type: 'diff',
	autoDestroy: true,
	autoDestroyRstore: true,
	sorters: 'store',
	rstore: {
	    type: 'update',
	    storeid: 'pbs-gc-jobs-status',
	    model: 'pbs-gc-jobs-status',
	    interval: 5000,
	},
    },

    tbar: [
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Edit'),
	    handler: 'editGCJob',
	    enableFn: (rec) => !!rec,
	    disabled: true,
	},
	'-',
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Show Log'),
	    handler: 'showTaskLog',
	    enableFn: (rec) => !!rec.data.upid,
	    disabled: true,
	},
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Run now'),
	    handler: 'garbageCollect',
	    enableFn: (rec) => !!rec,
	    disabled: true,
	},
    ],

    columns: [
	{
	    header: gettext('Datastore'),
	    dataIndex: 'store',
	    renderer: Ext.String.htmlEncode,
	    hideable: false,
	    minWidth: 120,
	    maxWidth: 300,
	    flex: 2,
	},
	{
	    header: gettext('Schedule'),
	    dataIndex: 'schedule',
	    hideable: false,
	    renderer: (value) => value ? value : Proxmox.Utils.NoneText,
	    minWidth: 85,
	    flex: 1,
	},
	{
	    header: gettext('Last GC'),
	    dataIndex: 'last-run-endtime',
	    renderer: PBS.Utils.render_optional_timestamp,
	    minWidth: 150,
	    flex: 1,
	},
	{
	    text: gettext('Duration'),
	    dataIndex: 'duration',
	    renderer: Proxmox.Utils.render_duration,
	    minWidth: 80,
	    flex: 1,
	},
	{
	    header: gettext('Last Status'),
	    dataIndex: 'last-run-state',
	    renderer: PBS.Utils.render_task_status,
	    minWidth: 80,
	    flex: 1,
	},
	{
	    header: gettext('Next Run'),
	    dataIndex: 'next-run',
	    renderer: PBS.Utils.render_next_task_run,
	    minWidth: 150,
	    flex: 1,
	},
	{
	    header: gettext('Removed Data'),
	    dataIndex: 'removed-bytes',
	    renderer: (value, meta, record) => record.data.upid !== null
		? Proxmox.Utils.format_size(value, true) : "-",
	    minWidth: 85,
	    flex: 1,
	},
	{
	    header: gettext('Pending Data'),
	    dataIndex: 'pending-bytes',
	    renderer: (value, meta, record) => record.data.upid !== null
		? Proxmox.Utils.format_size(value, true) : "-",
	    minWidth: 80,
	    flex: 3,
	},
    ],

    initComponent: function() {
	let me = this;
	let isSingleDatastore = !!me.datastore;

	me.stateId = isSingleDatastore ? 'grid-gc-jobs-single' : 'grid-gc-jobs-v1';

	for (let column of me.columns) {
	    column.sortable = !isSingleDatastore;
	    if (column.dataIndex === 'store') {
		column.hidden = isSingleDatastore;
	    }
	}

	me.callParent();
    },
});
Ext.define('PBS.WebauthnConfigView', {
    extend: 'Proxmox.grid.ObjectGrid',
    alias: ['widget.pbsWebauthnConfigView'],

    url: "/api2/json/config/access/tfa/webauthn",
    cwidth1: 150,
    interval: 2500,

    rows: {
	rp: {
	    header: gettext('Relying Party'),
	    required: true,
	    defaultValue: gettext('Not configured'),
	},
	origin: {
	    header: gettext('Origin'),
	    required: true,
	    defaultValue: gettext('Not configured'),
	},
	id: {
	    header: 'ID',
	    required: true,
	    defaultValue: gettext('Not configured'),
	},
    },

    tbar: [
	{
	    text: gettext("Edit"),
	    handler: 'runEditor',
	},
    ],
    controller: {
	xclass: 'Ext.app.ViewController',

	runEditor: () => Ext.create('PBS.WebauthnConfigEdit', { autoShow: true }),

	startStore: function() { this.getView().getStore().rstore.startUpdate(); },
	stopStore: function() { this.getView().getStore().rstore.stopUpdate(); },
    },


    listeners: {
	itemdblclick: 'runEditor',
	activate: 'startStore',
	deactivate: 'stopStore',
	beforedestroy: 'stopStore',
    },
});

Ext.define('PBS.WebauthnConfigEdit', {
    extend: 'Proxmox.window.Edit',
    alias: ['widget.pbsWebauthnConfigEdit'],

    subject: gettext('Webauthn'),
    url: "/api2/extjs/config/access/tfa/webauthn",
    autoLoad: true,

    width: 512,

    fieldDefaults: {
	labelWidth: 120,
    },

    setValues: function(values) {
	let me = this;

	me.relayingPartySet = values && typeof values.rp === 'string';

	me.callParent(arguments);
    },

    items: [
	{
	    xtype: 'textfield',
	    fieldLabel: gettext('Relying Party'),
	    name: 'rp',
	    allowBlank: false,
	    listeners: {
		dirtychange: function(field, isDirty) {
		    let win = field.up('window');
		    let warningBox = win.down('box[id=rpChangeWarning]');
		    warningBox.setHidden(!win.relayingPartySet || !isDirty);
		},
	    },
	},
	{
	    xtype: 'textfield',
	    fieldLabel: gettext('Origin'),
	    name: 'origin',
	    allowBlank: false,
	},
	{
	    xtype: 'textfield',
	    fieldLabel: 'ID',
	    name: 'id',
	    allowBlank: false,
	},
	{
	    xtype: 'container',
	    layout: 'hbox',
	    items: [
		{
		    xtype: 'box',
		    flex: 1,
		},
		{
		    xtype: 'button',
		    text: gettext('Auto-fill'),
		    iconCls: 'fa fa-fw fa-pencil-square-o',
		    handler: function(button, ev) {
			let panel = this.up('panel');
			panel.down('field[name=rp]').setValue(document.location.hostname);
			panel.down('field[name=origin]').setValue(document.location.origin);
			panel.down('field[name=id]').setValue(document.location.hostname);
		    },
		},
	    ],
	},
	{
	    xtype: 'box',
	    html: `<span class='pmx-hint'>${gettext('Note:')}</span> `
		+ gettext('WebAuthn requires using a trusted certificate.'),
	},
	{
	    xtype: 'box',
	    id: 'rpChangeWarning',
	    hidden: true,
	    padding: '5 0 0 0',
	    html: '<i class="fa fa-exclamation-triangle warning"></i> '
	        + gettext('Changing the Relying Party may break existing webAuthn TFA entries.'),
	},
    ],
});
Ext.define('PBS.config.CertificateConfiguration', {
    extend: 'Ext.tab.Panel',
    alias: 'widget.pbsCertificateConfiguration',

    title: gettext('Certificates'),

    border: false,
    defaults: { border: false },

    items: [
       {
           itemId: 'certificates',
           xtype: 'pbsCertificatesView',
       },
       {
           itemId: 'acme',
           xtype: 'pbsACMEConfigView',
       },
    ],
});

Ext.define('PBS.config.CertificatesView', {
    extend: 'Ext.panel.Panel',
    alias: 'widget.pbsCertificatesView',

    title: gettext('Certificates'),
    border: false,
    defaults: {
	border: false,
    },
    scrollable: 'y',

    items: [
	{
	    xtype: 'pmxCertificates',
	    nodename: 'localhost',
	    infoUrl: '/nodes/localhost/certificates/info',
	    uploadButtons: [
		{
		    id: 'proxy.pem',
		    url: '/nodes/localhost/certificates/custom',
		    deletable: true,
		    reloadUi: true,
		},
	    ],
	},
	{
	    xtype: 'pmxACMEDomains',
	    border: 0,
	    url: `/nodes/localhost/config`,
	    nodename: 'localhost',
	    acmeUrl: '/config/acme',
	    orderUrl: `/nodes/localhost/certificates/acme/certificate`,
	    separateDomainEntries: true,
	},
    ],
});

Ext.define('PBS.ACMEConfigView', {
    extend: 'Ext.panel.Panel',
    alias: 'widget.pbsACMEConfigView',

    title: gettext('ACME Accounts'),

    //onlineHelp: 'sysadmin_certificate_management',

    items: [
       {
           region: 'north',
           border: false,
           xtype: 'pmxACMEAccounts',
           acmeUrl: '/config/acme',
       },
       {
           region: 'center',
           border: false,
           xtype: 'pmxACMEPluginView',
           acmeUrl: '/config/acme',
       },
    ],
});
Ext.define('PBS.NodeOptionView', {
    extend: 'Proxmox.grid.ObjectGrid',
    alias: 'widget.pbsNodeOptionView',

    monStoreErrors: true,

    url: `/api2/json/nodes/${Proxmox.NodeName}/config`,
    editorConfig: {
	url: `/api2/extjs/nodes/${Proxmox.NodeName}/config`,
    },
    interval: 5000,
    cwidth1: 200,

    listeners: {
	itemdblclick: function() { this.run_editor(); },
	activate: function() { this.rstore.startUpdate(); },
	destroy: function() { this.rstore.stopUpdate(); },
	deactivate: function() { this.rstore.stopUpdate(); },
    },

    tbar: [
	{
	    text: gettext('Edit'),
	    xtype: 'proxmoxButton',
	    disabled: true,
	    handler: btn => btn.up('grid').run_editor(),
	},
    ],

    gridRows: [
	{
	    xtype: 'text',
	    name: 'http-proxy',
	    text: gettext('HTTP proxy'),
	    defaultValue: Proxmox.Utils.noneText,
	    vtype: 'HttpProxy',
	    deleteEmpty: true,
	    onlineHelp: 'node_options_http_proxy',
	},
	{
	    xtype: 'text',
	    name: 'email-from',
	    defaultValue: gettext('root@$hostname'),
	    text: gettext('Email from address'),
	    vtype: 'proxmoxMail',
	    deleteEmpty: true,
	},
	{
	    xtype: 'combobox',
	    name: 'default-lang',
	    text: gettext('Default Language'),
	    defaultValue: '__default__',
	    comboItems: Proxmox.Utils.language_array(),
	    deleteEmpty: true,
	    renderer: Proxmox.Utils.render_language,
	},
	{
	    xtype: 'textareafield',
	    name: 'consent-text',
	    text: gettext('Consent Text'),
	    deleteEmpty: true,
	    onlineHelp: 'consent_banner',
	},
    ],
});
Ext.define('PBS.config.MetricServerView', {
    extend: 'Ext.grid.Panel',
    alias: ['widget.pbsMetricServerView'],

    stateful: true,
    stateId: 'grid-metricserver',

    controller: {
	xclass: 'Ext.app.ViewController',

	editWindow: function(xtype, id) {
	    let me = this;
	    Ext.create(`PBS.window.${xtype}Edit`, {
		serverid: id,
		autoShow: true,
		autoLoad: !!id,
		listeners: {
		    destroy: () => me.reload(),
		},
	    });
	},

	addServer: function(button) {
	    this.editWindow(PBS.Schema.metricServer[button.type]?.xtype);
	},

	editServer: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (!selection || selection.length < 1) {
		return;
	    }

	    let cfg = selection[0].data;

	    me.editWindow(PBS.Schema.metricServer[cfg.type]?.xtype, cfg.name);
	},

	reload: function() {
	    this.getView().getStore().load();
	},
    },

    store: {
	autoLoad: true,
	id: 'metricservers',
	proxy: {
	    type: 'proxmox',
	    url: '/api2/json/admin/metrics',
	},
    },

    columns: [
	{
	    text: gettext('Name'),
	    flex: 2,
	    dataIndex: 'name',
	},
	{
	    text: gettext('Type'),
	    width: 150,
	    dataIndex: 'type',
	    renderer: (v) => PBS.Schema.metricServer[v]?.type ?? v,
	},
	{
	    text: gettext('Enabled'),
	    dataIndex: 'enable',
	    width: 100,
	    renderer: v => Proxmox.Utils.format_boolean(v ?? true),
	},
	{
	    text: gettext('Target Server'),
	    width: 200,
	    dataIndex: 'server',
	},
	{
	    text: gettext('Comment'),
	    flex: 3,
	    dataIndex: 'comment',
	    renderer: Ext.htmlEncode,
	},
    ],

    tbar: [
	{
	    text: gettext('Add'),
	    menu: [
		{
		    text: 'InfluxDB (HTTP)',
		    type: 'influxdb-http',
		    iconCls: 'fa fa-fw fa-bar-chart',
		    handler: 'addServer',
		},
		{
		    text: 'InfluxDB (UDP)',
		    type: 'influxdb-udp',
		    iconCls: 'fa fa-fw fa-bar-chart',
		    handler: 'addServer',
		},
	    ],
	},
	{
	    text: gettext('Edit'),
	    xtype: 'proxmoxButton',
	    handler: 'editServer',
	    disabled: true,
	},
	{
	    xtype: 'proxmoxStdRemoveButton',
	    getUrl: (rec) => `/api2/extjs/config/metrics/${rec.data.type}/${rec.data.name}`,
	    getRecordName: (rec) => rec.data.name,
	    callback: 'reload',
	},
    ],

    listeners: {
	itemdblclick: 'editServer',
    },

    initComponent: function() {
	var me = this;

	me.callParent();

	Proxmox.Utils.monStoreErrors(me, me.getStore());
    },
});
Ext.define('PBS.config.NotificationConfigView', {
    extend: 'Proxmox.panel.NotificationConfigView',
    alias: ['widget.pbsNotificationConfigView'],
    mixins: ['Proxmox.Mixin.CBind'],

    cbindData: function(_initialConfig) {
        return {
            baseUrl: '/config/notifications',
        };
    },
});
Ext.define('PBS.config.PruneAndGC', {
    extend: 'Ext.panel.Panel',
    alias: 'widget.pbsPruneAndGC',
    title: gettext('Prune & GC Jobs'),

    mixins: ['Proxmox.Mixin.CBind'],

    layout: {
	type: 'vbox',
	align: 'stretch',
	multi: true,
    },
    defaults: {
	collapsible: false,
	margin: '7 10 3 10',
    },
    scrollable: true,
    items: [
	{
	    xtype: 'pbsGCJobView',
	    itemId: 'gcjobs',
	    nodename: 'localhost',
	    cbind: {
		datastore: '{datastore}',
	    },
	    minHeight: 125, // shows at least one line of content
	},
	{
	    xtype: 'splitter',
	    performCollapse: false,
	},
	{
	    xtype: 'pbsPruneJobView',
	    nodename: 'localhost',
	    itemId: 'prunejobs',
	    cbind: {
		datastore: '{datastore}',
	    },
	    flex: 1,
	    minHeight: 160, // shows at least one line of content
	},
    ],
    initComponent: function() {
	let me = this;

	let subPanelIds = me.items.map(el => el.itemId).filter(id => !!id);

	me.callParent();

	for (const itemId of subPanelIds) {
	    let component = me.getComponent(itemId);
	    component.relayEvents(me, ['activate', 'deactivate', 'destroy']);
	}
    },

    cbindData: function(initialConfig) {
        let me = this;
        me.datastore = initialConfig.datastore ? initialConfig.datastore : undefined;
    },
});
Ext.define('PBS.window.ACLEdit', {
    extend: 'Proxmox.window.Edit',
    alias: 'widget.pbsACLAdd',
    mixins: ['Proxmox.Mixin.CBind'],

    onlineHelp: 'user_acl',

    url: '/access/acl',
    method: 'PUT',
    isAdd: true,
    isCreate: true,
    width: 450,

    // caller can give a static path
    path: undefined,
    defaultFocus: 'proxmoxcheckbox',

    initComponent: function() {
	let me = this;

	me.items = [];

	me.items.push({
	    xtype: 'pbsPermissionPathSelector',
	    name: 'path',
	    fieldLabel: gettext('Path'),
	    allowBlank: false,
	    //editable: !me.path,
	    value: me.path,
	    datastore: me.datastore,
	});

	if (me.aclType === 'user') {
	    me.subject = gettext('User Permission');
	    me.items.push({
		xtype: 'pmxUserSelector',
		name: 'auth-id',
		fieldLabel: gettext('User'),
		allowBlank: false,
	    });
	} else if (me.aclType === 'token') {
	    me.subject = gettext('API Token Permission');
	    me.items.push({
		xtype: 'pbsTokenSelector',
		name: 'auth-id',
		fieldLabel: gettext('API Token'),
		allowBlank: false,
	    });
	}
	me.items.push({
	    xtype: 'pmxRoleSelector',
	    name: 'role',
	    fieldLabel: gettext('Role'),
	    value: 'NoAccess',
	});
	me.items.push({
	    xtype: 'proxmoxcheckbox',
	    name: 'propagate',
	    fieldLabel: gettext('Propagate'),
	    checked: true,
	    uncheckedValue: 0,
	});

	me.callParent();
    },
});
Ext.define('PBS.BackupGroupChangeOwner', {
    extend: 'Proxmox.window.Edit',
    alias: 'widget.pbsBackupGroupChangeOwner',

    onlineHelp: 'changing-backup-owner',

    submitText: gettext("Change Owner"),
    width: 350,

    initComponent: function() {
	let me = this;

	if (!me.datastore) {
	    throw "no datastore specified";
	}
	if (!me.backup_type) {
	    throw "no backup_type specified";
	}
	if (!me.backup_id) {
	    throw "no backup_id specified";
	}

	Ext.apply(me, {
	    url: `/api2/extjs/admin/datastore/${me.datastore}/change-owner`,
	    method: 'POST',
	    subject: gettext("Change Owner") + ` - ${me.backup_type}/${me.backup_id}`,
	    items: {
		xtype: 'inputpanel',
		onGetValues: function(values) {
		    values["backup-type"] = me.backup_type;
		    values["backup-id"] = me.backup_id;
		    if (me.ns && me.ns !== '') {
			values.ns = me.ns;
		    }
		    return values;
		},

		items: [
		    {
			xtype: 'pbsAuthidSelector',
			name: 'new-owner',
			value: me.owner,
			fieldLabel: gettext('New Owner'),
			allowBlank: false,
		    },
		],
	    },
	});

	me.callParent();
    },
});
Ext.define('PBS.window.CreateDirectory', {
    extend: 'Proxmox.window.Edit',
    xtype: 'pbsCreateDirectory',

    subject: Proxmox.Utils.directoryText,
    showProgress: true,
    isCreate: true,
    url: '/nodes/localhost/disks/directory',
    method: 'POST',

    onlineHelp: 'storage-disk-management',

    items: [
	{
	    xtype: 'pmxDiskSelector',
	    name: 'disk',
	    valueField: 'name',
	    typeProperty: 'usage-type',
	    nodename: 'localhost',
	    diskType: 'unused',
	    fieldLabel: gettext('Disk'),
	    allowBlank: false,
	},
	{
	    xtype: 'proxmoxKVComboBox',
	    comboItems: [
		['ext4', 'ext4'],
		['xfs', 'xfs'],
	    ],
	    fieldLabel: gettext('Filesystem'),
	    name: 'filesystem',
	    value: '',
	    allowBlank: false,
	},
	{
	    xtype: 'proxmoxtextfield',
	    name: 'name',
	    fieldLabel: gettext('Name'),
	    allowBlank: false,
	},
	{
	    xtype: 'proxmoxcheckbox',
	    name: 'add-datastore',
	    fieldLabel: gettext('Add as Datastore'),
	    value: '1',
	    listeners: {
		change(field, newValue, _oldValue) {
		    let form = field.up('form');
		    let rmBox = form.down('[name=removable-datastore]');

		    rmBox.setDisabled(!newValue);
		    rmBox.setValue(false);
		},
	    },
	},
	{
	    xtype: 'proxmoxcheckbox',
	    name: 'removable-datastore',
	    fieldLabel: gettext('Removable datastore'),
	},
    ],
});

Ext.define('PBS.DataStoreEdit', {
    extend: 'Proxmox.window.Edit',
    alias: 'widget.pbsDataStoreEdit',
    mixins: ['Proxmox.Mixin.CBind'],

    subject: gettext('Datastore'),
    isAdd: true,

    bodyPadding: 0,
    showProgress: true,

    cbindData: function(initialConfig) {
	var me = this;

	let name = initialConfig.name;
	let baseurl = '/api2/extjs/config/datastore';

	me.isCreate = !name;
	if (!me.isCreate) {
	    me.defaultFocus = 'textfield[name=comment]';
	}
	me.url = name ? baseurl + '/' + name : baseurl;
	me.method = name ? 'PUT' : 'POST';
	me.scheduleValue = name ? null : 'daily';
	me.autoLoad = !!name;
	return {};
    },

    items: {
	xtype: 'tabpanel',
	bodyPadding: 10,
	listeners: {
	    tabchange: function(tb, newCard) {
	        Ext.GlobalEvents.fireEvent('proxmoxShowHelp', newCard.onlineHelp);
	    },
	},
	items: [
	    {
		title: gettext('General'),
		xtype: 'inputpanel',
		onlineHelp: 'datastore_intro',
		cbind: {
		    isCreate: '{isCreate}',
		},
		column1: [
		    {
			xtype: 'pmxDisplayEditField',
			cbind: {
			    editable: '{isCreate}',
			},
			name: 'name',
			allowBlank: false,
			fieldLabel: gettext('Name'),
		    },
		    {
			xtype: 'pmxDisplayEditField',
			cbind: {
			    editable: '{isCreate}',
			},
			name: 'path',
			allowBlank: false,
			fieldLabel: gettext('Backing Path'),
			emptyText: gettext('An absolute path'),
			validator: val => val?.trim() !== '/',
		    },
		    {
			xtype: 'pbsPartitionSelector',
			fieldLabel: gettext('Device'),
			name: 'backing-device',
			disabled: true,
			allowBlank: true,
			cbind: {
			    editable: '{isCreate}',
			},
			emptyText: gettext('Device path'),
		    },
		],
		column2: [
		    {
			xtype: 'pbsCalendarEvent',
			name: 'gc-schedule',
			fieldLabel: gettext("GC Schedule"),
			emptyText: gettext('none'),
			cbind: {
			    deleteEmpty: '{!isCreate}',
			    value: '{scheduleValue}',
			},
		    },
		    {
			xtype: 'pbsCalendarEvent',
			name: 'prune-schedule',
			fieldLabel: gettext("Prune Schedule"),
			value: 'daily',
			emptyText: gettext('none'),
			cbind: {
			    deleteEmpty: '{!isCreate}',
			    value: '{scheduleValue}',
			},
		    },
		],
		columnB: [
		    {
			xtype: 'checkbox',
			boxLabel: gettext('Removable datastore'),
			submitValue: false,
			listeners: {
			    change: function(checkbox, isRemovable) {
				let inputPanel = checkbox.up('inputpanel');
				let pathField = inputPanel.down('[name=path]');
				let uuidEditField = inputPanel.down('[name=backing-device]');

				uuidEditField.setDisabled(!isRemovable);
				uuidEditField.allowBlank = !isRemovable;
				uuidEditField.setValue('');
				if (isRemovable) {
				    pathField.setFieldLabel(gettext('Path on Device'));
				    pathField.setEmptyText(gettext('A relative path'));
				} else {
				    pathField.setFieldLabel(gettext('Backing Path'));
				    pathField.setEmptyText(gettext('An absolute path'));
				}
			    },
			},
		    },
		    {
			xtype: 'textfield',
			name: 'comment',
			fieldLabel: gettext('Comment'),
		    },
		],
		advancedColumn1: [
		    {
			xtype: 'checkbox',
			name: 'reuse-datastore',
			fieldLabel: gettext('Reuse existing datastore'),
		    },
		],

		onGetValues: function(values) {
		    let me = this;

		    if (me.isCreate) {
			// New datastores default to using the notification system
			values['notification-mode'] = 'notification-system';
		    }
		    return values;
		},
	    },
	    {
		title: gettext('Prune Options'),
		xtype: 'pbsPruneInputPanel',
		cbind: {
		    isCreate: '{isCreate}',
		},
		onlineHelp: 'backup_pruning',
	    },
	],
    },
});
Ext.define('PBS.window.NamespaceEdit', {
    extend: 'Proxmox.window.Edit',
    xtype: 'pbsNamespaceEdit', // for now rather "NamespaceAdd"
    mixins: ['Proxmox.Mixin.CBind'],

    onlineHelp: 'storage-namespaces',

    isCreate: true,
    subject: gettext('Namespace'),
    // avoid that the trigger of the combogrid fields open on window show
    defaultFocus: 'proxmoxtextfield[name=name]',

    cbind: {
	url: '/api2/extjs/admin/datastore/{datastore}/namespace',
    },
    method: 'POST',

    width: 450,
    fieldDefaults: {
	labelWidth: 120,
    },

    items: {
	xtype: 'inputpanel',
	onGetValues: function(values) {
	    if (values.parent === '') {
		delete values.parent;
	    }
	    return values;
	},
	items: [
	    {
		xtype: 'pbsNamespaceSelector',
		name: 'parent',
		fieldLabel: gettext('Parent Namespace'),
		cbind: {
		    value: '{namespace}',
		    datastore: '{datastore}',
		},
	    },
	    {
		xtype: 'proxmoxtextfield',
		name: 'name',
		fieldLabel: gettext('Namespace Name'),
		value: '',
		allowBlank: false,
		maxLength: 31,
		regex: PBS.Utils.SAFE_ID_RE,
		regexText: gettext("Only alpha numerical, '_' and '-' (if not at start) allowed"),
	    },
	],
    },
});

Ext.define('PBS.window.NamespaceDelete', {
    extend: 'Proxmox.window.SafeDestroy',
    xtype: 'pbsNamespaceDelete',
    mixins: ['Proxmox.Mixin.CBind'],

    viewModel: {},

    autoShow: true,
    taskName: 'delete-namespace',

    cbind: {
	url: '/api2/extjs/admin/datastore/{datastore}/namespace',
    },
    additionalItems: [
	{
	    xtype: 'proxmoxcheckbox',
	    name: 'delete-groups',
	    reference: 'rmGroups',
	    boxLabel: gettext('Delete all Backup Groups'),
	    value: false,
	    listeners: {
		change: function(field, value) {
		    let win = field.up('proxmoxSafeDestroy');
		    if (value) {
			win.params['delete-groups'] = value;
		    } else {
			delete win.params['delete-groups'];
		    }
		},
	    },
	},
	{
	    xtype: 'box',
	    padding: '5 0 0 0',
	    html: `<span class="pmx-hint">${gettext('Note')}</span>: `
	      + gettext('This will permanently remove all backups from the current namespace and all namespaces below it!'),
	    bind: {
		hidden: '{!rmGroups.checked}',
	    },
	},
    ],

    initComponent: function() {
	let me = this;
	me.title = Ext.String.format(gettext("Destroy Namespace '{0}'"), me.namespace);
	me.params = { ns: me.namespace };

	me.callParent();
    },
});
Ext.define('PBS.form.maintenanceType', {
    extend: 'Proxmox.form.KVComboBox',
    alias: 'widget.pbsMaintenanceType',

    comboItems: [
	['__default__', gettext('None')],
	['read-only', gettext('Read only')],
	['offline', gettext('Offline')],
    ],
});

Ext.define('PBS.window.MaintenanceOptions', {
    extend: 'Proxmox.window.Edit',
    xtype: 'pbsMaintenanceOptionEdit',
    mixins: ['Proxmox.Mixin.CBind'],

    onlineHelp: 'maintenance-mode',

    subject: gettext('Maintenance mode'),

    width: 450,
    fieldDefaults: {
	labelWidth: 120,
    },

    apiCallDone: function(success, response, options) {
	if (success) {
	    let datastoreStore = Ext.data.StoreManager.lookup('pbs-datastore-list');
	    if (datastoreStore) {
		// delay a bit to allow the window to close and maintenance mode to take effect
		setTimeout(() => datastoreStore.load(), 10);
	    }
	}
    },

    items: {
	xtype: 'inputpanel',
	onGetValues: function(values) {
	    if (values.delete === 'maintenance-type') {
		values.delete = 'maintenance-mode';
	    } else if (values['maintenance-type']) {
		const message = (values['maintenance-msg'] ?? '')
		    .replaceAll('\\', '')
		    .replaceAll('"', '\\"');
		const maybe_message = values['maintenance-msg'] ? `,message="${message}"` : '';
		values['maintenance-mode'] = `type=${values['maintenance-type']}${maybe_message}`;
	    }
	    delete values['maintenance-type'];
	    delete values['maintenance-msg'];
	    return values;
	},
	items: [
	    {
		xtype: 'pbsMaintenanceType',
		reference: 'type-field',
		name: 'maintenance-type',
		fieldLabel: gettext('Maintenance Type'),
		value: '__default__',
		deleteEmpty: true,
		listeners: {
		    change: (field, newValue) => {
			field.up('form').down('[name=maintenance-msg]').setDisabled(newValue === '__default__');
		    },
		},
	    },
	    {
		xtype: 'proxmoxtextfield',
		reference: 'message-field',
		name: 'maintenance-msg',
		fieldLabel: gettext('Description'),
	    },
	],
    },
    setValues: function(values) {
	let me = this;

	let options = {
	    'maintenance-type': '__default__',
	    'maintenance-msg': '',
	};
	if (values['maintenance-mode']) {
	    const [type, message] = PBS.Utils.parseMaintenanceMode(values['maintenance-mode']);
	    options = {
		'maintenance-type': type,
		'maintenance-msg': message ?? '',
	    };
	}

        let unmounting = options['maintenance-type'] === 'unmount';
        let defaultType = options['maintenance-type'] === '__default__';
        if (unmounting) {
            options['maintenance-type'] = gettext('Unmounting');
        }

	me.callParent([options]);

        me.lookupReference('message-field').setDisabled(unmounting || defaultType);
    },
});
Ext.define('PBS.window.NotesEdit', {
    extend: 'Proxmox.window.Edit',
    mixins: ['Proxmox.Mixin.CBind'],

    title: gettext('Notes'),

    width: 600,
    height: '400px',
    resizable: true,
    layout: 'fit',

    autoLoad: true,

    defaultButton: undefined,

    notesFieldName: 'notes',

    setValues: function(values) {
	let me = this;
	if (typeof values === "string") {
	    let v = values;
	    values = {};
	    values[me.notesFieldName] = v;
	}
	me.callParent([values]);
    },

    items: {
	xtype: 'textarea',
	name: 'notes',
	cbind: {
	    name: '{notesFieldName}',
	},
	height: '100%',
	value: '',
	hideLabel: true,
    },
});
Ext.define('PBS.window.RemoteEdit', {
    extend: 'Proxmox.window.Edit',
    alias: 'widget.pbsRemoteEdit',
    mixins: ['Proxmox.Mixin.CBind'],

    onlineHelp: 'backup_remote',

    isAdd: true,

    subject: gettext('Remote'),

    fieldDefaults: { labelWidth: 120 },

    cbindData: function(initialConfig) {
	let me = this;

	let baseurl = '/api2/extjs/config/remote';
	let name = initialConfig.name;

	me.isCreate = !name;
	me.url = name ? `${baseurl}/${name}` : baseurl;
	me.method = name ? 'PUT' : 'POST';
	me.autoLoad = !!name;
	return {
	    passwordEmptyText: me.isCreate ? '' : gettext('Unchanged'),
	};
    },

    items: {
	xtype: 'inputpanel',
	column1: [
	    {
		xtype: 'pmxDisplayEditField',
		name: 'name',
		fieldLabel: gettext('Remote ID'),
		renderer: Ext.htmlEncode,
		allowBlank: false,
		minLength: 4,
		cbind: {
		    editable: '{isCreate}',
		},
	    },
	    {
		xtype: 'proxmoxtextfield',
		allowBlank: false,
		name: 'hostport',
		submitValue: false,
		vtype: 'HostPort',
		fieldLabel: gettext('Host'),
		emptyText: gettext('FQDN or IP-address'),
		listeners: {
		    change: function(field, newvalue) {
			let host = newvalue;
			let port;

			let match = Proxmox.Utils.HostPort_match.exec(newvalue);
			if (match === null) {
			    match = Proxmox.Utils.HostPortBrackets_match.exec(newvalue);
			    if (match === null) {
				match = Proxmox.Utils.IP6_dotnotation_match.exec(newvalue);
			    }
			}

			if (match !== null) {
			    host = match[1];
			    if (match[2] !== undefined) {
				port = match[2];
			    }
			}

			field.up('inputpanel').down('field[name=host]').setValue(host);
			field.up('inputpanel').down('field[name=port]').setValue(port);
		    },
		},
	    },
	    {
		xtype: 'proxmoxtextfield',
		name: 'host',
		hidden: true,
	    },
	    {
		xtype: 'proxmoxtextfield',
		name: 'port',
		hidden: true,
		cbind: {
		    deleteEmpty: '{!isCreate}',
		},
	    },
	],

	column2: [
	    {
		xtype: 'proxmoxtextfield',
		name: 'auth-id',
		fieldLabel: gettext('Auth ID'),
		allowBlank: false,
	    },
	    {
		xtype: 'textfield',
		name: 'password',
		inputType: 'password',
		fieldLabel: gettext('Password'),
		cbind: {
		    emptyText: '{passwordEmptyText}',
		    allowBlank: '{!isCreate}',
		},
	    },
	],

	columnB: [
	    {
		xtype: 'proxmoxtextfield',
		name: 'fingerprint',
		fieldLabel: gettext('Fingerprint'),
		emptyText: gettext("Server certificate's SHA-256 fingerprint, required for self-signed certificates"),
		cbind: {
		    deleteEmpty: '{!isCreate}',
		},
	    },
	    {
		xtype: 'proxmoxtextfield',
		name: 'comment',
		cbind: {
		    deleteEmpty: '{!isCreate}',
		},
		fieldLabel: gettext('Comment'),
	    },
	],
    },

    setValues: function(values) {
	let me = this;

	let host = values.host;
	if (values.port !== undefined) {
	    if (Proxmox.Utils.IP6_match.test(host)) {
		host = `[${host}]`;
	    }
	    host += `:${values.port}`;
	}
	values.hostport = host;

	return me.callParent([values]);
    },

    getValues: function() {
	let me = this;
	let values = me.callParent(arguments);

	if (values.password === '') {
	    delete values.password;
	}

	return values;
    },
});
Ext.define('PBS.window.TrafficControlEdit', {
    extend: 'Proxmox.window.Edit',
    alias: 'widget.pbsTrafficControlEdit',
    mixins: ['Proxmox.Mixin.CBind'],

    onlineHelp: 'sysadmin_traffic_control',
    width: 800,
    height: 600,

    isAdd: true,

    subject: gettext('Traffic Control Rule'),

    fieldDefaults: { labelWidth: 120 },

    cbindData: function(initialConfig) {
	let me = this;

	let baseurl = '/api2/extjs/config/traffic-control';
	let name = initialConfig.name;

	me.isCreate = !name;
	me.url = name ? `${baseurl}/${name}` : baseurl;
	me.method = name ? 'PUT' : 'POST';
	return { };
    },

    controller: {
	xclass: 'Ext.app.ViewController',

	weekdays: ['mon', 'tue', 'wed', 'thu', 'fri', 'sat', 'sun'],

	dowChanged: function(field, value) {
	    let me = this;
	    let record = field.getWidgetRecord();
	    if (record === undefined) {
		// this is sometimes called before a record/column is initialized
		return;
	    }
	    let col = field.getWidgetColumn();
	    record.set(col.dataIndex, value);
	    record.commit();

	    me.updateTimeframeField();
	},

	timeChanged: function(field, value) {
	    let me = this;
	    if (value === null) {
		return;
	    }
	    let record = field.getWidgetRecord();
	    if (record === undefined) {
		// this is sometimes called before a record/column is initialized
		return;
	    }
	    let col = field.getWidgetColumn();
	    let hours = value.getHours().toString().padStart(2, '0');
	    let minutes = value.getMinutes().toString().padStart(2, '0');
	    record.set(col.dataIndex, `${hours}:${minutes}`);
	    record.commit();

	    me.updateTimeframeField();
	},

	addTimeframe: function() {
	    let me = this;
	    me.lookup('timeframes').getStore().add({
		start: "00:00",
		end: "23:59",
		mon: true,
		tue: true,
		wed: true,
		thu: true,
		fri: true,
		sat: true,
		sun: true,
	    });

	    me.updateTimeframeField();
	},

	updateTimeframeField: function() {
	    let me = this;

	    let timeframes = [];
	    me.lookup('timeframes').getStore().each((rec) => {
		let timeframe = '';
		let days = me.weekdays.filter(day => rec.data[day]);
		if (days.length < 7 && days.length > 0) {
		    timeframe += days.join(',') + ' ';
		}
		let { start, end } = rec.data;

		timeframe += `${start}-${end}`;
		timeframes.push(timeframe);
	    });

	    let field = me.lookup('timeframe');
	    field.suspendEvent('change');
	    field.setValue(timeframes.join(';'));
	    field.resumeEvent('change');
	},

	removeTimeFrame: function(field) {
	    let me = this;
	    let record = field.getWidgetRecord();
	    if (record === undefined) {
		// this is sometimes called before a record/column is initialized
		return;
	    }

	    me.lookup('timeframes').getStore().remove(record);
	    me.updateTimeframeField();
	},

	parseTimeframe: function(timeframe) {
	    let me = this;
	    let [, days, start, end] = /^(?:(\S*)\s+)?([0-9:]+)-([0-9:]+)$/.exec(timeframe) || [];

	    if (start === '0') {
		start = "00:00";
	    }

	    let record = {
		start,
		end,
	    };

	    if (!days) {
		days = 'mon..sun';
	    }

	    days = days.split(',');
	    days.forEach((day) => {
		if (record[day]) {
		    return;
		}

		if (me.weekdays.indexOf(day) !== -1) {
		    record[day] = true;
		} else {
		    // we have a range 'xxx..yyy'
		    let [startDay, endDay] = day.split('..');
		    let startIdx = me.weekdays.indexOf(startDay);
		    let endIdx = me.weekdays.indexOf(endDay);

		    if (endIdx < startIdx) {
			endIdx += me.weekdays.length;
		    }

		    for (let dayIdx = startIdx; dayIdx <= endIdx; dayIdx++) {
			let curDay = me.weekdays[dayIdx%me.weekdays.length];
			if (!record[curDay]) {
			    record[curDay] = true;
			}
		    }
		}
	    });

	    return record;
	},

	setGridData: function(field, value) {
	    let me = this;
	    if (!value) {
		return;
	    }

	    value = value.split(';');
	    let records = value.map((timeframe) => me.parseTimeframe(timeframe));
	    me.lookup('timeframes').getStore().setData(records);
	},

	control: {
	    'grid checkbox': {
		change: 'dowChanged',
	    },
	    'grid timefield': {
		change: 'timeChanged',
	    },
	    'grid button': {
		click: 'removeTimeFrame',
	    },
	    'field[name=timeframe]': {
		change: 'setGridData',
	    },
	},
    },

    items: {
	xtype: 'inputpanel',
	onGetValues: function(values) {
	    let me = this;
	    let isCreate = me.up('window').isCreate;

	    if (!values.network) {
		values.network = ['0.0.0.0/0', '::/0'];
	    } else {
		values.network = [...new Set(values.network.split(/\s*,\s*/))];
	    }

	    if ('timeframe' in values && !values.timeframe) {
		delete values.timeframe;
	    }
	    if (values.timeframe && !Ext.isArray(values.timeframe)) {
		values.timeframe = [...new Set(values.timeframe.split(';'))];
	    }

	    if (!isCreate) {
		PBS.Utils.delete_if_default(values, 'timeframe');
		PBS.Utils.delete_if_default(values, 'rate-in');
		PBS.Utils.delete_if_default(values, 'rate-out');
		PBS.Utils.delete_if_default(values, 'burst-in');
		PBS.Utils.delete_if_default(values, 'burst-out');
		if (typeof values.delete === 'string') {
		    values.delete = values.delete.split(',');
		}
	    }

	    return values;
	},
	column1: [
	    {
		xtype: 'pmxDisplayEditField',
		name: 'name',
		fieldLabel: gettext('Name'),
		renderer: Ext.htmlEncode,
		allowBlank: false,
		minLength: 3,
		cbind: {
		    editable: '{isCreate}',
		},
	    },
	    {
		xtype: 'pmxBandwidthField',
		name: 'rate-in',
		fieldLabel: gettext('Rate In'),
		emptyText: gettext('Unlimited'),
		submitAutoScaledSizeUnit: true,
	    },
	    {
		xtype: 'pmxBandwidthField',
		name: 'rate-out',
		fieldLabel: gettext('Rate Out'),
		emptyText: gettext('Unlimited'),
		submitAutoScaledSizeUnit: true,
	    },
	],

	column2: [
	    {
		xtype: 'proxmoxtextfield',
		name: 'comment',
		cbind: {
		    deleteEmpty: '{!isCreate}',
		},
		fieldLabel: gettext('Comment'),
	    },
	    {
		xtype: 'pmxBandwidthField',
		name: 'burst-in',
		fieldLabel: gettext('Burst In'),
		emptyText: gettext('Same as Rate'),
		submitAutoScaledSizeUnit: true,
	    },
	    {
		xtype: 'pmxBandwidthField',
		name: 'burst-out',
		fieldLabel: gettext('Burst Out'),
		emptyText: gettext('Same as Rate'),
		submitAutoScaledSizeUnit: true,
	    },
	],

	columnB: [
	    {
		xtype: 'proxmoxtextfield',
		fieldLabel: gettext('Network(s)'),
		name: 'network',
		emptyText: `0.0.0.0/0, ::/0 (${gettext('Apply on all Networks')})`,
		autoEl: {
		    tag: 'div',
		    'data-qtip': gettext('A comma-separated list of networks to apply the (shared) limit.'),
		},
	    },
	    {
		xtype: 'displayfield',
		fieldLabel: gettext('Timeframes'),
	    },
	    {
		xtype: 'fieldcontainer',
		items: [
		    {
			xtype: 'grid',
			height: 300,
			scrollable: true,
			reference: 'timeframes',
			viewConfig: {
			    emptyText: gettext('Apply Always'),
			},
			store: {
			    fields: ['start', 'end', 'mon', 'tue', 'wed', 'thu', 'fri', 'sat', 'sun'],
			    data: [],
			},
			columns: [
			    {
				text: gettext('Time Start'),
				xtype: 'widgetcolumn',
				dataIndex: 'start',
				widget: {
				    xtype: 'timefield',
				    isFormField: false,
				    format: 'H:i',
				    formatText: 'HH:MM',
				},
				flex: 1,
			    },
			    {
				text: gettext('Time End'),
				xtype: 'widgetcolumn',
				dataIndex: 'end',
				widget: {
				    xtype: 'timefield',
				    isFormField: false,
				    format: 'H:i',
				    formatText: 'HH:MM',
				    maxValue: '23:59',
				},
				flex: 1,
			    },
			    {
				text: gettext('Mon'),
				xtype: 'widgetcolumn',
				dataIndex: 'mon',
				width: 60,
				widget: {
				    xtype: 'checkbox',
				    isFormField: false,
				},
			    },
			    {
				text: gettext('Tue'),
				xtype: 'widgetcolumn',
				dataIndex: 'tue',
				width: 60,
				widget: {
				    xtype: 'checkbox',
				    isFormField: false,
				},
			    },
			    {
				text: gettext('Wed'),
				xtype: 'widgetcolumn',
				dataIndex: 'wed',
				width: 60,
				widget: {
				    xtype: 'checkbox',
				    isFormField: false,
				},
			    },
			    {
				text: gettext('Thu'),
				xtype: 'widgetcolumn',
				dataIndex: 'thu',
				width: 60,
				widget: {
				    xtype: 'checkbox',
				    isFormField: false,
				},
			    },
			    {
				text: gettext('Fri'),
				xtype: 'widgetcolumn',
				dataIndex: 'fri',
				width: 60,
				widget: {
				    xtype: 'checkbox',
				    isFormField: false,
				},
			    },
			    {
				text: gettext('Sat'),
				xtype: 'widgetcolumn',
				dataIndex: 'sat',
				width: 60,
				widget: {
				    xtype: 'checkbox',
				    isFormField: false,
				},
			    },
			    {
				text: gettext('Sun'),
				xtype: 'widgetcolumn',
				dataIndex: 'sun',
				width: 60,
				widget: {
				    xtype: 'checkbox',
				    isFormField: false,
				},
			    },
			    {
				xtype: 'widgetcolumn',
				width: 40,
				widget: {
				    xtype: 'button',
				    iconCls: 'fa fa-trash-o',
				},
			    },
			],
		    },
		],
	    },
	    {
		xtype: 'button',
		text: gettext('Add'),
		iconCls: 'fa fa-plus-circle',
		handler: 'addTimeframe',
	    },
	    {
		xtype: 'hidden',
		reference: 'timeframe',
		name: 'timeframe',
	    },
	],
    },

    doSetValues: function(data) {
	let me = this;

	// NOTE: it can make sense to have any-ip (::/0 and 0/0) and specific ones in the same set
	// so only check for "is default" when there really just two networks
	if (data.network?.length === 2) {
	    let nets = [...new Set(data.network)]; // only the set of unique networks
	    if (nets.find(net => net === '0.0.0.0/0') && nets.find(net => net === '::/0')) {
		delete data.network;
	    }
	}
	if (data.network?.length) {
	    data.network = data.network.join(', ');
	}

	if (Ext.isArray(data.timeframe)) {
	    data.timeframe = data.timeframe.join(';');
	}

	me.setValues(data);
    },

    initComponent: function() {
	let me = this;

	me.callParent();

	if (!me.isCreate) {
	    me.load({
		success: ({ result: { data } }) => me.doSetValues(data),
	    });
	}
    },
});
Ext.define('PBS.form.NotifyType', {
    extend: 'Proxmox.form.KVComboBox',
    alias: 'widget.pbsNotifyType',

    comboItems: [
	['__default__', gettext('Default (Always)')],
	['always', gettext('Always')],
	['error', gettext('Errors')],
	['never', gettext('Never')],
    ],
});

Ext.define('PBS.form.NotifyErrorDefaultType', {
    extend: 'Proxmox.form.KVComboBox',
    alias: 'widget.pbsNotifyErrorDefaultType',

    comboItems: [
	['__default__', gettext('Default (Errors)')],
	['always', gettext('Always')],
	['error', gettext('Errors')],
	['never', gettext('Never')],
    ],
});

Ext.define('PBS.window.NotifyOptions', {
    extend: 'Proxmox.window.Edit',
    xtype: 'pbsNotifyOptionEdit',
    mixins: ['Proxmox.Mixin.CBind'],

    onlineHelp: 'notification_mode',

    user: undefined,
    tokenname: undefined,

    isAdd: false,
    isCreate: false,

    subject: gettext('Datastore Options'),
    // hack to avoid that the trigger of the combogrid fields open on window show
    defaultFocus: 'proxmoxHelpButton',

    width: 450,
    fieldDefaults: {
	labelWidth: 120,
    },

    viewModel: {
	data: {
	    notificationMode: '__default__',
	},
	formulas: {
	    notificationSystemSelected: (get) => get('notificationMode') === 'notification-system',
	},
    },

    items: {
	xtype: 'inputpanel',
	onGetValues: function(values) {
	    let notify = {};
	    for (const k of ['verify', 'sync', 'gc', 'prune']) {
		notify[k] = values[k];
		delete values[k];
	    }
	    values.notify = PBS.Utils.printPropertyString(notify);

	    if (values.delete && !Ext.isArray(values.delete)) {
		values.delete = values.delete.split(',');
	    }

	    PBS.Utils.delete_if_default(values, 'notify', '');
	    PBS.Utils.delete_if_default(values, 'notify-user', '');

	    return values;
	},
	items: [
	    {
		xtype: 'proxmoxKVComboBox',
		comboItems: [
		    ['__default__', `${Proxmox.Utils.defaultText}  (Email)`],
		    ['legacy-sendmail', gettext('Email (legacy)')],
		    ['notification-system', gettext('Notification system')],
		],
		deleteEmpty: true,
		fieldLabel: gettext('Notification mode'),
		name: 'notification-mode',
		bind: {
		    value: '{notificationMode}',
		},
	    },
	    {
		xtype: 'pmxUserSelector',
		name: 'notify-user',
		fieldLabel: gettext('Notify User'),
		emptyText: 'root@pam',
		value: null,
		allowBlank: true,
		renderer: Ext.String.htmlEncode,
		deleteEmpty: true,
		bind: {
		    disabled: "{notificationSystemSelected}",
		},
	    },
	    {
		xtype: 'pbsNotifyType',
		name: 'verify',
		fieldLabel: gettext('Verification Jobs'),
		value: '__default__',
		deleteEmpty: false,
		bind: {
		    disabled: "{notificationSystemSelected}",
		},
	    },
	    {
		xtype: 'pbsNotifyType',
		name: 'sync',
		fieldLabel: gettext('Sync Jobs'),
		value: '__default__',
		deleteEmpty: false,
		bind: {
		    disabled: "{notificationSystemSelected}",
		},
	    },
	    {
		xtype: 'pbsNotifyErrorDefaultType',
		name: 'prune',
		fieldLabel: gettext('Prune Jobs'),
		value: '__default__',
		deleteEmpty: false,
		bind: {
		    disabled: "{notificationSystemSelected}",
		},
	    },
	    {
		xtype: 'pbsNotifyType',
		name: 'gc',
		fieldLabel: gettext('Garbage Collection'),
		value: '__default__',
		deleteEmpty: false,
		bind: {
		    disabled: "{notificationSystemSelected}",
		},
	    },
	],
    },
    setValues: function(values) {
	let me = this;

	// we only handle a reduced set of options here
	let options = {
	    'notify-user': values['notify-user'],
	    'verify-new': values['verify-new'],
	    'notification-mode': values['notification-mode']
		? values['notification-mode'] : '__default__',
	};

	let notify = {};
	if (values.notify) {
	    notify = PBS.Utils.parsePropertyString(values.notify);
	}
	Object.assign(options, notify);

	me.callParent([options]);
    },
});
Ext.define('PBS.window.SyncJobEdit', {
    extend: 'Proxmox.window.Edit',
    alias: 'widget.pbsSyncJobEdit',
    mixins: ['Proxmox.Mixin.CBind'],

    userid: undefined,

    onlineHelp: 'syncjobs',

    isAdd: true,

    subject: gettext('Sync Job - Pull Direction'),

    bodyPadding: 0,

    fieldDefaults: { labelWidth: 120 },
    defaultFocus: 'proxmoxtextfield[name=comment]',

    cbindData: function(initialConfig) {
	let me = this;

	let baseurl = '/api2/extjs/config/sync';
	let id = initialConfig.id;

	me.isCreate = !id;
	me.url = id ? `${baseurl}/${id}` : baseurl;
	me.method = id ? 'PUT' : 'POST';
	me.autoLoad = !!id;
	me.scheduleValue = id ? null : 'hourly';
	me.authid = id ? null : Proxmox.UserName;
	me.editDatastore = me.datastore === undefined && me.isCreate;

	if (me.syncDirection === 'push') {
	    me.subject = gettext('Sync Job - Push Direction');
	    me.syncDirectionPush = true;
	    me.syncRemoteLabel = gettext('Target Remote');
	    me.syncRemoteDatastore = gettext('Target Datastore');
	    me.syncRemoteNamespace = gettext('Target Namespace');
	    me.syncLocalOwner = gettext('Local User');
	    // Sync direction request parameter is only required for creating new jobs,
	    // for edit and delete it is derived from the job config given by it's id.
	    if (me.isCreate) {
		me.extraRequestParams = {
		    "sync-direction": 'push',
		};
	    }
	} else {
	    me.subject = gettext('Sync Job - Pull Direction');
	    me.syncDirectionPush = false;
	    me.syncRemoteLabel = gettext('Source Remote');
	    me.syncRemoteDatastore = gettext('Source Datastore');
	    me.syncRemoteNamespace = gettext('Source Namespace');
	    me.syncLocalOwner = gettext('Local Owner');
	}

	return { };
    },

    controller: {
	xclass: 'Ext.app.ViewController',
	control: {
	    'pbsDataStoreSelector[name=store]': {
		change: 'storeChange',
	    },
	},

	storeChange: function(field, value) {
	    let view = this.getView();
	    let nsSelector = view.down('pbsNamespaceSelector[name=ns]');
	    nsSelector.setDatastore(value);
	},

	init: function() {
	    let view = this.getView();
	    if (view.syncDirectionPush && view.datastore !== undefined) {
		let localNs = view.down('pbsNamespaceSelector[name=ns]').getValue();
		view.down('pbsGroupFilter').setLocalNamespace(view.datastore, localNs);
	    }
	},
    },

    setValues: function(values) {
	let me = this;
	if (values.id && !values.remote) {
	    values.location = 'local';
	} else {
	    values.location = 'remote';
	}
	me.callParent([values]);
    },

    items: {
	xtype: 'tabpanel',
	bodyPadding: 10,
	border: 0,
	items: [
	    {
		title: 'Options',
		xtype: 'inputpanel',
		onGetValues: function(values) {
		    let me = this;

		    if (!values.id && me.up('pbsSyncJobEdit').isCreate) {
			values.id = 's-' + Ext.data.identifier.Uuid.Global.generate().slice(0, 13);
		    }
		    if (!me.isCreate) {
			PBS.Utils.delete_if_default(values, 'rate-in');
			PBS.Utils.delete_if_default(values, 'remote');
			if (typeof values.delete === 'string') {
			    values.delete = values.delete.split(',');
			}
		    }
		    return values;
		},
		cbind: {
		    isCreate: '{isCreate}', // pass it through
		},
		column1: [
		    {
			xtype: 'pmxDisplayEditField',
			fieldLabel: gettext('Local Datastore'),
			name: 'store',
			submitValue: true,
			cbind: {
			    editable: '{editDatastore}',
			    value: '{datastore}',
			},
			editConfig: {
			    xtype: 'pbsDataStoreSelector',
			    allowBlank: false,
			},
			listeners: {
			    change: function(field, localStore) {
				let me = this;
				let view = me.up('pbsSyncJobEdit');
				if (view.syncDirectionPush) {
				    let localNs = view.down('pbsNamespaceSelector[name=ns]').getValue();
				    view.down('pbsGroupFilter').setLocalNamespace(localStore, localNs);
				}
			    },
			},
		    },
		    {
			xtype: 'pbsNamespaceSelector',
			fieldLabel: gettext('Local Namespace'),
			name: 'ns',
			cbind: {
			    datastore: '{datastore}',
			},
			listeners: {
			    change: function(field, localNs) {
				let me = this;
				let view = me.up('pbsSyncJobEdit');

				if (view.syncDirectionPush) {
				    let localStore = view.down('field[name=store]').getValue();
				    view.down('pbsGroupFilter').setLocalNamespace(localStore, localNs);
				}

				let remoteNs = view.down('pbsRemoteNamespaceSelector[name=remote-ns]').getValue();
				let maxDepthField = view.down('field[name=max-depth]');
				maxDepthField.setLimit(localNs, remoteNs);
				maxDepthField.validate();
			    },
			},
		    },
		    {
			xtype: 'pbsAuthidSelector',
			name: 'owner',
			cbind: {
			    fieldLabel: '{syncLocalOwner}',
			    value: '{authid}',
			    deleteEmpty: '{!isCreate}',
			},
		    },
		    {
			fieldLabel: gettext('Sync Schedule'),
			xtype: 'pbsCalendarEvent',
			name: 'schedule',
			emptyText: gettext('none (disabled)'),
			cbind: {
			    deleteEmpty: '{!isCreate}',
			    value: '{scheduleValue}',
			},
		    },
		    {
			xtype: 'pmxBandwidthField',
			name: 'rate-in',
			fieldLabel: gettext('Rate Limit'),
			emptyText: gettext('Unlimited'),
			submitAutoScaledSizeUnit: true,
			// NOTE: handle deleteEmpty in onGetValues due to bandwidth field having a cbind too
		    },
		],

		column2: [
		    {
			xtype: 'radiogroup',
			fieldLabel: gettext('Location'),
			defaultType: 'radiofield',
			cbind: {
			    disabled: '{syncDirectionPush}',
			},
			items: [
			    {
				boxLabel: 'Local',
				name: 'location',
				inputValue: 'local',
				submitValue: false,
			    },
			    {
				boxLabel: 'Remote',
				name: 'location',
				inputValue: 'remote',
				submitValue: false,
				checked: true,
			    },
			],
			listeners: {
			    change: function(_group, radio) {
				let me = this;
				let form = me.up('pbsSyncJobEdit');
				let nsField = form.down('field[name=remote-ns]');
				let rateLimitField = form.down('field[name=rate-in]');
				let remoteField = form.down('field[name=remote]');
				let storeField = form.down('field[name=remote-store]');

				if (!storeField.value) {
				    nsField.clearValue();
				    nsField.setDisabled(true);
				}

				let isLocalSync = radio.location === 'local';
				rateLimitField.setDisabled(isLocalSync);
				remoteField.allowBlank = isLocalSync;
				remoteField.setDisabled(isLocalSync);
				storeField.setDisabled(!isLocalSync && !remoteField.value);
				if (isLocalSync === !!remoteField.value) {
				    remoteField.clearValue();
				}

				if (isLocalSync) {
				    storeField.setDisabled(false);
				    rateLimitField.setValue(null);
				    storeField.setRemote(null, true);
				} else {
				    storeField.clearValue();
				    remoteField.validate();
				}
			    },
			},
		    },
		    {
			cbind: {
			    fieldLabel: '{syncRemoteLabel}',
			},
			xtype: 'pbsRemoteSelector',
			allowBlank: false,
			name: 'remote',
			skipEmptyText: true,
			listeners: {
			    change: function(f, value) {
				let me = this;
				let remoteStoreField = me.up('pbsSyncJobEdit').down('field[name=remote-store]');
				remoteStoreField.setRemote(value);
				let rateLimitField = me.up('pbsSyncJobEdit').down('field[name=rate-in]');
				rateLimitField.setDisabled(!value);
				if (!value) {
				    rateLimitField.setValue(null);
				}
				let remoteNamespaceField = me.up('pbsSyncJobEdit').down('field[name=remote-ns]');
				remoteNamespaceField.setRemote(value);
			    },
			},
		    },
		    {
			xtype: 'pbsRemoteStoreSelector',
			allowBlank: false,
			autoSelect: false,
			name: 'remote-store',
			cbind: {
			    datastore: '{datastore}',
			    fieldLabel: '{syncRemoteDatastore}',
			},
			listeners: {
			    change: function(field, value) {
				let me = this;
				let remoteField = me.up('pbsSyncJobEdit').down('field[name=remote]');
				let remote = remoteField.getValue();
				let remoteNamespaceField = me.up('pbsSyncJobEdit').down('field[name=remote-ns]');
				remoteNamespaceField.setRemote(remote);
				remoteNamespaceField.setRemoteStore(value);

				let view = me.up('pbsSyncJobEdit');
				if (!view.syncDirectionPush) {
				    me.up('tabpanel').down('pbsGroupFilter').setRemoteDatastore(remote, value);
				} else {
				    let localStore = me.up('pbsSyncJobEdit').down('field[name=store]').getValue();
				    me.up('tabpanel').down('pbsGroupFilter').setLocalDatastore(localStore);
				}
			    },
			},
		    },
		    {
			cbind: {
			    fieldLabel: '{syncRemoteNamespace}',
			},
			xtype: 'pbsRemoteNamespaceSelector',
			allowBlank: true,
			autoSelect: false,
			name: 'remote-ns',
			disabled: true,
			listeners: {
			    change: function(field, remoteNs) {
				let me = this;
				let view = me.up('pbsSyncJobEdit');

				let remote = view.down('field[name=remote]').getValue();
				let remoteStore = view.down('field[name=remote-store]').getValue();

				if (!view.syncDirectionPush) {
				    me.up('tabpanel').down('pbsGroupFilter').setRemoteNamespace(remote, remoteStore, remoteNs);
				}

				let localNs = view.down('pbsNamespaceSelector[name=ns]').getValue();
				let maxDepthField = view.down('field[name=max-depth]');
				maxDepthField.setLimit(localNs, remoteNs);
				maxDepthField.validate();
			    },
			},
		    },
		    {
			xtype: 'pbsNamespaceMaxDepthReduced',
			name: 'max-depth',
			fieldLabel: gettext('Max. Depth'),
			cbind: {
			    deleteEmpty: '{!isCreate}',
			},
		    },
		    {
			fieldLabel: gettext('Remove vanished'),
			xtype: 'proxmoxcheckbox',
			name: 'remove-vanished',
			autoEl: {
			    tag: 'div',
			    'data-qtip': gettext('Remove snapshots from sync target datastore if they vanished from source datastore?'),
			},
			uncheckedValue: false,
			value: false,
		    },
		],

		columnB: [
		    {
			fieldLabel: gettext('Comment'),
			xtype: 'proxmoxtextfield',
			name: 'comment',
			cbind: {
			    deleteEmpty: '{!isCreate}',
			},
		    },
		],
		advancedColumn1: [
		    {
			xtype: 'pmxDisplayEditField',
			fieldLabel: gettext('Job ID'),
			emptyText: gettext('Autogenerate'),
			name: 'id',
			allowBlank: true,
			regex: PBS.Utils.SAFE_ID_RE,
			cbind: {
			    editable: '{isCreate}',
			},
		    },
		    {
			fieldLabel: gettext('Transfer Last'),
			xtype: 'pbsPruneKeepInput',
			name: 'transfer-last',
			emptyText: gettext('all'),
			autoEl: {
			    tag: 'div',
			    'data-qtip': gettext('The maximum amount of snapshots to be transferred (per group)'),
			},
			cbind: {
			    deleteEmpty: '{!isCreate}',
			},
		    },
		    {
			fieldLabel: gettext('Re-sync corrupt snapshots'),
			xtype: 'proxmoxcheckbox',
			name: 'resync-corrupt',
			autoEl: {
			    tag: 'div',
			    'data-qtip': gettext('Re-sync snapshots, whose verification failed.'),
			},
			cbind: {
			    disabled: '{syncDirectionPush}',
			},
			uncheckedValue: false,
			value: false,
		    },
		],
	    },
	    {
		xtype: 'inputpanel',
		onGetValues: function(values) {
		    let me = this;
		    PBS.Utils.delete_if_default(values, 'group-filter');
		    if (Ext.isArray(values['group-filter'])) {
			if (values['group-filter'].length === 0) {
			    delete values['group-filter'];
			    values.delete = 'group-filter';
			} else {
			    // merge duplicates
			    values['group-filter'] = [...new Set(values['group-filter'])];
			}
		    }
		    if (me.isCreate) {
			delete values.delete;
		    }
		    return values;
		},
		cbind: {
		    isCreate: '{isCreate}', // pass it through
		},
		title: gettext('Group Filter'),
		items: [
		    {
			xtype: 'pbsGroupFilter',
			name: 'group-filter',
		    },
		],
	    },
	],
    },
});
Ext.define('PBS.window.PruneJobEdit', {
    extend: 'Proxmox.window.Edit',
    alias: 'widget.pbsPruneJobEdit',
    mixins: ['Proxmox.Mixin.CBind'],

    userid: undefined,

    onlineHelp: 'maintenance_prune_jobs',

    isAdd: true,

    subject: gettext('Prune Job'),

    defaultFocus: 'proxmoxtextfield[name=comment]',

    cbindData: function(initialConfig) {
	let me = this;

	let baseurl = '/api2/extjs/config/prune';
	let id = initialConfig.id;

	me.isCreate = !id;
	me.url = id ? `${baseurl}/${id}` : baseurl;
	me.method = id ? 'PUT' : 'POST';
	me.autoLoad = !!id;
	me.scheduleValue = id ? null : 'hourly';
	me.editDatastore = me.datastore === undefined && me.isCreate;
	return { };
    },

    controller: {
	xclass: 'Ext.app.ViewController',
	control: {
	    'pbsDataStoreSelector[name=store]': {
		change: 'storeChange',
	    },
	},

	storeChange: function(field, value) {
	    let view = this.getView();
	    let nsSelector = view.down('pbsNamespaceSelector[name=ns]');
	    nsSelector.setDatastore(value);
	},
    },

    items: {
	xtype: 'inputpanel',
	onGetValues: function(values) {
	    let me = this;

	    if (!values.id && me.up('pbsPruneJobEdit').isCreate) {
		values.id = 's-' + Ext.data.identifier.Uuid.Global.generate().slice(0, 13);
	    }
	    if (!me.isCreate) {
		if (typeof values.delete === 'string') {
		    values.delete = values.delete.split(',');
		}
	    }
	    values.disable = !values.enable;
	    delete values.enable;

	    return values;
	},
	onSetValues: function(values) {
	    let me = this;
	    values.enable = !values.disable;
	    delete values.disable;

	    return values;
	},
	column1: [
	    {
		xtype: 'pmxDisplayEditField',
		fieldLabel: gettext('Datastore'),
		name: 'store',
		submitValue: true,
		cbind: {
		    editable: '{editDatastore}',
		    value: '{datastore}',
		},
		editConfig: {
		    xtype: 'pbsDataStoreSelector',
		    allowBlank: false,
		},
	    },
	    {
		xtype: 'pbsNamespaceSelector',
		fieldLabel: gettext('Namespace'),
		name: 'ns',
		cbind: {
		    datastore: '{datastore}',
		},
		listeners: {
		    change: function(field, localNs) {
			let me = this;
			let view = me.up('pbsPruneJobEdit');

			let maxDepthField = view.down('field[name=max-depth]');
			maxDepthField.setLimit(localNs);
			maxDepthField.validate();
		    },
		},
	    },
	    {
		xtype: 'pbsNamespaceMaxDepthReduced',
		name: 'max-depth',
		fieldLabel: gettext('Max. Depth'),
		cbind: {
		    deleteEmpty: '{!isCreate}',
		},
	    },
	],

	column2: [
	    {
		fieldLabel: gettext('Prune Schedule'),
		xtype: 'pbsCalendarEvent',
		name: 'schedule',
		allowBlank: false,
		cbind: {
		    value: '{scheduleValue}',
		},
	    },
	    {
		xtype: 'proxmoxcheckbox',
		fieldLabel: gettext('Enabled'),
		name: 'enable',
		uncheckedValue: 0,
		defaultValue: 1,
		checked: true,
	    },
	],

	columnB: [
	    {
		xtype: 'pbsPruneInputPanel',
		cbind: {
		    isCreate: '{isCreate}',
		},
		getValues: () => ({}), // let that handle our inputpanel here
	    },
	    {
		fieldLabel: gettext('Comment'),
		xtype: 'proxmoxtextfield',
		name: 'comment',
		cbind: {
		    deleteEmpty: '{!isCreate}',
		},
	    },
	],
	advancedColumn1: [
	    {
		xtype: 'pmxDisplayEditField',
		fieldLabel: gettext('Job ID'),
		emptyText: gettext('Autogenerate'),
		name: 'id',
		allowBlank: true,
		regex: PBS.Utils.SAFE_ID_RE,
		cbind: {
		    editable: '{isCreate}',
		},
	    },
	],
    },
});
Ext.define('PBS.window.GCJobEdit', {
    extend: 'Proxmox.window.Edit',
    alias: 'widget.pbsGCJobEdit',
    mixins: ['Proxmox.Mixin.CBind'],

    userid: undefined,
    onlineHelp: 'maintenance_gc',
    isAdd: false,

    subject: gettext('Garbage Collect Schedule'),

    cbindData: function(initial) {
        let me = this;

        me.datastore = encodeURIComponent(me.datastore);
	me.url = `/api2/extjs/config/datastore/${me.datastore}`;
        me.method = 'PUT';
        me.autoLoad = true;
	return {};
    },

    items: {
	xtype: 'pbsCalendarEvent',
	name: 'gc-schedule',
	fieldLabel: gettext("GC Schedule"),
	emptyText: gettext('none (disabled)'),
    },
});
Ext.define('PBS.window.UserEditViewModel', {
    extend: 'Ext.app.ViewModel',
    alias: 'viewmodel.pbsUserEdit',

    data: {
	realm: 'pbs',
    },

    formulas: {
	maySetPassword: function(get) {
	    let realm = get('realm');

	    let view = this.getView();
	    let realmStore = view.down('pmxRealmComboBox').getStore();
	    if (realmStore.isLoaded()) {
		let rec = realmStore.findRecord('realm', realm, 0, false, true, true);
		return Proxmox.Schema.authDomains[rec.data.type]?.pwchange && view.isCreate;
	    } else {
		return view.isCreate;
	    }
	},
    },
});

Ext.define('PBS.window.UserEdit', {
    extend: 'Proxmox.window.Edit',
    alias: 'widget.pbsUserEdit',
    mixins: ['Proxmox.Mixin.CBind'],

    onlineHelp: 'user_mgmt',

    userid: undefined,

    isAdd: true,

    subject: gettext('User'),

    fieldDefaults: { labelWidth: 120 },

    viewModel: {
	type: 'pbsUserEdit',
    },

    cbindData: function(initialConfig) {
	var me = this;

	var userid = initialConfig.userid;
	var baseurl = '/api2/extjs/access/users';

	me.isCreate = !userid;
	me.url = userid ? baseurl + '/' + encodeURIComponent(userid) : baseurl;
	me.method = userid ? 'PUT' : 'POST';
	me.autoLoad = !!userid;

	return {
	    useridXType: userid ? 'displayfield' : 'textfield',
	};
    },

    items: {
	xtype: 'inputpanel',
	column1: [
	    {
		xtype: 'pmxDisplayEditField',
		name: 'userid',
		fieldLabel: gettext('User name'),
		renderer: Ext.htmlEncode,
		allowBlank: false,
		cbind: {
		    editable: '{isCreate}',
		},
	    },
	    {
		xtype: 'pmxRealmComboBox',
		name: 'realm',
		fieldLabel: gettext('Realm'),
		allowBlank: false,
		matchFieldWidth: false,
		listConfig: { width: 300 },
		bind: {
		    value: '{realm}',
		},
		cbind: {
		    hidden: '{!isCreate}',
		    disabled: '{!isCreate}',
		},
		submitValue: true,
		storeFilter: rec => rec.data?.type !== 'pam',
	    },
	    {
		xtype: 'textfield',
		inputType: 'password',
		fieldLabel: gettext('Password'),
		minLength: 8,
		allowBlank: false,
		name: 'password',
		listeners: {
		    change: function(field) {
			field.next().validate();
		    },
		    blur: function(field) {
			field.next().validate();
		    },
		},
		bind: {
		    disabled: '{!maySetPassword}',
		    hidden: '{!maySetPassword}',
		},
	    },
	    {
		xtype: 'textfield',
		inputType: 'password',
		fieldLabel: gettext('Confirm password'),
		name: 'verifypassword',
		vtype: 'password',
		initialPassField: 'password',
		allowBlank: false,
		submitValue: false,
		bind: {
		    disabled: '{!maySetPassword}',
		    hidden: '{!maySetPassword}',
		},
	    },
	    {
		xtype: 'datefield',
		name: 'expire',
		emptyText: Proxmox.Utils.neverText,
		format: 'Y-m-d',
		submitFormat: 'U',
		fieldLabel: gettext('Expire'),
	    },
	    {
		xtype: 'proxmoxcheckbox',
		fieldLabel: gettext('Enabled'),
		name: 'enable',
		uncheckedValue: 0,
		defaultValue: 1,
		checked: true,
	    },
	],

	column2: [
	    {
		xtype: 'proxmoxtextfield',
		name: 'firstname',
		fieldLabel: gettext('First Name'),
		cbind: {
		    deleteEmpty: '{!isCreate}',
		},
	    },
	    {
		xtype: 'proxmoxtextfield',
		name: 'lastname',
		fieldLabel: gettext('Last Name'),
		cbind: {
		    deleteEmpty: '{!isCreate}',
		},
	    },
	    {
		xtype: 'proxmoxtextfield',
		name: 'email',
		fieldLabel: gettext('E-Mail'),
		vtype: 'proxmoxMail',
		cbind: {
		    deleteEmpty: '{!isCreate}',
		},
	    },
	],

	columnB: [
	    {
		xtype: 'proxmoxtextfield',
		name: 'comment',
		fieldLabel: gettext('Comment'),
		cbind: {
		    deleteEmpty: '{!isCreate}',
		},
	    },
	],
    },

    getValues: function(dirtyOnly) {
	let me = this;

	let values = me.callParent(arguments);

	if (!values.expire) {
	    values.expire = 0; // "no expiry" is encoded as 0, so set that explicitly if left empty
	}

	if (me.isCreate) {
	    values.userid = values.userid + '@' + values.realm;
	    delete values.realm;
	}

	if (!values.password) {
	    delete values.password;
	}

	return values;
    },

    setValues: function(values) {
	var me = this;

	if (Ext.isDefined(values.expire)) {
	    if (values.expire) {
		values.expire = new Date(values.expire * 1000);
	    } else {
		// display 'never' instead of '1970-01-01'
		values.expire = null;
	    }
	}

	me.callParent([values]);
    },
});
Ext.define('PBS.window.Settings', {
    extend: 'Ext.window.Window',

    width: '800px',
    title: gettext('My Settings'),
    iconCls: 'fa fa-gear',
    modal: true,
    bodyPadding: 10,
    resizable: false,

    buttons: [
	'->',
	{
	    text: gettext('Close'),
	    handler: function() {
		this.up('window').close();
	    },
	},
    ],

    layout: 'hbox',

    controller: {
	xclass: 'Ext.app.ViewController',

	init: function(view) {
	    let me = this;
	    let sp = Ext.state.Manager.getProvider();

	    let username = sp.get('login-username') || Proxmox.Utils.noneText;
	    me.lookupReference('savedUserName').setValue(Ext.String.htmlEncode(username));

	    let summarycolumns = sp.get('summarycolumns', 'auto');
	    me.lookup('summarycolumns').setValue(summarycolumns);

	    let settings = ['fontSize', 'fontFamily', 'letterSpacing', 'lineHeight'];
	    settings.forEach(function(setting) {
		let val = localStorage.getItem('pve-xterm-' + setting);
		if (val !== undefined && val !== null) {
		    let field = me.lookup(setting);
		    field.setValue(val);
		    field.resetOriginalValue();
		}
	    });
	},

	set_button_status: function() {
	    let me = this;

	    let form = me.lookup('xtermform');
	    let valid = form.isValid();
	    let dirty = form.isDirty();

	    let hasvalues = false;
	    let values = form.getValues();
	    Ext.Object.eachValue(values, function(value) {
		if (value) {
		    hasvalues = true;
		    return false;
		}
		return true;
	    });

	    me.lookup('xtermsave').setDisabled(!dirty || !valid);
	    me.lookup('xtermreset').setDisabled(!hasvalues);
	},

	control: {
	    '#xtermjs form': {
		dirtychange: 'set_button_status',
		validitychange: 'set_button_status',
	    },
	    '#xtermjs button': {
		click: function(button) {
		    let me = this;
		    let settings = ['fontSize', 'fontFamily', 'letterSpacing', 'lineHeight'];
		    settings.forEach(function(setting) {
			let field = me.lookup(setting);
			if (button.reference === 'xtermsave') {
			    let value = field.getValue();
			    if (value) {
				localStorage.setItem('pve-xterm-' + setting, value);
			    } else {
				localStorage.removeItem('pve-xterm-' + setting);
			    }
			} else if (button.reference === 'xtermreset') {
			    field.setValue(undefined);
			    localStorage.removeItem('pve-xterm-' + setting);
			}
			field.resetOriginalValue();
		    });
		    me.set_button_status();
		},
	    },
	    'button[name=reset]': {
		click: function() {
		    let blacklist = ['login-username'];
		    let sp = Ext.state.Manager.getProvider();
		    for (const state of Object.keys(sp.state)) {
			if (blacklist.indexOf(state) !== -1) {
			    continue;
			}

			sp.clear(state);
		    }

		    window.location.reload();
		},
	    },
	    'button[name=clear-username]': {
		click: function() {
		    let me = this;
		    let usernamefield = me.lookupReference('savedUserName');
		    let sp = Ext.state.Manager.getProvider();

		    usernamefield.setValue(Proxmox.Utils.noneText);
		    sp.clear('login-username');
		},
	    },
	    'field[reference=summarycolumns]': {
		change: function(el, newValue) {
		    var sp = Ext.state.Manager.getProvider();
		    sp.set('summarycolumns', newValue);
		},
	    },
	},
    },

    items: [{
	xtype: 'fieldset',
	flex: 1,
	title: gettext('Webinterface Settings'),
	margin: '5',
	layout: {
	    type: 'vbox',
	    align: 'left',
	},
	defaults: {
	    width: '100%',
	    margin: '0 0 10 0',
	},
	items: [
	    {
		xtype: 'container',
		layout: 'hbox',
		items: [
		    {
			xtype: 'displayfield',
			fieldLabel: gettext('Saved User Name') + ':',
			labelWidth: 150,
			stateId: 'login-username',
			reference: 'savedUserName',
			flex: 1,
			value: '',
		    },
		    {
			xtype: 'button',
			cls: 'x-btn-default-toolbar-small proxmox-inline-button',
			text: gettext('Reset'),
			name: 'clear-username',
		    },
		],
	    },
	    {
		xtype: 'box',
		autoEl: { tag: 'hr' },
	    },
	    {
		xtype: 'container',
		layout: 'hbox',
		items: [
		    {
			xtype: 'displayfield',
			fieldLabel: gettext('Layout') + ':',
			flex: 1,
		    },
		    {
			xtype: 'button',
			cls: 'x-btn-default-toolbar-small proxmox-inline-button',
			text: gettext('Reset'),
			tooltip: gettext('Reset all layout changes (for example, column widths)'),
			name: 'reset',
		    },
		],
	    },
	    {
		xtype: 'box',
		autoEl: { tag: 'hr' },
	    },
	    {
		xtype: 'proxmoxKVComboBox',
		fieldLabel: gettext('Summary/Dashboard columns') + ':',
		labelWidth: 150,
		stateId: 'summarycolumns',
		reference: 'summarycolumns',
		comboItems: [
		    ['auto', 'auto'],
		    ['1', '1'],
		    ['2', '2'],
		    ['3', '3'],
		],
	    },
	],
    },
    {
	xtype: 'container',
	layout: 'vbox',
	flex: 1,
	margin: '5',
	defaults: {
	    width: '100%',
	    // right margin ensures that the right border of the fieldsets
	    // is shown
	    margin: '0 2 10 0',
	},
	items: [
	    {
		xtype: 'fieldset',
		itemId: 'xtermjs',
		title: gettext('xterm.js Settings'),
		items: [{
		    xtype: 'form',
		    reference: 'xtermform',
		    border: false,
		    layout: {
			type: 'vbox',
			algin: 'left',
		    },
		    defaults: {
			width: '100%',
			margin: '0 0 10 0',
		    },
		    items: [
			{
			    xtype: 'textfield',
			    name: 'fontFamily',
			    reference: 'fontFamily',
			    emptyText: Proxmox.Utils.defaultText,
			    fieldLabel: gettext('Font-Family'),
			},
			{
			    xtype: 'proxmoxintegerfield',
			    emptyText: Proxmox.Utils.defaultText,
			    name: 'fontSize',
			    reference: 'fontSize',
			    minValue: 1,
			    fieldLabel: gettext('Font-Size'),
			},
			{
			    xtype: 'numberfield',
			    name: 'letterSpacing',
			    reference: 'letterSpacing',
			    emptyText: Proxmox.Utils.defaultText,
			    fieldLabel: gettext('Letter Spacing'),
			},
			{
			    xtype: 'numberfield',
			    name: 'lineHeight',
			    minValue: 0.1,
			    reference: 'lineHeight',
			    emptyText: Proxmox.Utils.defaultText,
			    fieldLabel: gettext('Line Height'),
			},
			{
			    xtype: 'container',
			    layout: {
				type: 'hbox',
				pack: 'end',
			    },
			    defaults: {
				margin: '0 0 0 5',
			    },
			    items: [
				{
				    xtype: 'button',
				    reference: 'xtermreset',
				    disabled: true,
				    text: gettext('Reset'),
				},
				{
				    xtype: 'button',
				    reference: 'xtermsave',
				    disabled: true,
				    text: gettext('Save'),
				},
			    ],
			},
		    ],
		}],
	    },
	],
    }],
});
Ext.define('PBS.window.TokenEdit', {
    extend: 'Proxmox.window.Edit',
    alias: 'widget.pbsTokenEdit',
    mixins: ['Proxmox.Mixin.CBind'],

    onlineHelp: 'user_tokens',

    user: undefined,
    tokenname: undefined,

    isAdd: true,
    isCreate: false,
    fixedUser: false,

    subject: gettext('API token'),

    fieldDefaults: { labelWidth: 120 },

    items: {
	xtype: 'inputpanel',
	column1: [
	    {
		xtype: 'pmxDisplayEditField',
		cbind: {
		    editable: (get) => get('isCreate') && !get('fixedUser'),
		    value: () => Proxmox.UserName,
		},
		editConfig: {
		    xtype: 'pmxUserSelector',
		    allowBlank: false,
		},
		name: 'user',
		renderer: Ext.String.htmlEncode,
		fieldLabel: gettext('User'),
	    },
	    {
		xtype: 'pmxDisplayEditField',
		cbind: {
		    editable: '{isCreate}',
		},
		name: 'tokenname',
		fieldLabel: gettext('Token Name'),
		minLength: 2,
		allowBlank: false,
	    },
	],

	column2: [
	    {
                xtype: 'datefield',
                name: 'expire',
		emptyText: Proxmox.Utils.neverText,
		format: 'Y-m-d',
		submitFormat: 'U',
                fieldLabel: gettext('Expire'),
            },
	    {
		xtype: 'proxmoxcheckbox',
		fieldLabel: gettext('Enabled'),
		name: 'enable',
		uncheckedValue: 0,
		defaultValue: 1,
		checked: true,
	    },
	],

	columnB: [
	    {
		xtype: 'proxmoxtextfield',
		name: 'comment',
		deleteEmpty: true,
		fieldLabel: gettext('Comment'),
	    },
	],
    },

    getValues: function(dirtyOnly) {
	var me = this;

	var values = me.callParent(arguments);

	// hack: ExtJS datefield does not submit 0, so we need to set that
	if (!values.expire) {
	    values.expire = 0;
	}

	if (me.isCreate) {
	    me.url = '/api2/extjs/access/users/';
	    let uid = encodeURIComponent(values.user);
	    let tid = encodeURIComponent(values.tokenname);
	    delete values.user;
	    delete values.tokenname;

	    me.url += `${uid}/token/${tid}`;
	}

	return values;
    },

    setValues: function(values) {
	var me = this;

	if (Ext.isDefined(values.expire)) {
	    if (values.expire) {
		values.expire = new Date(values.expire * 1000);
	    } else {
		// display 'never' instead of '1970-01-01'
		values.expire = null;
	    }
	}

	me.callParent([values]);
    },

    initComponent: function() {
	let me = this;

	me.url = '/api2/extjs/access/users/';

	me.callParent();

	if (me.isCreate) {
	    me.method = 'POST';
	} else {
	    me.method = 'PUT';

	    let uid = encodeURIComponent(me.user);
	    let tid = encodeURIComponent(me.tokenname);

	    me.url += `${uid}/token/${tid}`;
	    me.load({
		success: function(response, options) {
		    let values = response.result.data;
		    values.user = me.user;
		    values.tokenname = me.tokenname;
		    me.setValues(values);
		},
	    });
	}
    },

    apiCallDone: function(success, response, options) {
	let res = response.result.data;
	if (!success || !res || !res.value) {
	    return;
	}

	Ext.create('PBS.window.TokenShow', {
	    autoShow: true,
	    tokenid: res.tokenid,
	    secret: res.value,
	});
    },
});

Ext.define('PBS.window.TokenShow', {
    extend: 'Ext.window.Window',
    alias: ['widget.pbsTokenShow'],
    mixins: ['Proxmox.Mixin.CBind'],

    width: 600,
    modal: true,
    resizable: false,
    title: gettext('Token Secret'),

    items: [
	{
	    xtype: 'container',
	    layout: 'form',
	    bodyPadding: 10,
	    border: false,
	    fieldDefaults: {
		labelWidth: 100,
		anchor: '100%',
            },
	    padding: '0 10 10 10',
	    items: [
		{
		    xtype: 'textfield',
		    fieldLabel: gettext('Token ID'),
		    cbind: {
			value: '{tokenid}',
		    },
		    editable: false,
		},
		{
		    xtype: 'textfield',
		    fieldLabel: gettext('Secret'),
		    inputId: 'token-secret-value',
		    cbind: {
			value: '{secret}',
		    },
		    editable: false,
		},
	    ],
	},
	{
	    xtype: 'component',
	    border: false,
	    padding: '10 10 10 10',
	    userCls: 'pmx-hint',
	    html: gettext('Please record the API token secret - it will only be displayed now'),
	},
    ],
    buttons: [
	{
	    handler: async function(b) {
		let el = document.getElementById('token-secret-value');
		await navigator.clipboard.writeText(el.value);
	    },
	    text: gettext('Copy Secret Value'),
	},
    ],
});
Ext.define('PBS.window.VerifyJobEdit', {
    extend: 'Proxmox.window.Edit',
    alias: 'widget.pbsVerifyJobEdit',
    mixins: ['Proxmox.Mixin.CBind'],

    userid: undefined,

    onlineHelp: 'maintenance-verification',

    isAdd: true,

    subject: gettext('Verification Job'),

    fieldDefaults: { labelWidth: 120 },
    defaultFocus: 'field[name="ignore-verified"]',

    cbindData: function(initialConfig) {
	let me = this;

	let baseurl = '/api2/extjs/config/verify';
	let id = initialConfig.id;

	me.isCreate = !id;
	me.url = id ? `${baseurl}/${id}` : baseurl;
	me.method = id ? 'PUT' : 'POST';
	me.scheduleValue = id ? null : 'daily';
	me.autoLoad = !!id;
	me.editDatastore = me.datastore === undefined && me.isCreate;
	return { };
    },

    viewModel: {
	data: {
	    'ignoreVerified': true,
	},
    },
    controller: {
	xclass: 'Ext.app.ViewController',
	control: {
	    'pbsDataStoreSelector': {
		change: 'storeChange',
	    },
	},

	storeChange: function(field, value) {
	    let view = this.getView();
	    let nsSelector = view.down('pbsNamespaceSelector');
	    nsSelector.setDatastore(value);
	},
    },

    items: {
	xtype: 'inputpanel',
	onGetValues: function(values) {
	    let me = this;

	    if (!values.id && me.up('pbsVerifyJobEdit').isCreate) {
		values.id = 'v-' + Ext.data.identifier.Uuid.Global.generate().slice(0, 13);
	    }
	    return values;
	},
	column1: [
	    {
		xtype: 'pmxDisplayEditField',
		fieldLabel: gettext('Local Datastore'),
		name: 'store',
		submitValue: true,
		cbind: {
		    editable: '{editDatastore}',
		    value: '{datastore}',
		},
		editConfig: {
		    xtype: 'pbsDataStoreSelector',
		    allowBlank: false,
		},
	    },
	    {
		xtype: 'pbsNamespaceSelector',
		name: 'ns',
		fieldLabel: gettext('Namespace'),
		cbind: {
		    datastore: '{datastore}',
		},
	    },
	    {
		xtype: 'pbsNamespaceMaxDepth',
		name: 'max-depth',
		fieldLabel: gettext('Max. Depth'),
		cbind: {
		    deleteEmpty: '{!isCreate}',
		},
	    },
	],

	column2: [
	    {
		xtype: 'pbsCalendarEvent',
		name: 'schedule',
		fieldLabel: gettext('Schedule'),
		emptyText: gettext('none (disabled)'),
		cbind: {
		    value: '{scheduleValue}',
		    deleteEmpty: '{!isCreate}',
		},
	    },
	    {
		xtype: 'proxmoxcheckbox',
		name: 'ignore-verified',
		fieldLabel: gettext('Skip Verified'),
		uncheckedValue: false,
		value: true,
		bind: {
		    value: '{ignoreVerified}',
		},
	    },
	    {
		xtype: 'fieldcontainer',
		layout: 'hbox',
		fieldLabel: gettext('Re-Verify After'),
		items: [
		    {
			xtype: 'pbsVerifyOutdatedAfter',
			name: 'outdated-after',
			bind: {
			    disabled: '{!ignoreVerified}',
			},
			cbind: {
			    deleteEmpty: '{!isCreate}',
			},
			flex: 1,
		    },
		    {
			xtype: 'displayfield',
			padding: '0 0 0 5',
			name: 'unit',
			submitValue: false,
			value: gettext('days'),
			bind: {
			    disabled: '{!ignoreVerified}',
			},
		    },
		],
	    },
	],

	columnB: [
	    {
		fieldLabel: gettext('Comment'),
		xtype: 'proxmoxtextfield',
		name: 'comment',
		cbind: {
		    deleteEmpty: '{!isCreate}',
		},
	    },
	],
	advancedColumn1: [
	    {
		xtype: 'pmxDisplayEditField',
		fieldLabel: gettext('Job ID'),
		emptyText: gettext('Autogenerate'),
		name: 'id',
		allowBlank: true,
		regex: PBS.Utils.SAFE_ID_RE,
		cbind: {
		    editable: '{isCreate}',
		},
	    },
	],
    },
});
Ext.define('PBS.window.VerifyAll', {
    extend: 'Proxmox.window.Edit',
    alias: 'widget.pbsVerifyAll',
    mixins: ['Proxmox.Mixin.CBind'],

    onlineHelp: 'maintenance_verification',

    method: 'POST',
    cbind: {
	title: `Verify Datastore '{datastore}'`,
	url: `/admin/datastore/{datastore}/verify`,
    },

    submitText: gettext('Verify'),
    isCreate: true,
    showTaskViewer: true,
    showReset: false,
    defaultFocus: 'submitbutton',
    width: 450,
    items: [
	{
	    xtype: 'inputpanel',
	    viewModel: {
		data: { ignoreVerified: true },
	    },
	    onGetValues: values => {
		if (!values.ns || values.ns === '') {
		    delete values.ns;
		}
		return values;
	    },
	    items: [
		{
		    xtype: 'pbsNamespaceSelector',
		    name: 'ns',
		    fieldLabel: gettext('Namespace'),
		    cbind: {
			datastore: '{datastore}',
			value: '{namespace}',
		    },
		},
		{
		    xtype: 'pbsNamespaceMaxDepth',
		    name: 'max-depth',
		    deleteEmpty: false,
		},
		{
		    xtype: 'fieldcontainer',
		    layout: 'hbox',
		    fieldLabel: gettext('Skip Verified'),
		    items: [
			{
			    xtype: 'proxmoxcheckbox',
			    name: 'ignore-verified',
			    uncheckedValue: false,
			    value: true,
			    bind: {
				value: '{ignoreVerified}',
			    },
			},
			{
			    xtype: 'pbsVerifyOutdatedAfter',
			    name: 'outdated-after',
			    fieldLabel: gettext('Re-Verify After'),
			    padding: '0 0 0 5',
			    bind: {
				disabled: '{!ignoreVerified}',
			    },
			    flex: 1,
			},
			{
			    xtype: 'displayfield',
			    name: 'unit',
			    submitValue: false,
			    padding: '0 0 0 5',
			    value: gettext('days'),
			    bind: {
				disabled: '{!ignoreVerified}',
			    },
			},
		    ],
		},
	    ],
	},
    ],
});
Ext.define('PBS.window.CreateZFS', {
    extend: 'Proxmox.window.Edit',
    xtype: 'pbsCreateZFS',

    subject: 'ZFS',

    showProgress: true,
    isCreate: true,

    onlineHelp: 'chapter_zfs',

    width: 800,

    url: '/nodes/localhost/disks/zfs',
    method: 'POST',
    items: [
	{
	    xtype: 'inputpanel',
	    onGetValues: function(values) {
		return values;
	    },
	    column1: [
		{
		    xtype: 'proxmoxtextfield',
		    name: 'name',
		    fieldLabel: gettext('Name'),
		    minLength: 3,
		    allowBlank: false,
		},
		{
		    xtype: 'proxmoxcheckbox',
		    name: 'add-datastore',
		    fieldLabel: gettext('Add as Datastore'),
		    value: '1',
		},
	    ],
	    column2: [
		{
		    xtype: 'proxmoxKVComboBox',
		    fieldLabel: gettext('RAID Level'),
		    name: 'raidlevel',
		    value: 'single',
		    comboItems: [
			['single', gettext('Single Disk')],
			['mirror', 'Mirror'],
			['raid10', 'RAID10'],
			['raidz', 'RAIDZ'],
			['raidz2', 'RAIDZ2'],
			['raidz3', 'RAIDZ3'],
		    ],
		},
		{
		    xtype: 'proxmoxKVComboBox',
		    fieldLabel: gettext('Compression'),
		    name: 'compression',
		    value: 'on',
		    comboItems: [
			['on', 'on'],
			['off', 'off'],
			['gzip', 'gzip'],
			['lz4', 'lz4'],
			['lzjb', 'lzjb'],
			['zle', 'zle'],
			['zstd', 'zstd'],
		    ],
		},
		{
		    xtype: 'proxmoxintegerfield',
		    fieldLabel: gettext('ashift'),
		    minValue: 9,
		    maxValue: 16,
		    value: '12',
		    name: 'ashift',
		},
	    ],
	    columnB: [
		{
		    xtype: 'pmxMultiDiskSelector',
		    name: 'devices',
		    nodename: 'localhost',
		    typeParameter: 'usage-type',
		    valueField: 'name',
		    height: 200,
		    emptyText: gettext('No Disks unused'),
		},
	    ],
	},
	{
	    xtype: 'displayfield',
	    padding: '5 0 0 0',
	    userCls: 'pmx-hint',
	    value: 'Note: ZFS is not compatible with disks backed by a hardware ' +
	    'RAID controller. For details see ' +
	    '<a target="_blank" href="' + Proxmox.Utils.get_help_link('chapter_zfs') + '">the reference documentation</a>.',
	},
    ],
});
Ext.define('PBS.window.InfluxDbHttpEdit', {
    extend: 'Proxmox.window.Edit',
    mixins: ['Proxmox.Mixin.CBind'],

    subject: 'InfluxDB (HTTP)',

    cbindData: function() {
	let me = this;
	me.isCreate = !me.serverid;
	me.serverid = me.serverid || "";
	me.url = `/api2/extjs/config/metrics/influxdb-http/${me.serverid}`;
	me.tokenEmptyText = me.isCreate ? '' : gettext('unchanged');
	me.method = me.isCreate ? 'POST' : 'PUT';
	if (!me.isCreate) {
	    me.subject = `${me.subject}: ${me.serverid}`;
	}
	return {};
    },

    items: [
	{
	    xtype: 'inputpanel',

	    column1: [
		{
		    xtype: 'pmxDisplayEditField',
		    name: 'name',
		    fieldLabel: gettext('Name'),
		    allowBlank: false,
		    cbind: {
			editable: '{isCreate}',
			value: '{serverid}',
		    },
		},
		{
		    xtype: 'proxmoxtextfield',
		    name: 'url',
		    fieldLabel: gettext('URL'),
		    allowBlank: false,
		},
	    ],

	    column2: [
		{
		    xtype: 'checkbox',
		    name: 'enable',
		    fieldLabel: gettext('Enabled'),
		    inputValue: 1,
		    uncheckedValue: 0,
		    checked: true,
		},
		{
		    xtype: 'proxmoxtextfield',
		    name: 'organization',
		    fieldLabel: gettext('Organization'),
		    emptyText: 'proxmox',
		    cbind: {
			deleteEmpty: '{!isCreate}',
		    },
		},
		{
		    xtype: 'proxmoxtextfield',
		    name: 'bucket',
		    fieldLabel: gettext('Bucket'),
		    emptyText: 'proxmox',
		    cbind: {
			deleteEmpty: '{!isCreate}',
		    },
		},
		{
		    xtype: 'proxmoxtextfield',
		    name: 'token',
		    fieldLabel: gettext('Token'),
		    allowBlank: true,
		    deleteEmpty: false,
		    submitEmpty: false,
		    cbind: {
			emptyText: '{tokenEmptyText}',
		    },
		},
	    ],

	    columnB: [
		{
		    xtype: 'proxmoxtextfield',
		    name: 'comment',
		    fieldLabel: gettext('Comment'),
		    cbind: {
			deleteEmpty: '{!isCreate}',
		    },
		},
	    ],

	    advancedColumn1: [
		{
		    xtype: 'proxmoxintegerfield',
		    name: 'max-body-size',
		    fieldLabel: gettext('Batch Size (b)'),
		    minValue: 1,
		    emptyText: '25000000',
		    submitEmpty: false,
		    cbind: {
			deleteEmpty: '{!isCreate}',
		    },
		},
	    ],
	},
    ],
});

Ext.define('PBS.window.InfluxDbUdpEdit', {
    extend: 'Proxmox.window.Edit',
    mixins: ['Proxmox.Mixin.CBind'],

    subject: 'InfluxDB (UDP)',

    cbindData: function() {
	let me = this;
	me.isCreate = !me.serverid;
	me.serverid = me.serverid || "";
	me.url = `/api2/extjs/config/metrics/influxdb-udp/${me.serverid}`;
	me.method = me.isCreate ? 'POST' : 'PUT';
	if (!me.isCreate) {
	    me.subject = `${me.subject}: ${me.serverid}`;
	}
	return {};
    },

    items: [
	{
	    xtype: 'inputpanel',

	    onGetValues: function(values) {
		values.host += `:${values.port}`;
		delete values.port;
		return values;
	    },

	    column1: [
		{
		    xtype: 'pmxDisplayEditField',
		    name: 'name',
		    fieldLabel: gettext('Name'),
		    allowBlank: false,
		    cbind: {
			editable: '{isCreate}',
			value: '{serverid}',
		    },
		},
		{
		    xtype: 'proxmoxtextfield',
		    name: 'host',
		    fieldLabel: gettext('Host'),
		    allowBlank: false,
		},
	    ],

	    column2: [
		{
		    xtype: 'checkbox',
		    name: 'enable',
		    fieldLabel: gettext('Enabled'),
		    inputValue: 1,
		    uncheckedValue: 0,
		    checked: true,
		},
		{
		    xtype: 'proxmoxintegerfield',
		    name: 'port',
		    minValue: 1,
		    maxValue: 65535,
		    fieldLabel: gettext('Port'),
		    allowBlank: false,
		},
	    ],

	    columnB: [
		{
		    xtype: 'proxmoxtextfield',
		    name: 'comment',
		    fieldLabel: gettext('Comment'),
		    cbind: {
			deleteEmpty: '{!isCreate}',
		    },
		},
	    ],

	    advancedColumn1: [
		{
		    xtype: 'proxmoxintegerfield',
		    name: 'mtu',
		    fieldLabel: 'MTU',
		    minValue: 1,
		    emptyText: '1500',
		    submitEmpty: false,
		    cbind: {
			deleteEmpty: '{!isCreate}',
		    },
		},
	    ],
	},
    ],

    initComponent: function() {
	let me = this;
	me.callParent();

	if (me.serverid) {
	    me.load({
		    success: function(response, options) {
			let values = response.result.data;
			let [_match, host, port] = /^(.*):(\d+)$/.exec(values.host) || [];
			values.host = host;
			values.port = port;
			me.setValues(values);
		    },
	    });
	}
    },
});
Ext.define('PBS.window.DatastoreRepoInfo', {
    extend: 'Ext.window.Window',
    alias: 'widget.pbsDatastoreRepoInfo',
    mixins: ['Proxmox.Mixin.CBind'],

    title: gettext('Connection Information'),

    modal: true,
    resizable: false,
    width: 600,
    layout: 'anchor',
    bodyPadding: 10,

    cbindData: function() {
	let me = this;
	let fingerprint = Proxmox.Fingerprint;
	let host = window.location.hostname;
	let hostname = host;
	if (window.location.port.toString() !== "8007") {
	    host += `:${window.location.port}`;
	}
	let datastore = me.datastore;
	let user = Proxmox.UserName;
	let repository = `${host}:${datastore}`;
	let repositoryWithUser = `${user}@${host}:${datastore}`;

	return {
	    datastore,
	    hostname,
	    fingerprint,
	    repository,
	    repositoryWithUser,
	};
    },

    defaults: {
	xtype: 'pbsCopyField',
	labelWidth: 120,
    },

    items: [
	{
	    fieldLabel: gettext('Datastore'),
	    cbind: {
		value: '{datastore}',
	    },
	},
	{
	    fieldLabel: gettext('Hostname/IP'),
	    cbind: {
		value: '{hostname}',
	    },
	},
	{
	    fieldLabel: gettext('Fingerprint'),
	    cbind: {
		value: '{fingerprint}',
		hidden: '{!fingerprint}',
	    },
	},
	{
	    xtype: 'displayfield',
	    value: '',
	    labelWidth: 500,
	    fieldLabel: gettext('Repository for CLI and API'),
	    padding: '10 0 0 0',
	},
	{
	    fieldLabel: gettext('Repository'),
	    cbind: {
		value: '{repository}',
	    },
	},
	{
	    fieldLabel: gettext('With Current User'),
	    cbind: {
		value: '{repositoryWithUser}',
	    },
	},
    ],
    buttons: [
	{
	    xtype: 'proxmoxHelpButton',
	    onlineHelp: 'client_repository',
	    hidden: false,
	},
	'->',
	{
	    text: gettext('Ok'),
	    handler: function() {
		this.up('window').close();
	    },
	},
    ],
});

Ext.define('PBS.form.CopyField', {
    extend: 'Ext.form.FieldContainer',
    alias: 'widget.pbsCopyField',

    layout: 'hbox',

    items: [
	{
	    xtype: 'textfield',
	    itemId: 'inputField',
	    editable: false,
	    flex: 1,
	},
	{
	    xtype: 'button',
	    margin: '0 0 0 10',
	    iconCls: 'fa fa-clipboard x-btn-icon-el-default-toolbar-small',
	    baseCls: 'x-btn',
	    cls: 'x-btn-default-toolbar-small proxmox-inline-button',
	    handler: async function() {
		let me = this;
		let field = me.up('pbsCopyField');
		let el = field.getComponent('inputField')?.inputEl;
		if (!el?.dom) {
		    return;
		}
		await navigator.clipboard.writeText(el.dom.value);
	    },
	    text: gettext('Copy'),
	},
    ],

    initComponent: function() {
	let me = this;
	me.callParent();
	me.getComponent('inputField').setValue(me.value);
    },
});
Ext.define('pbs-datastore-statistics', {
    extend: 'Ext.data.Model',

    fields: [
	'store',
	{
	    name: 'total',
	    calculate: function(data) {
		return data.avail + data.used;
	    },
	},
	'used',
	'avail',
	'estimated-full-date',
	'error',
	{
	    name: 'history',
	    convert: function(values) {
		if (!values) {
		    return [];
		}
		let last = null;
		return values.map(v => {
		    if (v !== undefined && v !== null) {
			last = v;
		    }
		    return last;
		});
	    },
	},
	{
	    name: 'usage',
	    calculate: function(data) {
		let used = data.used || 0;
		let total = data.total || 0;
		if (total > 0) {
		    return used/total;
		} else {
		    return -1;
		}
	    },
	},
    ],

    proxy: {
        type: 'proxmox',
	url: "/api2/json/status/datastore-usage",
    },
    idProperty: 'store',
});

Ext.define('PBS.DatastoreStatistics', {
    extend: 'Ext.grid.Panel',
    alias: 'widget.pbsDatastoresStatistics',

    title: gettext('Datastore Usage'),
    disableSelection: true,

    emptyText: gettext('No Data'),

    controller: {
	xclass: 'Ext.app.ViewController',

	init: function(view) {
	    Proxmox.Utils.monStoreErrors(view, view.getStore().rstore);
	},
    },

    columns: [
	{
	    text: gettext('Name'),
	    dataIndex: 'store',
	    sortable: true,
	    renderer: (value, metaData, record, rowIndex, colIndex, store) => {
		let err = record.get('error');
		if (err) {
		    metaData.tdAttr = `data-qtip="${Ext.htmlEncode(err)}"`;
		    metaData.tdCls = 'proxmox-invalid-row';
		    return `${value || ''} <i class="fa fa-fw critical fa-exclamation-circle"></i>`;
		}
		return value;
	    },
	},
	{
	    text: gettext('Size'),
	    dataIndex: 'total',
	    sortable: true,
	    width: 90,
	    renderer: v => v === undefined || v < 0 ? '-' : Proxmox.Utils.format_size(v, true),
	},
	{
	    text: gettext('Used'),
	    dataIndex: 'used',
	    sortable: true,
	    width: 90,
	    renderer: v => v === undefined || v < 0 ? '-' : Proxmox.Utils.format_size(v, true),
	},
	{
	    text: gettext('Available'),
	    dataIndex: 'avail',
	    sortable: true,
	    width: 90,
	    renderer: v => v === undefined || v < 0 ? '-' : Proxmox.Utils.format_size(v, true),
	},
	{
	    text: gettext('Usage %'),
	    dataIndex: 'usage',
	    sortable: true,
	    xtype: 'widgetcolumn',
	    widget: {
		xtype: 'progressbarwidget',
		bind: '{record.usage}',
		textTpl: [
		    '<tpl if="value &gt;= 0">',
		    '{value:number("0.00")*100}%',
		    '<tpl else>',
		    Proxmox.Utils.unknownText,
		    '</tpl>',
		],
	    },
	},
	{
	    text: gettext('Estimated Full'),
	    dataIndex: 'estimated-full-date',
	    sortable: true,
	    renderer: PBS.Utils.render_estimate,
	    flex: 1,
	    minWidth: 130,
	    maxWidth: 200,
	},
	{
	    text: gettext("History (last Month)"),
	    width: 100,
	    xtype: 'widgetcolumn',
	    dataIndex: 'history',
	    flex: 1,
	    widget: {
		xtype: 'sparklineline',
		bind: '{record.history}',
		spotRadius: 0,
		fillColor: '#ddd',
		lineColor: '#555',
		lineWidth: 0,
		chartRangeMin: 0,
		chartRangeMax: 1,
		tipTpl: '{y:number("0.00")*100}%',
	    },
	},
    ],

    store: {
	type: 'diff',
	autoDestroy: true,
	autoDestroyRstore: true,
	sorters: 'store',
	rstore: {
	    type: 'update',
	    storeid: 'pbs-datastore-statistics',
	    model: 'pbs-datastore-statistics',
	    autoStart: true,
	    interval: 30000,
	},
    },

});
Ext.define('PBS.LongestTasks', {
    extend: 'Ext.grid.Panel',
    alias: 'widget.pbsLongestTasks',

    title: gettext('Longest Tasks'),

    hideHeaders: true,
    rowLines: false,

    emptyText: gettext('No Tasks'),

    controller: {
	xclass: 'Ext.app.ViewController',

	openTask: function(record) {
	    let me = this;
	    Ext.create('Proxmox.window.TaskViewer', {
		upid: record.data.upid,
		endtime: record.data.endtime,
	    }).show();
	},

	openTaskItemDblClick: function(grid, record) {
	    this.openTask(record);
	},

	openTaskActionColumn: function(grid, rowIndex) {
	    this.openTask(grid.getStore().getAt(rowIndex));
	},

	render_status: function(value) {
	    let cls = 'times-circle critical';
	    if (value === 'OK') {
		cls = 'check-circle good';
	    } else if (value.startsWith('WARNINGS:')) {
		cls = 'exclamation-circle warning';
	    } else if (value === 'unknown') {
		cls = 'question-circle faded';
	    }

	    return `<i class="fa fa-${cls}"></i>`;
	},
    },

    updateTasks: function(data) {
	let me = this;
	me.getStore().setData(data);
    },

    listeners: {
	itemdblclick: 'openTaskItemDblClick',
    },

    store: {
	type: 'diff',
	autoDestroy: true,
	autoDestroyRstore: true,
	sorters: [
	    {
		property: 'duration',
		direction: 'DESC',
	    },
	    {
		property: 'upid',
		direction: 'ASC',
	    },
	],
	rstore: {
	    storeid: 'proxmox-tasks-dash',
	    type: 'store',
	    model: 'proxmox-tasks',
	    proxy: {
		type: 'memory',
	    },
	},
    },

    columns: [
	{
	    text: gettext('Task'),
	    dataIndex: 'upid',
	    renderer: Proxmox.Utils.render_upid,
	    flex: 1,
	},
	{
	    text: gettext('Duration'),
	    dataIndex: 'duration',
	    renderer: Proxmox.Utils.format_duration_human,
	},
	{
	    text: gettext('Status'),
	    align: 'center',
	    width: 40,
	    dataIndex: 'status',
	    renderer: 'render_status',
	},
	{
	    xtype: 'actioncolumn',
	    width: 40,
	    items: [
		{
		    iconCls: 'fa fa-chevron-right',
		    tooltip: gettext('Open Task'),
		    handler: 'openTaskActionColumn',
		},
	    ],
	},
    ],
});
Ext.define('PBS.RunningTasks', {
    extend: 'Ext.grid.Panel',
    alias: 'widget.pbsRunningTasks',

    title: gettext('Running Tasks'),
    emptyText: gettext('No running tasks'),

    hideHeaders: true,
    rowLines: false,

    scrollable: true,
    maxHeight: 500,

    viewConfig: {
	deferEmptyText: false,
    },

    controller: {
	xclass: 'Ext.app.ViewController',

	openTask: function(record) {
	    let me = this;
	    let view = me.getView();
	    Ext.create('Proxmox.window.TaskViewer', {
		upid: record.data.upid,
		endtime: record.data.endtime,
	    }).show();

	    view.fireEvent('taskopened', view, record.data.upid);
	},

	openTaskItemDblClick: function(grid, record) {
	    this.openTask(record);
	},

	openTaskActionColumn: function(grid, rowIndex) {
	    this.openTask(grid.getStore().getAt(rowIndex));
	},

	render_status: function(value) {
	    let cls = 'times-circle critical';
	    if (value === 'OK') {
		cls = 'check-circle good';
	    } else if (value.startsWith('WARNINGS:')) {
		cls = 'exclamation-circle warning';
	    } else if (value === 'unknown') {
		cls = 'question-circle faded';
	    }

	    return `<i class="fa fa-${cls}"></i>`;
	},
    },

    updateTasks: function(data) {
	let me = this;
	me.getStore().setData(data);
    },

    listeners: {
	itemdblclick: 'openTaskItemDblClick',
    },

    store: {
	type: 'diff',
	autoDestroy: true,
	sorters: 'starttime',
	rstore: PBS.data.RunningTasksStore,
    },

    columns: [
	{
	    text: gettext('Task'),
	    dataIndex: 'upid',
	    renderer: Proxmox.Utils.render_upid,
	    flex: 2,
	},
	{
	    text: gettext('Starttime'),
	    dataIndex: 'starttime',
	    renderer: function(value) {
		return Ext.Date.format(value, "Y-m-d H:i:s");
	    },
	    flex: 1,
	},
	{
	    text: gettext('Duration'),
	    dataIndex: 'duration',
	    renderer: function(value, md, record) {
		return Proxmox.Utils.format_duration_human((Date.now() - record.data.starttime)/1000);
	    },
	},
	{
	    xtype: 'actioncolumn',
	    width: 40,
	    items: [
		{
		    iconCls: 'fa fa-chevron-right',
		    tooltip: gettext('Open Task'),
		    handler: 'openTaskActionColumn',
		},
	    ],
	},
    ],
});

Ext.define('PBS.TaskSummary', {
    extend: 'Ext.panel.Panel',
    alias: 'widget.pbsTaskSummary',

    title: gettext('Task Summary'),

    states: [
	"",
	"error",
	"warning",
	"ok",
    ],

    types: [
	"backup",
	"prune",
	"garbage_collection",
	"sync",
	"verify",
	"tape-backup",
	"tape-restore",
    ],

    typeFilterMap: {
	'verify': 'verif', // some verify task start with 'verification''
    },

    titles: {
	"backup": gettext('Backups'),
	"prune": gettext('Prunes'),
	"garbage_collection": gettext('Garbage collections'),
	"sync": gettext('Syncs'),
	"verify": gettext('Verify'),
	"tape-backup": gettext('Tape Backup'),
	"tape-restore": gettext('Tape Restore'),
    },

    // set true to show the onclick panel as modal grid
    subPanelModal: false,

    // the datastore the onclick panel is filtered by
    datastore: undefined,

    controller: {
	xclass: 'Ext.app.ViewController',


	openTaskList: function(grid, td, cellindex, record, tr, rowindex) {
	    let me = this;
	    let view = me.getView();

	    if (cellindex > 0) {
		let tasklist = view.tasklist;
		let state = view.states[cellindex];
		let type = view.types[rowindex];
		let typefilter = type;
		if (view.typeFilterMap[type] !== undefined) {
		    typefilter = view.typeFilterMap[type];
		}

		let filterParam = {
		    limit: 0,
		    'statusfilter': state,
		    'typefilter': typefilter,
		};

		if (me.since) {
		    filterParam.since = me.since;
		}

		if (view.datastore) {
		    filterParam.store = view.datastore;
		}

		if (record.data[state] === 0 || record.data[state] === undefined) {
		    return;
		}

		if (tasklist === undefined) {
		    tasklist = Ext.create('Ext.grid.Panel', {
			tools: [{
			    type: 'close',
			    handler: () => tasklist.setVisible(false),
			}],
			floating: true,
			scrollable: true,

			height: 400,
			width: 600,

			columns: [
			    {
				text: gettext('Task'),
				dataIndex: 'upid',
				renderer: Proxmox.Utils.render_upid,
				flex: 1,
			    },
			    {
				header: gettext("Start Time"),
				dataIndex: 'starttime',
				width: 130,
				renderer: function(value) {
				    return Ext.Date.format(value, "M d H:i:s");
				},
			    },
			    {
				xtype: 'actioncolumn',
				width: 40,
				items: [
				    {
					iconCls: 'fa fa-chevron-right',
					tooltip: gettext('Open Task'),
					handler: function(g, rowIndex) {
					    let rec = tasklist.getStore().getAt(rowIndex);
					    tasklist.setVisible(false);
					    Ext.create('Proxmox.window.TaskViewer', {
						upid: rec.data.upid,
						endtime: rec.data.endtime,
						listeners: {
						    close: () => tasklist.setVisible(true),
						},
					    }).show();
					},
				    },
				],
			    },
			],

			store: {
			    sorters: [
				{
				    property: 'starttime',
				    direction: 'DESC',
				},
			    ],
			    type: 'store',
			    model: 'proxmox-tasks',
			    proxy: {
				type: 'proxmox',
				url: "/api2/json/nodes/localhost/tasks",
			    },
			},
		    });

		    view.on('destroy', function() {
			tasklist.setVisible(false);
			tasklist.destroy();
			tasklist = undefined;
		    });

		    view.tasklist = tasklist;
		} else {
		    let cidx = tasklist.cidx;
		    let ridx = tasklist.ridx;

		    if (cidx === cellindex && ridx === rowindex && tasklist.isVisible()) {
			tasklist.setVisible(false);
			return;
		    }
		}

		tasklist.cidx = cellindex;
		tasklist.ridx = rowindex;

		let task = view.titles[type];
		let status = "";
		switch (state) {
		    case 'ok': status = gettext("OK"); break;
		    case 'warnings': status = gettext("Warning"); break;
		    case 'error': status = Proxmox.Utils.errorText; break;
		}
		let icon = me.render_icon(state, 1);
		tasklist.setTitle(`${task} - ${status} ${icon}`);
		tasklist.getStore().getProxy().setExtraParams(filterParam);
		tasklist.getStore().removeAll();

		if (view.subPanelModal) {
		    tasklist.modal = true;
		    tasklist.showBy(Ext.getBody(), 'c-c');
		} else {
		    tasklist.modal = false;
		    tasklist.showBy(td, 'bl-tl');
		}
		setTimeout(() => tasklist.getStore().reload(), 10);
	    }
	},

	render_icon: function(state, count) {
	    let cls = 'question';
	    let color = 'faded';
	    switch (state) {
		case "error":
		    cls = "times-circle";
		    color = "critical";
		    break;
		case "warning":
		    cls = "exclamation-circle";
		    color = "warning";
		    break;
		case "ok":
		    cls = "check-circle";
		    color = "good";
		    break;
		default: break;
	    }

	    if (count < 1) {
		color = "faded";
	    }
	    cls += " " + color;
	    return `<i class="fa fa-${cls}"></i>`;
	},

	render_count: function(value, md, record, rowindex, colindex) {
	    let me = this;
	    let view = me.getView();
	    let count = value || 0;
	    if (count > 0) {
		md.tdCls = 'pointer';
	    }
	    let icon = me.render_icon(view.states[colindex], count);
	    return `${icon} ${value || 0}`;
	},
    },

    updateTasks: function(source, since) {
	let me = this;
	let controller = me.getController();
	let data = [];
	if (!source) {
	    source = {};
	}
	me.types.forEach((type) => {
	    if (!source[type]) {
		source[type] = {
		    error: 0,
		    warning: 0,
		    ok: 0,
		};
	    }
	    source[type].type = me.titles[type];
	    data.push(source[type]);
	});
	me.lookup('grid').getStore().setData(data);
	controller.since = since;
    },

    layout: 'fit',
    bodyPadding: 15,
    minHeight: 166,

    // we have to wrap the grid in a panel to get the padding right
    items: [
	{
	    xtype: 'grid',
	    reference: 'grid',
	    hideHeaders: true,
	    border: false,
	    bodyBorder: false,
	    rowLines: false,
	    viewConfig: {
		stripeRows: false,
		trackOver: true,
	    },
	    scrollable: false,
	    disableSelection: true,

	    store: {
		data: [],
	    },

	    listeners: {
		cellclick: 'openTaskList',
	    },

	    columns: [
		{
		    dataIndex: 'type',
		    flex: 1,
		},
		{
		    dataIndex: 'error',
		    renderer: 'render_count',
		},
		{
		    dataIndex: 'warning',
		    renderer: 'render_count',
		},
		{
		    dataIndex: 'ok',
		    renderer: 'render_count',
		},
	    ],
	},
    ],

});
Ext.define('PBS.panel.XtermJsConsole', {
    extend: 'Ext.panel.Panel',
    alias: 'widget.pbsXtermJsConsole',

    layout: 'fit',

    items: [
	{
	    xtype: 'uxiframe',
	    itemId: 'iframe',
	},
    ],

    listeners: {
	'afterrender': function() {
	    let me = this;
	    let params = {
		console: 'shell',
		node: 'localhost',
		xtermjs: 1,
	    };
	    me.getComponent('iframe').load('/?' + Ext.Object.toQueryString(params));
	},
    },
});
Ext.define('PBS.AccessControlPanel', {
    extend: 'Ext.tab.Panel',
    alias: 'widget.pbsAccessControlPanel',
    mixins: ['Proxmox.Mixin.CBind'],

    title: gettext('Access Control'),

    tools: [PBS.Utils.get_help_tool("user-mgmt")],

    border: false,
    defaults: {
	border: false,
    },

    items: [
	{
	    xtype: 'pbsUserView',
	    title: gettext('User Management'),
	    itemId: 'users',
	    iconCls: 'fa fa-user',
	},
	{
	    xtype: 'pmxTfaView',
	    title: gettext('Two Factor Authentication'),
	    itemId: 'tfa',
	    iconCls: 'fa fa-key',
	},
	{
	    xtype: 'pbsTokenView',
	    title: gettext('API Token'),
	    itemId: 'apitokens',
	    iconCls: 'fa fa-user-o',
	},
	{
	    xtype: 'pbsACLView',
	    title: gettext('Permissions'),
	    itemId: 'permissions',
	    iconCls: 'fa fa-unlock',
	},
	{
	    xtype: 'pmxAuthView',
	    baseUrl: '/config/access',
	    useTypeInUrl: true,
	    title: gettext('Realms'),
	    itemId: 'domains',
	    iconCls: 'fa fa-address-book-o',
	},
    ],

});
Ext.define('PBS.StorageAndDiskPanel', {
    extend: 'Ext.tab.Panel',
    alias: 'widget.pbsStorageAndDiskPanel',
    mixins: ['Proxmox.Mixin.CBind'],

    title: gettext('Storage / Disks'),

    tools: [PBS.Utils.get_help_tool("storage-disk-management")],

    border: false,
    defaults: {
	border: false,
    },

    items: [
	{
	    xtype: 'pmxDiskList',
	    title: gettext('Disks'),
	    includePartitions: true,
	    supportsWipeDisk: true,
	    itemId: 'disks',
	    iconCls: 'fa fa-hdd-o',
	},
	{
	    xtype: 'pbsDirectoryList',
	    title: Proxmox.Utils.directoryText,
	    itemId: 'directorystorage',
	    iconCls: 'fa fa-folder',
	},
	{
	    xtype: 'pbsZFSList',
	    title: "ZFS",
	    nodename: 'localhost',
	    iconCls: 'fa fa-th-large',
	    itemId: 'zfsstorage',
	},
    ],

});
Ext.define('PBS.widget.UsageChart', {
    extend: 'Ext.container.Container',
    alias: 'widget.pbsUsageChart',

    layout: {
	type: 'hbox',
	align: 'center',
    },

    items: [
	{
	    width: 80,
	    xtype: 'box',
	    itemId: 'title',
	    data: {
		title: '',
	    },
	    tpl: '<h3>{title}:</h3>',
	},
	{
	    flex: 1,
	    xtype: 'cartesian',
	    downloadServerUrl: '-',
	    height: '100%',
	    itemId: 'chart',
	    border: false,
	    axes: [
		{
		    type: 'numeric',
		    position: 'right',
		    hidden: false,
		    minimum: 0,
		    // TODO: make this configurable?!
		    maximum: 1,
		    renderer: (axis, label) => `${label*100}%`,
		},
		{
		    type: 'time',
		    position: 'bottom',
		    hidden: true,
		},
	    ],

	    store: {
		trackRemoved: false,
		data: {},
	    },

	    series: [{
		type: 'line',
		xField: 'time',
		yField: 'val',
		fill: 'true',
		colors: ['#cfcfcf'],
		tooltip: {
		    trackMouse: true,
		    renderer: function(tooltip, record, ctx) {
			if (!record || !record.data) return;
			let date = new Date(record.data.time);
			date = Ext.Date.format(date, 'c');
			let value = (100*record.data.val).toFixed(2);
			tooltip.setHtml(
			    `${value} %<br />
			    ${date}`,
			);
		    },
		},
		style: {
		    lineWidth: 1.5,
		    opacity: 0.60,
		},
		marker: {
		    opacity: 0,
		    scaling: 0.01,
		    fx: {
			duration: 200,
			easing: 'easeOut',
		    },
		},
		highlightCfg: {
		    opacity: 1,
		    scaling: 1.5,
		},
	    }],
	},
    ],

    setData: function(data) {
	let me = this;
	let chart = me.chart;
	chart.store.setData(data);
	chart.redraw();
    },

    // the renderer for the tooltip and last value, default just the value
    renderer: Ext.identityFn,

    setTitle: function(title) {
	let me = this;
	me.title = title;
	me.getComponent('title').update({ title: title });
    },

    checkThemeColors: function() {
	let me = this;
	let rootStyle = getComputedStyle(document.documentElement);

	// get color
	let background = rootStyle.getPropertyValue("--pwt-panel-background").trim() || "#ffffff";
	let text = rootStyle.getPropertyValue("--pwt-text-color").trim() || "#000000";
	let gridStroke = rootStyle.getPropertyValue("--pwt-chart-grid-stroke").trim() || "#dddddd";

	// set the colors
	me.chart.setBackground(background);
	if (!me.color) {
	    me.chart.axes.forEach((axis) => {
		axis.setLabel({ color: text });
		axis.setTitle({ color: text });
		axis.setStyle({ strokeStyle: gridStroke });
	    });
	}
	me.chart.redraw();
    },

    initComponent: function() {
	var me = this;
	me.callParent();

	if (me.title) {
	    me.getComponent('title').update({ title: me.title });
	}
	me.chart = me.getComponent('chart');
	me.chart.timeaxis = me.chart.getAxes()[1];
	if (me.color) {
	    me.chart.series[0].setStyle({
		fill: me.color,
		stroke: me.color,
	    });
	}

	me.checkThemeColors();

	// switch colors on media query changes
	me.mediaQueryList = window.matchMedia("(prefers-color-scheme: dark)");
	me.themeListener = (e) => { me.checkThemeColors(); };
	me.mediaQueryList.addEventListener("change", me.themeListener);
    },
});
Ext.define('PBS.NodeInfoPanel', {
    extend: 'Proxmox.panel.StatusView',
    alias: 'widget.pbsNodeInfoPanel',

    height: 300,
    bodyPadding: '15 5 15 5',

    layout: {
	type: 'table',
	columns: 2,
	tableAttrs: {
	    style: {
		width: '100%',
	    },
	},
    },

    defaults: {
	xtype: 'pmxInfoWidget',
	padding: '0 10 5 10',
    },

    controller: {
	xclass: 'Ext.app.ViewController',

	showFingerPrint: function() {
	    let me = this;
	    let view = me.getView();
	    let fingerprint = view.fingerprint;
	    Ext.create('Ext.window.Window', {
		modal: true,
		width: 600,
		title: gettext('Fingerprint'),
		layout: 'form',
		bodyPadding: '10 0',
		items: [
		    {
			xtype: 'textfield',
			inputId: 'fingerprintField',
			value: fingerprint,
			editable: false,
		    },
		],
		buttons: [
		    {
			xtype: 'button',
			iconCls: 'fa fa-clipboard',
			handler: async function(b) {
			    var el = document.getElementById('fingerprintField');
			    await navigator.clipboard.writeText(el.value);
			},
			text: gettext('Copy'),
		    },
		    {
			text: gettext('Ok'),
			handler: function() {
			    this.up('window').close();
			},
		    },
		],
	    }).show();
	},
    },

    tools: [
	{
	    xtype: 'button',
	    reference: 'fpButton',
	    text: gettext('Show Fingerprint'),
	    handler: 'showFingerPrint',
	    disabled: true,
	},
    ],

    items: [
	{
	    itemId: 'cpu',
	    iconCls: 'fa fa-fw pmx-itype-icon-processor pmx-icon',
	    title: gettext('CPU usage'),
	    valueField: 'cpu',
	    maxField: 'cpuinfo',
	    renderer: Proxmox.Utils.render_node_cpu_usage,
	},
	{
	    itemId: 'wait',
	    iconCls: 'pmx-icon-size fa fa-fw fa-clock-o',
	    title: gettext('IO delay'),
	    valueField: 'wait',
	},
	{
	    xtype: 'box',
	    colspan: 2,
	    padding: '0 0 20 0',
	},
	{
	    iconCls: 'fa fa-fw pmx-itype-icon-memory pmx-icon',
	    itemId: 'memory',
	    title: gettext('RAM usage'),
	    valueField: 'memory',
	    maxField: 'memory',
	    renderer: Proxmox.Utils.render_node_size_usage,
	},
	{
	    itemId: 'load',
	    iconCls: 'pmx-icon-size fa fa-fw fa-tasks',
	    title: gettext('Load average'),
	    printBar: false,
	    textField: 'loadavg',
	},
	{
	    iconCls: 'pmx-icon-size fa fa-fw fa-hdd-o',
	    itemId: 'rootfs',
	    title: gettext('HD space') + '(root)',
	    valueField: 'root',
	    maxField: 'root',
	    renderer: ({ used, total }) => Proxmox.Utils.render_size_usage(used, total, true),
	},
	{
	    iconCls: 'pmx-icon-size fa fa-fw fa-refresh',
	    itemId: 'swap',
	    printSize: true,
	    title: gettext('SWAP usage'),
	    valueField: 'swap',
	    maxField: 'swap',
	    renderer: Proxmox.Utils.render_node_size_usage,
	},
	{
	    xtype: 'box',
	    colspan: 2,
	    padding: '0 0 20 0',
	},
	{
	    itemId: 'cpus',
	    colspan: 2,
	    printBar: false,
	    title: gettext('CPU(s)'),
	    textField: 'cpuinfo',
	    renderer: Proxmox.Utils.render_cpu_model,
	    value: '',
	},
	{
	    colspan: 2,
	    title: gettext('Kernel Version'),
	    printBar: false,
	    // TODO: remove with next major and only use newish current-kernel textfield
	    multiField: true,
	    //textField: 'current-kernel',
	    renderer: ({ data }) => {
		if (!data['current-kernel']) {
		    return data.kversion;
		}
		let kernel = data['current-kernel'];
		let buildDate = kernel.version.match(/\((.+)\)\s*$/)?.[1] ?? 'unknown';
		return `${kernel.sysname} ${kernel.release} (${buildDate})`;
	    },
	    value: '',
	},
	{
	    colspan: 2,
	    title: gettext('Boot Mode'),
	    printBar: false,
	    textField: 'boot-info',
	    renderer: boot => {
		if (boot.mode === 'legacy-bios') {
		    return 'Legacy BIOS';
		} else if (boot.mode === 'efi') {
		    return `EFI${boot.secureboot ? ' (Secure Boot)' : ''}`;
		}
		return Proxmox.Utils.unknownText;
	    },
	    value: '',
	},
	{
	    xtype: 'pmxNodeInfoRepoStatus',
	    itemId: 'repositoryStatus',
	    product: 'Proxmox Backup Server',
	    repoLink: '#pbsServerAdministration:aptrepositories',
	},
    ],

    updateTitle: function() {
	var me = this;
	var uptime = Proxmox.Utils.render_uptime(me.getRecordValue('uptime'));
	me.setTitle(Proxmox.NodeName + ' (' + gettext('Uptime') + ': ' + uptime + ')');
    },

    initComponent: function() {
	let me = this;

	me.rstore = Ext.create('Proxmox.data.ObjectStore', {
	    interval: 3000,
	    url: '/api2/json/nodes/localhost/status',
	    autoStart: true,
	});

	me.callParent();

	me.mon(me.rstore, 'load', function(store, records, success) {
	    if (!success) {
		return;
	    }

	    let info = me.getRecordValue('info');
	    me.fingerprint = info.fingerprint;
	    me.lookup('fpButton').setDisabled(!me.fingerprint);
	});
	me.on('destroy', function() { me.rstore.stopUpdate(); });
    },
});
Ext.define('PBS.admin.ZFSList', {
    extend: 'Ext.grid.Panel',
    xtype: 'pbsZFSList',

    stateful: true,
    stateId: 'grid-node-zfs',

    controller: {
	xclass: 'Ext.app.ViewController',

	openCreateWindow: function() {
	    let me = this;
	    Ext.create('PBS.window.CreateZFS', {
		nodename: me.nodename,
		listeners: {
		    destroy: function() { me.reload(); },
		},
	    }).show();
	},

	openDetailWindow: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (!selection || selection.length < 1) return;

	    let rec = selection[0];
	    let zpool = rec.get('name');

	    Ext.create('Proxmox.window.ZFSDetail', {
		zpool,
		nodename: view.nodename,
	    }).show();
	},

	reload: function() {
	    let me = this;
	    let view = me.getView();
	    let store = view.getStore();
	    store.load();
	    store.sort();
	},

	init: function(view) {
	    let me = this;

	    if (!view.nodename) {
		throw "no nodename given";
	    }

	    let url = `/api2/json/nodes/${view.nodename}/disks/zfs`;
	    view.getStore().getProxy().setUrl(url);

	    Proxmox.Utils.monStoreErrors(view, view.getStore(), true);

	    me.reload();
	},
    },

    columns: [
	{
	    text: gettext('Name'),
	    dataIndex: 'name',
	    flex: 1,
	},
	{
	    header: gettext('Size'),
	    renderer: Proxmox.Utils.format_size,
	    dataIndex: 'size',
	},
	{
	    header: gettext('Free'),
	    renderer: Proxmox.Utils.format_size,
	    dataIndex: 'free',
	},
	{
	    header: gettext('Allocated'),
	    renderer: Proxmox.Utils.format_size,
	    dataIndex: 'alloc',
	},
	{
	    header: gettext('Fragmentation'),
	    renderer: function(value) {
		return value.toString() + '%';
	    },
	    dataIndex: 'frag',
	},
	{
	    header: gettext('Health'),
	    renderer: Proxmox.Utils.render_zfs_health,
	    dataIndex: 'health',
	},
	{
	    header: gettext('Deduplication'),
	    hidden: true,
	    renderer: function(value) {
		return value.toFixed(2).toString() + 'x';
	    },
	    dataIndex: 'dedup',
	},
    ],

    rootVisible: false,
    useArrows: true,

    tbar: [
	{
	    text: gettext('Reload'),
	    iconCls: 'fa fa-refresh',
	    handler: 'reload',
	},
	{
	    text: gettext('Create') + ': ZFS',
	    handler: 'openCreateWindow',
	},
	{
	    text: gettext('Detail'),
	    xtype: 'proxmoxButton',
	    disabled: true,
	    handler: 'openDetailWindow',
	},
    ],

    listeners: {
	itemdblclick: 'openDetailWindow',
    },

    store: {
	fields: ['name', 'size', 'free', 'alloc', 'dedup', 'frag', 'health'],
	proxy: {
	    type: 'proxmox',
	},
	sorters: 'name',
    },
});

Ext.define('PBS.admin.Directorylist', {
    extend: 'Ext.grid.Panel',
    xtype: 'pbsDirectoryList',

    stateful: true,
    stateId: 'grid-node-directory',

    emptyText: gettext('No Mount-Units found'),

    viewModel: {
	data: {
	    path: '',
	},
	formulas: {
	    dirName: (get) => get('path')?.replace('/mnt/datastore/', '') || undefined,
	},
    },

    controller: {
	xclass: 'Ext.app.ViewController',

	createDirectory: function() {
	    let me = this;
	    Ext.create('PBS.window.CreateDirectory', {
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
	    }).show();
	},

	removeDirectory: function() {
	    let me = this;
	    let vm = me.getViewModel();

	    let dirName = vm.get('dirName');

	    if (!dirName) {
		throw "no directory name specified";
	    }

	    Ext.create('Proxmox.window.SafeDestroy', {
		url: `/nodes/localhost/disks/directory/${dirName}`,
		item: { id: dirName },
		showProgress: true,
		taskName: 'dirremove',
		listeners: {
		    destroy: () => me.reload(),
		},
	    }).show();
	},

	reload: function() {
	    let me = this;
	    let store = me.getView().getStore();
	    store.load();
	    store.sort();
	},

	init: function(view) {
	    let me = this;
	    Proxmox.Utils.monStoreErrors(view, view.getStore(), true);
	    me.reload();
	},
    },


    rootVisible: false,
    useArrows: true,

    tbar: [
	{
	    text: gettext('Reload'),
	    iconCls: 'fa fa-refresh',
	    handler: 'reload',
	},
	{
	    text: gettext('Create') + ': Directory',
	    handler: 'createDirectory',
	},
	'->',
	{
	    xtype: 'tbtext',
	    data: {
		dirName: undefined,
	    },
	    bind: {
		data: {
		    dirName: "{dirName}",
		},
	    },
	    tpl: [
		'<tpl if="dirName">',
		gettext('Directory') + ' {dirName}:',
		'<tpl else>',
		Ext.String.format(gettext('No {0} selected'), gettext('directory')),
		'</tpl>',
	    ],
	},
	{
	    text: gettext('More'),
	    iconCls: 'fa fa-bars',
	    disabled: true,
	    bind: {
		disabled: '{!dirName}',
	    },
	    menu: [
		{
		    text: gettext('Remove'),
		    itemId: 'remove',
		    iconCls: 'fa fa-fw fa-trash-o',
		    handler: 'removeDirectory',
		    disabled: true,
		    bind: {
			disabled: '{!dirName}',
		    },
		},
	    ],
	},
    ],

    columns: [
	{
	    text: '<span class="fa fa-plug"/>',
	    flex: 0,
	    width: 35,
	    dataIndex: 'removable',
	    renderer: function(_text, _, row) {
		if (row.data.removable) {
		    return `<i class="fa fa-check"/>`;
		} else {
		    return '';
		}
	    },
	},
	{
	    text: gettext('Path'),
	    dataIndex: 'path',
	    flex: 1,
	},
	{
	    header: gettext('Device'),
	    flex: 1,
	    dataIndex: 'device',
	},
	{
	    header: gettext('Filesystem'),
	    width: 100,
	    dataIndex: 'filesystem',
	},
	{
	    header: gettext('Options'),
	    width: 100,
	    dataIndex: 'options',
	},
	{
	    header: gettext('Unit File'),
	    hidden: true,
	    dataIndex: 'unitfile',
	},
    ],

    listeners: {
	activate: "reload",
	selectionchange: function(model, selected) {
	    let me = this;
	    let vm = me.getViewModel();

	    vm.set('path', selected[0]?.data.path || '');
	},
    },

    store: {
	fields: ['path', 'device', 'filesystem', 'options', 'unitfile'],
	proxy: {
	    type: 'proxmox',
	    url: '/api2/json/nodes/localhost/disks/directory',
	},
	sorters: 'path',
    },
});
Ext.define('PBS.LoginView', {
    extend: 'Ext.container.Container',
    xtype: 'loginview',

    viewModel: {
	data: {
	    openid: false,
	},
	formulas: {
	    button_text: function(get) {
		if (get("openid") === true) {
		    return gettext("Login (OpenID redirect)");
		} else {
		    return gettext("Login");
		}
	    },
	},
    },

    controller: {
	xclass: 'Ext.app.ViewController',

	init: async function() {
	    if (Proxmox.consentText !== "") {
		Ext.create('Proxmox.window.ConsentModal', {
		    autoShow: true,
		    consent: Proxmox.Markdown.parse(
			Ext.htmlEncode(
			    Proxmox.Utils.base64ToUtf8(Proxmox.consentText),
			),
		    ),
		});
	    }
	},

	submitForm: async function() {
	    var me = this;
	    var loginForm = me.lookupReference('loginForm');
	    var unField = me.lookupReference('usernameField');
	    var saveunField = me.lookupReference('saveunField');

	    if (!loginForm.isValid()) {
		return;
	    }

	    let creds = loginForm.getValues();

	    if (this.getViewModel().data.openid === true) {
		const redirectURL = location.origin;
		try {
		    let resp = await Proxmox.Async.api2({
			url: '/api2/extjs/access/openid/auth-url',
			params: {
			    realm: creds.realm,
			    "redirect-url": redirectURL,
			},
			method: 'POST',
		    });
		    window.location = resp.result.data;
		} catch (response) {
		    Proxmox.Utils.authClear();
		    loginForm.unmask();
		    Ext.MessageBox.alert(
			gettext('Error'),
			gettext('OpenID redirect failed, please try again') + `<br>${response.result.message}`,
		    );
		}
		return;
	    }

	    creds.username = `${creds.username}@${creds.realm}`;
	    delete creds.realm;

	    if (loginForm.isVisible()) {
		loginForm.mask(gettext('Please wait...'), 'x-mask-loading');
	    }

	    // set or clear username
	    var sp = Ext.state.Manager.getProvider();
	    if (saveunField.getValue() === true) {
		sp.set(unField.getStateId(), unField.getValue());
	    } else {
		sp.clear(unField.getStateId());
	    }
	    sp.set(saveunField.getStateId(), saveunField.getValue());

	    try {
		let resp = await Proxmox.Async.api2({
		    url: '/api2/extjs/access/ticket',
		    params: creds,
		    method: 'POST',
		});

		let data = resp.result.data;
		if (data.ticket.startsWith("PBS:!tfa!")) {
		    data = await me.performTFAChallenge(data);
		}

		PBS.Utils.updateLoginData(data);
		PBS.app.changeView('mainview');
	    } catch (error) {
		Proxmox.Utils.authClear();
		loginForm.unmask();
		Ext.MessageBox.alert(
		    gettext('Error'),
		    gettext('Login failed. Please try again'),
		);
	    }
	},

	performTFAChallenge: async function(data) {
	    let me = this;

	    let userid = data.username;
	    let ticket = data.ticket;
	    let challenge = JSON.parse(decodeURIComponent(
	        ticket.split(':')[1].slice("!tfa!".length),
	    ));

	    let resp = await new Promise((resolve, reject) => {
		Ext.create('Proxmox.window.TfaLoginWindow', {
		    userid,
		    ticket,
		    challenge,
		    onResolve: value => resolve(value),
		    onReject: reject,
		}).show();
	    });

	    return resp.result.data;
	},

	control: {
	    'field[name=username]': {
		specialkey: function(f, e) {
		    if (e.getKey() === e.ENTER) {
			var pf = this.lookupReference('passwordField');
			if (!pf.getValue()) {
			    pf.focus(false);
			}
		    }
		},
	    },
	    'field[name=lang]': {
		change: function(f, value) {
		    var dt = Ext.Date.add(new Date(), Ext.Date.YEAR, 10);
		    Ext.util.Cookies.set('PBSLangCookie', value, dt);
		    this.getView().mask(gettext('Please wait...'), 'x-mask-loading');
		    window.location.reload();
		},
	    },
	    'field[name=realm]': {
		change: function(f, value) {
		    let record = f.store.getById(value);
		    if (record === undefined) return;
		    let data = record.data;
		    this.getViewModel().set("openid", data.type === "openid");
		},
	    },
	    'button[reference=loginButton]': {
		click: 'submitForm',
	    },
	    'window[reference=loginwindow]': {
		show: function() {
		    var sp = Ext.state.Manager.getProvider();
		    var checkboxField = this.lookupReference('saveunField');
		    var unField = this.lookupReference('usernameField');

		    var checked = sp.get(checkboxField.getStateId());
		    checkboxField.setValue(checked);

		    if (checked === true) {
			var username = sp.get(unField.getStateId());
			unField.setValue(username);
			var pwField = this.lookupReference('passwordField');
			pwField.focus();
		    }

		    let auth = Proxmox.Utils.getOpenIDRedirectionAuthorization();
		    if (auth !== undefined) {
			Proxmox.Utils.authClear();

			let loginForm = this.lookupReference('loginForm');
			loginForm.mask(gettext('OpenID login - please wait...'), 'x-mask-loading');

			// openID checks the original redirection URL we used, so pass that too
			const redirectURL = location.origin;

			Proxmox.Utils.API2Request({
			    url: '/api2/extjs/access/openid/login',
			    params: {
				state: auth.state,
				code: auth.code,
				"redirect-url": redirectURL,
			    },
			    method: 'POST',
			    failure: function(response) {
				loginForm.unmask();
				let error = response.htmlStatus;
				Ext.MessageBox.alert(
				    gettext('Error'),
				    gettext('OpenID login failed, please try again') + `<br>${error}`,
				    () => { window.location = redirectURL; },
				);
			    },
			    success: function(response, options) {
				loginForm.unmask();
				let creds = response.result.data;
				PBS.Utils.updateLoginData(creds);
				PBS.app.changeView('mainview');
				history.replaceState(null, '', `${redirectURL}#pbsDashboard`);
			    },
			});
		    }
		},
	    },
	},
    },

    plugins: 'viewport',

    layout: {
	type: 'border',
    },

    items: [
	{
	    region: 'north',
	    xtype: 'container',
	    layout: {
		type: 'hbox',
		align: 'middle',
	    },
	    margin: '2 5 2 5',
	    height: 38,
	    items: [
		{
		    xtype: 'proxmoxlogo',
		    prefix: '',
		},
		{
		    xtype: 'versioninfo',
		    makeApiCall: false,
		},
	    ],
	},
	{
	    region: 'center',
	},
	{
	    xtype: 'window',
	    closable: false,
	    resizable: false,
	    reference: 'loginwindow',
	    autoShow: true,
	    modal: true,
	    width: 400,

	    defaultFocus: 'usernameField',

	    layout: {
		type: 'auto',
	    },

	    title: gettext('Proxmox Backup Server Login'),

	    items: [
		{
		    xtype: 'form',
		    layout: {
			type: 'form',
		    },
		    defaultButton: 'loginButton',
		    url: '/api2/extjs/access/ticket',
		    reference: 'loginForm',

		    fieldDefaults: {
			labelAlign: 'right',
			allowBlank: false,
		    },

		    items: [
			{
			    xtype: 'textfield',
			    fieldLabel: gettext('User name'),
			    name: 'username',
			    itemId: 'usernameField',
			    reference: 'usernameField',
			    stateId: 'login-username',
			    inputAttrTpl: 'autocomplete=username',
			    bind: {
				visible: "{!openid}",
				disabled: "{openid}",
			    },
			},
			{
			    xtype: 'textfield',
			    inputType: 'password',
			    fieldLabel: gettext('Password'),
			    name: 'password',
			    itemId: 'passwordField',
			    reference: 'passwordField',
			    inputAttrTpl: 'autocomplete=current-password',
			    bind: {
				visible: "{!openid}",
				disabled: "{openid}",
			    },
			},
			{
			    xtype: 'pmxRealmComboBox',
			    name: 'realm',
			},
			{
			    xtype: 'proxmoxLanguageSelector',
			    fieldLabel: gettext('Language'),
			    value: Ext.util.Cookies.get('PBSLangCookie') || Proxmox.defaultLang || '__default__',
			    name: 'lang',
			    reference: 'langField',
			    submitValue: false,
			},
		    ],
		    buttons: [
			{
			    xtype: 'checkbox',
			    fieldLabel: gettext('Save User name'),
			    name: 'saveusername',
			    reference: 'saveunField',
			    stateId: 'login-saveusername',
			    labelWidth: 250,
			    labelAlign: 'right',
			    submitValue: false,
			    bind: {
				visible: "{!openid}",
			    },
			},
			{
			    bind: {
				text: "{button_text}",
			    },
			    reference: 'loginButton',
			    formBind: true,
			},
		    ],
		},
	    ],
	},
    ],
});
Ext.define('PBS.view.main.VersionInfo', {
    extend: 'Ext.Component',
    xtype: 'versioninfo',

    makeApiCall: true,

    data: {
	version: false,
    },

    style: {
	'font-size': '14px',
	'line-height': '18px',
    },

    tpl: [
	'Backup Server',
	'<tpl if="version">',
	' {version}.{release}',
	'</tpl>',
    ],

    initComponent: function() {
	var me = this;
	me.callParent();

	if (me.makeApiCall) {
	    Proxmox.Utils.API2Request({
		url: '/version',
		method: 'GET',
		success: function(response) {
		    me.update(response.result.data);
		},
	    });
	}
    },
});
Ext.define('PBS.SystemConfiguration', {
    extend: 'Ext.tab.Panel',
    xtype: 'pbsSystemConfiguration',

    title: gettext('Configuration') + ': ' + gettext('System'),
    border: true,
    defaults: { border: false },
    tools: [PBS.Utils.get_help_tool("sysadmin-network-configuration")],
    items: [
	{
	    xtype: 'panel',
	    title: gettext('Network/Time'),
	    itemId: 'network',
	    iconCls: 'fa fa-exchange',
	    layout: {
		type: 'vbox',
		align: 'stretch',
		multi: true,
	    },
	    scrollable: true,
	    defaults: {
		collapsible: true,
		animCollapse: false,
		margin: '7 10 3 10',
	    },
	    items: [
		{
		    xtype: 'proxmoxNodeTimeView',
		    title: gettext('Time'),
		    nodename: 'localhost',
		},
		{
		    xtype: 'proxmoxNodeDNSView',
		    deleteEmpty: true,
		    title: gettext('DNS'),
		    nodename: 'localhost',
		},
		{
		    xtype: 'proxmoxNodeNetworkView',
		    title: gettext('Network Interfaces'),
		    flex: 1,
		    minHeight: 200,
		    showApplyBtn: true,
		    types: ['bond', 'bridge', 'vlan'],
		    nodename: 'localhost',
		},
	    ],
	},
	{
	    title: gettext('Metric Server'),
	    iconCls: 'fa fa-bar-chart',
	    xtype: 'pbsMetricServerView',
	    itemId: 'metrics',
	},
	{
	    xtype: 'panel',
	    title: gettext('Other'),
	    itemId: 'other-options',
	    iconCls: 'fa fa-sliders',
	    layout: {
		type: 'vbox',
		align: 'stretch',
		multi: true,
	    },
	    scrollable: true,
	    defaults: {
		collapsible: true,
		animCollapse: false,
		margin: '7 10 3 10',
	    },
	    items: [
		{
		    title: gettext('General'),
		    xtype: 'pbsNodeOptionView',
		},
		{
		    title: gettext('WebAuthn TFA'),
		    xtype: 'pbsWebauthnConfigView',
		},
	    ],
	},
    ],

    initComponent: function() {
	let me = this;

	me.callParent();

	let networktime = me.getComponent('network');
	networktime.query()?.forEach(el => el.relayEvents(networktime, ['activate', 'deactivate', 'destroy']));

	let options = me.getComponent('other-options');
	options.query()?.forEach(el => el.relayEvents(options, ['activate', 'deactivate', 'destroy']));
    },
});


Ext.define('PBS.SubscriptionKeyEdit', {
    extend: 'Proxmox.window.Edit',

    title: gettext('Upload Subscription Key'),
    width: 320,
    autoLoad: true,

    onlineHelp: 'get_help',

    items: {
	xtype: 'proxmoxtextfield',
	trimValue: true,
	labelWidth: 120,
	name: 'key',
	value: '',
	fieldLabel: gettext('Subscription Key'),
    },
});

Ext.define('PBS.Subscription', {
    extend: 'Proxmox.grid.ObjectGrid',
    xtype: 'pbsSubscription',

    title: gettext('Subscription'),
    border: true,

    onlineHelp: 'get_help',
    tools: [PBS.Utils.get_help_tool("get_help")],

    viewConfig: {
	enableTextSelection: true,
    },

    showReport: function() {
	var me = this;

	var getReportFileName = function() {
	    var now = Ext.Date.format(new Date(), 'D-d-F-Y-G-i');
	    return `${me.nodename}-pbs-report-${now}.txt`;
	};

	var view = Ext.createWidget('component', {
	    itemId: 'system-report-view',
	    scrollable: true,
	    style: {
		'white-space': 'pre',
		'font-family': 'monospace',
		padding: '5px',
	    },
	});

	let reportWindow;
	reportWindow = Ext.create('Ext.window.Window', {
	    title: gettext('System Report'),
	    width: 1024,
	    height: 600,
	    layout: 'fit',
	    modal: true,
	    buttons: [
		'->',
		{
		    text: gettext('Download'),
		    handler: function() {
			let fileContent = Ext.htmlDecode(reportWindow.getComponent('system-report-view').html);
			let fileName = getReportFileName();

			let dataUrl = `data:text/plain;charset=utf-8,${encodeURIComponent(fileContent)}`;

			Proxmox.Utils.downloadAsFile(dataUrl, fileName);
		    },
		},
	    ],
	    items: view,
	});

	Proxmox.Utils.API2Request({
	    url: '/api2/extjs/nodes/' + me.nodename + '/report',
	    method: 'GET',
	    waitMsgTarget: me,
	    success: function(response) {
		var report = Ext.htmlEncode(response.result.data);
		reportWindow.show();
		view.update(report);
	    },
	});
    },

    initComponent: function() {
	let me = this;

	let reload = () => me.rstore.load();
	let baseurl = '/nodes/localhost/subscription';

	let rows = {
	    productname: {
		header: gettext('Type'),
	    },
	    key: {
		header: gettext('Subscription Key'),
	    },
	    status: {
		header: gettext('Status'),
		renderer: (value) => {
		    value = Ext.String.capitalize(value);
		    let message = me.getObjectValue('message');
		    if (message) {
			return value + ": " + message;
		    }
		    return value;
		},
	    },
	    message: {
		visible: false,
	    },
	    serverid: {
		header: gettext('Server ID'),
	    },
	    checktime: {
		header: gettext('Last checked'),
		renderer: Proxmox.Utils.render_timestamp,
	    },
	    nextduedate: {
		header: gettext('Next due date'),
	    },
	    signature: {
		header: gettext('Signed/Offline'),
		renderer: (value) => {
		    if (value) {
			return gettext('Yes');
		    } else {
			return gettext('No');
		    }
		},
	    },
	};

	Ext.apply(me, {
	    url: `/api2/json${baseurl}`,
	    cwidth1: 170,
	    tbar: [
		{
		    text: gettext('Upload Subscription Key'),
		    iconCls: 'fa fa-ticket',
		    handler: function() {
			Ext.create('PBS.SubscriptionKeyEdit', {
			    url: '/api2/extjs/' + baseurl,
			    autoShow: true,
			    listeners: {
				destroy: () => reload(),
			    },
			});
		    },
		},
		{
		    text: gettext('Check'),
		    iconCls: 'fa fa-check-square-o',
		    handler: function() {
			Proxmox.Utils.API2Request({
			    params: { force: 1 },
			    url: baseurl,
			    method: 'POST',
			    waitMsgTarget: me,
			    callback: reload,
			});
		    },
		},
		{
		    text: gettext('Remove Subscription'),
		    xtype: 'proxmoxStdRemoveButton',
		    confirmMsg: gettext('Are you sure you want to remove the subscription key?'),
		    baseurl: baseurl,
		    dangerous: true,
		    selModel: false,
		    callback: reload,
		    iconCls: 'fa fa-trash-o',
		},
		'-',
		{
		    text: gettext('System Report'),
		    iconCls: 'fa fa-stethoscope',
		    handler: function() {
			Proxmox.Utils.checked_command(function() { me.showReport(); });
		    },
		},
	    ],
	    rows: rows,
	});

	me.callParent();

	reload();
    },
});
Ext.define('pve-rrd-datastore', {
    extend: 'Ext.data.Model',
    fields: [
	'used',
	'total',
	{
	    name: 'unpriv-total', // Can't reuse 'total' here as that creates a stack overflow
	    calculate: function(data) {
		let used = data.used;
		let avail = data.available;

		if (avail && used) {
		    return avail + used;
		}

		return data.total;
	    },
	},
	'available',
	'read_ios',
	'read_bytes',
	'write_ios',
	'write_bytes',
	'io_ticks',
	{
	    name: 'io_delay', calculate: function(data) {
		let ios = 0;
		if (data.read_ios !== undefined) { ios += data.read_ios; }
		if (data.write_ios !== undefined) { ios += data.write_ios; }
		if (data.io_ticks === undefined) {
		    return undefined;
		} else if (ios === 0) {
		    return 0;
		}
		return (data.io_ticks*1000.0)/ios;
	    },
	},
	{ type: 'date', dateFormat: 'timestamp', name: 'time' },
    ],
});

Ext.define('PBS.DataStoreInfo', {
    extend: 'Ext.panel.Panel',
    alias: 'widget.pbsDataStoreInfo',

    viewModel: {
	data: {
	    countstext: '',
	    usage: {},
	    stillbad: 0,
	    mountpoint: "",
	},
    },

    controller: {
	xclass: 'Ext.app.ViewController',

	onLoad: function(store, data, success) {
	    let me = this;
	    if (!success) {
		Proxmox.Utils.API2Request({
		    url: `/config/datastore/${me.view.datastore}`,
		    success: function(response) {
			let maintenanceString = response.result.data['maintenance-mode'];
			let removable = !!response.result.data['backing-device'];
			if (!maintenanceString && !removable) {
			    me.view.el.mask(gettext('Datastore is not available'));
			    return;
			}

			let [_type, msg] = PBS.Utils.parseMaintenanceMode(maintenanceString);
			let isUnplugged = !maintenanceString && removable;
			let maskMessage = isUnplugged
			    ? gettext('Datastore is not mounted')
			    : `${gettext('Datastore is in maintenance mode')}${msg ? ': ' + msg : ''}`;

			let maskIcon = isUnplugged ? 'fa pbs-unplugged-mask' : 'fa pbs-maintenance-mask';
			me.view.el.mask(maskMessage, maskIcon);
		    },
		});
		return;
	    }
	    me.view.el.unmask();

	    let vm = me.getViewModel();

	    let counts = store.getById('counts').data.value;
	    let used = store.getById('used').data.value;
	    let total = store.getById('avail').data.value + used;

	    let usage = Proxmox.Utils.render_size_usage(used, total, true);
	    vm.set('usagetext', usage);
	    vm.set('usage', used/total);

	    let countstext = function(count) {
		count = count || {};
		return `${count.groups || 0} ${gettext('Groups')}, ${count.snapshots || 0} ${gettext('Snapshots')}`;
	    };
	    let gcstatus = store.getById('gc-status')?.data.value;
	    if (gcstatus) {
		let dedup = PBS.Utils.calculate_dedup_factor(gcstatus);
		vm.set('deduplication', dedup.toFixed(2));
		vm.set('stillbad', gcstatus['still-bad']);
	    }

	    vm.set('ctcount', countstext(counts.ct));
	    vm.set('vmcount', countstext(counts.vm));
	    vm.set('hostcount', countstext(counts.host));
	},

	startStore: function() { this.store.startUpdate(); },
	stopStore: function() { this.store.stopUpdate(); },
	doSingleStoreLoad: function() { this.store.load(); },

	init: function(view) {
	    let me = this;
	    let datastore = encodeURIComponent(view.datastore);
	    me.store = Ext.create('Proxmox.data.ObjectStore', {
		interval: 5*1000,
		url: `/api2/json/admin/datastore/${datastore}/status/?verbose=true`,
	    });
	    me.store.on('load', me.onLoad, me);
	},
    },

    listeners: {
	activate: 'startStore',
	beforedestroy: 'stopStore',
	deactivate: 'stopStore',
    },

    defaults: {
	xtype: 'pmxInfoWidget',
    },

    bodyPadding: 20,

    items: [
	{
	    iconCls: 'fa fa-fw fa-hdd-o',
	    title: gettext('Usage'),
	    bind: {
		data: {
		    usage: '{usage}',
		    text: '{usagetext}',
		},
	    },
	},
	{
	    xtype: 'box',
	    html: `<b>${gettext('Backup Count')}</b>`,
	    padding: '10 0 5 0',
	},
	{
	    iconCls: 'fa fa-fw fa-cube',
	    title: gettext('CT'),
	    printBar: false,
	    bind: {
		data: {
		    text: '{ctcount}',
		},
	    },
	},
	{
	    iconCls: 'fa fa-fw fa-building',
	    title: gettext('Host'),
	    printBar: false,
	    bind: {
		data: {
		    text: '{hostcount}',
		},
	    },
	},
	{
	    iconCls: 'fa fa-fw fa-desktop',
	    title: gettext('VM'),
	    printBar: false,
	    bind: {
		data: {
		    text: '{vmcount}',
		},
	    },
	},
	{
	    xtype: 'box',
	    html: `<b>${gettext('Stats from last Garbage Collection')}</b>`,
	    padding: '10 0 5 0',
	},
	{
	    iconCls: 'fa fa-fw fa-compress',
	    title: gettext('Deduplication Factor'),
	    printBar: false,
	    bind: {
		data: {
		    text: '{deduplication}',
		},
	    },
	},
	{
	    iconCls: 'fa critical fa-fw fa-exclamation-triangle',
	    title: gettext('Bad Chunks'),
	    printBar: false,
	    bind: {
		data: {
		    text: '{stillbad}',
		},
		visible: '{stillbad}',
	    },
	},
    ],
});

Ext.define('PBS.DataStoreSummary', {
    extend: 'Ext.panel.Panel',
    alias: 'widget.pbsDataStoreSummary',
    mixins: ['Proxmox.Mixin.CBind'],

    layout: 'column',
    scrollable: true,

    bodyPadding: 5,
    defaults: {
	columnWidth: 1,
	padding: 5,
    },

    tbar: [
	{
	    xtype: 'button',
	    text: gettext('Show Connection Information'),
	    handler: function() {
		let me = this;
		let datastore = me.up('panel').datastore;
		Ext.create('PBS.window.DatastoreRepoInfo', {
		    datastore,
		    autoShow: true,
		});
	    },
	},
	{ xtype: 'tbseparator', reference: 'mountButtonSeparator', hidden: true },
	{
	    xtype: 'button',
	    text: gettext('Unmount'),
	    hidden: true,
	    itemId: 'unmountButton',
	    reference: 'unmountButton',
	    handler: function() {
		let me = this;
		let datastore = me.up('panel').datastore;
		Proxmox.Utils.API2Request({
		    url: `/admin/datastore/${datastore}/unmount`,
		    method: 'POST',
		    failure: response => Ext.Msg.alert(gettext('Error'), response.htmlStatus),
		    success: function(response, options) {
			Ext.create('Proxmox.window.TaskViewer', {
			    upid: response.result.data,
			    taskDone: () => {
				me.up('panel').statusStore.load();
				Ext.ComponentQuery.query('navigationtree')[0]?.reloadStore();
			    },
			}).show();
		    },
		});
	    },
	},
	{
	    xtype: 'button',
	    text: gettext('Mount'),
	    hidden: true,
	    itemId: 'mountButton',
	    reference: 'mountButton',
	    handler: function() {
		let me = this;
		let datastore = me.up('panel').datastore;
		Proxmox.Utils.API2Request({
		    url: `/admin/datastore/${datastore}/mount`,
		    method: 'POST',
		    failure: response => Ext.Msg.alert(gettext('Error'), response.htmlStatus),
		    success: function(response, options) {
			Ext.create('Proxmox.window.TaskViewer', {
			    upid: response.result.data,
			    taskDone: () => {
				me.up('panel').statusStore.startUpdate();
				Ext.ComponentQuery.query('navigationtree')[0]?.reloadStore();
			    },
			}).show();
		    },
		});
	    },
	},
	'->',
	{
	    xtype: 'proxmoxRRDTypeSelector',
	},
    ],

    items: [
	{
	    xtype: 'container',
	    height: 300,
	    layout: {
		type: 'hbox',
		align: 'stretch',
	    },
	    items: [
		{
		    xtype: 'pbsDataStoreInfo',
		    flex: 1,
		    padding: '0 10 0 0',
		    cbind: {
			title: '{datastore}',
			datastore: '{datastore}',
		    },
		},
		{
		    xtype: 'pbsDataStoreNotes',
		    flex: 1,
		    cbind: {
			datastore: '{datastore}',
		    },
		},
	    ],
	},
	{
	    xtype: 'proxmoxRRDChart',
	    title: gettext('Storage usage (bytes)'),
	    fields: ['unpriv-total', 'used'],
	    fieldTitles: [gettext('Total'), gettext('Storage usage')],
	},
	{
	    xtype: 'proxmoxRRDChart',
	    title: gettext('Transfer Rate (bytes/second)'),
	    fields: ['read_bytes', 'write_bytes'],
	    fieldTitles: [gettext('Read'), gettext('Write')],
	},
	{
	    xtype: 'proxmoxRRDChart',
	    title: gettext('Input/Output Operations per Second (IOPS)'),
	    fields: ['read_ios', 'write_ios'],
	    fieldTitles: [gettext('Read'), gettext('Write')],
	},
	{
	    xtype: 'proxmoxRRDChart',
	    itemId: 'ioDelayChart',
	    hidden: true,
	    title: gettext('IO Delay (ms)'),
	    fields: ['io_delay'],
	    fieldTitles: [gettext('IO Delay')],
	},
    ],

    listeners: {
	activate: function() { this.rrdstore.startUpdate(); },
	afterrender: function() { this.statusStore.startUpdate(); },
	deactivate: function() { this.rrdstore.stopUpdate(); },
	destroy: function() {
	    this.rrdstore.stopUpdate();
	    this.statusStore.stopUpdate();
	},
	resize: function(panel) {
	    Proxmox.Utils.updateColumns(panel);
	},
    },

    initComponent: function() {
	let me = this;

	me.rrdstore = Ext.create('Proxmox.data.RRDStore', {
	    rrdurl: "/api2/json/admin/datastore/" + me.datastore + "/rrd",
	    model: 'pve-rrd-datastore',
	});

	me.statusStore = Ext.create('Proxmox.data.ObjectStore', {
	    url: `/api2/json/admin/datastore/${me.datastore}/status`,
	    interval: 1000,
	});

	let lastRequestWasFailue = false;
	me.mon(me.statusStore, 'load', (s, records, success) => {
	    let mountBtn = me.lookupReferenceHolder().lookupReference('mountButton');
	    let unmountBtn = me.lookupReferenceHolder().lookupReference('unmountButton');
	    if (!success) {
		lastRequestWasFailue = true;

		me.statusStore.stopUpdate();
		me.rrdstore.stopUpdate();

		let infoPanelController = me.down('pbsDataStoreInfo').getController();
		infoPanelController.stopStore();
		infoPanelController.doSingleStoreLoad();

		Proxmox.Utils.API2Request({
		    url: `/config/datastore/${me.datastore}`,
		    success: response => {
			let mode = response.result.data['maintenance-mode'];
			let [type, _message] = PBS.Utils.parseMaintenanceMode(mode);
			if (!response.result.data['backing-device']) {
			    return;
			}
			if (!type || type === 'read-only') {
			    unmountBtn.setDisabled(true);
			    mountBtn.setDisabled(false);
			} else if (type === 'unmount') {
			    unmountBtn.setDisabled(true);
			    mountBtn.setDisabled(true);
			} else {
			    unmountBtn.setDisabled(false);
			    mountBtn.setDisabled(false);
			}
		    },
		});
	    } else {
		// only trigger on edges, else we couple our interval to the info one
		if (lastRequestWasFailue) {
		    me.down('pbsDataStoreInfo').fireEvent('activate');
		    me.rrdstore.startUpdate();
		}
		unmountBtn.setDisabled(false);
		mountBtn.setDisabled(true);
		lastRequestWasFailue = false;
	    }
	});

	let sp = Ext.state.Manager.getProvider();
	me.mon(sp, 'statechange', function(provider, key, value) {
	    if (key !== 'summarycolumns') {
		return;
	    }
	    if (!me.rendered) {
		return;
	    }
	    Proxmox.Utils.updateColumns(me);
	});

	me.callParent();

	Proxmox.Utils.API2Request({
	    url: `/config/datastore/${me.datastore}`,
	    waitMsgTarget: me.down('pbsDataStoreInfo'),
	    success: function(response) {
		let data = response.result.data;

		const removable = !!data['backing-device'];
		me.lookupReferenceHolder().lookupReference('mountButtonSeparator').setHidden(!removable);
		me.lookupReferenceHolder().lookupReference('mountButton').setHidden(!removable);
		me.lookupReferenceHolder().lookupReference('unmountButton').setHidden(!removable);

		let path = Ext.htmlEncode(data.path);
		me.down('pbsDataStoreInfo').setTitle(`${me.datastore} (${path})`);
		me.down('pbsDataStoreNotes').setNotes(data.comment);
	    },
	    failure: function(response) {
		// fallback if e.g. we have no permissions to the config
		let rec = Ext.getStore('pbs-datastore-list')
		    .findRecord('store', me.datastore, 0, false, true, true);
		if (rec) {
		    me.down('pbsDataStoreNotes').setNotes(rec.data.comment || "");
		}
	    },
	});

	me.mon(me.rrdstore, 'load', function(store, records, success) {
	    let hasIoTicks = records?.some((rec) => rec?.data?.io_ticks !== undefined);
	    me.down('#ioDelayChart').setVisible(!success || hasIoTicks);
	}, undefined, { single: true });

	me.query('proxmoxRRDChart').forEach((chart) => {
	    chart.setStore(me.rrdstore);
	});

	me.down('pbsDataStoreInfo').relayEvents(me, ['activate', 'deactivate']);
    },
});
Ext.define('PBS.DataStoreNotes', {
    extend: 'Ext.panel.Panel',
    xtype: 'pbsDataStoreNotes',
    mixins: ['Proxmox.Mixin.CBind'],

    title: gettext("Comment"),
    bodyStyle: 'white-space:pre',
    bodyPadding: 10,
    scrollable: true,
    animCollapse: false,

    cbindData: function(initialConfig) {
	let me = this;
	me.url = `/api2/extjs/config/datastore/${me.datastore}`;
	return { };
    },

    run_editor: function() {
	let me = this;
	let win = Ext.create('Proxmox.window.Edit', {
	    title: gettext('Comment'),
	    width: 600,
	    resizable: true,
	    layout: 'fit',
	    defaultButton: undefined,
	    items: {
		xtype: 'textfield',
		name: 'comment',
		value: '',
		hideLabel: true,
	    },
	    url: me.url,
	    listeners: {
		destroy: function() {
		    me.load();
		},
	    },
	}).show();
	win.load();
    },

    setNotes: function(value) {
	let me = this;
	var data = value || '';
	me.update(Ext.htmlEncode(data));

	if (me.collapsible && me.collapseMode === 'auto') {
	    me.setCollapsed(data === '');
	}
    },

    load: function() {
	var me = this;

	Proxmox.Utils.API2Request({
	    url: me.url,
	    waitMsgTarget: me,
	    failure: function(response, opts) {
		Ext.Msg.alert(gettext('Error'), response.htmlStatus);
		me.setCollapsed(false);
	    },
	    success: function(response, opts) {
		me.setNotes(response.result.data.comment);
	    },
	});
    },

    listeners: {
	render: function(c) {
	    var me = this;
	    me.getEl().on('dblclick', me.run_editor, me);
	},
	afterlayout: function() {
	    let me = this;
	    if (me.collapsible && !me.getCollapsed() && me.collapseMode === 'always') {
		me.setCollapsed(true);
		me.collapseMode = ''; // only once, on initial load!
	    }
	},
    },

    tools: [{
	type: 'gear',
	handler: function() {
	    this.up('panel').run_editor();
	},
    }],

    collapsible: true,
    collapseDirection: 'right',

    initComponent: function() {
	var me = this;

	me.callParent();

	let sp = Ext.state.Manager.getProvider();
	me.collapseMode = sp.get('notes-collapse', 'never');

	if (me.collapseMode === 'auto') {
	    me.setCollapsed(true);
	}
    },
});
Ext.define('pbs-prune-list', {
    extend: 'Ext.data.Model',
    fields: [
	'backup-type',
	'backup-id',
	{
	    name: 'backup-time',
	    type: 'date',
	    dateFormat: 'timestamp',
	},
    ],
});

Ext.define('PBS.PruneKeepInput', {
    extend: 'Proxmox.form.field.Integer',
    alias: 'widget.pbsPruneKeepInput',

    allowBlank: true,
    minValue: 1,

    listeners: {
	change: function(field, newValue, oldValue) {
	    if (newValue !== this.originalValue) {
		this.triggers.clear.setVisible(true);
	    }
	},
    },
    triggers: {
	clear: {
	    cls: 'pmx-clear-trigger',
	    weight: -1,
	    hidden: true,
	    handler: function() {
		this.triggers.clear.setVisible(false);
		this.setValue("");
	    },
	},
    },

});

Ext.define('PBS.Datastore.PruneInputPanel', {
    extend: 'Proxmox.panel.InputPanel',
    alias: 'widget.pbsDataStorePruneInputPanel',
    mixins: ['Proxmox.Mixin.CBind'],

    onGetValues: function(values) {
	var me = this;

	values["backup-type"] = me.backup_type;
	values["backup-id"] = me.backup_id;
	if (me.ns && me.ns !== '') {
	    values.ns = me.ns;
	}
	values["use-task"] = true;
	return values;
    },

    controller: {
	xclass: 'Ext.app.ViewController',

	init: function(view) {
	    if (!view.url) {
		throw "no url specified";
	    }
	    if (!view.backup_type) {
		throw "no backup_type specified";
	    }
	    if (!view.backup_id) {
		throw "no backup_id specified";
	    }

	    this.reload(); // initial load
	},

	reload: function() {
	    var view = this.getView();

	    // helper to allow showing why a backup is kept
	    let addKeepReasons = function(backups, params) {
		const rules = [
		    'keep-last',
		    'keep-hourly',
		    'keep-daily',
		    'keep-weekly',
		    'keep-monthly',
		    'keep-yearly',
		    'keep-all', // when all keep options are not set
		];
		let counter = {};

		backups.sort(function(a, b) {
		    return b["backup-time"] - a["backup-time"];
		});

		let ruleIndex = -1;
		let nextRule = function() {
		    let rule;
		    do {
			ruleIndex++;
			rule = rules[ruleIndex];
		    } while (!params[rule] && rule !== 'keep-all');
		    counter[rule] = 0;
		    return rule;
		};

		let rule = nextRule();
		for (let backup of backups) {
		    if (backup.keep) {
			if (backup.protected) {
			    backup.keepReason = 'protected';
			    continue;
			}
			counter[rule]++;
			if (rule !== 'keep-all') {
			    backup.keepReason = rule + ': ' + counter[rule];
			    if (counter[rule] >= params[rule]) {
				rule = nextRule();
			    }
			} else {
			    backup.keepReason = rule;
			}
		    }
		}
	    };

	    let params = view.getValues();
	    params["dry-run"] = true;
	    if (view.ns && view.ns !== '') {
		params.ns = view.ns;
	    }

	    Proxmox.Utils.API2Request({
		url: view.url,
		method: "POST",
		params: params,
		callback: function() {
		     // for easy breakpoint setting
		},
		failure: response => Ext.Msg.alert(gettext('Error'), response.htmlStatus),
		success: function(response, options) {
		    let data = response.result.data;
		    addKeepReasons(data, params);
		    view.prune_store.setData(data);
		},
	    });
	},

	control: {
	    field: { change: 'reload' },
	},
    },

    column1: [
	{
	    xtype: 'pbsPruneKeepInput',
	    name: 'keep-last',
	    fieldLabel: gettext('keep-last'),
	},
	{
	    xtype: 'pbsPruneKeepInput',
	    name: 'keep-hourly',
	    fieldLabel: gettext('keep-hourly'),
	},
	{
	    xtype: 'pbsPruneKeepInput',
	    name: 'keep-daily',
	    fieldLabel: gettext('keep-daily'),
	},
	{
	    xtype: 'pbsPruneKeepInput',
	    name: 'keep-weekly',
	    fieldLabel: gettext('keep-weekly'),
	},
	{
	    xtype: 'pbsPruneKeepInput',
	    name: 'keep-monthly',
	    fieldLabel: gettext('keep-monthly'),
	},
	{
	    xtype: 'pbsPruneKeepInput',
	    name: 'keep-yearly',
	    fieldLabel: gettext('keep-yearly'),
	},
    ],


    initComponent: function() {
        var me = this;

	me.prune_store = Ext.create('Ext.data.Store', {
	    model: 'pbs-prune-list',
	    sorters: { property: 'backup-time', direction: 'DESC' },
	});

	me.column2 = [
	    {
		xtype: 'grid',
		height: 200,
		store: me.prune_store,
		columns: [
		    {
			header: gettext('Backup Time'),
			sortable: true,
			dataIndex: 'backup-time',
			renderer: function(value, metaData, record) {
			    let text = Ext.Date.format(value, 'Y-m-d H:i:s');
			    if (record.data.keep) {
				return text;
			    } else {
				return '<div style="text-decoration: line-through;">'+ text +'</div>';
			    }
			},
			flex: 1,
		    },
		    {
			text: 'Keep (reason)',
			dataIndex: 'keep',
			renderer: function(value, metaData, record) {
			    if (record.data.keep) {
				return 'true (' + record.data.keepReason + ')';
			    } else {
				return 'false';
			    }
			},
			flex: 1,
		    },
		],
	    },
	];

	me.callParent();
    },
});

Ext.define('PBS.DataStorePrune', {
    extend: 'Proxmox.window.Edit',

    onlineHelp: 'maintenance_pruning',

    method: 'POST',
    submitText: "Prune",

    isCreate: true,

    fieldDefaults: { labelWidth: 130 },

    initComponent: function() {
        var me = this;

	if (!me.datastore) {
	    throw "no datastore specified";
	}
	if (!me.backup_type) {
	    throw "no backup_type specified";
	}
	if (!me.backup_id) {
	    throw "no backup_id specified";
	}

	let ns = me.ns && me.ns !== '' ? `${me.ns} ` : '';

	Ext.apply(me, {
	    url: '/api2/extjs/admin/datastore/' + me.datastore + "/prune",
	    title: `Prune Group '${me.backup_type}/${me.backup_id}' on '${me.datastore}:${ns}'`,
	    items: [{
		xtype: 'pbsDataStorePruneInputPanel',
		url: '/api2/extjs/admin/datastore/' + me.datastore + "/prune",
		ns: me.ns,
		backup_type: me.backup_type,
		backup_id: me.backup_id,
	    }],
	});

	me.callParent();
    },
});
Ext.define('pbs-data-store-snapshots', {
    extend: 'Ext.data.Model',
    fields: [
	'backup-type',
	'backup-id',
	{
	    name: 'backup-time',
	    type: 'date',
	    dateFormat: 'timestamp',
	},
	'comment',
	'files',
	'owner',
	'verification',
	'fingerprint',
	{ name: 'size', type: 'int', allowNull: true },
	{ name: 'sortWeight', type: 'int', allowNull: true },
	{ name: 'ty', type: 'string', allowNull: true },
	{
	    name: 'crypt-mode',
	    type: 'boolean',
	    calculate: function(data) {
		let crypt = {
		    none: 0,
		    mixed: 0,
		    'sign-only': 0,
		    encrypt: 0,
		    count: 0,
		};
		data.files.forEach(file => {
		    if (file.filename === 'index.json.blob') return; // is never encrypted
		    let mode = PBS.Utils.cryptmap.indexOf(file['crypt-mode']);
		    if (mode !== -1) {
			crypt[file['crypt-mode']]++;
			crypt.count++;
		    }
		});

		return PBS.Utils.calculateCryptMode(crypt);
	    },
	},
	{
	    name: 'matchesFilter',
	    type: 'boolean',
	    defaultValue: true,
	},
    ],
});

Ext.define('PBS.DataStoreContent', {
    extend: 'Ext.tree.Panel',
    alias: 'widget.pbsDataStoreContent',
    mixins: ['Proxmox.Mixin.CBind'],

    rootVisible: false,

    title: gettext('Content'),

    controller: {
	xclass: 'Ext.app.ViewController',

	init: function(view) {
	    if (!view.datastore) {
		throw "no datastore specified";
	    }

	    this.store = Ext.create('Ext.data.Store', {
		model: 'pbs-data-store-snapshots',
		groupField: 'backup-group',
	    });
	    this.store.on('load', this.onLoad, this);

	    view.getStore().setSorters([
		'sortWeight',
		'text',
		'backup-time',
	    ]);
	},

	control: {
	    '#': { // view
		rowdblclick: 'rowDoubleClicked',
	    },
	    'pbsNamespaceSelector': {
		change: 'nsChange',
	    },
	},

	rowDoubleClicked: function(table, rec, el, rowId, ev) {
	    if (rec?.data?.ty === 'ns' && !rec.data.root) {
		this.nsChange(null, rec.data.ns);
	    }
	},

	nsChange: function(field, value) {
	    let view = this.getView();
	    if (field === null) {
		field = view.down('pbsNamespaceSelector');
		field.setValue(value);
		return;
	    }
	    view.namespace = value;
	    this.reload();
	},

	reload: function() {
	    let view = this.getView();

	    if (!view.store || !this.store) {
		console.warn('cannot reload, no store(s)');
		return;
	    }

	    let url = `/api2/json/admin/datastore/${view.datastore}/snapshots`;
	    if (view.namespace && view.namespace !== '') {
		url += `?ns=${encodeURIComponent(view.namespace)}`;
	    }
	    this.store.setProxy({
		type: 'proxmox',
		timeout: 300*1000, // 5 minutes, we should make that api call faster
		url: url,
	    });

	    this.store.load();
	},

	getRecordGroups: function(records) {
	    let groups = {};

	    for (const item of records) {
		var btype = item.data["backup-type"];
		let group = btype + "/" + item.data["backup-id"];

		if (groups[group] !== undefined) {
		    continue;
		}

		var cls = PBS.Utils.get_type_icon_cls(btype);
		if (cls === "") {
		    console.warn(`got unknown backup-type '${btype}'`);
		    continue; // FIXME: auto render? what do?
		}

		groups[group] = {
		    text: group,
		    leaf: false,
		    iconCls: "fa " + cls,
		    expanded: false,
		    backup_type: item.data["backup-type"],
		    backup_id: item.data["backup-id"],
		    children: [],
		};
	    }

	    return groups;
	},

	updateGroupNotes: async function(view) {
	    try {
		let url = `/api2/extjs/admin/datastore/${view.datastore}/groups`;
		if (view.namespace && view.namespace !== '') {
		    url += `?ns=${encodeURIComponent(view.namespace)}`;
		}
		let { result: { data: groups } } = await Proxmox.Async.api2({ url });
		let map = {};
		for (const group of groups) {
		    map[`${group["backup-type"]}/${group["backup-id"]}`] = group.comment;
		}
		view.getRootNode().cascade(node => {
		    if (node.data.ty === 'group') {
			let group = `${node.data.backup_type}/${node.data.backup_id}`;
			node.set('comment', map[group], { dirty: false });
		    }
		});
	    } catch (err) {
		console.debug(err);
	    }
	},

	loadNamespaceFromSameLevel: async function() {
	    let view = this.getView();
	    try {
		let url = `/api2/extjs/admin/datastore/${view.datastore}/namespace?max-depth=1`;
		if (view.namespace && view.namespace !== '') {
		    url += `&parent=${encodeURIComponent(view.namespace)}`;
		}
		let { result: { data: ns } } = await Proxmox.Async.api2({ url });
		return ns;
	    } catch (err) {
		console.debug(err);
	    }
	    return [];
	},

	onLoad: async function(store, records, success, operation) {
	    let me = this;
	    let view = this.getView();

	    let namespaces = await me.loadNamespaceFromSameLevel();

	    if (!success) {
		// TODO also check error code for != 403 ?
		if (namespaces.length === 0) {
		    let error = Proxmox.Utils.getResponseErrorMessage(operation.getError());
		    Proxmox.Utils.setErrorMask(view.down('treeview'), error);
		    return;
		} else {
		    records = [];
		}
	    } else {
		Proxmox.Utils.setErrorMask(view.down('treeview'));
	    }

	    let groups = this.getRecordGroups(records);

	    let selected;
	    let expanded = {};

	    view.getSelection().some(function(item) {
		let id = item.data.text;
		if (item.data.leaf) {
		    id = item.parentNode.data.text + id;
		}
		selected = id;
		return true;
	    });

	    view.getRootNode().cascadeBy({
		before: item => {
		    if (item.isExpanded() && !item.data.leaf) {
			let id = item.data.text;
			expanded[id] = true;
			return true;
		    }
		    return false;
		},
		after: Ext.emptyFn,
	    });

	    for (const item of records) {
		let group = item.data["backup-type"] + "/" + item.data["backup-id"];
		let children = groups[group].children;

		let data = item.data;

		data.text = group + '/' + PBS.Utils.render_datetime_utc(data["backup-time"]);
		data.leaf = false;
		data.cls = 'no-leaf-icons';
		data.matchesFilter = true;
		data.ty = 'dir';

		data.expanded = !!expanded[data.text];

		data.children = [];
		for (const file of data.files) {
		    file.text = file.filename;
		    file['crypt-mode'] = PBS.Utils.cryptmap.indexOf(file['crypt-mode']);
		    file.fingerprint = data.fingerprint;
		    file.leaf = true;
		    file.matchesFilter = true;
		    file.ty = 'file';

		    data.children.push(file);
		}

		children.push(data);
	    }

	    let nowSeconds = Date.now() / 1000;
	    let children = [];
	    for (const [name, group] of Object.entries(groups)) {
		let last_backup = 0;
		let crypt = {
		    none: 0,
		    mixed: 0,
		    'sign-only': 0,
		    encrypt: 0,
		};
		let verify = {
		    outdated: 0,
		    none: 0,
		    failed: 0,
		    ok: 0,
		};
		for (let item of group.children) {
		    crypt[PBS.Utils.cryptmap[item['crypt-mode']]]++;
		    if (item["backup-time"] > last_backup && item.size !== null) {
			last_backup = item["backup-time"];
			group["backup-time"] = last_backup;
			group["last-comment"] = item.comment;
			group.files = item.files;
			group.size = item.size;
			group.owner = item.owner;
			verify.lastFailed = item.verification && item.verification.state !== 'ok';
		    }
		    if (!item.verification) {
			verify.none++;
		    } else {
			if (item.verification.state === 'ok') {
			    verify.ok++;
			} else {
			    verify.failed++;
			}
			let task = Proxmox.Utils.parse_task_upid(item.verification.upid);
			item.verification.lastTime = task.starttime;
			if (nowSeconds - task.starttime > 30 * 24 * 60 * 60) {
			    verify.outdated++;
			}
		    }
		}
		group.verification = verify;
		group.count = group.children.length;
		group.matchesFilter = true;
		crypt.count = group.count;
		group['crypt-mode'] = PBS.Utils.calculateCryptMode(crypt);
		group.expanded = !!expanded[name];
		group.sortWeight = 0;
		group.ty = 'group';
		children.push(group);
	    }

	    for (const item of namespaces) {
		if (item.ns === view.namespace || (!view.namespace && item.ns === '')) {
		    continue;
		}
		children.push({
		    text: item.ns,
		    iconCls: 'fa fa-object-group',
		    expanded: true,
		    expandable: false,
		    ns: (view.namespaces ?? '') !== '' ? `/${item.ns}` : item.ns,
		    ty: 'ns',
		    sortWeight: 10,
		    leaf: true,
		});
	    }

	    let isRootNS = !view.namespace || view.namespace === '';
	    let rootText = isRootNS
		? gettext('Root Namespace')
		: Ext.String.format(gettext("Namespace '{0}'"), view.namespace);

	    let topNodes = [];
	    if (!isRootNS) {
		let parentNS = view.namespace.split('/').slice(0, -1).join('/');
		topNodes.push({
		    text: `.. (${parentNS === '' ? gettext('Root') : parentNS})`,
		    iconCls: 'fa fa-level-up',
		    ty: 'ns',
		    ns: parentNS,
		    sortWeight: -10,
		    leaf: true,
		});
	    }
	    topNodes.push({
		text: rootText,
		iconCls: "fa fa-" + (isRootNS ? 'database' : 'object-group'),
		expanded: true,
		expandable: false,
		sortWeight: -5,
		root: true, // fake root
		isRootNS,
		ty: 'ns',
		children: children,
	    });

	    view.setRootNode({
		expanded: true,
		children: topNodes,
	    });

	    if (!children.length) {
		view.setEmptyText(Ext.String.format(
		    gettext('No accessible snapshots found in namespace {0}'),
		    view.namespace && view.namespace !== '' ? `'${view.namespace}'`: gettext('Root'),
		));
	    }

	    this.updateGroupNotes(view);

	    if (selected !== undefined) {
		let selection = view.getRootNode().findChildBy(function(item) {
		    let id = item.data.text;
		    if (item.data.leaf) {
			id = item.parentNode.data.text + id;
		    }
		    return selected === id;
		}, undefined, true);
		if (selection) {
		    view.setSelection(selection);
		    view.getView().focusRow(selection);
		}
	    }

	    Proxmox.Utils.setErrorMask(view, false);
	    if (view.getStore().getFilters().length > 0) {
		let searchBox = me.lookup("searchbox");
		let searchvalue = searchBox.getValue();
		me.search(searchBox, searchvalue);
	    }
	},

	onChangeOwner: function(table, rI, cI, item, e, { data }) {
	    let view = this.getView();

	    if (data.ty !== 'group' || !view.datastore) {
		return;
	    }

	    let win = Ext.create('PBS.BackupGroupChangeOwner', {
		datastore: view.datastore,
		ns: view.namespace,
		backup_type: data.backup_type,
		backup_id: data.backup_id,
		owner: data.owner,
		autoShow: true,
	    });
	    // FIXME: don't reload all, use the record and query only its info, then update it
	    // directly in the tree
	    win.on('destroy', this.reload, this);
	},

	onPrune: function(table, rI, cI, item, e, rec) {
	    let me = this;
	    let view = me.getView();

	    if (rec.data.ty !== 'group' || !view.datastore) {
		return;
	    }
	    let data = rec.data;
	    Ext.create('PBS.DataStorePrune', {
		autoShow: true,
		datastore: view.datastore,
		ns: view.namespace,
		backup_type: data.backup_type,
		backup_id: data.backup_id,
		listeners: {
		    // FIXME: don't reload all, use the record and query only its info, then update
		    // it directly in the tree
		    destroy: () => me.reload(),
		},
	    });
	},

	verifyAll: function() {
	    let me = this;
	    let view = me.getView();

	    Ext.create('PBS.window.VerifyAll', {
		taskDone: () => me.reload(),
		autoShow: true,
		datastore: view.datastore,
		namespace: view.namespace,
	    });
	},

	pruneAll: function() {
	    let me = this;
	    let view = me.getView();

	    if (!view.datastore) return;

	    let ns = view.namespace;
	    let titleNS = ns && ns !== '' ? `Namespace '${ns}' on ` : '';

	    Ext.create('Proxmox.window.Edit', {
		title: `Prune ${titleNS}Datastore '${view.datastore}'`,
		onlineHelp: 'maintenance_pruning',
		method: 'POST',
		submitText: "Prune",
		autoShow: true,
		isCreate: true,
		showTaskViewer: true,
		taskDone: () => me.reload(),
		url: `/api2/extjs/admin/datastore/${view.datastore}/prune-datastore`,
		items: [
		    {
			xtype: 'pbsPruneInputPanel',
			ns,
			dryrun: true,
			canRecurse: true,
			isCreate: true,
		    },
		],
	    });
	},

	addNS: function() {
	    let me = this;
	    let view = me.getView();
	    if (!view.datastore) return;

	    Ext.create('PBS.window.NamespaceEdit', {
		autoShow: true,
		datastore: view.datastore,
		namespace: view.namespace ?? '',
		apiCallDone: success => {
		    if (success) {
			view.down('pbsNamespaceSelector').store?.load();
			me.reload();
		    }
		},
	    });
	},

	onVerify: function(view, rI, cI, item, e, { data }) {
	    let me = this;
	    view = me.getView();

	    if ((data.ty !== 'group' && data.ty !== 'dir') || !view.datastore) {
		return;
	    }

	    let params;
	    if (data.ty === 'dir') {
		params = {
		    "backup-type": data["backup-type"],
		    "backup-id": data["backup-id"],
		    "backup-time": (data['backup-time'].getTime()/1000).toFixed(0),
		    "ignore-verified": false, // always reverify single snapshots
		};
	    } else {
		params = {
		    "backup-type": data.backup_type,
		    "backup-id": data.backup_id,
		    "outdated-after": 29, // reverify after 29 days so match with the "old" display
		};
	    }
	    if (view.namespace && view.namespace !== '') {
		params.ns = view.namespace;
	    }

	    Proxmox.Utils.API2Request({
		params: params,
		url: `/admin/datastore/${view.datastore}/verify`,
		method: 'POST',
		failure: function(response) {
		    Ext.Msg.alert(gettext('Error'), response.htmlStatus);
		},
		success: function(response, options) {
		    Ext.create('Proxmox.window.TaskViewer', {
			upid: response.result.data,
			taskDone: () => me.reload(),
		    }).show();
		},
	    });
	},

	onCopy: async function(view, rI, cI, item, e, { data }) {
	    await navigator.clipboard.writeText(data.text);
	},

	onNotesEdit: function(view, data) {
	    let me = this;

	    let isGroup = data.ty === 'group';

	    let params;
	    if (isGroup) {
		params = {
		    "backup-type": data.backup_type,
		    "backup-id": data.backup_id,
		};
	    } else {
		params = {
		    "backup-type": data["backup-type"],
		    "backup-id": data["backup-id"],
		    "backup-time": (data['backup-time'].getTime()/1000).toFixed(0),
		};
	    }
	    if (view.namespace && view.namespace !== '') {
		params.ns = view.namespace;
	    }

	    Ext.create('PBS.window.NotesEdit', {
		url: `/admin/datastore/${view.datastore}/${isGroup ? 'group-notes' : 'notes'}`,
		autoShow: true,
		apiCallDone: () => me.reload(), // FIXME: do something more efficient?
		extraRequestParams: params,
	    });
	},

	forgetNamespace: function(data) {
	    let me = this;
	    let view = me.getView();
	    if (!view.namespace || view.namespace === '') {
		console.warn('forgetNamespace called with root NS!');
		return;
	    }
	    let nsParts = view.namespace.split('/');
	    let nsName = nsParts.pop();
	    let parentNS = nsParts.join('/');

	    Ext.create('PBS.window.NamespaceDelete', {
		datastore: view.datastore,
		namespace: view.namespace,
		item: { id: nsName },
		apiCallDone: success => {
		    if (success) {
			view.namespace = parentNS; // move up before reload to avoid "ENOENT" error
			me.reload();
		    }
		},
	    });
	},

	forgetGroup: function(data) {
	    let me = this;
	    let view = me.getView();

	    let params = {
		"backup-type": data.backup_type,
		"backup-id": data.backup_id,
	    };
	    if (view.namespace && view.namespace !== '') {
		params.ns = view.namespace;
	    }

	    Ext.create('Proxmox.window.SafeDestroy', {
		url: `/admin/datastore/${view.datastore}/groups`,
		params,
		item: {
		    id: data.text,
		},
		autoShow: true,
		taskName: 'forget-group',
		listeners: {
		    destroy: () => me.reload(),
		},
	    });
	},

	forgetSnapshot: function(data) {
	    let me = this;
	    let view = me.getView();

	    Ext.Msg.show({
		title: gettext('Confirm'),
		icon: Ext.Msg.WARNING,
		message: Ext.String.format(gettext('Are you sure you want to remove snapshot {0}'), `'${data.text}'`),
		buttons: Ext.Msg.YESNO,
		defaultFocus: 'no',
		callback: function(btn) {
		    if (btn !== 'yes') {
		        return;
		    }
		    let params = {
			"backup-type": data["backup-type"],
			"backup-id": data["backup-id"],
			"backup-time": (data['backup-time'].getTime()/1000).toFixed(0),
		    };
		    if (view.namespace && view.namespace !== '') {
			params.ns = view.namespace;
		    }

		    Proxmox.Utils.API2Request({
			url: `/admin/datastore/${view.datastore}/snapshots`,
			params,
			method: 'DELETE',
			waitMsgTarget: view,
			failure: function(response, opts) {
			    Ext.Msg.alert(gettext('Error'), response.htmlStatus);
			},
			callback: me.reload.bind(me),
		    });
		},
	    });
	},

	onProtectionChange: function(view, rI, cI, item, e, rec) {
	    let me = this;
	    view = this.getView();

	    if (!(rec && rec.data)) return;
	    let data = rec.data;
	    if (!view.datastore) return;

	    let type = data["backup-type"];
	    let id = data["backup-id"];
	    let time = (data["backup-time"].getTime()/1000).toFixed(0);

	    let params = {
		'backup-type': type,
		'backup-id': id,
		'backup-time': time,
	    };
	    if (view.namespace && view.namespace !== '') {
		params.ns = view.namespace;
	    }

	    let url = `/api2/extjs/admin/datastore/${view.datastore}/protected`;

	    Ext.create('Proxmox.window.Edit', {
		subject: gettext('Protection') + ` - ${data.text}`,
		width: 400,

		method: 'PUT',
		autoShow: true,
		isCreate: false,
		autoLoad: true,

		url,
		extraRequestParams: params,

		items: [
		    {
			xtype: 'proxmoxcheckbox',
			fieldLabel: gettext('Protected'),
			uncheckedValue: 0,
			name: 'protected',
			value: data.protected,
		    },
		],
		listeners: {
		    destroy: () => me.reload(),
		},
	    });
	},

	onForget: function(table, rI, cI, item, e, { data }) {
	    let me = this;
	    let view = this.getView();
	    if ((data.ty !== 'group' && data.ty !== 'dir' && data.ty !== 'ns') || !view.datastore) {
		return;
	    }

	    if (data.ty === 'ns') {
		me.forgetNamespace(data);
	    } else if (data.ty === 'dir') {
		me.forgetSnapshot(data);
	    } else {
		me.forgetGroup(data);
	    }
	},

	downloadFile: function(tV, rI, cI, item, e, rec) {
	    let me = this;
	    let view = me.getView();
	    if (rec.data.ty !== 'file') return;

	    let snapshot = rec.parentNode.data;
	    let file = rec.data.filename;
	    let params = {
		'backup-id': snapshot['backup-id'],
		'backup-type': snapshot['backup-type'],
		'backup-time': (snapshot['backup-time'].getTime()/1000).toFixed(0),
		'file-name': file,
	    };
	    if (view.namespace && view.namespace !== '') {
		params.ns = view.namespace;
	    }

	    let idx = file.lastIndexOf('.');
	    let filename = file.slice(0, idx);
	    let atag = document.createElement('a');
	    atag.download = filename;
	    let url = new URL(
	        `/api2/json/admin/datastore/${view.datastore}/download-decoded`,
	        window.location.origin,
	    );
	    for (const [key, value] of Object.entries(params)) {
		url.searchParams.append(key, value);
	    }
	    atag.href = url.href;
	    atag.click();
	},

	// opens either a namespace or a pxar file-browser
	openBrowser: function(tv, rI, Ci, item, e, rec) {
	    let me = this;
	    let view = me.getView();

	    if (rec.data.ty === 'ns') {
		me.nsChange(null, rec.data.ns);
		return;
	    }
	    if (rec?.data?.ty !== 'file') return;
	    let snapshot = rec.parentNode.data;

	    let id = snapshot['backup-id'];
	    let time = snapshot['backup-time'];
	    let type = snapshot['backup-type'];
	    let timetext = PBS.Utils.render_datetime_utc(snapshot["backup-time"]);
	    let extraParams = {
		'backup-id': id,
		'backup-time': (time.getTime()/1000).toFixed(0),
		'backup-type': type,
	    };
	    if (rec.data.filename.endsWith(".mpxar.didx")) {
		extraParams['archive-name'] = rec.data.filename;
	    }
	    if (view.namespace && view.namespace !== '') {
		extraParams.ns = view.namespace;
	    }
	    Ext.create('Proxmox.window.FileBrowser', {
		title: `${type}/${id}/${timetext}`,
		listURL: `/api2/json/admin/datastore/${view.datastore}/catalog`,
		downloadURL: `/api2/json/admin/datastore/${view.datastore}/pxar-file-download`,
		extraParams,
		enableTar: true,
		downloadPrefix: `${type}-${id}-`,
		archive: rec.data.filename,
	    }).show();
	},

	filter: function(item, value) {
	    if (item.data.text.indexOf(value) !== -1) {
		return true;
	    }

	    if (item.data.owner && item.data.owner.indexOf(value) !== -1) {
		return true;
	    }

	    return false;
	},

	search: function(tf, value) {
	    let me = this;
	    let view = me.getView();
	    let store = view.getStore();
	    if (!value && value !== 0) {
		store.clearFilter();
		// only collapse the children below our toplevel namespace "root"
		store.getRoot().lastChild.collapseChildren(true);
		tf.triggers.clear.setVisible(false);
		return;
	    }
	    tf.triggers.clear.setVisible(true);
	    if (value.length < 2) return;
	    Proxmox.Utils.setErrorMask(view, true);
	    // we do it a little bit later for the error mask to work
	    setTimeout(function() {
		store.clearFilter();
		store.getRoot().collapseChildren(true);

		store.beginUpdate();
		store.getRoot().cascadeBy({
		    before: function(item) {
			if (me.filter(item, value)) {
			    item.set('matchesFilter', true);
			    if (item.parentNode && item.parentNode.id !== 'root') {
				item.parentNode.childmatches = true;
			    }
			    return false;
			}
			return true;
		    },
		    after: function(item) {
			if (me.filter(item, value) || item.id === 'root' || item.childmatches) {
			    item.set('matchesFilter', true);
			    if (item.parentNode && item.parentNode.id !== 'root') {
				item.parentNode.childmatches = true;
			    }
			    if (item.childmatches) {
				item.expand();
			    }
			} else {
			    item.set('matchesFilter', false);
			}
			delete item.childmatches;
		    },
		});
		store.endUpdate();

		store.filter((item) => !!item.get('matchesFilter'));
		Proxmox.Utils.setErrorMask(view, false);
	    }, 10);
	},
    },

    listeners: {
	activate: function() {
	    let me = this;
	    // only load on first activate to not load every tab switch
	    if (!me.firstLoad) {
		me.getController().reload();
		me.firstLoad = true;
	    }
	},
	itemcontextmenu: function(panel, record, item, index, event) {
	    event.stopEvent();
	    let menu;
	    let view = panel.up('pbsDataStoreContent');
	    let controller = view.getController();
	    let createControllerCallback = function(name) {
		return function() {
		    controller[name](view, undefined, undefined, undefined, undefined, record);
		};
	    };
	    if (record.data.ty === 'group') {
		menu = Ext.create('PBS.datastore.GroupCmdMenu', {
		    title: gettext('Group'),
		    onCopy: createControllerCallback('onCopy'),
		    onVerify: createControllerCallback('onVerify'),
		    onChangeOwner: createControllerCallback('onChangeOwner'),
		    onPrune: createControllerCallback('onPrune'),
		    onForget: createControllerCallback('onForget'),
		});
	    } else if (record.data.ty === 'dir') {
		menu = Ext.create('PBS.datastore.SnapshotCmdMenu', {
		    title: gettext('Snapshot'),
		    onCopy: createControllerCallback('onCopy'),
		    onVerify: createControllerCallback('onVerify'),
		    onProtectionChange: createControllerCallback('onProtectionChange'),
		    onForget: createControllerCallback('onForget'),
		});
	    }
	    if (menu) {
		menu.showAt(event.getXY());
	    }
	},
    },

    viewConfig: {
	getRowClass: function(record, index) {
	    let verify = record.get('verification');
	    if (verify && verify.lastFailed) {
		return 'proxmox-invalid-row';
	    }
	    return null;
	},
    },

    columns: [
	{
	    xtype: 'treecolumn',
	    header: gettext("Backup Group"),
	    dataIndex: 'text',
	    renderer: (value, meta, record) => {
		if (record.data.protected) {
		    return `${value} (${gettext('protected')})`;
		}
		return value;
	    },
	    flex: 1,
	},
	{
	    text: gettext('Comment'),
	    dataIndex: 'comment',
	    flex: 1,
	    renderer: (v, meta, record) => {
		let data = record.data;
		if (!data || data.leaf || data.root) {
		    return '';
		}

		let additionalClasses = "";
		if (!v) {
		    if (!data.expanded) {
			v = data['last-comment'] ?? '';
			additionalClasses = 'pmx-opacity-75';
		    } else {
			v = '';
		    }
		}
		v = Ext.String.htmlEncode(v);
		let icon = 'x-action-col-icon fa fa-fw fa-pencil pointer';

		return `<span class="snapshot-comment-column ${additionalClasses}">${v}</span>
		    <i data-qtip="${gettext('Edit')}" style="float: right; margin: 0px;" class="${icon}"></i>`;
	    },
	    listeners: {
		afterrender: function(component) {
		    // a bit of a hack, but relatively easy, cheap and works out well.
		    // more efficient to use one handler for the whole column than for each icon
		    component.on('click', function(tree, cell, rowI, colI, e, rec) {
			let el = e.target;
			if (el.tagName !== "I" || !el.classList.contains("fa-pencil")) {
			    return;
			}
			let view = tree.up();
			let controller = view.controller;
			controller.onNotesEdit(view, rec.data);
		    });
		},
		dblclick: function(tree, el, row, col, ev, rec) {
		    let data = rec.data || {};
		    if (data.leaf || data.root) {
			return;
		    }
		    let view = tree.up();
		    let controller = view.controller;
		    controller.onNotesEdit(view, rec.data);
		},
	    },
	},
	{
	    header: gettext('Actions'),
	    xtype: 'actioncolumn',
	    dataIndex: 'text',
	    width: 150,
	    items: [
		{
		    handler: 'onVerify',
		    getTip: (v, m, rec) => Ext.String.format(gettext("Verify '{0}'"), v),
		    getClass: (v, m, { data }) => data.ty === 'group' || data.ty === 'dir'
		        ? 'pve-icon-verify-lettering' : 'pmx-hidden',
		    isActionDisabled: (v, r, c, i, rec) => !!rec.data.leaf,
                },
                {
		    handler: 'onChangeOwner',
		    getClass: (v, m, { data }) => data.ty === 'group' ? 'fa fa-user' : 'pmx-hidden',
		    getTip: (v, m, rec) => Ext.String.format(gettext("Change owner of '{0}'"), v),
		    isActionDisabled: (v, r, c, i, { data }) => data.ty !== 'group',
                },
		{
		    handler: 'onPrune',
		    getTip: (v, m, rec) => Ext.String.format(gettext("Prune '{0}'"), v),
		    getClass: (v, m, { data }) => data.ty === 'group' ? 'fa fa-scissors' : 'pmx-hidden',
		    isActionDisabled: (v, r, c, i, { data }) => data.ty !== 'group',
		},
		{
		    handler: 'onProtectionChange',
		    getTip: (v, m, rec) => Ext.String.format(gettext("Change protection of '{0}'"), v),
		    getClass: (v, m, rec) => {
			if (rec.data.ty === 'dir') {
			    let extraCls = rec.data.protected ? 'good' : 'faded';
			    return `fa fa-shield ${extraCls}`;
			}
			return 'pmx-hidden';
		    },
		    isActionDisabled: (v, r, c, i, rec) => rec.data.ty !== 'dir',
		},
		{
		    handler: 'onForget',
		    getTip: (v, m, { data }) => {
			let tip = '{0}';
			if (data.ty === 'ns') {
			    tip = gettext("Remove namespace '{0}'");
			} else if (data.ty === 'dir') {
			    tip = gettext("Permanently forget snapshot '{0}'");
			} else if (data.ty === 'group') {
			    tip = gettext("Permanently forget group '{0}'");
			}
			return Ext.String.format(tip, v);
		    },
		    getClass: (v, m, { data }) =>
		        (data.ty === 'ns' && !data.isRootNS && data.ns === undefined) ||
		           data.ty === 'group' || data.ty === 'dir'
		        ? 'fa critical fa-trash-o'
		        : 'pmx-hidden',
		    isActionDisabled: (v, r, c, i, { data }) => false,
		},
		{
		    handler: 'downloadFile',
		    getTip: (v, m, rec) => Ext.String.format(gettext("Download '{0}'"), v),
		    getClass: (v, m, { data }) => data.ty === 'file' ? 'fa fa-download' : 'pmx-hidden',
		    isActionDisabled: (v, r, c, i, rec) => rec.data.ty !== 'file' || rec.data['crypt-mode'] > 2,
		},
		{
		    handler: 'openBrowser',
		    tooltip: gettext('Browse'),
		    getClass: (v, m, { data }) => {
			if (
			    (data.ty === 'file' && (data.filename.endsWith('.pxar.didx') || data.filename.endsWith('.mpxar.didx'))) ||
			    (data.ty === 'ns' && !data.root)
			) {
			    return 'fa fa-folder-open-o';
			}
			return 'pmx-hidden';
		    },
		    isActionDisabled: (v, r, c, i, { data }) =>
			!(data.ty === 'file' &&
			(data.filename.endsWith('.pxar.didx') || data.filename.endsWith('.mpxar.didx')) &&
			data['crypt-mode'] < 3) && data.ty !== 'ns',
		},
	    ],
	},
	{
	    xtype: 'datecolumn',
	    header: gettext('Backup Time'),
	    sortable: true,
	    dataIndex: 'backup-time',
	    format: 'Y-m-d H:i:s',
	    width: 150,
	},
	{
	    header: gettext("Size"),
	    sortable: true,
	    dataIndex: 'size',
	    renderer: (v, meta, { data }) => {
		if ((data.text === 'client.log.blob' && v === undefined) || (data.ty !== 'dir' && data.ty !== 'file')) {
		    return '';
		}
		if (v === undefined || v === null) {
		    meta.tdCls = "x-grid-row-loading";
		    return '';
		}
		return Proxmox.Utils.format_size(v);
	    },
	},
	{
	    xtype: 'numbercolumn',
	    format: '0',
	    header: gettext("Count"),
	    sortable: true,
	    width: 75,
	    align: 'right',
	    dataIndex: 'count',
	},
	{
	    header: gettext("Owner"),
	    sortable: true,
	    dataIndex: 'owner',
	},
	{
	    header: gettext('Encrypted'),
	    dataIndex: 'crypt-mode',
	    renderer: (v, meta, record) => {
		if (record.data.size === undefined || record.data.size === null) {
		    return '';
		}
		if (v === -1) {
		    return '';
		}
		let iconCls = PBS.Utils.cryptIconCls[v] || '';
		let iconTxt = "";
		if (iconCls) {
		    iconTxt = `<i class="fa fa-fw fa-${iconCls}"></i> `;
		}
		let tip;
		if (v !== PBS.Utils.cryptmap.indexOf('none') && record.data.fingerprint !== undefined) {
		    tip = "Key: " + PBS.Utils.renderKeyID(record.data.fingerprint);
		}
		let txt = (iconTxt + PBS.Utils.cryptText[v]) || Proxmox.Utils.unknownText;
		if (record.data.ty === 'group' || tip === undefined) {
		    return txt;
		} else {
		    return `<span data-qtip="${tip}">${txt}</span>`;
		}
	    },
	},
	{
	    header: gettext('Verify State'),
	    sortable: true,
	    dataIndex: 'verification',
	    width: 120,
	    sorter: (arec, brec) => {
		let a = arec.data.verification || { ok: 0, outdated: 0, failed: 0 };
		let b = brec.data.verification || { ok: 0, outdated: 0, failed: 0 };
		if (a.failed === b.failed) {
		    if (a.none === b.none) {
			if (a.outdated === b.outdated) {
			    return b.ok - a.ok;
			} else {
			    return b.outdated - a.outdated;
			}
		    } else {
			return b.none - a.none;
		    }
		} else {
		    return b.failed - a.failed;
		}
	    },
	    renderer: (v, meta, record) => {
		if (record.data.ty === 'ns') {
		    return ''; // TODO: accumulate verify of all groups into root NS node?
		}
		let i = (cls, txt) => `<i class="fa fa-fw fa-${cls}"></i> ${txt}`;
		if (v === undefined || v === null) {
		    return record.data.leaf ? '' : i('question-circle-o warning', gettext('None'));
		}
		let tip, iconCls, txt;
		if (record.data.ty === 'group') {
		    if (v.failed === 0) {
			if (v.none === 0) {
			    if (v.outdated > 0) {
				tip = 'All OK, but some snapshots were not verified in last 30 days';
				iconCls = 'check warning';
				txt = gettext('All OK (old)');
			    } else {
				tip = 'All snapshots verified at least once in last 30 days';
				iconCls = 'check good';
				txt = gettext('All OK');
			    }
			} else if (v.ok === 0) {
			    tip = `${v.none} not verified yet`;
			    iconCls = 'question-circle-o warning';
			    txt = gettext('None');
			} else {
			    tip = `${v.ok} OK, ${v.none} not verified yet`;
			    iconCls = 'check faded';
			    txt = `${v.ok} OK`;
			}
		    } else {
			tip = `${v.ok} OK, ${v.failed} failed, ${v.none} not verified yet`;
			iconCls = 'times critical';
			txt = v.ok === 0 && v.none === 0
			    ? gettext('All failed')
			    : `${v.failed} failed`;
		    }
		} else if (!v.state) {
		    return record.data.leaf ? '' : gettext('None');
		} else {
		    let verify_time = Proxmox.Utils.render_timestamp(v.lastTime);
		    tip = `Last verify task started on ${verify_time}`;
		    txt = v.state;
		    iconCls = 'times critical';
		    if (v.state === 'ok') {
			iconCls = 'check good';
			let now = Date.now() / 1000;
			if (now - v.lastTime > 30 * 24 * 60 * 60) {
			    tip = `Last verify task over 30 days ago: ${verify_time}`;
			    iconCls = 'check warning';
			}
		    }
		}
		return `<span data-qtip="${tip}">
		    <i class="fa fa-fw fa-${iconCls}"></i> ${txt}
		</span>`;
	    },
	    listeners: {
		dblclick: function(view, el, row, col, ev, rec) {
		    let verify = rec?.data?.verification;
		    if (verify?.upid && rec.parentNode?.id !== 'root') {
			Ext.create('Proxmox.window.TaskViewer', {
			    autoShow: true,
			    upid: verify.upid,
			});
		    }
		},
	    },
	},
    ],

    tbar: [
	{
	    text: gettext('Reload'),
	    iconCls: 'fa fa-refresh',
	    handler: 'reload',
	},
	'-',
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Verify All'),
	    iconCls: 'pve-icon-verify-lettering',
	    handler: 'verifyAll',
	},
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Prune All'),
	    iconCls: 'fa fa-scissors',
	    handler: 'pruneAll',
	},
	'->',
	{
	    xtype: 'tbtext',
	    html: gettext('Namespace') + ':',
	},
	{
	    xtype: 'pbsNamespaceSelector',
	    width: 200,
	    cbind: {
		datastore: '{datastore}',
	    },
	},
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Add Namespace'),
	    iconCls: 'fa fa-plus-square',
	    handler: 'addNS',
	},
	'-',
	{
	    xtype: 'tbtext',
	    html: gettext('Search'),
	},
	{
	    xtype: 'textfield',
	    reference: 'searchbox',
	    emptyText: gettext('group, date or owner'),
	    triggers: {
		clear: {
		    cls: 'pmx-clear-trigger',
		    weight: -1,
		    hidden: true,
		    handler: function() {
			this.triggers.clear.setVisible(false);
			this.setValue('');
		    },
		},
	    },
	    listeners: {
		change: {
		    fn: 'search',
		    buffer: 500,
		},
	    },
	},
    ],
});

Ext.define('PBS.datastore.GroupCmdMenu', {
    extend: 'Ext.menu.Menu',
    mixins: ['Proxmox.Mixin.CBind'],

    onCopy: undefined,
    onVerify: undefined,
    onChangeOwner: undefined,
    onPrune: undefined,
    onForget: undefined,

    items: [
	{
	    text: gettext('Copy name to clipboard'),
	    iconCls: 'fa fa-clipboard',
	    handler: function() { this.up('menu').onCopy(); },
	    cbind: {
		hidden: '{!onCopy}',
	    },
	},
	{
	    text: gettext('Verify'),
	    iconCls: 'pve-icon-verify-lettering',
	    handler: function() { this.up('menu').onVerify(); },
	    cbind: {
		hidden: '{!onVerify}',
	    },
	},
	{
	    text: gettext('Change owner'),
	    iconCls: 'fa fa-user',
	    handler: function() { this.up('menu').onChangeOwner(); },
	    cbind: {
		hidden: '{!onChangeOwner}',
	    },
	},
	{
	    text: gettext('Prune'),
	    iconCls: 'fa fa-scissors',
	    handler: function() { this.up('menu').onPrune(); },
	    cbind: {
		hidden: '{!onPrune}',
	    },
	},
	{ xtype: 'menuseparator' },
	{
	    text: gettext('Remove'),
	    iconCls: 'fa critical fa-trash-o',
	    handler: function() { this.up('menu').onForget(); },
	    cbind: {
		hidden: '{!onForget}',
	    },
	},
    ],
});

Ext.define('PBS.datastore.SnapshotCmdMenu', {
    extend: 'Ext.menu.Menu',
    mixins: ['Proxmox.Mixin.CBind'],

    onCopy: undefined,
    onVerify: undefined,
    onProtectionChange: undefined,
    onForget: undefined,

    items: [
	{
	    text: gettext('Copy name to clipboard'),
	    iconCls: 'fa fa-clipboard',
	    handler: function() { this.up('menu').onCopy(); },
	    cbind: {
		hidden: '{!onCopy}',
		disabled: '{!onCopy}',
	    },
	},
	{
	    text: gettext('Verify'),
	    iconCls: 'pve-icon-verify-lettering',
	    handler: function() { this.up('menu').onVerify(); },
	    cbind: {
		hidden: '{!onVerify}',
		disabled: '{!onVerify}',
	    },
	},
	{
	    text: gettext('Change Protection'),
	    iconCls: 'fa fa-shield',
	    handler: function() { this.up('menu').onProtectionChange(); },
	    cbind: {
		hidden: '{!onProtectionChange}',
		disabled: '{!onProtectionChange}',
	    },
	},
	{ xtype: 'menuseparator' },
	{
	    text: gettext('Remove'),
	    iconCls: 'fa critical fa-trash-o',
	    handler: function() { this.up('menu').onForget(); },
	    cbind: {
		hidden: '{!onForget}',
		disabled: '{!onForget}',
	    },
	},
    ],
});
Ext.define('PBS.window.SafeDatastoreDestroy', {
    extend: 'Proxmox.window.SafeDestroy',
    xtype: 'pbsDatastoreSafeDestroy',
    mixins: ['Proxmox.Mixin.CBind'],

    cbind: {
	url: `/config/datastore/{datastore}`,
	item: get => ({ id: get('datastore') }),
    },
    viewModel: {
	data: {
	    'destroyData': 0,
	    'keepJobConfigs': 0,
	},
	formulas: {
	    destroyNote: get => get('destroyData')
		? gettext('All backup snapshots and their data will be permanently destroyed!')
		: gettext('Configuration change only, no data will be deleted.'),
	    destroyNoteCls: get => get('destroyData') ? 'pmx-hint' : '',
	},
    },

    autoShow: true,
    taskName: 'delete-datastore',

    apiCallDone: function(success) {
	if (success) {
	    let navtree = Ext.ComponentQuery.query('navigationtree')[0];
	    navtree.rstore.load();
	    let mainview = Ext.ComponentQuery.query('mainview')[0];
	    mainview.getController().redirectTo('pbsDataStores');
	}
    },

    getParams: function() {
	let viewModel = this.getViewModel();

	let params = {
	    'destroy-data': viewModel.get('destroyData'),
	    'keep-job-configs': viewModel.get('keepJobConfigs'),
	};
	return `?${Ext.Object.toQueryString(params)}`;
    },
    additionalItems: [{
	xtype: 'proxmoxcheckbox',
	name: 'destroy-data',
	boxLabel: gettext("Destroy all data (dangerous!)"),
	defaultValue: false,
	bind: {
	    value: '{destroyData}',
	},
    }, {
	xtype: 'proxmoxcheckbox',
	name: 'keep-job-configs',
	boxLabel: gettext("Keep configured jobs and permissions"),
	defaultValue: false,
	bind: {
	    value: '{keepJobConfigs}',
	},
    }, {
	xtype: 'component',
	reference: 'noteCmp',
	bind: {
	    html: '{destroyNote}',
	    userCls: '{destroyNoteCls}',
	},
    }],
});

Ext.define('PBS.Datastore.Options', {
    extend: 'Proxmox.grid.ObjectGrid',
    xtype: 'pbsDatastoreOptionView',
    mixins: ['Proxmox.Mixin.CBind'],

    cbindData: function(initial) {
	let me = this;

	me.maintenanceActiveTasks = {
	    read: 0,
	    write: 0,
	};
	me.datastore = encodeURIComponent(me.datastore);
	me.url = `/api2/json/config/datastore/${me.datastore}`;
	me.editorConfig = {
	    url: `/api2/extjs/config/datastore/${me.datastore}`,
	    datastore: me.datastore,
	};
	return {};
    },

    controller: {
	xclass: 'Ext.app.ViewController',

	init: function(view) {
	    let me = this;

	    me.activeOperationsRstore = Ext.create('Proxmox.data.ObjectStore', {
		url: `/api2/json/admin/datastore/${view.datastore}/active-operations`,
		interval: 3000,
	    });
	    me.activeOperationsRstore.startUpdate();

	    view.mon(me.activeOperationsRstore, 'load', (store, data, success) => {
		let activeTasks = me.getView().maintenanceActiveTasks;
		activeTasks.read = data?.[0]?.data.value ?? 0;
		activeTasks.write = data?.[1]?.data.value ?? 0;
	    });
	},

	edit: function() {
	    this.getView().run_editor();
	},

	removeDatastore: function() {
	    let me = this;
	    Ext.create('PBS.window.SafeDatastoreDestroy', {
		datastore: me.getView().datastore,
	    });
	},

	stopUpdates: function() {
	    let me = this;
	    let view = me.getView();

	    view.rstore.stopUpdate();
	    me.activeOperationsRstore.stopUpdate();
	},
	startUpdates: function() {
	    let me = this;
	    let view = me.getView();

	    view.rstore.startUpdate();
	    me.activeOperationsRstore.startUpdate();
	},
    },

    tbar: [
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Edit'),
	    disabled: true,
	    handler: 'edit',
	},
	'->',
	{
	    xtype: 'proxmoxButton',
	    selModel: null,
	    iconCls: 'fa fa-trash-o',
	    text: gettext('Remove Datastore'),
	    handler: 'removeDatastore',
	},
    ],

    listeners: {
	activate: 'startUpdates',
	beforedestroy: 'stopUpdates',
	deactivate: 'stopUpdates',
	itemdblclick: 'edit',
    },

    rows: {
	"notification-mode": {
	    required: true,
	    defaultValue: 'legacy-sendmail',
	    header: gettext('Notification mode'),
	    renderer: function(value) {
		if (value === 'notification-system') {
		    return gettext('Notification system');
		} else {
		    return gettext('Email (legacy)');
		}
	    },
	    editor: {
		xtype: 'pbsNotifyOptionEdit',
	    },
	},
	"notify": {
	    required: true,
	    header: gettext('Notify'),
	    renderer: (value) => {
		let notify = PBS.Utils.parsePropertyString(value);
		let res = [];
		for (const k of ['Verify', 'Sync', 'GC', 'Prune']) {
		    let fallback = k === 'Prune' ? 'Error' : 'Always';
		    let v = Ext.String.capitalize(notify[k.toLowerCase()]) || fallback;
		    res.push(`${k}=${v}`);
		}
		return res.join(', ');
	    },
	    editor: {
		xtype: 'pbsNotifyOptionEdit',
	    },
	},
	"notify-user": {
	    required: true,
	    defaultValue: 'root@pam',
	    header: gettext('Notify User'),
	    editor: {
		xtype: 'pbsNotifyOptionEdit',
	    },
	},
	"verify-new": {
	    required: true,
	    header: gettext('Verify New Snapshots'),
	    defaultValue: false,
	    renderer: Proxmox.Utils.format_boolean,
	    editor: {
		xtype: 'proxmoxWindowEdit',
		title: gettext('Verify New'),
		width: 350,
		items: {
		    xtype: 'proxmoxcheckbox',
		    name: 'verify-new',
		    boxLabel: gettext("Verify new backups immediately after completion"),
		    defaultValue: false,
		    deleteDefaultValue: true,
		    deleteEmpty: true,
		},
	    },
	},
	"maintenance-mode": {
	    required: true,
	    header: gettext('Maintenance mode'),
	    renderer: function(v) {
		return PBS.Utils.renderMaintenance(v, this.maintenanceActiveTasks);
	    },
	    editor: {
		xtype: 'pbsMaintenanceOptionEdit',
	    },
	},
	'tuning': {
	    required: true,
	    header: gettext('Tuning Options'),
	    renderer: v => PBS.Utils.render_tuning_options(PBS.Utils.parsePropertyString(v)),
	    editor: {
		xtype: 'proxmoxWindowEdit',
		title: gettext('Tuning Options'),
		onlineHelp: 'datastore_tuning_options',
		width: 350,
		items: {
		    xtype: 'inputpanel',
		    onGetValues: function(values) {
			if (!Ext.isArray(values.delete ?? [])) {
			    values.delete = [values.delete];
			}
			for (const k of values.delete ?? []) {
			    delete values[k];
			}
			delete values.delete;
			let tuning = PBS.Utils.printPropertyString(values);
			if (!tuning) {
			    return { 'delete': 'tuning' };
			}
			return { tuning };
		    },
		    onSetValues: values => PBS.Utils.parsePropertyString(values?.tuning),
		    items: [
			{
			    xtype: 'proxmoxKVComboBox',
			    name: 'chunk-order',
			    fieldLabel: gettext('Chunk Order'),
			    comboItems: Object.entries(PBS.Utils.tuningOptions['chunk-order']),
			    deleteEmpty: true,
			    value: '__default__',
			},
			{
			    xtype: 'proxmoxKVComboBox',
			    name: 'sync-level',
			    fieldLabel: gettext('Sync Level'),
			    comboItems: Object.entries(PBS.Utils.tuningOptions['sync-level']),
			    deleteEmpty: true,
			    value: '__default__',
			},
		    ],
		},
	    },
	},
    },
});
Ext.define('PBS.DataStorePanel', {
    extend: 'Ext.tab.Panel',
    alias: 'widget.pbsDataStorePanel',
    mixins: ['Proxmox.Mixin.CBind'],

    cbindData: function(initialConfig) {
	let me = this;
	return {
	    aclPath: `/datastore/${me.datastore}`,
	};
    },

    stateId: 'pbs-datastore-panel',
    stateful: true,

    stateEvents: ['tabchange'],

    applyState: function(state) {
	let me = this;
	if (state.tab !== undefined && me.rendered) {
	    me.setActiveTab(state.tab);
	} else if (state.tab) {
	    // if we are not rendered yet, defer setting the activetab
	    setTimeout(() => me.setActiveTab(state.tab), 10);
	}
    },

    getState: function() {
	let me = this;
	return {
	    tab: me.getActiveTab().getItemId(),
	};
    },

    border: false,
    defaults: {
	border: false,
    },

    tools: [PBS.Utils.get_help_tool("datastore_intro")],

    items: [
	{
	    xtype: 'pbsDataStoreSummary',
	    title: gettext('Summary'),
	    itemId: 'summary',
	    iconCls: 'fa fa-book',
	    cbind: {
		datastore: '{datastore}',
	    },
	},
	{
	    xtype: 'pbsDataStoreContent',
	    itemId: 'content',
	    iconCls: 'fa fa-th',
	    cbind: {
		datastore: '{datastore}',
	    },
	},
	{
	    xtype: 'pbsPruneAndGC',
	    itemId: 'prunegc',
	    iconCls: 'fa fa-trash-o',
	    cbind: {
		datastore: '{datastore}',
	    },
	},
	{
	    iconCls: 'fa fa-refresh',
	    itemId: 'syncjobs',
	    xtype: 'pbsSyncJobView',
	    cbind: {
		datastore: '{datastore}',
	    },
	},
	{
	    iconCls: 'fa fa-check-circle',
	    itemId: 'verifyjobs',
	    xtype: 'pbsVerifyJobView',
	    cbind: {
		datastore: '{datastore}',
	    },
	},
	{
	    xtype: 'pbsDatastoreOptionView',
	    itemId: 'options',
	    title: gettext('Options'),
	    iconCls: 'fa fa-cog',
	    cbind: {
		datastore: '{datastore}',
	    },
	},
	{
	    itemId: 'acl',
	    xtype: 'pbsACLView',
	    iconCls: 'fa fa-unlock',
	    cbind: {
		aclPath: '{aclPath}',
		datastore: '{datastore}',
	    },
	},
    ],

    initComponent: function() {
	let me = this;
	me.title = `${gettext("Datastore")}: ${me.datastore}`;
	// remove invalid activeTab settings
	if (me.activeTab && !me.items.some((item) => item.itemId === me.activeTab)) {
	    delete me.activeTab;
	}
	me.callParent();
    },
});
// Summary Panel for a single datastore in overview
Ext.define('PBS.datastore.DataStoreListSummary', {
    extend: 'Ext.panel.Panel',
    alias: 'widget.pbsDataStoreListSummary',
    mixins: ['Proxmox.Mixin.CBind'],

    cbind: {
	title: '{datastore}',
    },

    referenceHolder: true,
    bodyPadding: 10,

    layout: {
	type: 'hbox',
	align: 'stretch',
    },

    viewModel: {
	data: {
	    full: "N/A",
	    stillbad: 0,
	    deduplication: 1.0,
	    error: "",
	    removable: false,
	    maintenance: '',
	},
    },
    setTasks: function(taskdata, since) {
	let me = this;
	me.down('pbsTaskSummary').updateTasks(taskdata, since);
    },

    setStatus: function(statusData) {
	let me = this;
	let vm = me.getViewModel();

	if (statusData['mount-status'] === 'notmounted') {
	    let maskMessage = gettext('Datastore is not mounted');
	    let maskIcon = 'fa pbs-unplugged-mask';
	    me.mask(maskMessage, maskIcon);
	    return;
	} else if (me.isMasked()) {
	    me.unmask();
	}

	if (statusData.error !== undefined) {
	    Proxmox.Utils.API2Request({
		url: `/config/datastore/${statusData.store}`,
		success: (response) => {
		    const config = response.result.data;
		    if (config['maintenance-mode']) {
			const [_type, msg] = PBS.Utils.parseMaintenanceMode(config['maintenance-mode']);
			vm.set('maintenance', `${gettext('Datastore is in maintenance mode')}${msg ? ': ' + msg : ''}`);
		    }
		},
	    });
	    vm.set('error', statusData.error);
	    return;
	} else {
	    vm.set('error', "");
	    vm.set('maintenance', '');
	}

	let usagetext;
	let usage;

	if (Object.hasOwn(statusData, 'avail') && Object.hasOwn(statusData, 'used')) {
	    let total = statusData.avail + statusData.used;
	    usage = statusData.used / total;
	    usagetext = Ext.String.format(gettext('{0} of {1}'),
		Proxmox.Utils.format_size(statusData.used, true),
		Proxmox.Utils.format_size(total, true),
	    );
	} else {
	    usagetext = Ext.String.format(gettext('{0} of {1}'), 0, 0);
	    usage = 0;
	}

	let usagePanel = me.lookup('usage');
	usagePanel.updateValue(usage, usagetext);

	let estimate = PBS.Utils.render_estimate(statusData['estimated-full-date'], null, { data: statusData });

	vm.set('full', estimate);
	vm.set('deduplication', PBS.Utils.calculate_dedup_factor(statusData['gc-status']).toFixed(2));
	vm.set('stillbad', statusData['gc-status']['still-bad']);

	let last = 0;
	let time = statusData['history-start'];
	let delta = statusData['history-delta'];
	let data = statusData.history.map((val) => {
	    if (val === null) {
		val = last;
	    } else {
		last = val;
	    }
	    let entry = {
		time: time*1000, // js Dates are ms since epoch
		val,
	    };

	    time += delta;
	    return entry;
	});

	me.lookup('historychart').setData(data);
    },

    items: [
	{
	    xtype: 'container',
	    layout: {
		type: 'vbox',
		align: 'stretch',
	    },

	    width: 375,
	    padding: '5 25 5 5',

	    defaults: {
		padding: 2,
	    },

	    items: [
		{
		    xtype: 'box',
		    hidden: true,
		    tpl: [
			'<center>',
			`<h3>${gettext("Error")}</h3>`,
			'<i class="fa fa-5x fa-exclamation-circle critical"></i>',
			'<br /><br/>',
			'{text}',
			'</center>',
		    ],
		    bind: {
			visible: '{error && !maintenance}',
			data: {
			    text: '{error}',
			},
		    },
		},
		{
		    xtype: 'box',
		    hidden: true,
		    tpl: [
			'<center>',
			`<h3>${gettext("Maintenance mode")}</h3>`,
			'<i class="fa fa-5x fa-wrench"></i>',
			'<br /><br/>',
			'{text}',
			'</center>',
		    ],
		    bind: {
			visible: '{maintenance}',
			data: {
			    text: '{maintenance}',
			},
		    },
		},
		{
		    xtype: 'proxmoxGauge',
		    warningThreshold: 0.8,
		    criticalThreshold: 0.95,
		    flex: 1,
		    reference: 'usage',
		    bind: {
			visible: '{!error}',
		    },
		},
		{
		    xtype: 'pmxInfoWidget',
		    iconCls: 'fa fa-fw fa-line-chart',
		    title: gettext('Estimated Full'),
		    printBar: false,
		    bind: {
			data: {
			    text: '{full}',
			},
			visible: '{!error}',
		    },
		},
		{
		    xtype: 'pmxInfoWidget',
		    iconCls: 'fa fa-fw fa-compress',
		    title: gettext('Deduplication Factor'),
		    printBar: false,
		    bind: {
			data: {
			    text: '{deduplication}',
			},
			visible: '{!error}',
		    },
		},
		{
		    xtype: 'pmxInfoWidget',
		    iconCls: 'fa critical fa-fw fa-exclamation-triangle',
		    title: gettext('Bad Chunks'),
		    printBar: false,
		    hidden: true,
		    bind: {
			data: {
			    text: '{stillbad}',
			},
			visible: '{stillbad}',
		    },
		},
	    ],
	},
	{
	    xtype: 'container',
	    layout: {
		type: 'vbox',
		align: 'stretch',
	    },

	    flex: 1,

	    items: [
		{
		    padding: 5,
		    xtype: 'pbsUsageChart',
		    reference: 'historychart',
		    title: gettext('Usage History'),
		    height: 100,
		    bind: {
			visible: '{!error}',
		    },
		},
		{
		    xtype: 'container',
		    flex: 1,
		    layout: {
			type: 'vbox',
			align: 'stretch',
		    },

		    defaults: {
			padding: 5,
		    },

		    items: [
			{
			    xtype: 'label',
			    text: gettext('Task Summary')
			        + ` (${Ext.String.format(gettext('{0} days'), 30)})`,
			},
			{
			    xtype: 'pbsTaskSummary',
			    border: false,
			    header: false,
			    subPanelModal: true,
			    flex: 2,
			    bodyPadding: 0,
			    minHeight: 0,
			    cbind: {
				datastore: '{datastore}',
			    },
			},
		    ],
		},
	    ],
	},
    ],
});
// Overview over all datastores
Ext.define('PBS.datastore.DataStoreList', {
    extend: 'Ext.panel.Panel',
    alias: 'widget.pbsDataStoreList',

    title: gettext('Summary'),

    scrollable: true,

    bodyPadding: 5,
    defaults: {
	xtype: 'pbsDataStoreListSummary',
	padding: 5,
    },

    datastores: {},
    tasks: {},

    updateTasks: function(taskStore, records, success) {
	let me = this;
	if (!success) {
	    return;
	}

	for (const store of Object.keys(me.tasks)) {
	    me.tasks[store] = {};
	}

	records.forEach(record => {
	    let task = record.data;
	    if (!task.worker_id) {
		return;
	    }

	    let type = task.worker_type;
	    if (type === 'syncjob') {
		type = 'sync';
	    }

	    if (type.startsWith('verif')) {
		type = 'verify';
	    }

	    if (type === 'prunejob') {
		type = 'prune';
	    }

	    let datastore = PBS.Utils.parse_datastore_worker_id(type, task.worker_id);
	    if (!datastore) {
		return;
	    }

	    if (!me.tasks[datastore]) {
		me.tasks[datastore] = {};
	    }

	    if (!me.tasks[datastore][type]) {
		me.tasks[datastore][type] = {};
	    }

	    if (me.tasks[datastore][type] && task.status) {
		let parsed = Proxmox.Utils.parse_task_status(task.status);
		if (!me.tasks[datastore][type][parsed]) {
		    me.tasks[datastore][type][parsed] = 0;
		}
		me.tasks[datastore][type][parsed]++;
	    }
	});

	for (const [store, panel] of Object.entries(me.datastores)) {
	    panel.setTasks(me.tasks[store], me.since);
	}
    },

    updateStores: function(usageStore, records, success) {
	let me = this;
	if (!success) {
	    return;
	}

	let found = {};

	records.forEach((rec) => {
	    found[rec.data.store] = true;
	    me.addSorted(rec.data);
	});

	for (const [store, panel] of Object.entries(me.datastores)) {
	    if (!found[store]) {
		me.remove(panel);
		delete me.datastores[store];
	    }
	}

	let hasDatastores = Object.keys(me.datastores).length > 0;

	me.getComponent('emptybox').setHidden(hasDatastores);
    },

    addSorted: function(data) {
	let me = this;
	let i = 1;
	let datastores = Object
	    .keys(me.datastores)
	    .sort((a, b) => a.localeCompare(b));

	for (const datastore of datastores) {
	    let result = datastore.localeCompare(data.store);
	    if (result === 0) {
		me.datastores[datastore].setStatus(data);
		return;
	    } else if (result > 0) {
		break;
	    }
	    i++;
	}

	me.datastores[data.store] = me.insert(i, {
	    datastore: data.store,
	});
	me.datastores[data.store].setStatus(data);
	me.datastores[data.store].setTasks(me.tasks[data.store], me.since);
    },

    initComponent: function() {
	let me = this;
	me.items = [
	    {
		itemId: 'emptybox',
		hidden: true,
		xtype: 'box',
		html: gettext('No Datastores configured'),
	    },
	];
	me.datastores = {};
	// todo make configurable?
	me.since = (Date.now()/1000 - 30 * 24*3600).toFixed(0);

	me.usageStore = Ext.create('Proxmox.data.UpdateStore', {
	    storeid: 'datastore-overview-usage',
	    interval: 5000,
	    proxy: {
		type: 'proxmox',
		url: '/api2/json/status/datastore-usage',
	    },
	    listeners: {
		load: {
		    fn: me.updateStores,
		    scope: me,
		},
	    },
	});

	me.taskStore = Ext.create('Proxmox.data.UpdateStore', {
	    storeid: 'datastore-overview-tasks',
	    interval: 15000,
	    model: 'proxmox-tasks',
	    proxy: {
		type: 'proxmox',
		url: '/api2/json/nodes/localhost/tasks',
		extraParams: {
		    limit: 0,
		    since: me.since,
		},
	    },
	    listeners: {
		load: {
		    fn: me.updateTasks,
		    scope: me,
		},
	    },
	});

	me.callParent();
	Proxmox.Utils.monStoreErrors(me, me.usageStore);
	Proxmox.Utils.monStoreErrors(me, me.taskStore);
	me.on('activate', function() {
	    me.usageStore.startUpdate();
	    me.taskStore.startUpdate();
	});
	me.on('destroy', function() {
	    me.usageStore.stopUpdate();
	    me.taskStore.stopUpdate();
	});
	me.on('deactivate', function() {
	    me.usageStore.stopUpdate();
	    me.taskStore.stopUpdate();
	});
    },
});

Ext.define('PBS.datastore.DataStores', {
    extend: 'Ext.tab.Panel',
    alias: 'widget.pbsDataStores',

    title: gettext('Datastores'),

    stateId: 'pbs-datastores-panel',
    stateful: true,

    stateEvents: ['tabchange'],

    applyState: function(state) {
	let me = this;
	if (state.tab !== undefined && me.rendered) {
	    me.setActiveTab(state.tab);
	} else if (state.tab) {
	    // if we are not rendered yet, defer setting the activetab
	    setTimeout(function() {
		me.setActiveTab(state.tab);
	    }, 10);
	}
    },

    getState: function() {
	let me = this;
	return {
	    tab: me.getActiveTab().getItemId(),
	};
    },

    border: false,
    defaults: {
	border: false,
    },

    tools: [PBS.Utils.get_help_tool("datastore_intro")],

    items: [
	{
	    xtype: 'pbsDataStoreList',
	    iconCls: 'fa fa-book',
	},
	{
	    iconCls: 'fa fa-trash-o',
	    itemId: 'prunegc',
	    xtype: 'pbsPruneAndGC',
	},
	{
	    iconCls: 'fa fa-refresh',
	    itemId: 'syncjobs',
	    xtype: 'pbsSyncJobView',
	},
	{
	    iconCls: 'fa fa-check-circle',
	    itemId: 'verifyjobs',
	    xtype: 'pbsVerifyJobView',
	},
	{
	    itemId: 'acl',
	    xtype: 'pbsACLView',
	    iconCls: 'fa fa-unlock',
	    aclPath: '/datastore',
	},
    ],

    initComponent: function() {
	let me = this;
	// remove invalid activeTab settings
	if (me.activeTab && !me.items.some((item) => item.itemId === me.activeTab)) {
	    delete me.activeTab;
	}
	me.callParent();
    },
});
Ext.define('pve-rrd-node', {
    extend: 'Ext.data.Model',
    fields: [
	{
	    name: 'cpu',
	    // percentage
	    convert: function(value) {
		return value*100;
	    },
	},
	{
	    name: 'iowait',
	    // percentage
	    convert: function(value) {
		return value*100;
	    },
	},
	'netin',
	'netout',
	'memtotal',
	'memused',
	'swaptotal',
	'swapused',
	'total',
	'used',
	'read_ios',
	'read_bytes',
        'write_ios',
	'write_bytes',
        'io_ticks',
	{
	    name: 'io_delay', calculate: function(data) {
		let ios = 0;
		if (data.read_ios !== undefined) { ios += data.read_ios; }
		if (data.write_ios !== undefined) { ios += data.write_ios; }
		if (ios === 0 || data.io_ticks === undefined) {
		    return undefined;
		}
		return (data.io_ticks*1000.0)/ios;
	    },
	},
	'loadavg',
	{ type: 'date', dateFormat: 'timestamp', name: 'time' },
    ],
});
Ext.define('PBS.ServerStatus', {
    extend: 'Ext.panel.Panel',
    alias: 'widget.pbsServerStatus',

    title: gettext('Server Status'),

    scrollable: true,

    showVersions: function() {
	let me = this;

	// Note: use simply text/html here, as ExtJS grid has problems with cut&paste
	let panel = Ext.createWidget('component', {
	    autoScroll: true,
	    id: 'pkgversions',
	    padding: 5,
	    style: {
		'white-space': 'pre',
		'font-family': 'monospace',
	    },
	});

	let win = Ext.create('Ext.window.Window', {
	    title: gettext('Package versions'),
	    width: 600,
	    height: 600,
	    layout: 'fit',
	    modal: true,
	    items: [panel],
	    buttons: [
		{
		    xtype: 'button',
		    iconCls: 'fa fa-clipboard',
		    handler: async function(button) {
			let el = document.getElementById('pkgversions');
			await navigator.clipboard.writeText(el.textContent);
		    },
		    text: gettext('Copy'),
		},
		{
		    text: gettext('Ok'),
		    handler: function() {
			this.up('window').close();
		    },
		},
	    ],
	});

	Proxmox.Utils.API2Request({
	    waitMsgTarget: me,
	    url: `/nodes/localhost/apt/versions`,
	    method: 'GET',
	    failure: function(response, opts) {
		win.close();
		Ext.Msg.alert(gettext('Error'), response.htmlStatus);
	    },
	    success: function(response, opts) {
		let text = '';
		Ext.Array.each(response.result.data, function(rec) {
		    let version = "not correctly installed";
		    let pkg = rec.Package;
		    if (rec.OldVersion && rec.OldVersion !== 'unknown') {
			version = rec.OldVersion;
		    }
		    if (rec.ExtraInfo) {
			text += `${pkg}: ${version} (${rec.ExtraInfo})\n`;
		    } else {
			text += `${pkg}: ${version}\n`;
		    }
		});

		win.show();
		panel.update(Ext.htmlEncode(text));
	    },
	});
    },

    initComponent: function() {
        var me = this;

	var node_command = function(cmd) {
	    Proxmox.Utils.API2Request({
		params: { command: cmd },
		url: '/nodes/localhost/status',
		method: 'POST',
		waitMsgTarget: me,
		failure: function(response, opts) {
		    Ext.Msg.alert(gettext('Error'), response.htmlStatus);
		},
	    });
	};

	var restartBtn = Ext.create('Proxmox.button.Button', {
	    text: gettext('Reboot'),
	    dangerous: true,
	    confirmMsg: gettext("Reboot backup server?"),
	    handler: function() {
		node_command('reboot');
	    },
	    iconCls: 'fa fa-undo',
	});

	var shutdownBtn = Ext.create('Proxmox.button.Button', {
	    text: gettext('Shutdown'),
	    dangerous: true,
	    confirmMsg: gettext("Shutdown backup server?"),
	    handler: function() {
		node_command('shutdown');
	    },
	    iconCls: 'fa fa-power-off',
	});

	var consoleBtn = Ext.create('Proxmox.button.Button', {
	    text: gettext('Console'),
	    iconCls: 'fa fa-terminal',
	    handler: function() {
		Proxmox.Utils.openXtermJsViewer('shell', 0, Proxmox.NodeName);
	    },
	});

	let version_btn = new Ext.Button({
	    text: gettext('Package versions'),
	    iconCls: 'fa fa-gift',
	    handler: function() {
		Proxmox.Utils.checked_command(function() { me.showVersions(); });
	    },
	});

	me.tbar = [version_btn, '-', consoleBtn, '-', restartBtn, shutdownBtn, '->', { xtype: 'proxmoxRRDTypeSelector' }];

	var rrdstore = Ext.create('Proxmox.data.RRDStore', {
	    rrdurl: "/api2/json/nodes/localhost/rrd",
	    model: 'pve-rrd-node',
	});

	me.items = {
	    xtype: 'container',
	    itemId: 'itemcontainer',
	    layout: 'column',
	    minWidth: 700,
	    listeners: {
		resize: function(panel) {
		    Proxmox.Utils.updateColumns(panel);
		},
	    },
	    defaults: {
		minHeight: 320,
		padding: 5,
		columnWidth: 1,
	    },
	    items: [
		{
		    xtype: 'proxmoxRRDChart',
		    title: gettext('CPU usage'),
		    fields: ['cpu', 'iowait'],
		    fieldTitles: [gettext('CPU usage'), gettext('IO wait')],
		    store: rrdstore,
		},
		{
		    xtype: 'proxmoxRRDChart',
		    title: gettext('Server load'),
		    fields: ['loadavg'],
		    fieldTitles: [gettext('Load average')],
		    store: rrdstore,
		},
		{
		    xtype: 'proxmoxRRDChart',
		    title: gettext('Memory usage'),
		    fields: ['memtotal', 'memused'],
		    fieldTitles: [gettext('Total'), gettext('RAM usage')],
		    unit: 'bytes',
		    powerOfTwo: true,
		    store: rrdstore,
		},
		{
		    xtype: 'proxmoxRRDChart',
		    title: gettext('Swap usage'),
		    fields: ['swaptotal', 'swapused'],
		    fieldTitles: [gettext('Total'), gettext('Swap usage')],
		    unit: 'bytes',
		    powerOfTwo: true,
		    store: rrdstore,
		},
		{
		    xtype: 'proxmoxRRDChart',
		    title: gettext('Network traffic'),
		    fields: ['netin', 'netout'],
		    store: rrdstore,
		},
		{
		    xtype: 'proxmoxRRDChart',
		    title: gettext('Root Disk usage'),
		    fields: ['total', 'used'],
		    fieldTitles: [gettext('Total'), gettext('Disk usage')],
		    store: rrdstore,
		},
		{
		    xtype: 'proxmoxRRDChart',
		    title: gettext('Root Disk Transfer Rate (bytes/second)'),
		    fields: ['read_bytes', 'write_bytes'],
		    fieldTitles: [gettext('Read'), gettext('Write')],
		    store: rrdstore,
		},
		{
		    xtype: 'proxmoxRRDChart',
		    title: gettext('Root Disk Input/Output Operations per Second (IOPS)'),
		    fields: ['read_ios', 'write_ios'],
		    fieldTitles: [gettext('Read'), gettext('Write')],
		    store: rrdstore,
		},
		{
		    xtype: 'proxmoxRRDChart',
		    title: gettext('Root Disk IO Delay (ms)'),
		    fields: ['io_delay'],
		    fieldTitles: [gettext('IO Delay')],
		    store: rrdstore,
		},
	    ],
	};

	me.listeners = {
	    activate: function() {
		rrdstore.startUpdate();
	    },
	    destroy: function() {
		rrdstore.stopUpdate();
	    },
	};

	me.callParent();

	let sp = Ext.state.Manager.getProvider();
	me.mon(sp, 'statechange', function(provider, key, value) {
	    if (key !== 'summarycolumns') {
		return;
	    }
	    Proxmox.Utils.updateColumns(me.getComponent('itemcontainer'));
	});
    },

});
Ext.define('PBS.ServerAdministration', {
    extend: 'Ext.tab.Panel',
    alias: 'widget.pbsServerAdministration',

    title: gettext('Server Administration'),

    border: true,
    defaults: { border: false },

    tools: [PBS.Utils.get_help_tool("sysadmin-host-administration")],

    controller: {
	xclass: 'Ext.app.ViewController',

        init: function(view) {
	    var upgradeBtn = view.lookupReference('upgradeBtn');
	    upgradeBtn.setDisabled(!(Proxmox.UserName && Proxmox.UserName === 'root@pam'));
	},
    },

    items: [
	{
	    xtype: 'pbsServerStatus',
	    itemId: 'status',
	    iconCls: 'fa fa-area-chart',
	},
	{
	    xtype: 'proxmoxNodeServiceView',
            title: gettext('Services'),
	    itemId: 'services',
	    iconCls: 'fa fa-cogs',
	    restartCommand: 'reload', // avoid disruptions
	    startOnlyServices: {
		syslog: true,
		'proxmox-backup': true,
		'proxmox-backup-proxy': true,
	    },
	    nodename: 'localhost',
	},
	{
	    xtype: 'proxmoxNodeAPT',
            title: gettext('Updates'),
	    iconCls: 'fa fa-refresh',
	    upgradeBtn: {
		xtype: 'button',
		reference: 'upgradeBtn',
		disabled: true,
		text: gettext('Upgrade'),
		handler: function() {
		    Proxmox.Utils.openXtermJsViewer('upgrade', 0, 'localhost');
		},
	    },
	    itemId: 'updates',
	    nodename: 'localhost',
	},
	{
	    xtype: 'proxmoxNodeAPTRepositories',
	    title: gettext('Repositories'),
	    iconCls: 'fa fa-files-o',
	    itemId: 'aptrepositories',
	    nodename: 'localhost',
	    product: 'Proxmox Backup Server',
	    onlineHelp: 'sysadmin_package_repositories',
	},
	{
	    xtype: 'proxmoxJournalView',
	    itemId: 'logs',
	    iconCls: 'fa fa-list',
	    title: gettext('Syslog'),
	    url: "/api2/extjs/nodes/localhost/journal",
	},
	{
	    xtype: 'proxmoxNodeTasks',
	    itemId: 'tasks',
	    iconCls: 'fa fa-list-alt',
	    title: gettext('Tasks'),
	    height: 'auto',
	    nodename: 'localhost',
	    extraFilter: [
		{
		    xtype: 'pbsDataStoreSelector',
		    fieldLabel: gettext('Datastore'),
		    emptyText: gettext('All'),
		    name: 'store',
		    allowBlank: true,
		},
	    ],
	},
    ],
});


// Needs to be its own xtype for `path` to work in `NavigationTree`
Ext.define('PBS.NodeNotes', {
    extend: 'Ext.panel.Panel',
    xtype: 'pbsNodeNotes',

    scrollable: true,
    layout: 'fit',

    items: [
	{
	    xtype: 'container',
	    layout: 'fit',
	    items: [{
		xtype: 'pmxNotesView',
		tools: false,
		border: false,
		node: 'localhost',
		enableTBar: true,
		maxLength: 1022*64,
	    }],
	},
    ],
});
Ext.define('PBS.Dashboard', {
    extend: 'Ext.panel.Panel',
    xtype: 'pbsDashboard',

    controller: {
	xclass: 'Ext.app.ViewController',

	openDashboardOptions: function() {
	    var me = this;
	    var viewModel = me.getViewModel();
	    Ext.create('Ext.window.Window', {
		modal: true,
		width: 300,
		title: gettext('Dashboard Options'),
		layout: {
		    type: 'auto',
		},
		items: [{
		    xtype: 'form',
		    bodyPadding: '10 10 10 10',
		    defaultButton: 'savebutton',
		    items: [{
			xtype: 'proxmoxintegerfield',
			itemId: 'days',
			labelWidth: 100,
			anchor: '100%',
			allowBlank: false,
			minValue: 1,
			maxValue: 60,
			value: viewModel.get('days'),
			fieldLabel: gettext('Days to show'),
		    }],
		    buttons: [{
			text: gettext('Save'),
			reference: 'savebutton',
			formBind: true,
			handler: function() {
			    var win = this.up('window');
			    var days = win.down('#days').getValue();
			    me.setDays(days, true);
			    win.close();
			},
		    }],
		}],
	    }).show();
	},

	setDays: function(days, setState) {
	    var me = this;
	    var viewModel = me.getViewModel();
	    viewModel.set('days', days);
	    viewModel.notify();

	    viewModel.getStore('tasks').reload();

	    if (setState) {
		var sp = Ext.state.Manager.getProvider();
		sp.set('dashboard-days', days);
	    }
	},

	updateRepositoryStatus: function(store, records, success) {
	    if (!success) { return; }
	    let me = this;
	    let view = me.getView();
	    view.down('#repositoryStatus').setRepositoryInfo(records[0].data['standard-repos']);
	},

	updateSubscription: function(store, records, success) {
	    if (!success) { return; }
	    let me = this;
	    let view = me.getView();
	    let status = records[0].data.status || 'unknown';
	    // 2 = all good, 1 = different levels, 0 = none
	    let subscriptionActive = status.toLowerCase() === 'active';
	    let subStatus = status.toLowerCase() === 'active' ? 2 : 0;
	    me.lookup('subscription').setSubStatus(subStatus);
	    view.down('#repositoryStatus').setSubscriptionStatus(subscriptionActive);
	},

	updateTasks: function(store, records, success) {
	    if (!success) return;
	    let me = this;
	    let viewModel = me.getViewModel();

	    records.sort((a, b) => a.data.duration - b.data.duration);
	    let top10 = records.slice(-10);
	    me.lookup('longesttasks').updateTasks(top10);

	    let data = {
		backup: { error: 0, warning: 0, ok: 0 },
		prune: { error: 0, warning: 0, ok: 0 },
		garbage_collection: { error: 0, warning: 0, ok: 0 },
		sync: { error: 0, warning: 0, ok: 0 },
		verify: { error: 0, warning: 0, ok: 0 },
		'tape-backup': { error: 0, warning: 0, ok: 0 },
		'tape-restore': { error: 0, warning: 0, ok: 0 },
	    };

	    records.forEach(record => {
		let task = record.data;
		let type = task.worker_type;
		if (type === 'syncjob') {
		    type = 'sync';
		}

		if (type.startsWith('verif')) {
		    type = 'verify';
		}

		if (type.startsWith('prune')) {
		    type = 'prune';
		}

		if (type.startsWith('tape-backup')) {
		    type = 'tape-backup';
		}

		if (data[type] && task.status) {
		    let parsed = Proxmox.Utils.parse_task_status(task.status);
		    data[type][parsed]++;
		}
	    });

	    me.lookup('tasksummary').updateTasks(data, viewModel.get('sinceEpoch'));
	},

	init: function(view) {
	    var me = this;
	    var sp = Ext.state.Manager.getProvider();
	    var days = sp.get('dashboard-days') || 30;
	    me.setDays(days, false);

	    view.mon(sp, 'statechange', function(provider, key, value) {
		if (key !== 'summarycolumns') {
		    return;
		}
		Proxmox.Utils.updateColumns(view);
	    });
	},
    },

    viewModel: {
	data: {
	    days: 30,
	},

	formulas: {
	    sinceEpoch: (get) => (Date.now()/1000 - get('days') * 24*3600).toFixed(0),
	},

	stores: {
	    repositories: {
		storeid: 'dash-repositories',
		type: 'update',
		interval: 15000,
		autoStart: true,
		autoLoad: true,
		autoDestroy: true,
		proxy: {
		    type: 'proxmox',
		    url: '/api2/json/nodes/localhost/apt/repositories',
		},
		listeners: {
		    load: 'updateRepositoryStatus',
		},
	    },
	    subscription: {
		storeid: 'dash-subscription',
		type: 'update',
		interval: 10000,
		autoStart: true,
		autoLoad: true,
		autoDestroy: true,
		proxy: {
		    type: 'proxmox',
		    url: '/api2/json/nodes/localhost/subscription',
		},
		listeners: {
		    load: 'updateSubscription',
		},
	    },
	    tasks: {
		storeid: 'dash-tasks',
		type: 'update',
		interval: 15000,
		autoStart: true,
		autoLoad: true,
		autoDestroy: true,
		model: 'proxmox-tasks',
		proxy: {
		    type: 'proxmox',
		    url: '/api2/json/nodes/localhost/tasks',
		    extraParams: {
			limit: 0,
			since: '{sinceEpoch}',
		    },
		},
		listeners: {
		    load: 'updateTasks',
		},
	    },
	},
    },

    listeners: {
	resize: function(panel) {
	    Proxmox.Utils.updateColumns(panel);
	},
    },

    title: gettext('Dashboard'),

    layout: {
	type: 'column',
    },

    bodyPadding: '20 0 0 20',

    minWidth: 700,

    defaults: {
	columnWidth: 0.49,
	xtype: 'panel',
	margin: '0 20 20 0',
    },

    tools: [
	{
	    type: 'gear',
	    tooltip: gettext('Edit dashboard settings'),
	    handler: 'openDashboardOptions',
	},
    ],

    scrollable: true,

    items: [
	{
	    xtype: 'pbsNodeInfoPanel',
	    reference: 'nodeInfo',
	    height: 290,
	},
	{
	    xtype: 'pbsDatastoresStatistics',
	    height: 290,
	},
	{
	    xtype: 'pbsLongestTasks',
	    bind: {
		title: gettext('Longest Tasks') + ' (' +
		Ext.String.format(gettext('{0} days'), '{days}') + ')',
	    },
	    reference: 'longesttasks',
	    height: 290,
	},
	{
	    xtype: 'pbsRunningTasks',
	    height: 290,
	},
	{
	    bind: {
		title: gettext('Task Summary') + ' (' +
		Ext.String.format(gettext('{0} days'), '{days}') + ')',
	    },
	    xtype: 'pbsTaskSummary',
	    height: 250,
	    reference: 'tasksummary',
	},
	{
	    iconCls: 'fa fa-ticket',
	    title: gettext('Subscription'),
	    height: 250,
	    reference: 'subscription',
	    xtype: 'pbsSubscriptionInfo',
	},
    ],
});

Ext.define('PBS.dashboard.SubscriptionInfo', {
    extend: 'Ext.panel.Panel',
    xtype: 'pbsSubscriptionInfo',

    style: {
	cursor: 'pointer',
    },

    layout: {
	type: 'hbox',
	align: 'middle',
    },

    items: [
	{
	    xtype: 'box',
	    itemId: 'icon',
	    data: {
		icon: 'question-circle',
	    },
	    width: 100,
	    tpl: '<center><i class="fa fa-3x fa-{icon}"></i></center>',
	},
	{
	    flex: 1,
	    xtype: 'box',
	    data: {
		message: gettext('Unknown'),
	    },
	    itemId: 'message',
	    tpl: '<center>{message}</center>',
	},
    ],

    setSubStatus: function(status) {
	var me = this;
	let icon = '';
	let message = '';

	switch (status) {
	    case 2:
		icon = 'check good';
		message = gettext('Your subscription status is valid.');
		break;
	    case 1:
		icon = 'exclamation-triangle warning';
		message = gettext('Warning: Your subscription levels are not the same.');
		break;
	    case 0:
		icon = 'times-circle critical';
		message = `<h1>${gettext('No valid subscription')}</h1>${PBS.Utils.noSubKeyHtml}`;
		break;
	    default:
		throw 'invalid subscription status';
	}
	me.getComponent('icon').update({ icon });
	me.getComponent('message').update({ message });
    },

    listeners: {
	click: {
	    element: 'body',
	    fn: function() {
		var mainview = this.component.up('mainview');
		mainview.getController().redirectTo('pbsSubscription');
	    },
	},
    },
});
Ext.define('PBS.TapeManagement.AllocationStore', {
    extend: 'Ext.data.Store',
    alias: 'store.allocationCalendarEventStore',

    field: ['value', 'text'],
    data: [
	{ value: 'continue', text: gettext('Continue') },
	{ value: 'always', text: gettext('Always') },
	{ value: '*:0/30', text: Ext.String.format(gettext("Every {0} minutes"), 30) },
	{ value: 'hourly', text: gettext("Every hour") },
	{ value: '0/2:00', text: gettext("Every two hours") },
	{ value: '2,22:30', text: gettext("Every day") + " 02:30, 22:30" },
	{ value: 'daily', text: gettext("Every day") + " 00:00" },
	{ value: 'mon..fri', text: gettext("Monday to Friday") + " 00:00" },
	{ value: 'mon..fri *:00', text: gettext("Monday to Friday") + ', ' + gettext("hourly") },
	{ value: 'sat 18:15', text: gettext("Every Saturday") + " 18:15" },
	{ value: 'monthly', text: gettext("Every first day of the Month") + " 00:00" },
	{ value: 'sat *-1..7 02:00', text: gettext("Every first Saturday of the month") + " 02:00" },
	{ value: 'yearly', text: gettext("First day of the year") + " 00:00" },
    ],
});

Ext.define('PBS.TapeManagement.AllocationSelector', {
    extend: 'PBS.form.CalendarEvent',
    alias: 'widget.pbsAllocationSelector',

    store: {
	type: 'allocationCalendarEventStore',
    },
});

Ext.define('PBS.form.ChangerSelector', {
    extend: 'Proxmox.form.ComboGrid',
    alias: 'widget.pbsChangerSelector',

    allowBlank: false,
    displayField: 'name',
    valueField: 'name',
    value: null,
    multiSelect: false,


    store: {
	proxy: {
	    type: 'proxmox',
	    url: '/api2/json/tape/changer',
	},
	autoLoad: true,
	sorter: 'name',
    },

    listConfig: {
	columns: [
	    {
		text: gettext('Name'),
		dataIndex: 'name',
		sortable: true,
		flex: 1,
		renderer: Ext.String.htmlEncode,
	    },
	    {
		text: gettext('Path'),
		sortable: true,
		dataIndex: 'path',
		hidden: true,
		flex: 1,
	    },
	    {
		text: gettext('Vendor'),
		dataIndex: 'vendor',
		sortable: true,
		flex: 1,
		renderer: Ext.String.htmlEncode,
	    },
	    {
		text: gettext('Model'),
		dataIndex: 'model',
		sortable: true,
		flex: 1,
		renderer: Ext.String.htmlEncode,
	    },
	    {
		text: gettext('Serial'),
		dataIndex: 'serial',
		sortable: true,
		flex: 1,
		renderer: Ext.String.htmlEncode,
	    },
	],
    },
});
Ext.define('PBS.form.DriveSelector', {
    extend: 'Proxmox.form.ComboGrid',
    alias: 'widget.pbsDriveSelector',

    allowBlank: false,
    autoSelect: false,

    displayField: 'name',
    valueField: 'name',
    value: null,

    store: {
	proxy: {
	    type: 'proxmox',
	    url: '/api2/json/tape/drive',
	},
	autoLoad: true,
	sorters: 'name',
    },

    listConfig: {
	width: 450,
	columns: [
	    {
		text: gettext('Name'),
		dataIndex: 'name',
		sortable: true,
		flex: 3,
		renderer: Ext.String.htmlEncode,
	    },
	    {
		text: gettext('Vendor'),
		dataIndex: 'vendor',
		sortable: true,
		flex: 2,
		renderer: Ext.String.htmlEncode,
	    },
	    {
		text: gettext('Model'),
		dataIndex: 'model',
		sortable: true,
		flex: 3,
		renderer: Ext.String.htmlEncode,
	    },
	    {
		text: gettext('Serial'),
		dataIndex: 'serial',
		sortable: true,
		flex: 3,
		renderer: Ext.String.htmlEncode,
	    },
	],
    },

    initComponent: function() {
	let me = this;

	if (me.changer) {
	    me.store.proxy.extraParams = {
		changer: me.changer,
	    };
	} else {
	    me.store.proxy.extraParams = {};
	}

	me.callParent();
    },
});

Ext.define('PBS.TapeManagement.PoolSelector', {
    extend: 'Proxmox.form.ComboGrid',
    alias: 'widget.pbsMediaPoolSelector',

    allowBlank: false,
    displayField: 'name',
    valueField: 'name',
    autoSelect: false,

    store: {
	proxy: {
	    type: 'proxmox',
	    url: '/api2/json/config/media-pool',
	},
	autoLoad: true,
	sorters: 'name',
    },

    listConfig: {
	columns: [
	    {
		text: gettext('Name'),
		dataIndex: 'name',
	    },
	    {
		text: gettext('Drive'),
		dataIndex: 'drive',
	    },
	    {
		text: gettext('Allocation Policy'),
		dataIndex: 'allocation',
	    },
	    {
		text: gettext('Retention Policy'),
		dataIndex: 'retention',
	    },
	    {
		text: gettext('Encryption Fingerprint'),
		dataIndex: 'encryption',
	    },
	],
    },
});

Ext.define('PBS.TapeManagement.RetentionStore', {
    extend: 'Ext.data.Store',
    alias: 'store.retentionCalendarEventStore',

    field: ['value', 'text'],
    data: [
	{ value: 'overwrite', text: gettext('Overwrite') },
	{ value: 'keep', text: gettext('Keep') },
	{ value: '120 minutes', text: Ext.String.format(gettext("{0} minutes"), 120) },
	{ value: '12 hours', text: Ext.String.format(gettext("{0} hours"), 12) },
	{ value: '7 days', text: Ext.String.format(gettext("{0} days"), 7) },
	{ value: '4 weeks', text: Ext.String.format(gettext("{0} weeks"), 4) },
	{ value: '6 months', text: Ext.String.format(gettext("{0} months"), 6) },
	{ value: '2 years', text: Ext.String.format(gettext("{0} years"), 2) },
    ],
});

Ext.define('PBS.TapeManagement.RetentionSelector', {
    extend: 'PBS.form.CalendarEvent',
    alias: 'widget.pbsRetentionSelector',

    store: {
	type: 'retentionCalendarEventStore',
    },
});

Ext.define('PBS.form.TapeDevicePathSelector', {
    extend: 'Proxmox.form.ComboGrid',
    alias: 'widget.pbsTapeDevicePathSelector',

    allowBlank: false,
    displayField: 'path',
    valueField: 'path',

    // type can be 'drives' or 'changers'
    type: 'drives',

    listConfig: {
	columns: [
	    {
		text: gettext('Path'),
		dataIndex: 'path',
		sortable: true,
		flex: 1,
		renderer: Ext.String.htmlEncode,
	    },
	    {
		text: gettext('Vendor'),
		dataIndex: 'vendor',
		sortable: true,
		flex: 1,
		renderer: Ext.String.htmlEncode,
	    },
	    {
		text: gettext('Model'),
		dataIndex: 'model',
		sortable: true,
		flex: 1,
		renderer: Ext.String.htmlEncode,
	    },
	    {
		text: gettext('Serial'),
		dataIndex: 'serial',
		sortable: true,
		flex: 1,
		renderer: Ext.String.htmlEncode,
	    },
	],
    },

    initComponent: function() {
	let me = this;
	if (me.type !== 'drives' && me.type !== 'changers') {
	    throw `invalid type '${me.type}'`;
	}

	let url = `/api2/json/tape/scan-${me.type}`;
	me.store = {
	    proxy: {
		type: 'proxmox',
		url,
	    },
	    autoLoad: true,
	};

	me.callParent();
    },
});
Ext.define('PBS.form.TapeKeySelector', {
    extend: 'Proxmox.form.ComboGrid',
    alias: 'widget.pbsTapeKeySelector',

    allowBlank: false,
    displayField: 'hint',
    valueField: 'fingerprint',
    value: null,
    multiSelect: false,


    store: {
	proxy: {
	    type: 'proxmox',
	    url: '/api2/json/config/tape-encryption-keys',
	},
	autoLoad: true,
	sorter: 'hint',
    },

    listConfig: {
	columns: [
	    {
		text: gettext('Hint'),
		dataIndex: 'hint',
		sortable: true,
		flex: 1,
		renderer: Ext.String.htmlEncode,
	    },
	    {
		text: gettext('Fingerprint'),
		sortable: true,
		dataIndex: 'fingerprint',
		flex: 5,
	    },
	],
    },
});
Ext.define('PBS.TapeManagement.ChangerEditWindow', {
    extend: 'Proxmox.window.Edit',
    alias: 'widget.pbsChangerEditWindow',
    mixins: ['Proxmox.Mixin.CBind'],

    isCreate: true,
    isAdd: true,
    subject: gettext('Changer'),
    cbindData: function(initialConfig) {
	let me = this;

	let changerid = initialConfig.changerid;
	let baseurl = '/api2/extjs/config/changer';

	me.isCreate = !changerid;
	me.url = changerid ? `${baseurl}/${encodeURIComponent(changerid)}` : baseurl;
	me.method = changerid ? 'PUT' : 'POST';

	return { };
    },

    items: [
	{
	    fieldLabel: gettext('Name'),
	    name: 'name',
	    xtype: 'pmxDisplayEditField',
	    renderer: Ext.htmlEncode,
	    allowBlank: false,
	    cbind: {
		editable: '{isCreate}',
	    },
	},
	{
	    fieldLabel: gettext('Path'),
	    xtype: 'pbsTapeDevicePathSelector',
	    type: 'changers',
	    name: 'path',
	    allowBlank: false,
	},
	{
	    fieldLabel: gettext('Import-Export Slots'),
	    xtype: 'proxmoxtextfield',
	    name: 'export-slots',
	    cbind: {
		deleteEmpty: '{!isCreate}',
	    },
	},
    ],
});

Ext.define('PBS.TapeManagement.DriveEditWindow', {
    extend: 'Proxmox.window.Edit',
    alias: 'widget.pbsDriveEditWindow',
    mixins: ['Proxmox.Mixin.CBind'],

    isCreate: true,
    isAdd: true,
    subject: gettext('Drive'),
    cbindData: function(initialConfig) {
	let me = this;

	let driveid = initialConfig.driveid;
	let baseurl = '/api2/extjs/config/drive';

	me.isCreate = !driveid;
	me.url = driveid ? `${baseurl}/${encodeURIComponent(driveid)}` : baseurl;
	me.method = driveid ? 'PUT' : 'POST';

	return { };
    },

    items: [
	{
	    fieldLabel: gettext('Name'),
	    name: 'name',
	    xtype: 'pmxDisplayEditField',
	    renderer: Ext.htmlEncode,
	    allowBlank: false,
	    cbind: {
		editable: '{isCreate}',
	    },
	},
	{
	    fieldLabel: gettext('Changer'),
	    xtype: 'pbsChangerSelector',
	    name: 'changer',
	    skipEmptyText: true,
	    allowBlank: true,
	    autoSelect: false,
	    emptyText: gettext('No Changer'),
	    cbind: {
		deleteEmpty: '{!isCreate}',
	    },
	    listeners: {
		change: function(field, value) {
		    let disableSlotField = !value || value === '';
		    console.log(value);
		    field
			.up('window')
			.down('field[name=changer-drivenum]')
			.setDisabled(disableSlotField);
		},
	    },
	},
	{
	    fieldLabel: gettext('Drive Number'),
	    xtype: 'proxmoxintegerfield',
	    name: 'changer-drivenum',
	    disabled: true,
	    allowBlank: true,
	    emptyText: '0',
	    minValue: 0,
	    maxValue: 8,
	    cbind: {
		deleteEmpty: '{!isCreate}',
	    },
	},
	{
	    fieldLabel: gettext('Path'),
	    xtype: 'pbsTapeDevicePathSelector',
	    type: 'drives',
	    name: 'path',
	    allowBlank: false,
	},
    ],
});

Ext.define('PBS.TapeManagement.EraseWindow', {
    extend: 'Proxmox.window.Edit',
    mixins: ['Proxmox.Mixin.CBind'],


    changer: undefined,
    label: undefined,

    cbindData: function(config) {
	let me = this;
	return {
	    singleDrive: me.singleDrive,
	    hasSingleDrive: !!me.singleDrive,
	    warning: Ext.String.format(gettext("Are you sure you want to format tape '{0}' ?"), me.label),
	};
    },

    title: gettext('Format/Erase'),
    url: `/api2/extjs/tape/drive`,
    showProgress: true,
    submitUrl: function(url, values) {
	let drive = values.drive;
	delete values.drive;
	return `${url}/${drive}/format-media`;
    },

    layout: 'hbox',
    width: 400,
    method: 'POST',
    isCreate: true,
    submitText: gettext('Ok'),
    items: [
	{
	    xtype: 'container',
	    padding: 0,
	    layout: {
		type: 'hbox',
		align: 'stretch',
	    },
	    items: [
		{
		    xtype: 'component',
		    cls: [Ext.baseCSSPrefix + 'message-box-icon',
			Ext.baseCSSPrefix + 'message-box-warning',
			Ext.baseCSSPrefix + 'dlg-icon'],
		},
		{
		    xtype: 'container',
		    flex: 1,
		    items: [
			{
			    xtype: 'displayfield',
			    cbind: {
				value: '{warning}',
			    },
			},
			{
			    xtype: 'displayfield',
			    cls: 'pmx-hint',
			    value: gettext('Make sure to insert the tape into the selected drive.'),
			    cbind: {
				hidden: '{changer}',
			    },
			},
			{
			    xtype: 'hidden',
			    name: 'label-text',
			    cbind: {
				value: '{label}',
			    },
			},
			{
			    xtype: 'hidden',
			    name: 'drive',
			    cbind: {
				disabled: '{!hasSingleDrive}',
				value: '{singleDrive}',
			    },
			},
			{
			    xtype: 'pbsDriveSelector',
			    fieldLabel: gettext('Drive'),
			    name: 'drive',
			    cbind: {
				changer: '{changer}',
				disabled: '{hasSingleDrive}',
				hidden: '{hasSingleDrive}',
			    },
			},
		    ],
		},
	    ],
	},
    ],
});
Ext.define('PBS.TapeManagement.EncryptionEditWindow', {
    extend: 'Proxmox.window.Edit',
    alias: 'widget.pbsEncryptionEditWindow',
    mixins: ['Proxmox.Mixin.CBind'],

    isCreate: true,
    isAdd: true,
    subject: gettext('Encryption Key'),
    cbindData: function(initialConfig) {
	let me = this;

	let fingerprint = initialConfig.fingerprint;
	let baseurl = '/api2/extjs/config/tape-encryption-keys';

	me.isCreate = !fingerprint;
	me.url = fingerprint ? `${baseurl}/${encodeURIComponent(fingerprint)}` : baseurl;
	me.method = fingerprint ? 'PUT' : 'POST';

	return { };
    },

    items: [
	{
	    fieldLabel: gettext('Hint'),
	    name: 'hint',
	    xtype: 'pmxDisplayEditField',
	    renderer: Ext.htmlEncode,
	    allowBlank: false,
	    cbind: {
		editable: '{isCreate}',
	    },
	},
	{
	    xtype: 'textfield',
	    inputType: 'password',
	    fieldLabel: gettext('Password'),
	    name: 'password',
	    minLength: 5,
	    allowBlank: false,
	},
	{
	    xtype: 'textfield',
	    inputType: 'password',
	    submitValue: false,
	    fieldLabel: gettext('Confirm Password'),
	    minLength: 5,
	    vtype: 'password',
	    initialPassField: 'password',
	    allowBlank: false,
	},
    ],
});
Ext.define('PBS.TapeManagement.LabelMediaWindow', {
    extend: 'Proxmox.window.Edit',
    alias: 'widget.pbsLabelMediaWindow',
    mixins: ['Proxmox.Mixin.CBind'],

    isCreate: true,
    isAdd: true,
    title: gettext('Label Media'),
    submitText: gettext('OK'),

    url: '/api2/extjs/tape/drive/',

    cbindData: function(config) {
	let me = this;
	return {
	    driveid: config.driveid,
	    label: config.label,
	};
    },

    method: 'POST',

    showProgress: true,

    submitUrl: function(url, values) {
	let driveid = encodeURIComponent(values.drive);
	delete values.drive;
	return `${url}/${driveid}/label-media`;
    },

    items: [
	{
	    xtype: 'displayfield',
	    cls: 'pmx-hint',
	    value: gettext('Make sure that the correct tape is inserted in the selected drive and type in the label written on the tape.'),
	},
	{
	    xtype: 'pmxDisplayEditField',
	    fieldLabel: gettext('Drive'),
	    submitValue: true,
	    name: 'drive',
	    editConfig: {
		xtype: 'pbsDriveSelector',
	    },
	    cbind: {
		value: '{driveid}',
		editable: '{!driveid}',
	    },
	},
	{
	    fieldLabel: gettext('Label'),
	    name: 'label-text',
	    xtype: 'pmxDisplayEditField',
	    submitValue: true,
	    allowBlank: false,
	    cbind: {
		value: '{label}',
		editable: '{!label}',
	    },
	},
	{
	    xtype: 'pbsMediaPoolSelector',
	    fieldLabel: gettext('Media Pool'),
	    name: 'pool',
	    allowBlank: true,
	    skipEmptyText: true,
	},
    ],
});

Ext.define('PBS.TapeManagement.MediaRemoveWindow', {
    extend: 'Proxmox.window.Edit',
    mixins: ['Proxmox.Mixin.CBind'],

    uuid: undefined,
    label: undefined,

    cbindData: function(config) {
	let me = this;
	return {
	    uuid: me.uuid,
	    warning: Ext.String.format(gettext("Are you sure you want to remove tape '{0}' ?"), me.label),
	};
    },

    title: gettext('Remove Media'),
    url: `/api2/extjs/tape/media/destroy`,

    layout: 'hbox',
    width: 400,
    method: 'GET',
    isCreate: true,
    submitText: gettext('Ok'),
    items: [
	{
	    xtype: 'container',
	    padding: 0,
	    layout: {
		type: 'hbox',
		align: 'stretch',
	    },
	    items: [
		{
		    xtype: 'component',
		    cls: [Ext.baseCSSPrefix + 'message-box-icon',
			Ext.baseCSSPrefix + 'message-box-warning',
			Ext.baseCSSPrefix + 'dlg-icon'],
		},
		{
		    xtype: 'container',
		    flex: 1,
		    items: [
			{
			    xtype: 'displayfield',
			    cbind: {
				value: '{warning}',
			    },
			},
			{
			    xtype: 'hidden',
			    name: 'uuid',
			    cbind: {
				value: '{uuid}',
			    },
			},
			{
			    xtype: 'proxmoxcheckbox',
			    fieldLabel: gettext('Force'),
			    name: 'force',
			},
		    ],
		},
	    ],
	},
    ],
});
Ext.define('PBS.TapeManagement.PoolEditWindow', {
    extend: 'Proxmox.window.Edit',
    alias: 'widget.pbsPoolEditWindow',
    mixins: ['Proxmox.Mixin.CBind'],

    onlineHelp: 'tape_media_pool_config',

    isCreate: true,
    isAdd: true,
    subject: gettext('Media Pool'),
    cbindData: function(initialConfig) {
	let me = this;

	let poolid = initialConfig.poolid;
	let baseurl = '/api2/extjs/config/media-pool';

	me.isCreate = !poolid;
	me.url = poolid ? `${baseurl}/${encodeURIComponent(poolid)}` : baseurl;
	me.method = poolid ? 'PUT' : 'POST';

	return { };
    },

    items: {
	xtype: 'inputpanel',
	column1: [
	    {
		fieldLabel: gettext('Name'),
		name: 'name',
		xtype: 'pmxDisplayEditField',
		renderer: Ext.htmlEncode,
		allowBlank: false,
		cbind: {
		    editable: '{isCreate}',
		},
	    },
	    {
		fieldLabel: gettext('Allocation Policy'),
		xtype: 'pbsAllocationSelector',
		name: 'allocation',
		skipEmptyText: true,
		allowBlank: true,
		autoSelect: false,
		cbind: {
		    deleteEmpty: '{!isCreate}',
		},
	    },
	    {
		fieldLabel: gettext('Retention Policy'),
		xtype: 'pbsRetentionSelector',
		name: 'retention',
		skipEmptyText: true,
		allowBlank: true,
		autoSelect: false,
		cbind: {
		    deleteEmpty: '{!isCreate}',
		},
	    },
	],

	column2: [
	    {
		fieldLabel: gettext('Encryption Key'),
		xtype: 'pbsTapeKeySelector',
		name: 'encrypt',
		allowBlank: true,
		skipEmptyText: true,
		autoSelect: false,
		cbind: {
		    deleteEmpty: '{!isCreate}',
		},
	    },
	],

	columnB: [
	    {
		fieldLabel: gettext('Comment'),
		xtype: 'proxmoxtextfield',
		name: 'comment',
		cbind: {
		    deleteEmpty: '{!isCreate}',
		},
	    },
	],
    },
});
Ext.define('PBS.TapeManagement.TapeBackupWindow', {
    extend: 'Proxmox.window.Edit',
    alias: 'pbsTapeBackupWindow',

    subject: gettext('Backup'),
    url: '/api2/extjs/tape/backup',
    method: 'POST',
    showTaskViewer: true,
    isCreate: true,

    viewModel: {
	data: {
	    notificationMode: 'notification-system',
	},
	formulas: {
	    notificationSystemSelected: (get) => get('notificationMode') === 'notification-system',
	},
    },

    items: [
	{
	    xtype: 'inputpanel',
	    column1: [
		{
		    xtype: 'pbsDataStoreSelector',
		    fieldLabel: gettext('Datastore'),
		    name: 'store',
		    listeners: {
			change: function(_, value) {
			    let me = this;
			    if (value) {
				let namespace = me.up('window').down('pbsNamespaceSelector');
				namespace.setDatastore(value);
				namespace.setDisabled(false);
				me.up('window').down('pbsNamespaceMaxDepth').setDisabled(false);
			    }
			},
		    },
		},
		{
		    xtype: 'pbsNamespaceSelector',
		    fieldLabel: gettext('Namespace'),
		    disabled: true,
		    name: 'ns',
		},
		{
		    xtype: 'pbsNamespaceMaxDepth',
		    fieldLabel: gettext('Max Depth'),
		    disabled: true,
		    name: 'max-depth',
		    deleteEmpty: false,
		},
		{
		    xtype: 'pbsMediaPoolSelector',
		    fieldLabel: gettext('Media Pool'),
		    name: 'pool',
		},
		{
		    xtype: 'pbsDriveSelector',
		    fieldLabel: gettext('Drive'),
		    name: 'drive',
		},
	    ],

	    column2: [
		{
		    xtype: 'proxmoxcheckbox',
		    labelWidth: 150,
		    name: 'force-media-set',
		    fieldLabel: gettext('Force new Media-Set'),
		},
		{
		    xtype: 'proxmoxcheckbox',
		    labelWidth: 150,
		    name: 'export-media-set',
		    fieldLabel: gettext('Export Media-Set'),
		    listeners: {
			change: function(cb, value) {
			    let me = this;
			    let eject = me.up('window').down('proxmoxcheckbox[name=eject-media]');
			    if (value) {
				eject.setValue(false);
			    }
			    eject.setDisabled(!!value);
			},
		    },
		},
		{
		    xtype: 'proxmoxcheckbox',
		    labelWidth: 150,
		    name: 'eject-media',
		    fieldLabel: gettext('Eject Media'),
		},
		{
		    xtype: 'proxmoxKVComboBox',
		    labelWidth: 150,
		    comboItems: [
			['legacy-sendmail', gettext('Email (legacy)')],
			['notification-system', gettext('Notification system')],
		    ],
		    fieldLabel: gettext('Notification mode'),
		    name: 'notification-mode',
		    bind: {
			value: '{notificationMode}',
		    },
		},
		{
		    xtype: 'pmxUserSelector',
		    labelWidth: 150,
		    name: 'notify-user',
		    fieldLabel: gettext('Notify User'),
		    emptyText: 'root@pam',
		    value: null,
		    allowBlank: true,
		    skipEmptyText: true,
		    bind: {
			disabled: "{notificationSystemSelected}",
		    },
		    renderer: Ext.String.htmlEncode,
		},
	    ],

	    advancedColumn1: [
		{
		    xtype: 'proxmoxintegerfield',
		    name: 'worker-threads',
		    fieldLabel: gettext('# of Worker Threads'),
		    emptyText: '1',
		    skipEmptyText: true,
		    minValue: 1,
		    maxValue: 32,
		},
	    ],
	},
    ],

});
Ext.define('PBS.TapeManagement.BackupJobEdit', {
    extend: 'Proxmox.window.Edit',
    alias: 'widget.pbsTapeBackupJobEdit',
    mixins: ['Proxmox.Mixin.CBind'],

    userid: undefined,

    isAdd: true,

    subject: gettext('Tape Backup Job'),

    fieldDefaults: { labelWidth: 120 },

    bodyPadding: 0,

    onlineHelp: 'tape_backup_job_config',

    cbindData: function(initialConfig) {
	let me = this;

	let baseurl = '/api2/extjs/config/tape-backup-job';
	let id = initialConfig.id;

	me.isCreate = !id;
	me.url = id ? `${baseurl}/${id}` : baseurl;
	me.method = id ? 'PUT' : 'POST';
	me.autoLoad = !!id;
	me.scheduleValue = id ? null : 'daily';
	me.authid = id ? null : Proxmox.UserName;
	me.editDatastore = me.datastore === undefined && me.isCreate;
	return { };
    },

    controller: {
	xclass: 'Ext.app.ViewController',
	control: {
	    'pbsDataStoreSelector[name=store]': {
		change: 'storeChange',
	    },
	},

	storeChange: function(field, value) {
	    let me = this;
	    let nsSelector = me.lookup('namespace');
	    nsSelector.setDatastore(value);
	},
    },

    viewModel: {
	data: {
	    notificationMode: '__default__',
	},
	formulas: {
	    notificationSystemSelected: (get) => get('notificationMode') === 'notification-system',
	},
    },

    initComponent: function() {
	let me = this;
	// Automatically select the new system for new jobs
	let mode = me.isCreate ? "notification-system" : "__default__";
	me.getViewModel().set('notificationMode', mode);
	me.callParent();
    },

    items: {
	xtype: 'tabpanel',
	bodyPadding: 10,
	border: 0,
	items: [
	    {
		title: gettext('Options'),
		xtype: 'inputpanel',
		onGetValues: function(values) {
		    let me = this;

		    if (values['export-media-set'] && !me.up('pbsTapeBackupJobEdit').isCreate) {
			Proxmox.Utils.assemble_field_data(values, { "delete": 'eject-media' });
		    }
		    PBS.Utils.delete_if_default(values, 'notify-user');

		    if (me.isCreate) {
			delete values.delete;
		    }

		    return values;
		},
		cbind: {
		    isCreate: '{isCreate}', // pass it through
		},
		column1: [
		    {
			xtype: 'pmxDisplayEditField',
			name: 'id',
			fieldLabel: gettext('Job ID'),
			renderer: Ext.htmlEncode,
			allowBlank: false,
			cbind: {
			    editable: '{isCreate}',
			},
		    },
		    {
			xtype: 'pbsDataStoreSelector',
			fieldLabel: gettext('Local Datastore'),
			name: 'store',
			listeners: {
			    change: function(field, value) {
				let me = this;
				me.up('tabpanel').down('pbsGroupFilter').setLocalDatastore(value);
			    },
			},
		    },
		    {
			xtype: 'pbsNamespaceSelector',
			fieldLabel: gettext('Local Namespace'),
			reference: 'namespace',
			name: 'ns',
		    },
		    {
			xtype: 'pbsMediaPoolSelector',
			fieldLabel: gettext('Media Pool'),
			name: 'pool',
		    },
		    {
			xtype: 'pbsDriveSelector',
			fieldLabel: gettext('Drive'),
			name: 'drive',
		    },
		    {
			xtype: 'proxmoxKVComboBox',
			comboItems: [
			    ['__default__', `${Proxmox.Utils.defaultText}  (Email)`],
			    ['legacy-sendmail', gettext('Email (legacy)')],
			    ['notification-system', gettext('Notification system')],
			],
			fieldLabel: gettext('Notification mode'),
			name: 'notification-mode',
			bind: {
			    value: '{notificationMode}',
			},
		    },
		    {
			xtype: 'pmxUserSelector',
			name: 'notify-user',
			fieldLabel: gettext('Notify User'),
			emptyText: 'root@pam',
			allowBlank: true,
			value: null,
			renderer: Ext.String.htmlEncode,
			bind: {
			    disabled: "{notificationSystemSelected}",
			},
		    },
		],

		column2: [
		    {
			fieldLabel: gettext('Schedule'),
			xtype: 'pbsCalendarEvent',
			name: 'schedule',
			emptyText: gettext('none (disabled)'),
			cbind: {
			    deleteEmpty: '{!isCreate}',
			    value: '{scheduleValue}',
			},
		    },
		    {
			fieldLabel: gettext('Export Media-Set'),
			xtype: 'proxmoxcheckbox',
			name: 'export-media-set',
			cbind: {
			    deleteEmpty: '{!isCreate}',
			},
			listeners: {
			    change: function(cb, value) {
				let me = this;
				let eject = me.up('window').down('proxmoxcheckbox[name=eject-media]');
				if (value) {
				    eject.setValue(false);
				}
				eject.setDisabled(!!value);
			    },
			},
		    },
		    {
			fieldLabel: gettext('Eject Media'),
			xtype: 'proxmoxcheckbox',
			name: 'eject-media',
			cbind: {
			    deleteEmpty: '{!isCreate}',
			},
		    },
		    {
			fieldLabel: gettext('Latest Only'),
			xtype: 'proxmoxcheckbox',
			name: 'latest-only',
			cbind: {
			    deleteEmpty: '{!isCreate}',
			},
		    },
		    {
			xtype: 'pbsNamespaceMaxDepth',
			name: 'max-depth',
			fieldLabel: gettext('Max. Depth'),
			deleteEmpty: true,
		    },
		],

		columnB: [
		    {
			fieldLabel: gettext('Comment'),
			xtype: 'proxmoxtextfield',
			name: 'comment',
			cbind: {
			    deleteEmpty: '{!isCreate}',
			},
		    },
		],

		advancedColumn1: [
		    {
			xtype: 'proxmoxintegerfield',
			name: 'worker-threads',
			fieldLabel: gettext('# of Worker Threads'),
			emptyText: '1',
			minValue: 1,
			maxValue: 32,
			cbind: {
			    deleteEmpty: '{!isCreate}',
			},
		    },
		],
	    },
	    {
		xtype: 'inputpanel',
		onGetValues: function(values) {
		    PBS.Utils.delete_if_default(values, 'group-filter');
		    if (Ext.isArray(values['group-filter']) && values['group-filter'].length === 0) {
			delete values['group-filter'];
			values.delete = 'group-filter';
		    }
		    if (this.isCreate) {
			delete values.delete;
		    }
		    return values;
		},
		cbind: {
		    isCreate: '{isCreate}', // pass it through
		},
		title: gettext('Group Filter'),
		items: [
		    {
			xtype: 'pbsGroupFilter',
			name: 'group-filter',
		    },
		],
	    },
	],
    },
});
Ext.define('PBS.TapeManagement.TapeRestoreWindow', {
    extend: 'Ext.window.Window',
    alias: 'widget.pbsTapeRestoreWindow',
    mixins: ['Proxmox.Mixin.CBind'],

    title: gettext('Restore Media-Set'),

    width: 800,
    height: 500,

    url: '/api2/extjs/tape/restore',
    method: 'POST',

    resizable: false,
    modal: true,

    mediaset: undefined,
    prefilter: undefined,
    uuid: undefined,

    cbindData: function(config) {
	let me = this;
	if (me.prefilter !== undefined) {
	    me.title = gettext('Restore Snapshot(s)');
	}
	return {};
    },

    layout: 'fit',
    bodyPadding: 0,

    viewModel: {
	data: {
	    uuid: "",
	    singleDatastore: true,
	    notificationMode: 'notification-system',
	},
	formulas: {
	    singleSelectorLabel: get =>
		get('singleDatastore') ? gettext('Target Datastore') : gettext('Default Datastore'),
	    singleSelectorEmptyText: get => get('singleDatastore') ? '' : Proxmox.Utils.NoneText,
	    singleSelectorLabelNs: get =>
		get('singleDatastore') ? gettext('Target Namespace') : gettext('Default Namespace'),
	    notificationSystemSelected: (get) => get('notificationMode') === 'notification-system',
	},
    },

    controller: {
	xclass: 'Ext.app.ViewController',

	panelIsValid: function(panel) {
	    return panel.query('[isFormField]').every(field => field.isValid());
	},

	changeMediaSet: function(field, value) {
	    let me = this;
	    let vm = me.getViewModel();
	    vm.set('uuid', value);
	    me.updateSnapshots();
	},

	checkValidity: function() {
	    let me = this;

	    let tabpanel = me.lookup('tabpanel');
	    if (!tabpanel) {
		return; // can get triggered early, when the tabpanel is not yet available
	    }
	    let items = tabpanel.items;

	    let indexOfActiveTab = items.indexOf(tabpanel.getActiveTab());
	    let indexOfLastValidTab = 0;

	    let checkValidity = true;
	    items.each((panel) => {
		if (checkValidity) {
		    panel.setDisabled(false);
		    indexOfLastValidTab = items.indexOf(panel);
		    if (!me.panelIsValid(panel)) {
			checkValidity = false;
		    }
		} else {
		    panel.setDisabled(true);
		}

		return true;
	    });

	    if (indexOfLastValidTab < indexOfActiveTab) {
		tabpanel.setActiveTab(indexOfLastValidTab);
	    } else {
		me.setButtonState(tabpanel.getActiveTab());
	    }
	},

	setButtonState: function(panel) {
	    let me = this;
	    let isValid = me.panelIsValid(panel);
	    let nextButton = me.lookup('nextButton');
	    let finishButton = me.lookup('finishButton');
	    nextButton.setDisabled(!isValid);
	    finishButton.setDisabled(!isValid);
	},

	changeButtonVisibility: function(tabpanel, newItem) {
	    let me = this;
	    let items = tabpanel.items;

	    let backButton = me.lookup('backButton');
	    let nextButton = me.lookup('nextButton');
	    let finishButton = me.lookup('finishButton');

	    let isLast = items.last() === newItem;
	    let isFirst = items.first() === newItem;

	    backButton.setVisible(!isFirst);
	    nextButton.setVisible(!isLast);
	    finishButton.setVisible(isLast);

	    me.setButtonState(newItem);
	},

	previousTab: function() {
	    let me = this;
	    let tabpanel = me.lookup('tabpanel');
	    let index = tabpanel.items.indexOf(tabpanel.getActiveTab());
	    tabpanel.setActiveTab(index - 1);
	},

	nextTab: function() {
	    let me = this;
	    let tabpanel = me.lookup('tabpanel');
	    let index = tabpanel.items.indexOf(tabpanel.getActiveTab());
	    tabpanel.setActiveTab(index + 1);
	},

	getValues: function() {
	    let me = this;

	    let values = {};

	    let tabpanel = me.lookup('tabpanel');
	    tabpanel
		.query('inputpanel')
		.forEach((panel) =>
		    Proxmox.Utils.assemble_field_data(values, panel.getValues()));

	    return values;
	},

	finish: function() {
	    let me = this;
	    let view = me.getView();

	    let values = me.getValues();
	    let url = view.url;
	    let method = view.method;

	    Proxmox.Utils.API2Request({
		url,
		waitMsgTarget: view,
		method,
		params: values,
		failure: function(response, options) {
		    Ext.Msg.alert(gettext('Error'), response.htmlStatus);
		},
		success: function(response, options) {
			// keep around so we can trigger our close events when background action completes
			view.hide();

			Ext.create('Proxmox.window.TaskViewer', {
			    autoShow: true,
			    upid: response.result.data,
			    listeners: {
				destroy: () => view.close(),
			    },
			});
		},
	    });
	},

	updateDatastores: function(grid, values) {
	    let me = this;
	    let datastores = {};
	    values.forEach((snapshotOrDatastore) => {
		let datastore = snapshotOrDatastore;
		if (snapshotOrDatastore.indexOf(':') !== -1) {
		    let snapshot = snapshotOrDatastore;
		    let match = snapshot.split(':');
		    datastore = match[0];
		}
		datastores[datastore] = true;
	    });

	    me.setDataStores(Object.keys(datastores));
	},

	setDataStores: function(datastores, initial) {
	    let me = this;

	    // save all datastores on the first setting, and restore them if we selected all
	    if (initial) {
		me.datastores = datastores;
	    } else if (datastores.length === 0) {
		datastores = me.datastores;
	    }

	    const singleDatastore = !datastores || datastores.length <= 1;
	    me.getViewModel().set('singleDatastore', singleDatastore);

	    let grid = me.lookup('mappingGrid');
	    if (!singleDatastore && grid) {
		grid.setDataStores(datastores);
	    }
	},

	updateSnapshots: function() {
	    let me = this;
	    let view = me.getView();
	    let grid = me.lookup('snapshotGrid');
	    let vm = me.getViewModel();
	    let uuid = vm.get('uuid');

	    Proxmox.Utils.API2Request({
		waitMsgTarget: view,
		url: `/tape/media/content?media-set=${uuid}`,
		success: function(response, opt) {
		    let datastores = {};
		    for (const content of response.result.data) {
			datastores[content.store] = true;
		    }
		    me.setDataStores(Object.keys(datastores), true);
		    if (response.result.data.length > 0) {
			grid.setDisabled(false);
			grid.setData(response.result.data);
			grid.getSelectionModel().selectAll();
			// we've shown a big list, center the window again
			view.center();
		    }
		},
		failure: function() {
		    // ignore failing api call, maybe catalog is missing
		    me.setDataStores([], true);
		},
	    });
	},

	init: function(view) {
	    let me = this;
	    let vm = me.getViewModel();

	    vm.set('uuid', view.uuid);
	},

	control: {
	    '[isFormField]': {
		change: 'checkValidity',
		validitychange: 'checkValidity',
	    },
	    'tabpanel': {
		tabchange: 'changeButtonVisibility',
	    },
	},
    },

    buttons: [
	{
	    text: gettext('Back'),
	    reference: 'backButton',
	    handler: 'previousTab',
	    hidden: true,
	},
	{
	    text: gettext('Next'),
	    reference: 'nextButton',
	    handler: 'nextTab',
	},
	{
	    text: gettext('Restore'),
	    reference: 'finishButton',
	    handler: 'finish',
	    hidden: true,
	},
    ],

    items: [
	{
	    xtype: 'tabpanel',
	    reference: 'tabpanel',
	    layout: 'fit',
	    bodyPadding: 10,
	    items: [
		{
		    title: gettext('Snapshot Selection'),
		    xtype: 'inputpanel',
		    onGetValues: function(values) {
			let me = this;

			// cannot use the string serialized one from onGetValues, so gather manually
			delete values.snapshots;
			let snapshots = me.down('pbsTapeSnapshotGrid').getValue();

			if (snapshots.length > 0 && snapshots[0].indexOf(':') !== -1) {
			    values.snapshots = snapshots;
			}

			return values;
		    },

		    column1: [
			{
			    xtype: 'pbsMediaSetSelector',
			    fieldLabel: gettext('Media-Set'),
			    width: 350,
			    submitValue: false,
			    emptyText: gettext('Select Media-Set to restore'),
			    bind: {
				value: '{uuid}',
			    },
			    cbind: {
				hidden: '{uuid}',
				disabled: '{uuid}',
			    },
			    listeners: {
				change: 'changeMediaSet',
			    },
			},
			{
			    xtype: 'displayfield',
			    fieldLabel: gettext('Media-Set'),
			    cbind: {
				value: '{mediaset}',
				hidden: '{!uuid}',
				disabled: '{!uuid}',
			    },
			},
		    ],

		    column2: [
			{
			    xtype: 'displayfield',
			    fieldLabel: gettext('Media-Set UUID'),
			    name: 'media-set',
			    submitValue: true,
			    bind: {
				value: '{uuid}',
				hidden: '{!uuid}',
				disabled: '{!uuid}',
			    },
			},
		    ],

		    columnB: [
			{
			    xtype: 'pbsTapeSnapshotGrid',
			    reference: 'snapshotGrid',
			    name: 'snapshots',
			    height: 322,
			    disabled: true, // will be shown/enabled on successful load
			    listeners: {
				change: 'updateDatastores',
			    },
			    cbind: {
				prefilter: '{prefilter}',
			    },
			},
		    ],
		},
		{
		    title: gettext('Target'),
		    xtype: 'inputpanel',
		    onGetValues: function(values) {
			let me = this;
			let controller = me.up('window').getController();
			let vm = controller.getViewModel();
			let datastores = [];
			if (values.store.toString() !== "") {
			    let target = values.store.toString();
			    delete values.store;

			    let source = [];
			    if (vm.get('singleDatastore')) {
				// can be '[]' (for all), a list of datastores, or a list of snapshots
				source = controller.lookup('snapshotGrid').getValue();
				if (source.length > 0) {
				    if (source[0].indexOf(':') !== -1) {
					// one or multiple snapshots are selected
					// extract datastore from first
					source = source[0].split(':')[0];
				    } else {
					// one whole datstore is selected
					source = source[0];
				    }
				} else {
				    // must be [] (all snapshots) so we use it as a default target
				}
			    } else {
				// there is more than one datastore to be restored, so this is just
				// the default fallback
			    }

			    if (Ext.isString(source)) {
				datastores.push(`${source}=${target}`);
			    } else {
				datastores.push(target);
			    }
			}

			let defaultNs = values.defaultNs;
			delete values.defaultNs;

			// cannot use the string serialized one from onGetValues, so gather manually
			delete values.mapping;
			let [ds_map, ns_map] = me.down('pbsDataStoreMappingField').getValue();
			if (ds_map !== '') {
			    datastores.push(ds_map);
			}
			if (ns_map.length > 0) {
			    values.namespaces = ns_map;
			}

			if (defaultNs && ns_map.length === 0 && controller.datastores.length === 1) {
			    // we only have one datastore and a default ns
			    values.namespaces = [`store=${controller.datastores[0]},target=${defaultNs}`];
			}


			values.store = datastores.join(',');

			return values;
		    },
		    column1: [
			{
			    xtype: 'proxmoxKVComboBox',
			    comboItems: [
				['legacy-sendmail', gettext('Email (legacy)')],
				['notification-system', gettext('Notification system')],
			    ],
			    fieldLabel: gettext('Notification mode'),
			    name: 'notification-mode',
			    bind: {
				value: '{notificationMode}',
			    },
			},
			{
			    xtype: 'pmxUserSelector',
			    name: 'notify-user',
			    fieldLabel: gettext('Notify User'),
			    emptyText: gettext('Current User'),
			    value: null,
			    allowBlank: true,
			    skipEmptyText: true,
			    renderer: Ext.String.htmlEncode,
			    bind: {
				disabled: "{notificationSystemSelected}",
			    },
			},
			{
			    xtype: 'pbsAuthidSelector',
			    name: 'owner',
			    fieldLabel: gettext('Owner'),
			    emptyText: gettext('Current Auth ID'),
			    value: null,
			    allowBlank: true,
			    skipEmptyText: true,
			    renderer: Ext.String.htmlEncode,
			},
		    ],

		    column2: [
			{
			    xtype: 'pbsDriveSelector',
			    name: 'drive',
			    fieldLabel: gettext('Drive'),
			    labelWidth: 120,
			},
			{
			    xtype: 'pbsDataStoreSelector',
			    name: 'store',
			    labelWidth: 120,
			    bind: {
				fieldLabel: '{singleSelectorLabel}',
				emptyText: '{singleSelectorEmptyText}',
				allowBlank: '{!singleDatastore}',
			    },
			    listeners: {
				change: function(field, value) {
				    this.up('window').lookup('mappingGrid').setDefaultStore(value);
				    this.up('window').lookup('defaultNs').setDatastore(value);
				},
			    },
			},
			{
			    xtype: 'pbsNamespaceSelector',
			    name: 'defaultNs',
			    reference: 'defaultNs',
			    labelWidth: 120,
			    bind: {
				fieldLabel: '{singleSelectorLabelNs}',
			    },
			    listeners: {
				change: function(field, value) {
				    this.up('window').lookup('mappingGrid').setDefaultNs(value);
				},
			    },
			},
		    ],

		    columnB: [
			{
			    xtype: 'displayfield',
			    fieldLabel: gettext('Datastore Mapping'),
			    labelWidth: 200,
			    bind: {
				hidden: '{singleDatastore}',
			    },
			},
			{
			    xtype: 'pbsDataStoreMappingField',
			    name: 'mapping',
			    reference: 'mappingGrid',
			    height: 240,
			    defaultBindProperty: 'value',
			    bind: {
				hidden: '{singleDatastore}',
			    },
			},
		    ],
		},
	    ],
	},
    ],

    listeners: {
	afterrender: 'updateSnapshots',
    },
});

Ext.define('PBS.TapeManagement.DataStoreMappingGrid', {
    extend: 'Ext.grid.Panel',
    alias: 'widget.pbsDataStoreMappingField',
    mixins: ['Ext.form.field.Field'],

    scrollable: true,

    getValue: function() {
	let me = this;
	let datastores = [];
	let namespaces = [];
	let defaultStore = me.getViewModel().get('defaultStore');
	let defaultNs = me.getViewModel().get('defaultNs');
	me.getStore().each(rec => {
	    let { source, target, targetns } = rec.data;
	    if (target && target !== "") {
		datastores.push(`${source}=${target}`);
	    }
	    if (target || defaultStore) {
		let ns = targetns || defaultNs;
		if (ns) {
		    namespaces.push(`store=${source},target=${ns}`);
		} else {
		    namespaces.push(`store=${source}`);
		}
	    }
	});

	return [datastores.join(','), namespaces];
    },

    viewModel: {
	data: {
	    defaultStore: '',
	    defaultNs: false,
	},
	formulas: {
	    emptyStore: get => get('defaultStore') || Proxmox.Utils.NoneText,
	    emptyNs: get => get('defaultNs') || gettext('Root'),
	},
    },

    setDefaultStore: function(store) {
	let me = this;
	me.getViewModel().set('defaultStore', store);
	me.getStore().each((rec) => {
	    if (!rec.dswidget) {
		return; // not yet attached
	    }
	    if (!rec.dswidget.getValue()) {
		rec.nswidget.setDatastore(store);
	    }
	});
	me.checkChange();
	me.validate();
    },

    setDefaultNs: function(defaultNs) {
	let me = this;
	me.getViewModel().set('defaultNs', defaultNs);
	me.checkChange();
	me.validate();
    },

    setValue: function(value) {
	let me = this;
	me.setDataStores(value);
	return me;
    },

    getErrors: function(value) {
	let me = this;
	let error = false;

	if (!me.getViewModel().get('defaultStore')) {
	    error = true;
	    me.getStore().each(rec => {
		if (rec.data.target) {
		    error = false;
		}
	    });
	}

	let el = me.getActionEl();
	if (error) {
	    me.addCls(['x-form-trigger-wrap-default', 'x-form-trigger-wrap-invalid']);
	    let errorMsg = gettext("Need at least one mapping");
	    if (el) {
		el.dom.setAttribute('data-errorqtip', errorMsg);
	    }

	    return [errorMsg];
	}
	me.removeCls(['x-form-trigger-wrap-default', 'x-form-trigger-wrap-invalid']);
	if (el) {
	    el.dom.setAttribute('data-errorqtip', "");
	}
	return [];
    },

    setDataStores: function(datastores) {
	let me = this;

	let data = [];
	for (const datastore of datastores) {
	    data.push({
		source: datastore,
		target: '',
		targetNs: '',
	    });
	}

	me.getStore().setData(data);
    },

    viewConfig: {
	markDirty: false,
    },

    store: { data: [] },

    listeners: {
	beforedestroy: function() {
	    // break cyclic reference
	    this.getStore()?.each((rec) => {
		delete rec.nswidget;
		delete rec.dswidget;
	    });
	},
    },

    columns: [
	{
	    text: gettext('Source Datastore'),
	    dataIndex: 'source',
	    flex: 1,
	},
	{
	    text: gettext('Target Datastore'),
	    xtype: 'widgetcolumn',
	    onWidgetAttach: function(col, widget, rec) {
		// so that we can access it from the store
		rec.dswidget = widget;
	    },
	    dataIndex: 'target',
	    flex: 1,
	    widget: {
		xtype: 'pbsDataStoreSelector',
		isFormField: false,
		allowBlank: true,
		bind: {
		    emptyText: '{emptyStore}',
		},
		listeners: {
		    change: function(selector, value) {
			let me = this;
			let rec = me.getWidgetRecord();
			if (!rec) {
			    return;
			}
			rec.set('target', value);
			rec.nswidget.setDatastore(value);
			me.up('grid').checkChange();
		    },
		},
	    },
	},
	{
	    text: gettext('Target Namespace'),
	    xtype: 'widgetcolumn',
	    onWidgetAttach: function(col, widget, rec) {
		// so that we can access it from the store
		rec.nswidget = widget;
	    },
	    dataIndex: 'targetns',
	    flex: 1,
	    widget: {
		xtype: 'pbsNamespaceSelector',
		isFormField: false,
		allowBlank: true,
		bind: {
		    emptyText: '{emptyNs}',
		},
		listeners: {
		    change: function(selector, value) {
			let me = this;
			let rec = me.getWidgetRecord();
			if (!rec) {
			    return;
			}
			rec.set('targetns', value);
			me.up('grid').checkChange();
		    },
		},
	    },
	},
    ],
});

Ext.define('PBS.TapeManagement.SnapshotGrid', {
    extend: 'Ext.grid.Panel',
    alias: 'widget.pbsTapeSnapshotGrid',
    mixins: ['Ext.form.field.Field'],

    getValue: function() {
	let me = this;
	let snapshots = [];

	let selectedStoreCounts = {};

	me.getSelection().forEach((rec) => {
	    let id = rec.get('id');
	    let store = rec.data.store;
	    let snap = rec.data.snapshot;
	    // only add if not filtered
	    if (me.store.findExact('id', id) !== -1) {
		snapshots.push(`${store}:${snap}`);
		if (selectedStoreCounts[store] === undefined) {
		    selectedStoreCounts[store] = 0;
		}
		selectedStoreCounts[store]++;
	    }
	});

	// getSource returns null if data is not filtered
	let originalData = me.store.getData().getSource() || me.store.getData();

	if (snapshots.length === originalData.length) {
	    return [];
	}

	let wholeStores = [];
	let onlyWholeStoresSelected = true;
	for (const [store, selectedCount] of Object.entries(selectedStoreCounts)) {
	    if (me.storeCounts[store] === selectedCount) {
		wholeStores.push(store);
	    } else {
		onlyWholeStoresSelected = false;
		break;
	    }
	}

	if (onlyWholeStoresSelected) {
	    return wholeStores;
	}

	return snapshots;
    },

    setValue: function(value) {
	let me = this;
	// not implemented
	return me;
    },

    getErrors: function(value) {
	let me = this;
	if (me.getSelection().length < 1) {
	    me.addCls(['x-form-trigger-wrap-default', 'x-form-trigger-wrap-invalid']);
	    let errorMsg = gettext("Need at least one snapshot");
	    let el = me.getActionEl();
	    if (el) {
		el.dom.setAttribute('data-errorqtip', errorMsg);
	    }

	    return [errorMsg];
	}
	me.removeCls(['x-form-trigger-wrap-default', 'x-form-trigger-wrap-invalid']);
	let el = me.getActionEl();
	if (el) {
	    el.dom.setAttribute('data-errorqtip', "");
	}
	return [];
    },

    setData: function(records) {
	let me = this;
	let storeCounts = {};
	records.forEach((rec) => {
	    let store = rec.store;
	    if (storeCounts[store] === undefined) {
		storeCounts[store] = 0;
	    }
	    storeCounts[store]++;
	});
	me.storeCounts = storeCounts;
	me.getStore().setData(records);
    },

    scrollable: true,
    plugins: 'gridfilters',

    viewConfig: {
	emptyText: gettext('No Snapshots'),
	markDirty: false,
    },

    selModel: 'checkboxmodel',
    store: {
	sorters: ['store', 'snapshot'],
	data: [],
	filters: [],
    },

    listeners: {
	selectionchange: function() {
	    // to trigger validity and error checks
	    this.checkChange();
	},
    },

    checkChangeEvents: [
	'selectionchange',
	'change',
    ],

    columns: [
	{
	    text: gettext('Source Datastore'),
	    dataIndex: 'store',
	    filter: {
		type: 'list',
	    },
	    flex: 1,
	},
	{
	    text: gettext('Snapshot'),
	    dataIndex: 'snapshot',
	    filter: {
		type: 'string',
	    },
	    flex: 2,
	},
    ],

    initComponent: function() {
	let me = this;
	me.callParent();
	if (me.prefilter !== undefined) {
	    if (me.prefilter.store !== undefined) {
		me.store.filters.add(
		    {
			id: 'x-gridfilter-store',
			property: 'store',
			operator: 'in',
			value: [me.prefilter.store],
		    },
		);
	    }

	    if (me.prefilter.snapshot !== undefined) {
		me.store.filters.add(
		    {
			id: 'x-gridfilter-snapshot',
			property: 'snapshot',
			value: me.prefilter.snapshot,
		    },
		);
	    }
	}

	me.mon(me.store, 'filterchange', () => me.checkChange());
    },
});

Ext.define('PBS.TapeManagement.MediaSetSelector', {
    extend: 'Proxmox.form.ComboGrid',
    alias: 'widget.pbsMediaSetSelector',

    allowBlank: false,
    displayField: 'media-set-name',
    valueField: 'media-set-uuid',
    autoSelect: false,

    store: {
	proxy: {
	    type: 'proxmox',
	    url: '/api2/json/tape/media/media-sets',
	},
	autoLoad: true,
	idProperty: 'media-set-uuid',
	sorters: ['pool', 'media-set-ctime'],
    },

    listConfig: {
	width: 600,
	columns: [
	    {
		text: gettext('Pool'),
		dataIndex: 'pool',
		flex: 1,
	    },
	    {
		text: gettext('Name'),
		dataIndex: 'media-set-name',
		width: 180,
	    },
	    {
		text: gettext('Media-Set UUID'),
		dataIndex: 'media-set-uuid',
		width: 280,
	    },
	],
    },
});
Ext.define('PBS.TapeManagement.BackupOverview', {
    extend: 'Ext.tree.Panel',
    alias: 'widget.pbsBackupOverview',

    controller: {
	xclass: 'Ext.app.ViewController',

	backup: function() {
	    let me = this;
	    Ext.create('PBS.TapeManagement.TapeBackupWindow', {
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
		autoShow: true,
	    });
	},

	restore: function() {
	    Ext.create('PBS.TapeManagement.TapeRestoreWindow', {
		autoShow: true,
	    });
	},

	restoreBackups: function(view, rI, cI, item, e, rec) {
	    let me = this;

	    let mediaset = rec.data.is_media_set ? rec.data.text : rec.data['media-set'];
	    Ext.create('PBS.TapeManagement.TapeRestoreWindow', {
		autoShow: true,
		uuid: rec.data['media-set-uuid'],
		prefilter: rec.data.prefilter,
		mediaset,
	    });
	},

	loadContent: async function() {
	    let me = this;
	    let content_response = await Proxmox.Async.api2({
		url: '/api2/extjs/tape/media/list?update-status=false',
	    });
	    let data = {};

	    for (const entry of content_response.result.data) {
		let pool = entry.pool;
		if (pool === undefined) {
		    continue; // pools not belonging to a pool cannot contain data
		}
		let media_set = entry['media-set-name'];
		if (media_set === undefined) {
		    continue; // tape does not belong to media-set (yet))
		}
		if (data[pool] === undefined) {
		    data[pool] = {};
		}

		let seq_nr = entry['seq-nr'];

		if (data[pool][media_set] === undefined) {
		    data[pool][media_set] = entry;
		    data[pool][media_set].text = media_set;
		    data[pool][media_set].restore = true;
		    data[pool][media_set].tapes = 1;
		    data[pool][media_set]['seq-nr'] = undefined;
		    data[pool][media_set]['max-seq-nr'] = seq_nr;
		    data[pool][media_set].is_media_set = true;
		    data[pool][media_set].typeText = 'media-set';
		} else {
		    data[pool][media_set].tapes++;
		}

		if (data[pool][media_set]['max-seq-nr'] < seq_nr) {
		    data[pool][media_set]['max-seq-nr'] = seq_nr;
		}
	    }

	    let list = [];

	    for (const [pool, media_sets] of Object.entries(data)) {
		let pool_entry = Ext.create('Ext.data.TreeModel', {
		    text: pool,
		    iconCls: 'fa fa-object-group',
		    expanded: true,
		    leaf: false,
		});

		let children = [];

		for (const media_set of Object.values(media_sets)) {
		    let entry = Ext.create('Ext.data.TreeModel', media_set);
		    entry.on('beforeexpand', (node) => me.beforeExpand(node));
		    children.push(entry);
		}

		pool_entry.set('children', children);
		list.push(pool_entry);
	    }

	    return list;
	},

	reload: async function() {
	    let me = this;
	    let view = me.getView();

	    Proxmox.Utils.setErrorMask(view, true);

	    try {
		let list = await me.loadContent();

		view.setRootNode({
		    expanded: true,
		    children: list,
		});

		Proxmox.Utils.setErrorMask(view, false);
	    } catch (error) {
		Proxmox.Utils.setErrorMask(view, error.toString());
	    }
	},

	loadMediaSet: async function(node) {
	    let me = this;
	    let view = me.getView();

	    Proxmox.Utils.setErrorMask(view, true);
	    const media_set_uuid = node.data['media-set-uuid'];
	    const media_set = node.data.text;

	    try {
		let list = await Proxmox.Async.api2({
		    method: 'GET',
		    url: `/api2/extjs/tape/media/content`,
		    // a big media-set with large catalogs can take a while to load
		    // so we give a big (5min) timeout
		    timeout: 5*60*1000,
		    params: {
			'media-set': media_set_uuid,
		    },
		});

		list.result.data.sort(function(a, b) {
		    let storeRes = a.store.localeCompare(b.store);
		    if (storeRes === 0) {
			return a.snapshot.localeCompare(b.snapshot);
		    } else {
			return storeRes;
		    }
		});

		let stores = {};

		for (let entry of list.result.data) {
		    entry.text = entry.snapshot;
		    entry.restore = true;
		    entry.leaf = true;
		    entry.children = [];
		    entry['media-set'] = media_set;
		    entry.prefilter = {
			store: entry.store,
			snapshot: entry.snapshot,
		    };
		    let [type, group, _id, namespace, nsPath] = PBS.Utils.parse_snapshot_id(entry.snapshot);
		    let iconCls = PBS.Utils.get_type_icon_cls(type);
		    if (iconCls !== '') {
			entry.iconCls = `fa ${iconCls}`;
		    }

		    let store = entry.store;
		    let tape = entry['label-text'];
		    if (stores[store] === undefined) {
			stores[store] = {
			    text: store,
			    'media-set-uuid': entry['media-set-uuid'],
			    iconCls: 'fa fa-database',
			    typeText: 'datastore',
			    restore: true,
			    'media-set': media_set,
			    prefilter: {
				store,
			    },
			    tapes: {},
			};
		    }

		    if (stores[store].tapes[tape] === undefined) {
			stores[store].tapes[tape] = {
			    text: tape,
			    'media-set-uuid': entry['media-set-uuid'],
			    'seq-nr': entry['seq-nr'],
			    iconCls: 'pbs-icon-tape',
			    namespaces: {},
			    children: [],
			};
		    }

		    if (stores[store].tapes[tape].namespaces[namespace] === undefined) {
			stores[store].tapes[tape].namespaces[namespace] = {
			    text: namespace,
			    'media-set-uuid': entry['media-set-uuid'],
			    'is-namespace': true,
			    children: [],
			};
		    }

		    let children = stores[store].tapes[tape].namespaces[namespace].children;
		    let text = `${type}/${group}`;
		    if (children.length < 1 || children[children.length - 1].text !== text) {
			children.push({
			    text,
			    'media-set-uuid': entry['media-set-uuid'],
			    leaf: false,
			    restore: true,
			    prefilter: {
				store,
				snapshot: namespace ? `${nsPath}/${type}/${group}/` : `${type}/${group}`,
			    },
			    'media-set': media_set,
			    iconCls: `fa ${iconCls}`,
			    typeText: `group`,
			    children: [],
			});
		    }
		    children[children.length - 1].children.push(entry);
		}

		let storeList = Object.values(stores);
		let storeNameList = Object.keys(stores);
		let expand = storeList.length === 1;
		for (const store of storeList) {
		    let tapeList = Object.values(store.tapes);
		    for (const tape of tapeList) {
			let rootNs = tape.namespaces[''];
			if (rootNs) {
			    tape.children.push(...rootNs.children);
			    delete tape.namespaces[''];
			}
			tape.children.push(...Object.values(tape.namespaces));
			if (tape.children.length === 1) {
			    tape.children[0].expanded = true;
			}
			tape.expanded = tapeList.length === 1;
			delete tape.namespaces;
		    }
		    store.children = Object.values(store.tapes);
		    store.expanded = expand;
		    delete store.tapes;
		    node.appendChild(store);
		}

		if (list.result.data.length === 0) {
		    node.set('leaf', true);
		}

		node.set('loaded', true);
		node.set('datastores', storeNameList);
		Proxmox.Utils.setErrorMask(view, false);
		node.expand();
	    } catch (response) {
		Proxmox.Utils.setErrorMask(view, false);
		Ext.Msg.alert('Error', response.result.message.toString());
	    }
	},

	beforeExpand: function(node, e) {
	    let me = this;
	    if (node.isLoaded()) {
		return true;
	    }

	    me.loadMediaSet(node);

	    return false;
	},
    },

    listeners: {
	activate: 'reload',
    },

    store: {
	data: [],
	sorters: function(a, b) {
	    if (a.data.is_media_set && b.data.is_media_set) {
		return a.data['media-set-ctime'] - b.data['media-set-ctime'];
	    } else if (a.data['is-namespace'] && !b.data['is-namespace']) {
		return 1;
	    } else if (!a.data['is-namespace'] && b.data['is-namespace']) {
		return -1;
	    } else {
		return a.data.text.localeCompare(b.data.text);
	    }
	},
    },

    rootVisible: false,

    tbar: [
	{
	    text: gettext('Reload'),
	    iconCls: 'fa fa-refresh',
	    handler: 'reload',
	},
	'-',
	{
	    text: gettext('New Backup'),
	    iconCls: 'fa fa-floppy-o',
	    handler: 'backup',
	},
	'-',
	{
	    text: gettext('Restore'),
	    iconCls: 'fa fa-undo',
	    handler: 'restore',
	},
    ],

    viewConfig: {
	getRowClass: function(rec) {
	    let tapeCount = (rec.get('max-seq-nr') ?? 0) + 1;
	    let actualTapeCount = rec.get('tapes') ?? 1;

	    if (tapeCount !== actualTapeCount) {
		return 'proxmox-warning-row';
	    }

	    return '';
	},
    },

    columns: [
	{
	    xtype: 'treecolumn',
	    text: gettext('Pool/Media-Set/Snapshot'),
	    dataIndex: 'text',
	    renderer: function(value, mD, rec) {
		let tapeCount = (rec.get('max-seq-nr') ?? 0) + 1;
		let actualTapeCount = rec.get('tapes') ?? 1;

		if (tapeCount !== actualTapeCount) {
		    return `${value} (${gettext('Incomplete')})`;
		}
		return value;
	    },
	    sortable: false,
	    flex: 3,
	},
	{
	    header: gettext('Restore'),
	    xtype: 'actioncolumn',
	    dataIndex: 'text',
	    items: [
		{
		    handler: 'restoreBackups',
		    getTip: (v, m, rec) => {
			let typeText = rec.get('typeText');
			if (typeText) {
			    v = `${typeText} '${v}'`;
			}
			return Ext.String.format(gettext("Open restore wizard for {0}"), v);
		    },
		    getClass: (v, m, rec) => rec.data.restore ? 'fa fa-fw fa-undo' : 'pmx-hidden',
		    isActionDisabled: (v, r, c, i, rec) => !rec.data.restore,
                },
	    ],
	},
	{
	    text: gettext('Tapes'),
	    dataIndex: 'tapes',
	    sortable: false,
	},
	{
	    text: gettext('Seq. Nr.'),
	    dataIndex: 'seq-nr',
	    sortable: false,
	},
	{
	    text: gettext('Media-Set UUID'),
	    dataIndex: 'media-set-uuid',
	    hidden: true,
	    sortable: false,
	    width: 280,
	},
    ],
});

Ext.define('pbs-model-changers', {
    extend: 'Ext.data.Model',
    fields: ['path', 'model', 'name', 'serial', 'vendor', 'export-slots'],
    idProperty: 'name',
});

Ext.define('PBS.TapeManagement.ChangerPanel', {
    extend: 'Ext.grid.Panel',
    alias: 'widget.pbsTapeChangerPanel',

    controller: {
	xclass: 'Ext.app.ViewController',

	reloadTapeStore: function() {
	    let navtree = Ext.ComponentQuery.query('navigationtree')[0];
	    navtree.reloadTapeStore();
	},

	onAdd: function() {
	    let me = this;
	    Ext.create('PBS.TapeManagement.ChangerEditWindow', {
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
	    }).show();
	},

	onEdit: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (!selection || selection.length < 1) {
		return;
	    }
	    Ext.create('PBS.TapeManagement.ChangerEditWindow', {
		changerid: selection[0].data.name,
		autoLoad: true,
		listeners: {
		    destroy: () => me.reload(),
		},
	    }).show();
	},

	reload: function() {
	    this.getView().getStore().rstore.load();
	    this.reloadTapeStore();
	},

	stopStore: function() {
	    this.getView().getStore().rstore.stopUpdate();
	},

	startStore: function() {
	    this.getView().getStore().rstore.startUpdate();
	},

	init: function(view) {
	    Proxmox.Utils.monStoreErrors(view, view.getStore().rstore);
	},
    },

    listeners: {
	beforedestroy: 'stopStore',
	deactivate: 'stopStore',
	activate: 'startStore',
	itemdblclick: 'onEdit',
    },

    store: {
	type: 'diff',
	rstore: {
	    type: 'update',
	    storeid: 'proxmox-tape-changers',
	    model: 'pbs-model-changers',
	    proxy: {
		type: 'proxmox',
		url: "/api2/json/tape/changer",
	    },
	},
	sorters: 'name',
    },

    tbar: [
	{
	    text: gettext('Add'),
	    xtype: 'proxmoxButton',
	    handler: 'onAdd',
	    selModel: false,
	},
	'-',
	{
	    text: gettext('Edit'),
	    xtype: 'proxmoxButton',
	    handler: 'onEdit',
	    disabled: true,
	},
	{
	    xtype: 'proxmoxStdRemoveButton',
	    baseurl: '/api2/extjs/config/changer',
	    callback: 'reload',
	},
    ],
    columns: [
	{
	    text: gettext('Name'),
	    dataIndex: 'name',
	    flex: 1,
	},
	{
	    text: gettext('Path'),
	    dataIndex: 'path',
	    flex: 2,
	},
	{
	    text: gettext('Vendor'),
	    dataIndex: 'vendor',
	    flex: 1,
	},
	{
	    text: gettext('Model'),
	    dataIndex: 'model',
	    flex: 1,
	},
	{
	    text: gettext('Serial'),
	    dataIndex: 'serial',
	    flex: 1,
	},
	{
	    text: gettext('Import/Export Slots'),
	    dataIndex: 'export-slots',
	    flex: 1,
	},
    ],
});

Ext.define('pbs-slot-model', {
    extend: 'Ext.data.Model',
    fields: ['entry-id', 'label-text', 'is-labeled', ' model', 'name', 'vendor', 'serial', 'state', 'status', 'pool', 'activity',
	{
	    name: 'is-blocked',
	    calculate: function(data) {
		return data.state !== undefined;
	    },
	},
	{
	    name: 'is-empty',
	    calculate: function(data) {
		return data['label-text'] === undefined;
	    },
	},
    ],
    idProperty: 'entry-id',
});

Ext.define('PBS.TapeManagement.FreeSlotSelector', {
    extend: 'Proxmox.form.ComboGrid',
    alias: 'widget.pbsFreeSlotSelector',

    valueField: 'id',
    displayField: 'id',

    listConfig: {
	columns: [
	    {
		dataIndex: 'id',
		text: gettext('ID'),
		flex: 1,
	    },
	    {
		dataIndex: 'type',
		text: gettext('Type'),
		flex: 1,
	    },
	],
    },
});

Ext.define('PBS.TapeManagement.ChangerStatus', {
    extend: 'Ext.panel.Panel',
    alias: 'widget.pbsChangerStatus',

    tools: [PBS.Utils.get_help_tool("tape_backup")],

    controller: {
	xclass: 'Ext.app.ViewController',

	importTape: function(v, rI, cI, button, el, record) {
	    let me = this;
	    let view = me.getView();
	    let from = record.data['entry-id'];
	    let changer = encodeURIComponent(view.changer);
	    Ext.create('Proxmox.window.Edit', {
		title: gettext('Import'),
		isCreate: true,
		submitText: gettext('OK'),
		method: 'POST',
		url: `/api2/extjs/tape/changer/${changer}/transfer`,
		submitOptions: {
		    timeout: 3*60*1000,
		},
		items: [
		    {
			xtype: 'displayfield',
			name: 'from',
			value: from,
			submitValue: true,
			fieldLabel: gettext('From Slot'),
		    },
		    {
			xtype: 'pbsFreeSlotSelector',
			name: 'to',
			fieldLabel: gettext('To Slot'),
			store: {
			    data: me.free_slots,
			},
		    },
		],
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
	    }).show();
	},

	slotTransfer: function(v, rI, cI, button, el, record) {
	    let me = this;
	    let view = me.getView();
	    let from = record.data['entry-id'];
	    let changer = encodeURIComponent(view.changer);
	    Ext.create('Proxmox.window.Edit', {
		title: gettext('Transfer'),
		isCreate: true,
		submitText: gettext('OK'),
		method: 'POST',
		url: `/api2/extjs/tape/changer/${changer}/transfer`,
		submitOptions: {
		    timeout: 3*60*1000,
		},
		items: [
		    {
			xtype: 'displayfield',
			name: 'from',
			value: from,
			submitValue: true,
			fieldLabel: gettext('From Slot'),
		    },
		    {
			xtype: 'pbsFreeSlotSelector',
			name: 'to',
			fieldLabel: gettext('To Slot'),
			store: {
			    data: me.free_slots.concat(me.free_ie_slots),
			},
		    },
		],
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
	    }).show();
	},

	labelMedia: function(button, event, record) {
	    let me = this;
	    Ext.create('PBS.TapeManagement.LabelMediaWindow', {
		driveid: record.data.name,
		label: record.data["label-text"],
	    }).show();
	},

	catalog: function(button, event, record) {
	    let me = this;

	    let view = me.getView();
	    PBS.Utils.driveCommand(record.data.name, 'catalog', {
		waitMsgTarget: view,
		method: 'POST',
		success: function(response) {
		    Ext.create('Proxmox.window.TaskViewer', {
			upid: response.result.data,
		    }).show();
		},
	    });
	},

	'format-inserted': function(button, event, record) {
	    let me = this;

	    let view = me.getView();
	    PBS.Utils.driveCommand(record.data.name, 'format-media', {
		waitMsgTarget: view,
		method: 'POST',
		success: function(response) {
		    Ext.create('Proxmox.window.TaskProgress', {
			upid: response.result.data,
			taskDone: function() {
			    me.reload();
			},
		    }).show();
		},
	    });
	},

	format: function(v, rI, cI, button, el, record) {
	    let me = this;
	    let view = me.getView();
	    let label = record.data['label-text'];

	    let changer = encodeURIComponent(view.changer);
	    let singleDrive = me.drives.length === 1 ? me.drives[0] : undefined;
	    Ext.create('PBS.TapeManagement.EraseWindow', {
		label,
		changer,
		singleDrive,
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
	    }).show();
	},

	load: function(v, rI, cI, button, el, record) {
	    let me = this;
	    let view = me.getView();
	    let label = record.data['label-text'];
	    let slot = record.data['entry-id'];

	    let changer = encodeURIComponent(view.changer);
	    let singleDrive = me.drives.length === 1 ? me.drives[0] : undefined;

	    let apiCall = label !== "" ? 'load-media' : 'load-slot';
	    let params = label !== "" ? { 'label-text': label } : { 'source-slot': slot };

	    if (singleDrive !== undefined) {
		Proxmox.Utils.API2Request({
		    method: 'POST',
		    params,
		    url: `/api2/extjs/tape/drive/${singleDrive}/${apiCall}`,
		    success: function(response, opt) {
			Ext.create('Proxmox.window.TaskProgress', {
			    upid: response.result.data,
			    taskDone: function(success) {
				me.reload();
			    },
			}).show();
		    },
		    failure: function(response, opt) {
			Ext.Msg.alert(gettext('Error'), response.htmlStatus);
		    },
		});
	    } else {
		Ext.create('Proxmox.window.Edit', {
		    isCreate: true,
		    autoShow: true,
		    submitText: gettext('OK'),
		    title: gettext('Load Media into Drive'),
		    url: `/api2/extjs/tape/drive`,
		    method: 'POST',
		    submitUrl: function(url, values) {
			let drive = values.drive;
			delete values.drive;
			return `${url}/${encodeURIComponent(drive)}/${apiCall}`;
		    },
		    items: [
			label !== "" ? {
			    xtype: 'displayfield',
			    name: 'label-text',
			    value: label,
			    submitValue: true,
			    fieldLabel: gettext('Media'),
			} : {
			    xtype: 'displayfield',
			    name: 'source-slot',
			    value: slot,
			    submitValue: true,
			    fieldLabel: gettext('Source Slot'),
			},
			{
			    xtype: 'pbsDriveSelector',
			    fieldLabel: gettext('Drive'),
			    changer: changer,
			    name: 'drive',
			},
		    ],
		    listeners: {
			destroy: function() {
			    me.reload();
			},
		    },
		});
	    }
	},

	unload: async function(v, rI, cI, button, el, record) {
	    let me = this;
	    let drive = record.data.name;
	    try {
		await Proxmox.Async.api2({
		    method: 'POST',
		    timeout: 5*60*1000,
		    url: `/api2/extjs/tape/drive/${encodeURIComponent(drive)}/unload`,
		});
	    } catch (response) {
		Ext.Msg.alert(gettext('Error'), response.result.message);
	    }
	    me.reload();
	},

	cartridgeMemory: function(view, rI, cI, button, el, record) {
	    let me = this;
	    let drive = record.data.name;
	    PBS.Utils.driveCommand(drive, 'cartridge-memory', {
		waitMsgTarget: me.getView(),
		success: PBS.Utils.showCartridgeMemoryWindow,
	    });
	},

	cleanDrive: function(button, event, record) {
	    let me = this;
	    PBS.Utils.driveCommand(record.data.name, 'clean', {
		waitMsgTarget: me.getView(),
		method: 'PUT',
		success: function(response) {
		    Ext.create('Proxmox.window.TaskProgress', {
			upid: response.result.data,
			taskDone: function() {
			    me.reload();
			},
		    }).show();
		},
	    });
	},

	volumeStatistics: function(view, rI, cI, button, el, record) {
	    let me = this;
	    let drive = record.data.name;
	    PBS.Utils.driveCommand(drive, 'volume-statistics', {
		waitMsgTarget: me.getView(),
		success: PBS.Utils.showVolumeStatisticsWindow,
	    });
	},

	readLabel: function(view, rI, cI, button, el, record) {
	    let me = this;
	    let drive = record.data.name;

	    PBS.Utils.driveCommand(drive, 'read-label', {
		waitMsgTarget: me.getView(),
		success: PBS.Utils.showMediaLabelWindow,
	    });
	},

	status: function(view, rI, cI, button, el, record) {
	    let me = this;
	    let drive = record.data.name;
	    PBS.Utils.driveCommand(drive, 'status', {
		waitMsgTarget: me.getView(),
		success: PBS.Utils.showDriveStatusWindow,
	    });
	},

	reloadList: function() {
	    let me = this;
	    me.lookup('changerselector').getStore().load();
	},

	barcodeLabel: function() {
	    let me = this;
	    let view = me.getView();
	    let changer = view.changer;
	    if (changer === '') {
		return;
	    }

	    let singleDrive = me.drives.length === 1 ? me.drives[0] : undefined;

	    Ext.create('Proxmox.window.Edit', {
		title: gettext('Barcode Label'),
		showTaskViewer: true,
		method: 'POST',
		url: '/api2/extjs/tape/drive',
		submitUrl: function(url, values) {
		    let drive = values.drive;
		    delete values.drive;
		    return `${url}/${encodeURIComponent(drive)}/barcode-label-media`;
		},

		items: [
		    {
			xtype: singleDrive === undefined ? 'pbsDriveSelector' : 'displayfield',
			fieldLabel: gettext('Drive'),
			submitValue: true,
			name: 'drive',
			value: singleDrive,
			changer: changer,
		    },
		    {
			xtype: 'pbsMediaPoolSelector',
			fieldLabel: gettext('Pool'),
			name: 'pool',
			skipEmptyText: true,
			allowBlank: true,
		    },
		],
	    }).show();
	},

	inventory: function() {
	    let me = this;
	    let view = me.getView();
	    let changer = view.changer;
	    if (changer === '') {
		return;
	    }

	    Ext.create('Proxmox.window.Edit', {
		title: gettext('Inventory'),
		showTaskViewer: true,
		method: 'PUT',
		url: '/api2/extjs/tape/drive',
		submitUrl: function(url, values) {
		    let drive = values.drive;
		    delete values.drive;
		    return `${url}/${encodeURIComponent(drive)}/inventory`;
		},

		items: [
		    {
			xtype: 'pbsDriveSelector',
			labelWidth: 120,
			fieldLabel: gettext('Drive'),
			name: 'drive',
			changer: changer,
			autoSelect: true,
		    },
		    {
			xtype: 'proxmoxcheckbox',
			labelWidth: 120,
			fieldLabel: gettext('Restore Catalogs'),
			name: 'catalog',
		    },
		    {
			xtype: 'proxmoxcheckbox',
			labelWidth: 120,
			fieldLabel: gettext('Force all Tapes'),
			name: 'read-all-labels',
		    },
		],
	    }).show();
	},

	scheduleReload: function(time) {
	    let me = this;
	    if (me.reloadTimeout === undefined) {
		me.reloadTimeout = setTimeout(function() {
		    me.reload();
		}, time);
	    }
	},

	cancelReload: function() {
	    let me = this;
	    if (me.reloadTimeout !== undefined) {
		clearTimeout(me.reloadTimeout);
		me.reloadTimeout = undefined;
	    }
	},

	reload: function() {
	    let me = this;
	    me.cancelReload();
	    me.reload_full(true);
	},

	reload_no_cache: function() {
	    let me = this;
	    if (me.reloadTimeout !== undefined) {
		clearTimeout(me.reloadTimeout);
		me.reloadTimeout = undefined;
	    }
	    me.reload_full(false);
	},

	drives: [],

	updateDrives: function(drives) {
	    let me = this;
	    me.drives = drives;
	},

	free_slots: [],
	free_ie_slots: [],

	updateFreeSlots: function(free_slots, free_ie_slots) {
	    let me = this;
	    me.free_slots = free_slots;
	    me.free_ie_slots = free_ie_slots;
	},

	reload_full: async function(use_cache) {
	    let me = this;
	    let view = me.getView();
	    let changer = view.changer;
	    if (changer === '') {
		return;
	    }

	    try {
		if (!use_cache) {
		    Proxmox.Utils.setErrorMask(view, true);
		    Proxmox.Utils.setErrorMask(me.lookup('content'));
		}
		let status_fut = Proxmox.Async.api2({
		    timeout: 5*60*1000,
		    method: 'GET',
		    url: `/api2/extjs/tape/changer/${encodeURIComponent(changer)}/status`,
		    params: {
			cache: use_cache,
		    },
		});
		let drives_fut = Proxmox.Async.api2({
		    timeout: 5*60*1000,
		    url: `/api2/extjs/tape/drive?query-activity=true&changer=${encodeURIComponent(changer)}`,
		});

		let tapes_fut = Proxmox.Async.api2({
		    timeout: 5*60*1000,
		    url: '/api2/extjs/tape/media/list',
		    method: 'GET',
		    params: {
			"update-status": false,
		    },
		});

		let [status, drives, tapes_list] = await Promise.all([status_fut, drives_fut, tapes_fut]);

		let data = {
		    slot: [],
		    'import-export': [],
		    drive: [],
		};

		let tapes = {};

		for (const tape of tapes_list.result.data) {
		    tapes[tape['label-text']] = {
			labeled: true,
			pool: tape.pool,
			status: tape.expired ? 'expired' : tape.status,
		    };
		}

		let drive_entries = {};

		for (const entry of drives.result.data) {
		    drive_entries[entry['changer-drivenum'] || 0] = entry;
		}

		let free_slots = [];
		let free_ie_slots = [];

		let valid_drives = [];

		for (let entry of status.result.data) {
		    let type = entry['entry-kind'];
		    let id = entry['entry-id'];

		    if (type === 'drive') {
			if (drive_entries[id] === undefined) {
			    continue;
			}

			entry = Ext.applyIf(entry, drive_entries[id]);
			valid_drives.push(drive_entries[id].name);
		    }

		    if (tapes[entry['label-text']] !== undefined) {
			entry['is-labeled'] = true;
			entry.pool = tapes[entry['label-text']].pool;
			entry.status = tapes[entry['label-text']].status;
		    } else {
			entry['is-labeled'] = false;
		    }

		    if (!entry['label-text'] && type !== 'drive') {
			if (type === 'slot') {
			    free_slots.push({
				id,
				type,
			    });
			} else {
			    free_ie_slots.push({
				id,
				type,
			    });
			}
		    }
		    data[type].push(entry);
		}

		// the stores are diffstores and are only refreshed
		// on a 'load' event, which does not trigger on 'setData'
		// so we have to fire them ourselves

		me.lookup('slots').getStore().rstore.setData(data.slot);
		me.lookup('slots').getStore().rstore.fireEvent('load', me, [], true);

		me.lookup('import_export').getStore().rstore.setData(data['import-export']);
		me.lookup('import_export').getStore().rstore.fireEvent('load', me, [], true);

		me.lookup('drives').getStore().rstore.setData(data.drive);
		me.lookup('drives').getStore().rstore.fireEvent('load', me, [], true);

		// manually fire selectionchange to update button status
		me.lookup('drives').getSelectionModel().fireEvent('selectionchange', me);

		me.updateFreeSlots(free_slots, free_ie_slots);
		me.updateDrives(valid_drives);

		if (!use_cache) {
		    Proxmox.Utils.setErrorMask(view);
		}
		Proxmox.Utils.setErrorMask(me.lookup('content'));
	    } catch (response) {
		if (!view || view.isDestroyed) {
		    return;
		}

		if (!use_cache) {
		    Proxmox.Utils.setErrorMask(view);
		}
		Proxmox.Utils.setErrorMask(me.lookup('content'), response.result.message.toString());
	    }

	    me.scheduleReload(5000);
	},

	renderLabel: function(value) {
	    if (value === undefined) {
		return '';
	    }

	    if (value === "") {
		return Ext.htmlEncode("<no-barcode>");
	    }

	    return value;
	},

	renderIsLabeled: function(value, mD, record) {
	    if (!record.data['label-text']) {
		return "";
	    }

	    if (record.data['label-text'].startsWith("CLN")) {
		return "";
	    }

	    if (!value) {
		return gettext('Not Labeled');
	    }

	    let status = record.data.status;
	    if (record.data.pool) {
		return `${status} (${record.data.pool})`;
	    }
	    return status;
	},

	control: {
	    'grid[reference=drives]': {
		cellclick: function(table, td, ci, rec, tr, ri, e) {
		    if (e.position.column.dataIndex !== 'state') {
			return;
		    }

		    let upid = rec.data.state;
		    if (!upid || !upid.startsWith("UPID")) {
			return;
		    }

		    Ext.create('Proxmox.window.TaskViewer', {
			autoShow: true,
			upid,
		    });
		},
	    },
	},

	init: function(view) {
	    let me = this;
	    if (!view.changer) {
		throw "no changer given";
	    }

	    view.title = `${gettext("Changer")}: ${view.changer}`;
	    me.reload();
	},
    },

    listeners: {
	deactivate: 'cancelReload',
	beforedestroy: 'cancelReload',
    },

    tbar: [
	{
	    text: gettext('Reload'),
	    xtype: 'proxmoxButton',
	    handler: 'reload_no_cache',
	    selModel: false,
	},
	'-',
	{
	    text: gettext('Barcode Label'),
	    xtype: 'proxmoxButton',
	    handler: 'barcodeLabel',
	    iconCls: 'fa fa-barcode',
	},
	{
	    text: gettext('Inventory'),
	    xtype: 'proxmoxButton',
	    handler: 'inventory',
	    iconCls: 'fa fa-book',
	},
    ],

    layout: 'fit',
    bodyPadding: 5,

    items: [
	{
	    xtype: 'container',
	    reference: 'content',
	    layout: {
		type: 'hbox',
		align: 'stretch',
	    },
	    items: [
		{
		    xtype: 'grid',
		    reference: 'slots',
		    title: gettext('Slots'),
		    padding: 5,
		    srollable: true,
		    flex: 1,
		    store: {
			type: 'diff',
			rstore: {
			    type: 'store',
			    model: 'pbs-slot-model',
			},
			data: [],
		    },
		    columns: [
			{
			    text: gettext('ID'),
			    dataIndex: 'entry-id',
			    width: 50,
			},
			{
			    text: gettext("Content"),
			    dataIndex: 'label-text',
			    flex: 1,
			    renderer: 'renderLabel',
			},
			{
			    text: gettext('Inventory'),
			    dataIndex: 'is-labeled',
			    renderer: 'renderIsLabeled',
			    flex: 1,
			},
			{
			    text: gettext('Actions'),
			    xtype: 'actioncolumn',
			    width: 100,
			    items: [
				{
				    iconCls: 'fa fa-rotate-90 fa-exchange',
				    handler: 'slotTransfer',
				    tooltip: gettext('Transfer'),
				    isActionDisabled: (v, r, c, i, rec) => rec.data['is-empty'],
				},
				{
				    iconCls: 'fa fa-trash-o',
				    handler: 'format',
				    tooltip: gettext('Format'),
				    isActionDisabled: (v, r, c, i, rec) => rec.data['is-empty'],
				},
				{
				    iconCls: 'fa fa-rotate-90 fa-upload',
				    handler: 'load',
				    tooltip: gettext('Load'),
				    isActionDisabled: (v, r, c, i, rec) => rec.data['is-empty'],
				},
			    ],
			},
		    ],
		},
		{
		    xtype: 'container',
		    flex: 2,
		    defaults: {
			padding: 5,
		    },
		    layout: {
			type: 'vbox',
			align: 'stretch',
		    },
		    items: [
			{
			    xtype: 'grid',
			    reference: 'drives',
			    scrollable: true,
			    maxHeight: 350, // ~10 drives
			    title: gettext('Drives'),
			    store: {
				type: 'diff',
				rstore: {
				    type: 'store',
				    model: 'pbs-slot-model',
				},
				data: [],
			    },
			    tbar: [
				{
				    text: gettext('Label Media'),
				    xtype: 'proxmoxButton',
				    handler: 'labelMedia',
				    iconCls: 'fa fa-barcode',
				    disabled: true,
				    enableFn: (rec) => !rec.data["is-empty"],
				},
				{
				    text: gettext('Catalog'),
				    xtype: 'proxmoxButton',
				    handler: 'catalog',
				    iconCls: 'fa fa-book',
				    disabled: true,
				    enableFn: (rec) => !rec.data["is-empty"],
				},
				{
				    text: gettext('Format'),
				    xtype: 'proxmoxButton',
				    handler: 'format-inserted',
				    iconCls: 'fa fa-trash-o',
				    disabled: true,
				    enableFn: (rec) => !rec.data["is-empty"],
				    dangerous: true,
				    confirmMsg: gettext('Are you sure you want to format the inserted tape?'),
				},
				'-',
				{
				    text: gettext('Clean Drive'),
				    xtype: 'proxmoxButton',
				    handler: 'cleanDrive',
				    iconCls: 'fa fa-shower',
				    disabled: true,
				},
			    ],
			    columns: [
				{
				    text: gettext('ID'),
				    dataIndex: 'entry-id',
				    hidden: true,
				    width: 50,
				},
				{
				    text: gettext("Content"),
				    dataIndex: 'label-text',
				    flex: 1,
				    renderer: 'renderLabel',
				},
				{
				    text: gettext('Inventory'),
				    dataIndex: 'is-labeled',
				    renderer: 'renderIsLabeled',
				    flex: 1.5,
				},
				{
				    text: gettext("Name"),
				    sortable: true,
				    dataIndex: 'name',
				    flex: 1,
				    renderer: Ext.htmlEncode,
				},
				{
				    text: gettext('Activity'),
				    dataIndex: 'activity',
				    renderer: PBS.Utils.renderDriveActivity,
				    hidden: true,
				    flex: 1,
				},
				{
				    text: gettext('State'),
				    dataIndex: 'state',
				    flex: 3,
				    renderer: PBS.Utils.renderDriveState,
				},
				{
				    text: gettext("Vendor"),
				    sortable: true,
				    dataIndex: 'vendor',
				    hidden: true,
				    flex: 1,
				    renderer: Ext.htmlEncode,
				},
				{
				    text: gettext("Model"),
				    sortable: true,
				    dataIndex: 'model',
				    hidden: true,
				    flex: 1,
				    renderer: Ext.htmlEncode,
				},
				{
				    text: gettext("Serial"),
				    sortable: true,
				    dataIndex: 'serial',
				    hidden: true,
				    flex: 1,
				    renderer: Ext.htmlEncode,
				},
				{
				    xtype: 'actioncolumn',
				    text: gettext('Actions'),
				    width: 140,
				    items: [
					{
					    iconCls: 'fa fa-rotate-270 fa-upload',
					    handler: 'unload',
					    tooltip: gettext('Unload'),
					    isActionDisabled: (v, r, c, i, rec) => rec.data['is-empty'] || rec.data['is-blocked'],
					},
					{
					    iconCls: 'fa fa-hdd-o',
					    handler: 'cartridgeMemory',
					    tooltip: gettext('Cartridge Memory'),
					    isActionDisabled: (v, r, c, i, rec) => rec.data['is-empty'] || rec.data['is-blocked'],
					},
					{
					    iconCls: 'fa fa-line-chart',
					    handler: 'volumeStatistics',
					    tooltip: gettext('Volume Statistics'),
					    isActionDisabled: (v, r, c, i, rec) => rec.data['is-empty'] || rec.data['is-blocked'],
					},
					{
					    iconCls: 'fa fa-tag',
					    handler: 'readLabel',
					    tooltip: gettext('Read Label'),
					    isActionDisabled: (v, r, c, i, rec) => rec.data['is-empty'] || rec.data['is-blocked'],
					},
					{
					    iconCls: 'fa fa-info-circle',
					    tooltip: gettext('Status'),
					    handler: 'status',
					    isActionDisabled: (v, r, c, i, rec) => rec.data['is-blocked'],
					},
				    ],
				},
			    ],
			},
			{
			    xtype: 'grid',
			    reference: 'import_export',
			    flex: 1,
			    srollable: true,
			    store: {
				type: 'diff',
				rstore: {
				    type: 'store',
				    model: 'pbs-slot-model',
				},
				data: [],
			    },
			    title: gettext('Import-Export Slots'),
			    columns: [
				{
				    text: gettext('ID'),
				    dataIndex: 'entry-id',
				    width: 50,
				},
				{
				    text: gettext("Content"),
				    dataIndex: 'label-text',
				    renderer: 'renderLabel',
				    flex: 1,
				},
				{
				    text: gettext('Inventory'),
				    dataIndex: 'is-labeled',
				    renderer: 'renderIsLabeled',
				    flex: 1,
				},
				{
				    text: gettext('Actions'),
				    xtype: 'actioncolumn',
				    items: [
					{
					    iconCls: 'fa fa-rotate-270 fa-upload',
					    handler: 'importTape',
					    tooltip: gettext('Import'),
					    isActionDisabled: (v, r, c, i, rec) => rec.data['is-empty'],
					},
				    ],
				    width: 80,
				},
			    ],
			},
		    ],
		},
	    ],
	},
    ],
});
Ext.define('pbs-model-drives', {
    extend: 'Ext.data.Model',
    fields: [
	'path', 'model', 'name', 'serial', 'vendor',
	{ name: 'changer', defaultValue: '' },
	{
	    name: 'changer-drivenum',
	    defaultValue: 0,
	},
	'changer-slot',
    ],
    idProperty: 'name',
});

Ext.define('PBS.TapeManagement.DrivePanel', {
    extend: 'Ext.grid.Panel',
    alias: 'widget.pbsTapeDrivePanel',

    controller: {
	xclass: 'Ext.app.ViewController',

	reloadTapeStore: function() {
	    let navtree = Ext.ComponentQuery.query('navigationtree')[0];
	    navtree.reloadTapeStore();
	},

	onAdd: function() {
	    let me = this;
	    Ext.create('PBS.TapeManagement.DriveEditWindow', {
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
	    }).show();
	},

	onEdit: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (!selection || selection.length < 1) {
		return;
	    }
	    Ext.create('PBS.TapeManagement.DriveEditWindow', {
		driveid: selection[0].data.name,
		autoLoad: true,
		listeners: {
		    destroy: () => me.reload(),
		},
	    }).show();
	},

	status: function(view, rI, cI, button, el, record) {
	    let me = this;
	    let drive = record.data.name;
	    PBS.Utils.driveCommand(drive, 'status', {
		waitMsgTarget: me.getView(),
		success: PBS.Utils.showDriveStatusWindow,
	    });
	},

	reload: function() {
	    this.getView().getStore().rstore.load();
	    this.reloadTapeStore();
	},

	stopStore: function() {
	    this.getView().getStore().rstore.stopUpdate();
	},

	startStore: function() {
	    this.getView().getStore().rstore.startUpdate();
	},

	init: function(view) {
	    Proxmox.Utils.monStoreErrors(view, view.getStore().rstore);
	},
    },

    listeners: {
	beforedestroy: 'stopStore',
	deactivate: 'stopStore',
	activate: 'startStore',
	itemdblclick: 'onEdit',
    },

    store: {
	type: 'diff',
	rstore: {
	    type: 'update',
	    storeid: 'proxmox-tape-drives',
	    model: 'pbs-model-drives',
	    proxy: {
		type: 'proxmox',
		url: "/api2/json/tape/drive",
	    },
	},
	sorters: 'name',
	groupField: 'changer',
    },

    features: [
	{
	    ftype: 'grouping',
	    groupHeaderTpl: [
		'{name:this.formatName} ({rows.length} Item{[values.rows.length > 1 ? "s" : ""]})',
		{
		    formatName: function(changer) {
			if (changer === "") {
			    return "Standalone Drives";
			} else {
			    return `Changer ${changer}`;
			}
		    },
		},
	    ],
	},
    ],

    tbar: [
	{
	    text: gettext('Add'),
	    xtype: 'proxmoxButton',
	    handler: 'onAdd',
	    selModel: false,
	},
	'-',
	{
	    text: gettext('Edit'),
	    xtype: 'proxmoxButton',
	    handler: 'onEdit',
	    disabled: true,
	},
	{
	    xtype: 'proxmoxStdRemoveButton',
	    baseurl: '/api2/extjs/config/drive',
	    callback: 'reload',
	},
    ],
    columns: [
	{
	    text: gettext('Name'),
	    dataIndex: 'name',
	    flex: 1,
	},
	{
	    text: gettext('Path'),
	    dataIndex: 'path',
	    flex: 2,
	},
	{
	    text: gettext('Vendor'),
	    dataIndex: 'vendor',
	    flex: 1,
	},
	{
	    text: gettext('Model'),
	    dataIndex: 'model',
	    flex: 1,
	},
	{
	    text: gettext('Serial'),
	    dataIndex: 'serial',
	    flex: 1,
	},
	{
	    text: gettext('Drive Number'),
	    dataIndex: 'changer-drivenum',
	    renderer: function(value, mD, record) {
		return record.data.changer ? value : '';
	    },
	},
    ],
});

Ext.define('PBS.TapeManagement.DriveStatus', {
    extend: 'Ext.panel.Panel',
    alias: 'widget.pbsDriveStatus',
    mixins: ['Proxmox.Mixin.CBind'],

    tools: [PBS.Utils.get_help_tool("tape_backup")],

    cbindData: function(config) {
	let me = this;
	me.setTitle(`${gettext('Drive')}: ${me.drive}`);
	let baseurl = `/api2/json/tape/drive/${me.drive}/`;
	return {
	    driveStatusUrl: `${baseurl}/status`,
	    cartridgeMemoryUrl: `${baseurl}/cartridge-memory`,
	};
    },

    layout: {
	type: 'vbox',
	align: 'stretch',
    },

    bodyPadding: 5,

    viewModel: {
	data: {
	    online: false,
	    busy: true,
	    loaded: false,
	},
    },

    controller: {
	xclass: 'Ext.app.ViewController',

	reloadTapeStore: function() {
	    Ext.ComponentQuery.query('navigationtree')[0].reloadTapeStore();
	},

	reload: function() {
	    let me = this;
	    me.lookup('statusgrid').rstore.load();
	},

	onLoad: function() {
	    let me = this;
	    let statusgrid = me.lookup('statusgrid');
	    let online = statusgrid.getObjectValue('file-number') !== undefined || statusgrid.getObjectValue('manufactured');
	    let vm = me.getViewModel();
	    vm.set('online', online);
	    let title = online ? gettext('Status') : gettext('Status (No Tape loaded)');
	    statusgrid.setTitle(title);
	    Ext.ComponentQuery.query('navigationtree')[0].reloadTapeStore();
	},

	onStateLoad: function(store) {
	    let me = this;
	    let view = me.getView();
	    let vm = me.getViewModel();
	    let driveRecord = store.findRecord('name', view.drive, 0, false, true, true);
	    let busy = !!driveRecord.data.state;
	    vm.set('busy', busy);
	    let statusgrid = me.lookup('statusgrid');
	    if (!vm.get('loaded')) {
		if (busy) {
		    // have to use a timeout so that the component can be rendered first
		    // otherwise the 'mask' call errors out
		    setTimeout(function() {
			statusgrid.mask(gettext('Drive is busy'));
		    }, 10);
		} else {
		    // have to use a timeout so that the component can be rendered first
		    // otherwise the 'mask' call errors out
		    setTimeout(function() {
			statusgrid.unmask();
		    }, 10);
		    me.reload();
		    vm.set('loaded', true);
		}
	    }
	},

	labelMedia: function() {
	    let me = this;
	    Ext.create('PBS.TapeManagement.LabelMediaWindow', {
		driveid: me.getView().drive,
		apiCallDone: function(success) {
		    if (success) {
			me.reloadTapeStore();
		    }
		},
	    }).show();
	},

	format: function() {
	    let me = this;
	    let view = me.getView();
	    let driveid = view.drive;
	    PBS.Utils.driveCommand(driveid, 'format-media', {
		waitMsgTarget: view,
		method: 'POST',
		success: function(response) {
		    me.reloadTapeStore();
		    Ext.create('Proxmox.window.TaskProgress', {
			upid: response.result.data,
			taskDone: function() {
			    me.reload();
			},
		    }).show();
		},
	    });
	},

	ejectMedia: function() {
	    let me = this;
	    let view = me.getView();
	    let driveid = view.drive;
	    PBS.Utils.driveCommand(driveid, 'eject-media', {
		waitMsgTarget: view,
		method: 'POST',
		success: function(response) {
		    me.reloadTapeStore();
		    Ext.create('Proxmox.window.TaskProgress', {
			upid: response.result.data,
			taskDone: function() {
			    me.reload();
			},
		    }).show();
		},
	    });
	},

	catalog: function() {
	    let me = this;
	    let view = me.getView();
	    let drive = view.drive;
	    PBS.Utils.driveCommand(drive, 'catalog', {
		waitMsgTarget: view,
		method: 'POST',
		success: function(response) {
		    me.reloadTapeStore();
		    Ext.create('Proxmox.window.TaskViewer', {
			upid: response.result.data,
			taskDone: function() {
			    me.reload();
			},
		    }).show();
		},
	    });
	},

	readLabel: function() {
	    let me = this;
	    let view = me.getView();
	    let drive = view.drive;

	    PBS.Utils.driveCommand(drive, 'read-label', {
		waitMsgTarget: view,
		success: function(response) {
		    me.reloadTapeStore();
		    PBS.Utils.showMediaLabelWindow(response);
		},
	    });
	},

	volumeStatistics: function() {
	    let me = this;
	    let view = me.getView();
	    let drive = view.drive;
	    PBS.Utils.driveCommand(drive, 'volume-statistics', {
		waitMsgTarget: view,
		success: function(response) {
		    me.reloadTapeStore();
		    PBS.Utils.showVolumeStatisticsWindow(response);
		},
	    });
	},

	cartridgeMemory: function() {
	    let me = this;
	    let view = me.getView();
	    let drive = view.drive;
	    PBS.Utils.driveCommand(drive, 'cartridge-memory', {
		waitMsgTarget: me.getView(),
		success: function(response) {
		    me.reloadTapeStore();
		    PBS.Utils.showCartridgeMemoryWindow(response);
		},
	    });
	},

	init: function(view) {
	    let me = this;
	    me.mon(me.lookup('statusgrid').getStore().rstore, 'load', 'onLoad');
	    let tapeStore = Ext.ComponentQuery.query('navigationtree')[0].tapeStore;
	    me.mon(tapeStore, 'load', 'onStateLoad');
	    if (tapeStore.isLoaded()) {
		me.onStateLoad(tapeStore);
	    }
	},
    },

    tbar: [
	{
	    xtype: 'proxmoxButton',
	    handler: 'reload',
	    text: gettext('Reload'),
	    disabled: true,
	    bind: {
		disabled: '{busy}',
	    },
	},
	'-',
	{
	    text: gettext('Label Media'),
	    xtype: 'proxmoxButton',
	    handler: 'labelMedia',
	    iconCls: 'fa fa-barcode',
	    disabled: true,
	    bind: {
		disabled: '{!online}',
	    },
	},
	{
	    text: gettext('Eject'),
	    xtype: 'proxmoxButton',
	    handler: 'ejectMedia',
	    iconCls: 'fa fa-eject',
	    disabled: true,
	    bind: {
		disabled: '{!online}',
	    },
	},
	{
	    text: gettext('Format'),
	    xtype: 'proxmoxButton',
	    handler: 'format',
	    iconCls: 'fa fa-trash-o',
	    dangerous: true,
	    confirmMsg: gettext('Are you sure you want to format the inserted tape?'),
	    disabled: true,
	    bind: {
		disabled: '{!online}',
	    },
	},
	{
	    text: gettext('Catalog'),
	    xtype: 'proxmoxButton',
	    handler: 'catalog',
	    iconCls: 'fa fa-book',
	    disabled: true,
	    bind: {
		disabled: '{!online}',
	    },
	},
	{
	    text: gettext('Read Label'),
	    xtype: 'proxmoxButton',
	    handler: 'readLabel',
	    iconCls: 'fa fa-tag',
	    disabled: true,
	    bind: {
		disabled: '{!online}',
	    },
	},
	{
	    text: gettext('Volume Statistics'),
	    xtype: 'proxmoxButton',
	    handler: 'volumeStatistics',
	    iconCls: 'fa fa-line-chart',
	    disabled: true,
	    bind: {
		disabled: '{!online}',
	    },
	},
	{
	    text: gettext('Cartridge Memory'),
	    xtype: 'proxmoxButton',
	    iconCls: 'fa fa-hdd-o',
	    handler: 'cartridgeMemory',
	    disabled: true,
	    bind: {
		disabled: '{!online}',
	    },
	},

    ],

    items: [
	{
	    xtype: 'container',
	    layout: {
		type: 'hbox',
		align: 'stretch',
	    },
	    defaults: {
		padding: 5,
		flex: 1,
	    },
	    items: [
		{
		    xtype: 'pbsDriveInfoPanel',
		    cbind: {
			drive: '{drive}',
		    },
		},
		{
		    xtype: 'pbsDriveStatusGrid',
		    reference: 'statusgrid',
		    cbind: {
			url: '{driveStatusUrl}',
		    },
		},
	    ],
	},
    ],
});

Ext.define('PBS.TapeManagement.DriveStatusGrid', {
    extend: 'Proxmox.grid.ObjectGrid',
    alias: 'widget.pbsDriveStatusGrid',

    title: gettext('Status'),

    rows: {
	'density': {
	    required: true,
	    header: gettext('Tape Density'),
	},
	'blocksize': {
	    required: true,
	    header: gettext('Block Size'),
	    renderer: function(value) {
		if (!value) {
		    return gettext('Dynamic');
		}
		return `${gettext('Fixed')} - ${Proxmox.Utils.format_size(value)}`;
	    },
	},
	'write-protect': {
	    required: true,
	    header: gettext('Write Protect'),
	    defaultValue: false,
	    renderer: Proxmox.Utils.format_boolean,
	},
	'compression': {
	    required: true,
	    header: gettext('Compression'),
	    renderer: Proxmox.Utils.format_boolean,
	},
	'drive-activity': {
	    header: gettext('Drive Activity'),
	    renderer: PBS.Utils.renderDriveActivity,
	},
	'file-number': {
	    header: gettext('Tape Position'),
	    renderer: function(value, mD, r, rI, cI, store) {
		let me = this;
		let filenr = value;
		let rec = store.getById('block-number');
		if (rec) {
		    let blocknr = rec.data.value;
		    return `File ${filenr}, Block ${blocknr}`;
		}
		return `File ${filenr}`;
	    },
	},
	'block-number': {
	    visible: false,
	},
	'manufactured': {
	    header: gettext('Tape Manufacture Date'),
	    renderer: function(value) {
		if (value) {
		    return Ext.Date.format(new Date(value*1000), "Y-m-d");
		}
		return "";
	    },
	},
	'bytes-read': {
	    header: gettext('Tape Read'),
	    renderer: Proxmox.Utils.format_size,
	},
	'bytes-written': {
	    header: gettext('Tape Written'),
	    renderer: Proxmox.Utils.format_size,
	},
	'medium-passes': {
	    header: gettext('Tape Passes'),
	},
	'medium-wearout': {
	    header: gettext('Tape Wearout'),
	    renderer: function(value) {
		if (value !== undefined) {
		    return (value*100).toFixed(2) + "%";
		}
		return value;
	    },
	},
	'alert-flags': {
	    header: gettext('Alert Flags'),
	},
    },
});

Ext.define('PBS.TapeManagement.DriveInfoPanel', {
    extend: 'Ext.panel.Panel',
    alias: 'widget.pbsDriveInfoPanel',

    title: gettext('Information'),

    defaults: {
	printBar: false,
	padding: 5,
    },
    bodyPadding: 15,

    viewModel: {
	data: {
	    drive: {},
	},

	formulas: {
	    driveState: function(get) {
		let drive = get('drive');
		return PBS.Utils.renderDriveState(drive.state, {});
	    },
	},
    },

    items: [
	{
	    xtype: 'pmxInfoWidget',
	    title: gettext('Name'),
	    bind: {
		data: {
		    text: '{drive.name}',
		},
	    },
	},
	{
	    xtype: 'pmxInfoWidget',
	    title: gettext('Vendor'),
	    bind: {
		data: {
		    text: '{drive.vendor}',
		},
	    },
	},
	{
	    xtype: 'pmxInfoWidget',
	    title: gettext('Model'),
	    bind: {
		data: {
		    text: '{drive.model}',
		},
	    },
	},
	{
	    xtype: 'pmxInfoWidget',
	    title: gettext('Serial'),
	    bind: {
		data: {
		    text: '{drive.serial}',
		},
	    },
	},
	{
	    xtype: 'pmxInfoWidget',
	    title: gettext('Path'),
	    bind: {
		data: {
		    text: '{drive.path}',
		},
	    },
	},
	{
	    xtype: 'pmxInfoWidget',
	    reference: 'statewidget',
	    title: gettext('State'),
	    bind: {
		data: {
		    text: '{driveState}',
		},
	    },
	},
    ],

    clickState: function(e, t, eOpts) {
	let me = this;
	let vm = me.getViewModel();
	let drive = vm.get('drive');
	if (t.classList.contains('right-aligned')) {
	    let upid = drive.state;
	    if (!upid || !upid.startsWith("UPID")) {
		return;
	    }

	    Ext.create('Proxmox.window.TaskViewer', {
		autoShow: true,
		upid,
	    });
	}
    },

    updateData: function(store) {
	let me = this;
	if (!store) {
	    return;
	}
	let record = store.findRecord('name', me.drive, 0, false, true, true);
	if (!record) {
	    return;
	}

	let vm = me.getViewModel();
	vm.set('drive', record.data);
	vm.notify();
	me.updatePointer();
    },

    updatePointer: function() {
	let me = this;
	let stateWidget = me.down('pmxInfoWidget[reference=statewidget]');
	let stateEl = stateWidget.getEl();
	if (!stateEl) {
	    setTimeout(function() {
		me.updatePointer();
	    }, 100);
	    return;
	}

	let vm = me.getViewModel();
	let drive = vm.get('drive');

	if (drive.state) {
	    stateEl.addCls('info-pointer');
	} else {
	    stateEl.removeCls('info-pointer');
	}
    },

    listeners: {
	afterrender: function() {
	    let me = this;
	    let stateWidget = me.down('pmxInfoWidget[reference=statewidget]');
	    let stateEl = stateWidget.getEl();
	    stateEl.on('click', me.clickState, me);
	},
    },

    initComponent: function() {
	let me = this;
	if (!me.drive) {
	    throw "no drive given";
	}

	me.callParent();

	let tapeStore = Ext.ComponentQuery.query('navigationtree')[0].tapeStore;
	me.mon(tapeStore, 'load', me.updateData, me);
	if (tapeStore.isLoaded()) {
	    me.updateData(tapeStore);
	}
    },
});
Ext.define('pbs-tape-encryption-keys', {
    extend: 'Ext.data.Model',
    fields: [
	'fingerprint', 'hint', 'kdf', 'modified',
	{
	    name: 'created',
	    type: 'date',
	    dateFormat: 'timestamp',
	},
    ],
    idProperty: 'fingerprint',
});

Ext.define('PBS.TapeManagement.EncryptionPanel', {
    extend: 'Ext.grid.Panel',
    alias: 'widget.pbsEncryptionKeys',

    controller: {
	xclass: 'Ext.app.ViewController',

	onAdd: function() {
	    let me = this;
	    Ext.create('PBS.TapeManagement.EncryptionEditWindow', {
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
	    }).show();
	},

	onRestoreKey: function() {
	    Ext.create('Proxmox.window.Edit', {
		title: gettext('Restore Key'),
		isCreate: true,
		submitText: gettext('Restore'),
		method: 'POST',
		url: `/api2/extjs/tape/drive`,
		submitUrl: function(url, values) {
		    let drive = values.drive;
		    delete values.drive;
		    return `${url}/${drive}/restore-key`;
		},
		items: [
		    {
			xtype: 'pbsDriveSelector',
			fieldLabel: gettext('Drive'),
			name: 'drive',
		    },
		    {
			xtype: 'textfield',
			inputType: 'password',
			fieldLabel: gettext('Password'),
			name: 'password',
		    },
		],
	    }).show();
	},

	reload: function() {
	    this.getView().getStore().rstore.load();
	},

	stopStore: function() {
	    this.getView().getStore().rstore.stopUpdate();
	},

	startStore: function() {
	    this.getView().getStore().rstore.startUpdate();
	},

	init: function(view) {
	    Proxmox.Utils.monStoreErrors(view, view.getStore().rstore);
	},
    },

    listeners: {
	beforedestroy: 'stopStore',
	deactivate: 'stopStore',
	activate: 'startStore',
    },

    store: {
	type: 'diff',
	rstore: {
	    type: 'update',
	    storeid: 'proxmox-tape-encryption-keys',
	    model: 'pbs-tape-encryption-keys',
	    proxy: {
		type: 'proxmox',
		url: "/api2/json/config/tape-encryption-keys",
	    },
	},
	sorters: 'hint',
    },

    tbar: [
	{
	    text: gettext('Add'),
	    xtype: 'proxmoxButton',
	    handler: 'onAdd',
	    selModel: false,
	},
	'-',
	{
	    xtype: 'proxmoxStdRemoveButton',
	    baseurl: '/api2/extjs/config/tape-encryption-keys',
	    callback: 'reload',
	},
	'-',
	{
	    text: gettext('Restore Key'),
	    xtype: 'proxmoxButton',
	    handler: 'onRestoreKey',
	    selModel: false,
	},
    ],
    columns: [
	{
	    text: gettext('Hint'),
	    dataIndex: 'hint',
	    flex: 1,
	},
	{
	    text: gettext('Fingerprint'),
	    dataIndex: 'fingerprint',
	    flex: 4,
	},
	{
	    text: gettext('Created'),
	    xtype: 'datecolumn',
	    dataIndex: 'created',
	    width: 150,
	    format: 'Y-m-d H:i:s',
	},
    ],
});
Ext.define('pbs-model-media-pool', {
    extend: 'Ext.data.Model',
    fields: [
	'name', 'allocation', 'retention', 'template', 'encrypt', 'comment',
	{
	    name: 'encryption',
	    type: 'bool',
	    calculate: function(data) {
		return !!data.encrypt;
	    },
	},
    ],
    idProperty: 'name',
});

Ext.define('PBS.TapeManagement.PoolPanel', {
    extend: 'Ext.grid.Panel',
    alias: 'widget.pbsMediaPoolPanel',

    controller: {
	xclass: 'Ext.app.ViewController',

	onAdd: function() {
	    let me = this;
	    Ext.create('PBS.TapeManagement.PoolEditWindow', {
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
	    }).show();
	},

	onEdit: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (!selection || selection.length < 1) {
		return;
	    }
	    Ext.create('PBS.TapeManagement.PoolEditWindow', {
		poolid: selection[0].data.name,
		autoLoad: true,
		listeners: {
		    destroy: () => me.reload(),
		},
	    }).show();
	},

	reload: function() {
	    this.getView().getStore().rstore.load();
	},

	stopStore: function() {
	    this.getView().getStore().rstore.stopUpdate();
	},

	startStore: function() {
	    this.getView().getStore().rstore.startUpdate();
	},

	init: function(view) {
	    Proxmox.Utils.monStoreErrors(view, view.getStore().rstore);
	},
    },

    listeners: {
	beforedestroy: 'stopStore',
	deactivate: 'stopStore',
	activate: 'startStore',
	itemdblclick: 'onEdit',
    },

    store: {
	type: 'diff',
	rstore: {
	    type: 'update',
	    storeid: 'proxmox-tape-media-pools',
	    model: 'pbs-model-media-pool',
	    proxy: {
		type: 'proxmox',
		url: "/api2/json/config/media-pool",
	    },
	},
	sorters: 'name',
    },

    tbar: [
	{
	    text: gettext('Add'),
	    xtype: 'proxmoxButton',
	    handler: 'onAdd',
	    selModel: false,
	},
	'-',
	{
	    text: gettext('Edit'),
	    xtype: 'proxmoxButton',
	    handler: 'onEdit',
	    disabled: true,
	},
	{
	    xtype: 'proxmoxStdRemoveButton',
	    baseurl: '/api2/extjs/config/media-pool',
	    callback: 'reload',
	},
    ],

    columns: [
	{
	    text: gettext('Name'),
	    dataIndex: 'name',
	    flex: 1,
	},
	{
	    text: gettext('Allocation Policy'),
	    dataIndex: 'allocation',
	},
	{
	    text: gettext('Retention Policy'),
	    dataIndex: 'retention',
	},
	{
	    text: gettext('Encryption'),
	    dataIndex: 'encryption',
	    renderer: Proxmox.Utils.format_boolean,
	},
	{
	    text: gettext('Encryption Fingerprint'),
	    dataIndex: 'encrypt',
	    hidden: true,
	    flex: 3,
	},
	{
	    text: gettext('Comment'),
	    dataIndex: 'comment',
	    flex: 3,
	},
    ],
});
Ext.define('pbs-model-tapes', {
    extend: 'Ext.data.Model',
    fields: [
	{ name: 'catalog', type: 'boolean' },
	'ctime',
	{ name: 'expired', type: 'boolean' },
	'label-text',
	'location',
	'media-set-ctime',
	'media-set-name',
	'media-set-uuid',
	{
	    name: 'pool',
	    defaultValue: '',
	},
	'seq-nr',
	'status',
	'uuid',
	'bytes-used',
    ],
    idProperty: 'uuid',
    proxy: {
	type: 'proxmox',
	url: '/api2/json/tape/media/list',
	timeout: 5*60*1000,
    },
});

Ext.define('PBS.TapeManagement.TapeInventory', {
    extend: 'Ext.grid.Panel',
    alias: 'widget.pbsTapeInventory',

    controller: {
	xclass: 'Ext.app.ViewController',

	addTape: function() {
	    Ext.create('PBS.TapeManagement.LabelMediaWindow').show();
	},

	format: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (!selection || selection.length < 1) {
		return;
	    }
	    let label = selection[0].data['label-text'];
	    let inChanger = selection[0].data.location.startsWith('online-');
	    let changer;
	    if (inChanger) {
		changer = selection[0].data.location.slice("online-".length);
	    }
	    Ext.create('PBS.TapeManagement.EraseWindow', {
		label,
		changer,
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
	    }).show();
	},

	remove: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (!selection || selection.length < 1) {
		return;
	    }
	    let uuid = selection[0].data.uuid;
	    let label = selection[0].data['label-text'];
	    Ext.create('PBS.TapeManagement.MediaRemoveWindow', {
		uuid,
		label,
		autoShow: true,
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
	    });
	},

	moveToVault: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (!selection || selection.length < 1) {
		return;
	    }
	    let label = selection[0].data['label-text'];
	    let inVault = selection[0].data.location.startsWith('vault-');
	    let vault = "";
	    if (inVault) {
		vault = selection[0].data.location.slice("vault-".length);
	    }
	    Ext.create('Proxmox.window.Edit', {
		title: gettext('Set Media Location'),
		url: `/api2/extjs/tape/media/move`,
		method: 'POST',
		items: [
		    {
			xtype: 'displayfield',
			name: 'label-text',
			value: label,
			submitValue: true,
			fieldLabel: gettext('Media'),
		    },
		    {
			xtype: 'proxmoxtextfield',
			fieldLabel: gettext('Vault'),
			name: 'vault-name',
			value: vault,
			emptyText: gettext('On-site'),
			skipEmpty: true,
		    },
		],
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
	    }).show();
	},

	setStatus: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (!selection || selection.length < 1) {
		return;
	    }
	    let data = selection[0].data;

	    let uuid = data.uuid;
	    let label = data['label-text'];
	    let status = data.status;

	    Ext.create('Proxmox.window.Edit', {
		title: gettext('Set Media Status'),
		url: `/api2/extjs/tape/media/list/${uuid}/status`,
		method: 'POST',
		items: [
		    {
			xtype: 'displayfield',
			name: 'label-text',
			value: label,
			fieldLabel: gettext('Media'),
		    },
		    {
			xtype: 'proxmoxKVComboBox',
			fieldLabel: gettext('Status'),
			name: 'status',
			value: status,
			emptyText: gettext('Clear Status'),
			comboItems: [
			    ['__default__', gettext('Clear Status')],
			    ['full', gettext('Full')],
			    ['damaged', gettext('Damaged')],
			    ['retired', gettext('Retired')],
			],
			deleteEmpty: false,
		    },
		],
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
	    }).show();
	},

	reload: function() {
	    this.getView().getStore().load({
		params: { 'update-status': false },
	    });
	},

	reload_update_status: function() {
	    this.getView().getStore().load({
		params: { 'update-status': true },
	    });
	},

	init: function(view) {
	    Proxmox.Utils.monStoreErrors(view, view.getStore());
	},
    },

    listeners: {
	activate: 'reload',
    },

    store: {
	storeid: 'proxmox-tape-tapes',
	model: 'pbs-model-tapes',
	sorters: 'label-text',
	groupField: 'pool',
    },

    tbar: [
	{
	    text: gettext('Reload'),
	    handler: 'reload_update_status',
	},
	'-',
	{
	    text: gettext('Add Tape'),
	    handler: 'addTape',
	},
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Set Location'),
	    disabled: true,
	    handler: 'moveToVault',
	    enableFn: (rec) => !rec.data.location.startsWith('online-'),
	},
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Set Status'),
	    disabled: true,
	    handler: 'setStatus',
	},
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Format'),
	    disabled: true,
	    handler: 'format',
	},
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Remove'),
	    disabled: true,
	    handler: 'remove',
	},
    ],

    features: [
	{
	    ftype: 'grouping',
	    groupHeaderTpl: [
		'{name:this.formatName} ({rows.length} Item{[values.rows.length > 1 ? "s" : ""]})',
		{
		    formatName: function(pool) {
			if (pool === "") {
			    return "Free (no pool assignment)";
			} else {
			    return pool;
			}
		    },
		},
	    ],
	},
    ],

    viewConfig: {
	stripeRows: false, // does not work with getRowClass()

	getRowClass: function(record, index) {
	    let status = record.get('status');
	    if (status === 'damaged') {
		return "proxmox-invalid-row";
	    }
	    let catalog = record.get('catalog');
	    return catalog ? '' : "proxmox-warning-row";
	},
    },

    columns: [
	{
	    text: gettext('Label'),
	    dataIndex: 'label-text',
	    flex: 1,
	},
	{
	    text: gettext('Media-Set'),
	    dataIndex: 'media-set-name',
	    flex: 2,
	    sorter: function(a, b) {
		return (a.data['media-set-ctime'] || 0) - (b.data['media-set-ctime'] || 0);
	    },
	    renderer: function(value) {
		if (value === undefined) {
		    return "-- empty --";
		} else {
		    return value;
		}
	    },
	},
	{
	    text: gettext('Catalog'),
	    dataIndex: 'catalog',
	    renderer: function(value, metaData, record) {
		return value ? Proxmox.Utils.yesText : PBS.Utils.missingText;
	    },
	},
	{
	    text: gettext('Location'),
	    dataIndex: 'location',
	    flex: 1,
	    renderer: function(value) {
		if (value === 'offline') {
		    return `<i class="fa fa-circle-o"></i> ${gettext("Offline")} (${gettext('On-site')})`;
		} else if (value.startsWith('online-')) {
		    let location = value.substring(value.indexOf('-') + 1);
		    return `<i class="fa fa-dot-circle-o"></i> ${gettext("Online")} - ${location}`;
		} else if (value.startsWith('vault-')) {
		    let location = value.substring(value.indexOf('-') + 1);
		    return `<i class="fa fa-archive"></i> ${gettext("Vault")} - ${location}`;
		} else {
		    return value;
		}
	    },
	},
	{
	    text: gettext('Status'),
	    dataIndex: 'status',
	    renderer: function(value, mD, record) {
		return record.data.expired ? 'expired' : value;
	    },
	    flex: 1,
	},
	{
	    text: 'UUID',
	    dataIndex: 'uuid',
	    flex: 1,
	    hidden: true,
	},
	{
	    text: gettext("Bytes Used"),
	    dataIndex: 'bytes-used',
	    flex: 1,
	    renderer: Proxmox.Utils.render_size,
	},
    ],
});
Ext.define('pbs-tape-backup-job-status', {
    extend: 'Ext.data.Model',
    fields: [
	'id', 'store', 'pool', 'drive', 'store', 'schedule', 'comment', 'group-filter',
	{ name: 'eject-media', type: 'boolean' },
	{ name: 'export-media-set', type: 'boolean' },
	{ name: 'latest-only', type: 'boolean' },
	'next-run', 'next-media-label', 'last-run-upid', 'last-run-state', 'last-run-endtime',
	{
	    name: 'duration',
	    calculate: function(data) {
		let endtime = data['last-run-endtime'];
		if (!endtime) return undefined;
		let task = Proxmox.Utils.parse_task_upid(data['last-run-upid']);
		return endtime - task.starttime;
	    },
	},
    ],
    idProperty: 'id',
    proxy: {
	type: 'proxmox',
	url: '/api2/json/tape/backup',
    },
});

Ext.define('PBS.config.TapeBackupJobView', {
    extend: 'Ext.grid.GridPanel',
    alias: 'widget.pbsTapeBackupJobView',

    stateful: true,
    stateId: 'grid-tape-backup-jobs-v1',

    title: gettext('Tape Backup Jobs'),

    controller: {
	xclass: 'Ext.app.ViewController',

	addJob: function() {
	    let me = this;
	    Ext.create('PBS.TapeManagement.BackupJobEdit', {
		autoShow: true,
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
	    }).show();
	},

	editJob: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (!selection || selection.length < 1) {
		return;
	    }

	    Ext.create('PBS.TapeManagement.BackupJobEdit', {
		id: selection[0].data.id,
		autoShow: true,
		listeners: {
		    destroy: function() {
			me.reload();
		    },
		},
	    }).show();
	},

	openTaskLog: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (selection.length < 1) return;

	    let upid = selection[0].data['last-run-upid'];
	    if (!upid) return;

	    Ext.create('Proxmox.window.TaskViewer', {
		upid,
	    }).show();
	},

	runJob: function() {
	    let me = this;
	    let view = me.getView();
	    let selection = view.getSelection();
	    if (selection.length < 1) return;

	    let id = selection[0].data.id;
	    Proxmox.Utils.API2Request({
		method: 'POST',
		url: `/tape/backup/${id}`,
		success: function(response, opt) {
		    Ext.create('Proxmox.window.TaskViewer', {
		        upid: response.result.data,
		        taskDone: function(success) {
			    me.reload();
		        },
		    }).show();
		},
		failure: function(response, opt) {
		    Ext.Msg.alert(gettext('Error'), response.htmlStatus);
		},
	    });
	},

	startStore: function() { this.getView().getStore().rstore.startUpdate(); },

	stopStore: function() { this.getView().getStore().rstore.stopUpdate(); },

	reload: function() { this.getView().getStore().rstore.load(); },

	init: function(view) {
	    Proxmox.Utils.monStoreErrors(view, view.getStore().rstore);
	},
    },

    listeners: {
	activate: 'startStore',
	deactivate: 'stopStore',
	itemdblclick: 'editJob',
    },

    store: {
	type: 'diff',
	autoDestroy: true,
	autoDestroyRstore: true,
	sorters: 'id',
	rstore: {
	    type: 'update',
	    storeid: 'pbs-tape-backup-job-status',
	    model: 'pbs-tape-backup-job-status',
	    interval: 5000,
	},
    },

    viewConfig: {
	trackOver: false,
    },

    tbar: [
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Add'),
	    selModel: false,
	    handler: 'addJob',
	},
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Edit'),
	    handler: 'editJob',
	    disabled: true,
	},
	{
	    xtype: 'proxmoxStdRemoveButton',
	    baseurl: '/config/tape-backup-job/',
	    confirmMsg: gettext('Remove entry?'),
	    callback: 'reload',
	},
	'-',
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Show Log'),
	    handler: 'openTaskLog',
	    enableFn: (rec) => !!rec.data['last-run-upid'],
	    disabled: true,
	},
	{
	    xtype: 'proxmoxButton',
	    text: gettext('Run now'),
	    handler: 'runJob',
	    disabled: true,
	},
    ],

    columns: [
	{
	    header: gettext('Job ID'),
	    dataIndex: 'id',
	    renderer: Ext.String.htmlEncode,
	    maxWidth: 220,
	    minWidth: 75,
	    flex: 1,
	    sortable: true,
	},
	{
	    header: gettext('Datastore'),
	    dataIndex: 'store',
	    width: 120,
	    sortable: true,
	},
	{
	    header: gettext('Media Pool'),
	    dataIndex: 'pool',
	    width: 120,
	    sortable: true,
	},
	{
	    header: gettext('Drive'),
	    dataIndex: 'drive',
	    width: 120,
	    sortable: true,
	},
	{
	    header: gettext('Eject'),
	    dataIndex: 'eject-media',
	    renderer: Proxmox.Utils.format_boolean,
	    width: 60,
	    sortable: false,
	},
	{
	    header: gettext('Export'),
	    dataIndex: 'export-media-set',
	    renderer: Proxmox.Utils.format_boolean,
	    width: 60,
	    sortable: false,
	},
	{
	    header: gettext('Latest Only'),
	    dataIndex: 'latest-only',
	    renderer: Proxmox.Utils.format_boolean,
	    sortable: false,
	},
	{
	    header: gettext('Backup Groups'),
	    dataIndex: 'group-filter',
	    renderer: v => v ? Ext.String.htmlEncode(v) : gettext('All'),
	    width: 80,
	},
	{
	    header: gettext('Schedule'),
	    dataIndex: 'schedule',
	    maxWidth: 220,
	    minWidth: 80,
	    flex: 1,
	    sortable: true,
	},
	{
	    header: gettext('Last Backup'),
	    dataIndex: 'last-run-endtime',
	    renderer: PBS.Utils.render_optional_timestamp,
	    width: 150,
	    sortable: true,
	},
	{
	    text: gettext('Duration'),
	    dataIndex: 'duration',
	    renderer: Proxmox.Utils.render_duration,
	    width: 80,
	},
	{
	    header: gettext('Status'),
	    dataIndex: 'last-run-state',
	    renderer: PBS.Utils.render_task_status,
	    flex: 3,
	},
	{
	    header: gettext('Next Run'),
	    dataIndex: 'next-run',
	    renderer: PBS.Utils.render_next_task_run,
	    width: 150,
	    sortable: true,
	},
	{
	    header: gettext('Next Media'),
	    dataIndex: 'next-media-label',
	    width: 100,
	    sortable: true,
	},
	{
	    header: gettext('Comment'),
	    dataIndex: 'comment',
	    renderer: Ext.String.htmlEncode,
	    flex: 2,
	    sortable: true,
	},
    ],

    initComponent: function() {
	let me = this;

	me.callParent();
    },
});
Ext.define('PBS.TapeManagement', {
    extend: 'Ext.tab.Panel',
    alias: 'widget.pbsTapeManagement',

    title: gettext('Tape Backup'),

    tools: [PBS.Utils.get_help_tool("tape_backup")],

    border: true,
    defaults: {
	border: false,
	xtype: 'panel',
    },

    items: [
	{
	    xtype: 'pbsBackupOverview',
	    title: gettext('Content'),
	    itemId: 'content',
	    iconCls: 'fa fa-th',
	},
	{
	    xtype: 'pbsTapeInventory',
	    title: gettext('Inventory'),
	    itemId: 'inventory',
	    iconCls: 'fa fa-book',
	},
	{
	    xtype: 'pbsTapeChangerPanel',
	    title: gettext('Changers'),
	    itemId: 'changers',
	    iconCls: 'fa fa-exchange',
	},
	{
	    xtype: 'pbsTapeDrivePanel',
	    title: gettext('Drives'),
	    itemId: 'drives',
	    //iconCls: 'fa fa-download',
	    iconCls: 'pbs-icon-tape-drive',
	},
	{
	    title: gettext('Media Pools'),
	    itemId: 'pools',
	    xtype: 'pbsMediaPoolPanel',
	    iconCls: 'fa fa-object-group',
	},
	{
	    xtype: 'pbsEncryptionKeys',
	    title: gettext('Encryption Keys'),
	    itemId: 'encryption-keys',
	    iconCls: 'fa fa-key',
	},
	{
	    xtype: 'pbsTapeBackupJobView',
	    title: gettext('Backup Jobs'),
	    itemId: 'tape-backup-jobs',
	    iconCls: 'fa fa-floppy-o',
	},
    ],
});
Ext.define('pbs-datastore-list', {
    extend: 'Ext.data.Model',
    fields: ['name', 'comment', 'maintenance'],
    proxy: {
        type: 'proxmox',
        url: "/api2/json/admin/datastore",
    },
    idProperty: 'store',
});

Ext.define('pbs-tape-drive-list', {
    extend: 'Ext.data.Model',
    fields: ['name', 'changer'],
    proxy: {
        type: 'proxmox',
        url: "/api2/json/tape/drive",
    },
    idProperty: 'name',
});

Ext.define('PBS.store.NavigationStore', {
    extend: 'Ext.data.TreeStore',

    storeId: 'NavigationStore',

    root: {
	expanded: true,
	children: [
	    {
		text: gettext('Dashboard'),
		iconCls: 'fa fa-tachometer',
		path: 'pbsDashboard',
		leaf: true,
	    },
	    {
		text: gettext('Notes'),
		iconCls: 'fa fa-sticky-note-o',
		path: 'pbsNodeNotes',
		leaf: true,
	    },
	    {
		text: gettext('Configuration'),
		iconCls: 'fa fa-gears',
		path: 'pbsSystemConfiguration',
		expanded: true,
		children: [
		    {
			text: gettext('Access Control'),
			iconCls: 'fa fa-key',
			path: 'pbsAccessControlPanel',
			leaf: true,
		    },
		    {
			text: gettext('Remotes'),
			iconCls: 'fa fa-server',
			path: 'pbsRemoteView',
			leaf: true,
		    },
		    {
			text: gettext('Traffic Control'),
			iconCls: 'fa fa-signal fa-rotate-90',
			path: 'pbsTrafficControlView',
			leaf: true,
		    },
		    {
			text: gettext('Certificates'),
			iconCls: 'fa fa-certificate',
			path: 'pbsCertificateConfiguration',
			leaf: true,
		    },
		    {
			text: gettext('Notifications'),
			iconCls: 'fa fa-bell-o',
			path: 'pbsNotificationConfigView',
			leaf: true,
		    },
		    {
			text: gettext('Subscription'),
			iconCls: 'fa fa-support',
			path: 'pbsSubscription',
			leaf: true,
		    },
		],
	    },
	    {
		text: gettext('Administration'),
		iconCls: 'fa fa-wrench',
		path: 'pbsServerAdministration',
		expanded: true,
		leaf: false,
		children: [
		    {
			text: gettext('Shell'),
			iconCls: 'fa fa-terminal',
			path: 'pbsXtermJsConsole',
			leaf: true,
		    },
		    {
			text: gettext('Storage / Disks'),
			iconCls: 'fa fa-hdd-o',
			path: 'pbsStorageAndDiskPanel',
			leaf: true,
		    },
		],
	    },
	    {
		text: gettext('Tape Backup'),
		iconCls: 'pbs-icon-tape',
		id: 'tape_management',
		path: 'pbsTapeManagement',
		expanded: true,
		children: [],
	    },
	    {
		text: gettext('Datastore'),
		iconCls: 'fa fa-archive',
		id: 'datastores',
		path: 'pbsDataStores',
		expanded: true,
		expandable: false,
		leaf: false,
		children: [
		    {
			text: gettext('Add Datastore'),
			iconCls: 'fa fa-plus-circle',
			leaf: true,
			id: 'addbutton',
			virtualEntry: true,
		    },
		],
	    },
	],
    },
});

Ext.define('CustomTreeListItem', {
    extend: 'Ext.list.TreeItem',
    xtype: 'qtiptreelistitem',

    nodeUpdate: function(node, modifiedFieldNames) {
	this.callParent(arguments);
	const qtip = node ? node.get('qtip') : null;
	if (qtip) {
	    this.element.dom.setAttribute('data-qtip', qtip);
	} else {
	    this.element.dom.removeAttribute('data-qtip');
	}
    },
});

Ext.define('PBS.view.main.NavigationTree', {
    extend: 'Ext.list.Tree',
    xtype: 'navigationtree',

    animation: false,
    expanderOnly: true,
    expanderFirst: false,
    store: 'NavigationStore',
    ui: 'nav',

    defaults: {
	xtype: 'qtiptreelistitem',
    },

    controller: {
	xclass: 'Ext.app.ViewController',

	init: function(view) {
	    view.rstore = Ext.create('Proxmox.data.UpdateStore', {
		autoStart: true,
		interval: 15 * 1000,
		storeId: 'pbs-datastore-list', // NOTE: this is queried by selectors, avoid change!
		model: 'pbs-datastore-list',
	    });

	    view.rstore.on('load', this.onLoad, this);
	    view.on('destroy', view.rstore.stopUpdate);

	    if (view.tapeStore === undefined) {
		view.tapeStore = Ext.create('Proxmox.data.UpdateStore', {
		    autoStart: true,
		    interval: 60 * 1000,
		    storeid: 'pbs-tape-drive-list',
		    model: 'pbs-tape-drive-list',
		});
		view.tapeStore.on('load', this.onTapeDriveLoad, this);
		view.on('destroy', view.tapeStore.stopUpdate);
	    }
	},

	onTapeDriveLoad: function(store, records, success) {
	    if (!success) return;

	    let view = this.getView();
	    let root = view.getStore().getRoot();

	    records.sort((a, b) => a.data.name.localeCompare(b.data.name));

	    let list = root.findChild('id', 'tape_management', false);
	    let existingChildren = {};
	    for (const drive of records) {
		let path, text, iconCls;
		if (drive.data.changer !== undefined) {
		    text = drive.data.changer;
		    path = `Changer-${text}`;
		    iconCls = 'fa fa-exchange';
		} else {
		    text = drive.data.name;
		    path = `Drive-${text}`;
		    iconCls = 'pbs-icon-tape-drive';
		}
		existingChildren[path] = {
		    text,
		    path,
		    iconCls,
		    leaf: true,
		};
	    }

	    let paths = Object.keys(existingChildren).sort();

	    let oldIdx = 0;
	    for (let newIdx = 0; newIdx < paths.length; newIdx++) {
		let newPath = paths[newIdx];
		// find index to insert
		while (oldIdx < list.childNodes.length && newPath > list.getChildAt(oldIdx).data.path) {
		    oldIdx++;
		}

		if (oldIdx >= list.childNodes.length || list.getChildAt(oldIdx).data.path !== newPath) {
		    list.insertChild(oldIdx, existingChildren[newPath]);
		}
	    }

	    let toRemove = [];
	    list.eachChild((child) => {
		if (!existingChildren[child.data.path]) {
		    toRemove.push(child);
		}
	    });
	    toRemove.forEach((child) => list.removeChild(child, true));

	    if (view.pathToSelect !== undefined) {
		let path = view.pathToSelect;
		delete view.pathToSelect;
		view.select(path, true);
	    }
	},

	onLoad: function(store, records, success) {
	    if (!success) {
		return;
	    }
	    let view = this.getView();
	    let root = view.getStore().getRoot();

	    records.sort((a, b) => a.id.localeCompare(b.id));

	    let list = root.findChild('id', 'datastores', false);
	    let getChildTextAt = i => list.getChildAt(i).data.text;
	    let existingChildren = {};
	    for (let i = 0, j = 0, length = records.length; i < length; i++) {
		let name = records[i].id;
		existingChildren[name] = true;

		while (name.localeCompare(getChildTextAt(j)) > 0 && (j+1) < list.childNodes.length) {
		    j++;
		}

		let mountStatus = records[i].data['mount-status'] ?? 'nonremovable';
		let isRemovable = mountStatus !== 'nonremovable';
		let mainIcon = `fa fa-${isRemovable ? 'plug' : 'database'}`;
		let [qtip, iconCls] = ['', mainIcon];
		const maintenance = records[i].data.maintenance;

		const removable_not_mounted = records[i].data['mount-status'] === 'notmounted';
		if (removable_not_mounted) {
		    iconCls = `${mainIcon} pmx-tree-icon-custom unplugged`;
		    qtip = gettext('Removable datastore not mounted');
		}
		if (maintenance) {
		    const [type, message] = PBS.Utils.parseMaintenanceMode(maintenance);
		    qtip = `${type}${message ? ': ' + message : ''}`;
		    let maintenanceTypeCls = 'maintenance';
		    if (type === 'delete') {
			maintenanceTypeCls = 'destroying';
		    }
		    iconCls = `${mainIcon} pmx-tree-icon-custom ${maintenanceTypeCls}`;
		}

		if (getChildTextAt(j).localeCompare(name) !== 0) {
		    list.insertChild(j, {
			text: name,
			qtip,
			path: `DataStore-${name}`,
			iconCls,
			leaf: true,
		    });
		} else {
		    let oldChild = list.getChildAt(j);
		    oldChild.set('qtip', qtip);
		    oldChild.set('iconCls', iconCls);
		}
	    }

	    // remove entries which are not existing anymore
	    let toRemove = [];
	    list.eachChild(child => {
		if (!existingChildren[child.data.text] && !child.data.virtualEntry) {
		    toRemove.push(child);
		}
	    });
	    toRemove.forEach(child => list.removeChild(child, true));

	    if (view.pathToSelect !== undefined) {
		let path = view.pathToSelect;
		delete view.pathToSelect;
		view.select(path, true);
	    }
	},
    },

    listeners: {
	itemclick: function(tl, info) {
	    if (info.node.data.id === 'addbutton') {
		let me = this;
		Ext.create('PBS.DataStoreEdit', {
		    listeners: {
			destroy: () => me.rstore.reload(),
		    },
		}).show();
		return false;
	    }
	    return true;
	},
    },

    reloadTapeStore: function() {
	let me = this;
	me.tapeStore.load();
    },

    reloadStore: function() {
	let me = this;
	me.rstore.load();
    },

    select: function(path, silent) {
	var me = this;
	if (me.rstore.isLoaded() && me.tapeStore.isLoaded()) {
	    if (silent) {
		me.suspendEvents(false);
	    }
	    var item = me.getStore().findRecord('path', path, 0, false, true, true);
	    me.setSelection(item);
	    if (silent) {
		me.resumeEvents(true);
	    }
	} else {
	    me.pathToSelect = path;
	}
    },
});
Ext.define('PBS.Application', {
    extend: 'Ext.app.Application',

    name: 'PBS',
    appProperty: 'app',

    stores: [
	'NavigationStore',
    ],

    layout: 'fit',

    realignWindows: function() {
	var modalwindows = Ext.ComponentQuery.query('window[modal]');
	Ext.Array.forEach(modalwindows, function(item) {
	    item.center();
	});
    },

    logout: function() {
	var me = this;
	Proxmox.Utils.authClear();
	me.changeView('loginview', true);
    },

    changeView: function(view, skipCheck) {
	var me = this;
	PBS.view = view;
	me.view = view;

	if (me.currentView !== undefined) {
	    me.currentView.destroy();
	}

	me.currentView = Ext.create({
	    xtype: view,
	});
	if (skipCheck !== true) {
	    Proxmox.Utils.checked_command(Ext.emptyFn);
	}
    },

    view: 'loginview',

    launch: function() {
	var me = this;
	Ext.on('resize', me.realignWindows);

	var provider = new Ext.state.LocalStorageProvider({ prefix: 'ext-pbs-' });
	Ext.state.Manager.setProvider(provider);

	let isOpenIDLogin = Proxmox.Utils.getOpenIDRedirectionAuthorization() !== undefined;
	let alreadyLoggedIn = Proxmox.Utils.authOK();

	if (isOpenIDLogin || !alreadyLoggedIn) {
	    me.changeView('loginview', true); // show login window if not loggedin
	} else {
	    me.changeView('mainview', true);
	}
    },
});

Ext.application('PBS.Application');
Ext.define('PBS.MainView', {
    extend: 'Ext.container.Container',
    xtype: 'mainview',

    title: 'Proxmox Backup Server',

    controller: {
	xclass: 'Ext.app.ViewController',
	routes: {
	    ':path:subpath': {
		action: 'changePath',
		before: 'beforeChangePath',
                conditions: {
		    ':path': '(?:([%a-zA-Z0-9\\-\\_\\s,.]+))',
		    ':subpath': '(?:(?::)([%a-zA-Z0-9\\-\\_\\s,]+))?',
		},
	    },
	},

	parseRouterPath: function(path) {
	    let xtype = path;
	    let config = {};
	    if (PBS.Utils.isDataStorePath(path)) {
		config.datastore = PBS.Utils.getDataStoreFromPath(path);
		xtype = 'pbsDataStorePanel';
	    } else if (path.indexOf('Changer-') === 0) {
		config.changer = path.slice('Changer-'.length);
		xtype = 'pbsChangerStatus';
	    } else if (path.indexOf('Drive-') === 0) {
		config.drive = path.slice('Drive-'.length);
		xtype = 'pbsDriveStatus';
	    }

	    return [xtype, config];
	},

	beforeChangePath: function(path, subpathOrAction, action) {
	    var me = this;

	    let subpath = subpathOrAction;
	    if (!action) {
		action = subpathOrAction;
		subpath = undefined;
	    }

	    let [xtype, config] = me.parseRouterPath(path);

	    if (!Ext.ClassManager.getByAlias(`widget.${xtype}`)) {
		console.warn(`xtype ${xtype} not found`);
		action.stop();
		return;
	    }

	    var lastpanel = me.lookupReference('contentpanel').getLayout().getActiveItem();
	    if (lastpanel && lastpanel.xtype === xtype) {
		for (const [prop, value] of Object.entries(config)) {
		    if (lastpanel[prop] !== value) {
			action.resume();
			return;
		    }
		}
		// we have the right component already,
		// we just need to select the correct tab
		// default to the first
		subpath = subpath || 0;
		if (lastpanel.getActiveTab) {
		    // we assume lastpanel is a tabpanel
		    if (lastpanel.getActiveTab().getItemId() !== subpath) {
			// set the active tab
			lastpanel.setActiveTab(subpath);
		    }
		    // else we are already there
		}
		action.stop();
		return;
	    }

	    action.resume();
	},

	changePath: function(path, subpath) {
	    var me = this;
	    var contentpanel = me.lookupReference('contentpanel');
	    var lastpanel = contentpanel.getLayout().getActiveItem();

	    let tabChangeListener = function(tp, newc, oldc) {
		let newpath = path;

		// only add the subpath part for the
		// non-default tabs
		if (tp.items.findIndex('id', newc.id) !== 0) {
		    newpath += `:${newc.getItemId()}`;
		}

		me.redirectTo(newpath);
	    };

	    let [xtype, config] = me.parseRouterPath(path);
	    var obj;
	    if (PBS.Utils.isDataStorePath(path)) {
		if (lastpanel && lastpanel.xtype === xtype && !subpath) {
		    let activeTab = lastpanel.getActiveTab();
		    let newpath = path;
		    if (lastpanel.items.indexOf(activeTab) !== 0) {
			subpath = activeTab.getItemId();
			newpath += `:${subpath}`;
		    }
		    me.redirectTo(newpath);
		}
	    }
	    obj = contentpanel.add(Ext.apply(config, {
		xtype,
		nodename: 'localhost',
		border: false,
		activeTab: subpath || 0,
		listeners: {
		    tabchange: tabChangeListener,
		},
	    }));

	    var treelist = me.lookupReference('navtree');

	    treelist.select(path, true);

	    contentpanel.setActiveItem(obj);

	    if (lastpanel) {
		contentpanel.remove(lastpanel, { destroy: true });
	    }
	},

	logout: function() {
	    PBS.app.logout();
	},

	navigate: function(treelist, item) {
	    this.redirectTo(item.get('path'));
	},

	control: {
	    '[reference=logoutButton]': {
		click: 'logout',
	    },
	},

	init: function(view) {
	    var me = this;

	    PBS.data.RunningTasksStore.startUpdate();
	    me.lookupReference('usernameinfo').setText(Proxmox.UserName);

	    // show login on requestexception
	    // fixme: what about other errors
	    Ext.Ajax.on('requestexception', function(conn, response, options) {
		if (response.status === 401 || response.status === '401') { // auth failure
		    me.logout();
		}
	    });

	    // get ticket periodically
	    Ext.TaskManager.start({
		run: function() {
		    var ticket = Proxmox.Utils.authOK();
		    if (!ticket || !Proxmox.UserName) {
			return;
		    }

		    Ext.Ajax.request({
			params: {
			    username: Proxmox.UserName,
			    password: ticket,
			},
			url: '/api2/json/access/ticket',
			method: 'POST',
			failure: function() {
			    me.logout();
			},
			success: function(response, opts) {
			    var obj = Ext.decode(response.responseText);
			    PBS.Utils.updateLoginData(obj.data);
			},
		    });
		},
		interval: 15*60*1000,
	    });

	    Proxmox.Utils.API2Request({
		url: `/api2/extjs/nodes/localhost/status`,
		success: function({ result }) {
		    if (result?.data?.info?.fingerprint) {
			Proxmox.Fingerprint = result.data.info.fingerprint;
		    }
		},
		failure: function() {
		    // silently ignore errors
		},
	    });

	    // select treeitem and load page from url fragment, if set
	    let token = Ext.util.History.getToken() || 'pbsDashboard';
	    this.redirectTo(token, { force: true });
	},
    },

    plugins: 'viewport',

    layout: { type: 'border' },

    items: [
	{
	    region: 'north',
	    xtype: 'container',
	    layout: {
		type: 'hbox',
		align: 'middle',
	    },
	    margin: '2 0 2 5',
	    height: 38,
	    items: [
		{
		    xtype: 'proxmoxlogo',
		    prefix: '',
		},
		{
		    padding: '0 0 0 5',
		    xtype: 'versioninfo',
		},
		{
		    flex: 1,
		    baseCls: 'x-plain',
		},
		{
		    xtype: 'button',
		    baseCls: 'x-btn',
		    cls: 'x-btn-default-toolbar-small proxmox-inline-button',
		    iconCls: 'fa fa-book x-btn-icon-el-default-toolbar-small ',
		    text: gettext('Documentation'),
		    href: '/docs/index.html',
		    margin: '0 5 0 0',
		},
		{
		    xtype: 'pbsTaskButton',
		    margin: '0 5 0 0',
		},
		{
		    xtype: 'button',
		    reference: 'usernameinfo',
		    style: {
			// proxmox dark grey p light grey as border
			backgroundColor: '#464d4d',
			borderColor: '#ABBABA',
		    },
		    margin: '0 5 0 0',
		    iconCls: 'fa fa-user',
		    menu: [
			{
			    iconCls: 'fa fa-gear',
			    text: gettext('My Settings'),
			    handler: () => Ext.create('PBS.window.Settings').show(),
			},
			{
			    iconCls: 'fa fa-paint-brush',
			    text: gettext('Color Theme'),
			    handler: () => Ext.create('Proxmox.window.ThemeEditWindow', {
				cookieName: 'PBSThemeCookie',
				autoShow: true,
			    }),
			},
			{
			    iconCls: 'fa fa-language',
			    text: gettext('Language'),
			    reference: 'languageButton',
			    handler: () => Ext.create('Proxmox.window.LanguageEditWindow', {
				cookieName: 'PBSLangCookie',
				autoShow: true,
			    }),
			},
			'-',
			{
			    iconCls: 'fa fa-sign-out',
			    text: gettext('Logout'),
			    reference: 'logoutButton',
			},
		    ],
		},
	    ],
	},
	{
	    xtype: 'container',
	    scrollable: 'y',
	    border: false,
	    region: 'west',
	    layout: {
		type: 'vbox',
		align: 'stretch',
	    },
	    items: [{
		xtype: 'navigationtree',
		minWidth: 180,
		ui: 'pve-nav',
		reference: 'navtree',
		// we have to define it here until extjs 6.2
		// because of a bug where a viewcontroller does not detect
		// the selectionchange event of a treelist
		listeners: {
		    selectionchange: 'navigate',
		},
	    }, {
		xtype: 'box',
		cls: 'x-treelist-pve-nav',
		flex: 1,
	    }],
	},
	{
	    xtype: 'container',
	    layout: { type: 'card' },
	    region: 'center',
	    border: false,
	    reference: 'contentpanel',
	},
    ],
});
